<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: install.php,v 1.6 2002/02/11 20:11:59 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/

function draw_row($title, $var, $def, $descr=NULL)
{
	echo '<tr bgcolor="#bff8ff"><td valign="top"><b>'.$title.'</b>'.(($descr)?'<br><font size=-1>'.$descr.'</font>':'').'</td><td>'.(!empty($GLOBALS["errors"][$var])?$GLOBALS["errors"][$var]:'').'<input type="text" name="'.$var.'" value="'.htmlspecialchars(stripslashes($def)).'" size=40></td></tr>';
}

function draw_dialog_start($title, $help)
{
	echo '
	<table bgcolor="#000000" align="center" border="0" cellspacing="0" cellpadding="1">
		<tr>
			<td>
				<table bgcolor="#FFFFFF" border=0 cellspacing=1 cellpadding=4 align="center">
					<tr><td colspan=2 bgcolor="#e5ffe7">'.$title.'</td></tr>
					<tr><td colspan=2 bgcolor="#fffee5">'.$help.'</td></tr>
	';
}

function draw_dialog_end()
{	
	echo '<tr bgcolor="#FFFFFF">
			'.($GLOBALS["section"]!='install_path'?'<td align="left"><input type="button" onClick="history.go(-1)" name="buttn" value="&lt;&lt; Back"></td>':'<td>&nbsp;</td>').'
			<td align="right"><input type="submit" name="submit" value="Next &gt;&gt;"></td>
	</tr></table></td></tr></table>';			
}

function IFSTR($val, $alt)
{
	return (empty($alt))?$val:$alt;
}

function seterr($name, $text)
{
	$GLOBALS["errors"][$name] = '<font color="#ff0000">'.$text.'</font><br>';
}

function chkslash(&$val)
{
	if ( !empty($val) && $val[strlen($val)-1] != '/' ) $val .= '/';
	return $val;
}

function php_which($prg)
{
	if( $GLOBALS["HTTP_SERVER_VARS"]["PATH"][0] == '/' ) 
		$sep = ':';
	else
		$sep = ';';
		
	$path = explode($sep, $GLOBALS["HTTP_SERVER_VARS"]["PATH"]);
	
	while( list(,$v) = each($path) ) {
		chkslash($v);
		if( file_exists($v.$prg) ) {
			return $v.$prg;
		}
	}
	
	return;
}

function rcopy($from, $to)
{
	umask(0);
	if( @!is_dir($to) ) mkdir($to, fileperms($from));
	
	if( $dir = @opendir($from) ) {
		umask(0133);
		while( ($file = readdir($dir)) ) {
		  	if( $file == "." || $file == ".." ) continue;
		  	 
		  	if( @is_dir($from.$file.'/') ) rcopy($from.$file.'/', $to.$file.'/');
		  	else if( @is_file($from.$file) ) copy($from.$file, $to.$file);
		  }
		  closedir($dir);
	}
}

function change_var(&$source)
{
	$source = preg_replace($GLOBALS['from'], $GLOBALS['to'], $source);
}

function load_globals($path)
{
	$fp = fopen($path, "r");
		$data = fread($fp, filesize($path));
	fclose($fp);
	
	return $data;
}

function write_globals($path, $data)
{
	$fp = fopen($path, "w");
		fwrite($fp, $data);	
	fclose($fp);
}

function rep_add($val, $tval)
{
	$GLOBALS["to"][] = '\1\$'.$val.'\2=\3"'.$tval.'"\4;\5';
	$GLOBALS["from"][] = '!(.*)\$'.$val.'(.*)=(.*)".*?"(.*);(.*)!';
}

function make_into_query(&$data)
{
	$data = preg_replace('!\#.*$!s', '', $data);
	$data = preg_replace('! +!', ' ', $data);
}

switch ( $section )
{
	case "install_path":
		chkslash($INSTALL_PATH);
		if( @!is_dir($INSTALL_PATH.'install_data') ) {
			seterr('INSTALL_PATH', 'The directory you\'ve specified does not appear to be the directory where forum sources were decompressed to.');
		}
		else 
			$section = 'stor_path';
		break;
		
	case "stor_path":
		chkslash($SERVER_ROOT);
		chkslash($SERVER_DATA_ROOT);
		
		if( @!is_dir($SERVER_ROOT) )
			seterr('SERVER_ROOT', 'The directory where web browseable files are to be kept, does not exist, please create it.');
		else if( @!is_writable($SERVER_ROOT) )
			seterr('SERVER_ROOT', 'The webserver does not have write permissions to this directory, please chmod it 1777 or 777.');
		
		if( @!is_dir($SERVER_DATA_ROOT) )
			seterr('SERVER_DATA_ROOT', 'The directory where forum data files are to be kept, does not exist, please create it.');
		else if( @!is_writable($SERVER_DATA_ROOT) )
			seterr('SERVER_DATA_ROOT', 'The webserver does not have write permissions to this directory, please chmod it 1777 or 777.');
	
		if( empty($GLOBALS["errors"]) ) {
			$INCLUDE = $SERVER_DATA_ROOT.'include/';
			$ERROR_PATH  = $SERVER_DATA_ROOT.'errors/';
			$MSG_STORE_DIR = $SERVER_DATA_ROOT.'messages/';
			$FILE_STORE = $SERVER_DATA_ROOT.'files/';
			$TMP = $SERVER_DATA_ROOT.'tmp/';
			$IMG_ROOT_DISK = $SERVER_ROOT.'images/';
			$STYLES = 'styles/';
			$MOGRIFY_BIN = php_which('mogrify');
			$FORUM_SETTINGS_PATH = $SERVER_DATA_ROOT.'settings/';
			$USER_SETTINGS_PATH = $SERVER_DATA_ROOT.'user_settings/';
			
			umask(0);
			@mkdir($INCLUDE, 0755);
			@mkdir($ERROR_PATH, 0755);
			@mkdir($MSG_STORE_DIR, 0755);
			@mkdir($FILE_STORE, 0755);
			@mkdir($TMP, 0755);
			@mkdir($IMG_ROOT_DISK, 0755);
			@mkdir($FORUM_SETTINGS_PATH, 01777);
			@mkdir($USER_SETTINGS_PATH, 0755);
			@mkdir($IMG_ROOT_DISK.'custom_avatars/', 0755);
			
			rcopy($INSTALL_PATH.'install_data/sys/include/', $INCLUDE);
			rcopy($INSTALL_PATH.'install_data/sys/settings/', $FORUM_SETTINGS_PATH);
			rcopy($INSTALL_PATH.'install_data/docs/', $SERVER_ROOT);
			rcopy($INSTALL_PATH.'install_data/images/', $IMG_ROOT_DISK);
			
			chmod($INCLUDE.'GLOBALS.php', 0666); 
			
			@symlink($INCLUDE.'GLOBALS.php', $SERVER_ROOT.'GLOBALS.php');
			@symlink($INCLUDE.'GLOBALS.php', $SERVER_ROOT.'adm/GLOBALS.php');
			
			rep_add('INCLUDE', $INCLUDE);
			rep_add('ERROR_PATH', $ERROR_PATH);
			rep_add('MSG_STORE_DIR', $MSG_STORE_DIR);
			rep_add('FILE_STORE', $FILE_STORE);
			rep_add('TMP', $TMP);
			rep_add('IMG_ROOT_DISK', $IMG_ROOT_DISK);
			rep_add('WWW_ROOT', $WWW_ROOT);
			rep_add('MOGRIFY_BIN', $MOGRIFY_BIN);
			rep_add('FORUM_SETTINGS_PATH', $FORUM_SETTINGS_PATH);
			rep_add('USER_SETTINGS_PATH', $USER_SETTINGS_PATH);
			rep_add('COOKIE_NAME', 'fud_session_'.time());
			
			$url_parts = parse_url($WWW_ROOT);
			
			rep_add('COOKIE_PATH', $url_parts['path']);
			
			$glob_file = load_globals($INCLUDE.'GLOBALS.php');
			change_var($glob_file);
			write_globals($INCLUDE.'GLOBALS.php', $glob_file);
			
			$section = 'mysql';
		}
	
		break;	

	case "mysql" :
		if( @!mysql_connect($MYSQL_SERVER, $MYSQL_LOGIN, $MYSQL_PASSWORD) ) {
			seterr('MYSQL_SERVER', 'Failed to connect to MySQL Server, SQL Reason: '.mysql_error());
		}
		else if( @!mysql_select_db($MYSQL_DB) ) {
			seterr('MYSQL_DB', 'Could not open the database you\'ve specified, SQL Reason: '.mysql_error());
		}

		if( empty($GLOBALS["errors"]) ) {
			$tables = $def_data = array();
			
			$dir = opendir($INSTALL_PATH.'install_data/sql/');
			while( ($file = readdir($dir)) ) {
				if( preg_match('!\.tbl$!', $file) ) 
					$tables[] = $INSTALL_PATH.'install_data/sql/'.$file;
				else if( preg_match('!\.sql$!', $file) ) 
					$def_data[] = $INSTALL_PATH.'install_data/sql/'.$file;
			}
			closedir($dir);

			$error=NULL;
			
			while( list(,$v) = each($tables) ) {
				$tmp = array();
				
				$fp = fopen($v, 'r');
					$data = fread($fp, filesize($v));
				fclose($fp);
				
				$data = preg_replace('!#.*?\n!s', '', $data);
				$tmp = explode(';', $data);
				
				while( list(, $v2) = each($tmp) ) {
					if( trim($v2) ) {
						make_into_query(&$v2);
						if( trim($v2) ) {
							if( !mysql_query($v2) ) {
								$error = 1;
								seterr('MYSQL_DB', 'Failed to create table '.preg_replace('!.*/(.*?)\.tbl!','\1',$v).' ('.$v2.'), SQL Reason: '.mysql_error());
								break;
							}
						}	
					}	
				}
				if( $error ) break;
			}
			
			if( !$error ) {
				while( list(,$v) = each($def_data) ) {
					$tmp = array();
				
					$fp = fopen($v, 'r');
						$data = fread($fp, filesize($v));
					fclose($fp);
				
					$data = preg_replace('!\#.*$!s', '', $data);
					$tmp = preg_split('!;[\r\n]+!', $data);
				
					while( list(, $v2) = each($tmp) ) {
						if( trim($v2) ) {
							make_into_query(&$v2);
							
							if( trim($v2) ) {
								if( !mysql_query($v2) ) {
									$error = 1;
									seterr('MYSQL_DB', 'Failed to import default data ('.$v2.') into table '.preg_replace('!.*/(.*?)\.sql!','\1',$v).', SQL Reason: '.mysql_error());
									break;
								}
							}	
						}	
					}
					if( $error ) break;
				}
			
			}
			
			if( empty($GLOBALS["errors"]) ) { 
				rep_add('MYSQL_SERVER', $MYSQL_SERVER);
				rep_add('MYSQL_LOGIN', $MYSQL_LOGIN);
				rep_add('MYSQL_PASSWORD', $MYSQL_PASSWORD);
				rep_add('MYSQL_DB', $MYSQL_DB);
			
				$glob_file = load_globals($SERVER_DATA_ROOT.'include/GLOBALS.php');
				change_var($glob_file);
				write_globals($SERVER_DATA_ROOT.'include/GLOBALS.php', $glob_file);
				
				$section = 'cookies';	
			}	
		}
	
		break;
	case "cookies":
	
		if( empty($COOKIE_DOMAIN) ) {
			seterr('COOKIE_DOMAIN', 'You must enter a cookie domain, in order for cookies to work properly.');
		}
		
		if( empty($GLOBALS["errors"]) ) {
			rep_add('COOKIE_DOMAIN', $COOKIE_DOMAIN);
		
			$glob_file = load_globals($SERVER_DATA_ROOT.'include/GLOBALS.php');
			change_var($glob_file);
			write_globals($SERVER_DATA_ROOT.'include/GLOBALS.php', $glob_file);
				
			$section = 'admin';
		}	
	
		break;	
	case "admin":
	
		if( empty($ROOT_PASS) ) {
			seterr('ROOT_PASS', 'You must enter a password for the administrator account.');
		}
		else if( $ROOT_PASS != $ROOT_PASS_C ) {
			seterr('ROOT_PASS', 'Your passwords do not match.');	
		}
		if( empty($ROOT_LOGIN) ) {
			seterr('ROOT_LOGIN', 'You must enter a user name for the administrator account.');
		}
		
		if( empty($ADMIN_EMAIL) ) {
			seterr('ADMIN_EMAIL', 'You must enter a valid email address for the administrator account.');
		}
	
		if( empty($GLOBALS["errors"]) ) {
			mysql_connect($MYSQL_SERVER, $MYSQL_LOGIN, $MYSQL_PASSWORD);
			mysql_select_db($MYSQL_DB);
			
			mysql_query("INSERT INTO fud_users (login, passwd, name, email, email_conf, coppa, join_date,is_mod) VALUES('".$ROOT_LOGIN."','".md5($ROOT_PASS)."','Administrator', '".$ADMIN_EMAIL."','Y', 'N', ".time().", 'A')");
			
			rep_add('ADMIN_EMAIL', $ADMIN_EMAIL);
		
			$glob_file = load_globals($SERVER_DATA_ROOT.'include/GLOBALS.php');
			change_var($glob_file);
			write_globals($SERVER_DATA_ROOT.'include/GLOBALS.php', $glob_file);
				
			$section = 'done';			
		}
	
		break;	
	case "done":
		header("Location: ".$FORUM_WWW_ROOT."login.php?adm=1");
		exit;
		break;	
}
?>
<html>
<form name="install" action="install.php?<? echo rand(); ?>" method="post">
<?
	/*
		1) install path
		2) storage paths
		3) MYSQL Settings 
		4) Cookie settings
		5) Admin Email & Admin Account
		6) Redr user to login page
			- read person to admglobals
	*/

	if ( empty($section) ) $section = "install_path";
	
	switch ( $section ) 
	{
		case "install_path":
			$path = $GLOBALS["HTTP_SERVER_VARS"]["DOCUMENT_ROOT"];
			chkslash($path);
		
			draw_dialog_start('Installation Path&nbsp;&nbsp;&nbsp;&nbsp;<font size="-1"><b>Step 1 of 5</b></font>', 'Please enter the full path to the directory where the uncompressed files of the forum are located. <b>ex. /home/forum/forum_install/</b>');
			draw_row('Install Path:', 'INSTALL_PATH', IFSTR($path, $INSTALL_PATH));
			break;
		
		case "stor_path":
			$tmp_path = 'http://'.$GLOBALS["HTTP_SERVER_VARS"]["HTTP_HOST"];
			if( $GLOBALS["HTTP_SERVER_VARS"]["SERVER_PORT"] != 80 ) $tmp_path .= ':'.$GLOBALS["HTTP_SERVER_VARS"]["SERVER_PORT"];
			$tmp_path .= preg_replace("!/[^/]*$!", "/", $GLOBALS["HTTP_SERVER_VARS"]["REQUEST_URI"]);
			
			$tmp_data = preg_replace("!/[^/]*$!", "/", $GLOBALS["HTTP_SERVER_VARS"]["DOCUMENT_ROOT"]);
			
			draw_dialog_start('PATH OF SYSTEM FILES AND DIRECTORIES&nbsp;&nbsp;&nbsp;&nbsp;<font size="-1"><b>Step 2 of 5</b></font>', 'Directories where the forum files will be stored.<br>In order for the forum installation to work, you need to chmod the directories, Server Root & Forum Data Root, in such a way that the webserver can write to them. I suggest chmoding the directories to 1777, which will make them sticky, or just plain 777. When the installation process is complete you should chmod those directories back to 755, so that no one can overwrite your files<br>
			If you have shell access you can change the directory permission by typing "<b>chmod 1777 directory_name</b>"<br>
			In CuteFTP, you can chmod a directory, by selecting it and then pressing Ctrl+Shift+A. In the Manual checkbox enter 1777 or 777 and then press OK.<br>
			IN WS_FTP right click on the directory and choose the chmod UNIX option. In the dialog withing select all the checkboxes and click OK, this will chmod the directory 777.<br>');
			
			draw_row('Server Root', 'SERVER_ROOT', IFSTR(chkslash($GLOBALS["HTTP_SERVER_VARS"]["DOCUMENT_ROOT"]), $SERVER_ROOT), 'The path on the server where the browseable files of the forum (*.php) will be stored.');
			draw_row('Forum Data Root', 'SERVER_DATA_ROOT', IFSTR($tmp_data, $SERVER_DATA_ROOT), 'Inside this directory the files created and used by the forum, that are NOT web browseable will be stored.');
			draw_row('Forum WWW Root', 'WWW_ROOT', IFSTR($tmp_path, $WWW_ROOT), 'This is the main web browseable directory of the forum. This is where the forum\'s front page will be and what will be typed by people in their web browser to get to your forum.');
			break;
		
		case "mysql":
			$def_mysql = IFSTR(ini_get('mysql.default_socket'), ini_get('mysql.default_host').':'.ini_get('mysql.default_port'));
			
			draw_dialog_start('MySQL Settings&nbsp;&nbsp;&nbsp;&nbsp;<font size="-1"><b>Step 3 of 5</b></font>', 'FUD forum uses MySQL to store much of the data used in the forum. Please use the form below to enter infromation that would allow FUD Forum to access mysql database. It is recommended you create a seperate MySQL database for the forum.');
			
			draw_row('MySQL Server', 'MYSQL_SERVER', IFSTR($def_mysql, $MYSQL_SERVER), 'The ip of the mysql server');
			draw_row('MySQL Login', 'MYSQL_LOGIN', IFSTR('', $MYSQL_LOGIN), 'The login name that will be used to connect to MySQL');
			draw_row('MySQL Password', 'MYSQL_PASSWORD', IFSTR('', $MYSQL_PASSWORD));
			draw_row('MySQL Database', 'MYSQL_DB', IFSTR('', $MYSQL_DB), 'The name of the MySQL database where forum data will be stored.');
			
			break;
			
		case "cookies":
			$url_parts = parse_url($FORUM_WWW_ROOT);
			
			draw_dialog_start('Cookie Domain&nbsp;&nbsp;&nbsp;&nbsp;<font size="-1"><b>Step 4 of 5</b></font>', 'The domain name for which the forum cookies will be set.');
			draw_row('Cookie Domain', 'COOKIE_DOMAIN', IFSTR(preg_replace('!^www\.!i', '.', $url_parts['host']), $COOKIE_DOMAIN));
			
			break;	
			
		case "admin":
			draw_dialog_start('Admin Account&nbsp;&nbsp;&nbsp;&nbsp;<font size="-1"><b>Step 5 of 5</b></font>', 'This creates the "root" user account, which is an unrestricted account, which can do anything on the forum. This account you must use while editing & customizing the forum.');
			
			draw_row('Login Name', 'ROOT_LOGIN', IFSTR('root', $ROOT_LOGIN));
			draw_row('Root Password', 'ROOT_PASS', IFSTR('', $ROOT_PASS));
			draw_row('Confirm Password', 'ROOT_PASS_C', IFSTR('', $ROOT_PASS_C));
			draw_row('Admin Email', 'ADMIN_EMAIL', IFSTR('', $ADMIN_EMAIL));
			
			break;
		case "done":
			draw_dialog_start('Installation Complete', 'You have now completed the basic installation of the forum. To configure your forum further you must login and use the administrator control panel.<br>
			Clicking next, will take you to the login form, after you login you will be taken to the administrator control panel.<br>
			You should now chmod the web browseable directory ('.$SERVER_ROOT.') as well as the data directory ('.$SERVER_DATA_ROOT.') back to their normal permissions (755).<br>
			You should also move install.php from the browseable directory, so no one will be able to over write your settings.
			');	
			break;	
	}
	
	draw_dialog_end(); 
	
	echo '<input type="hidden" name="section" value="'.$section.'">';

	if( $section != 'install_path' ) echo '<input type="hidden" name="INSTALL_PATH" value="'.$INSTALL_PATH.'">';
	if( $WWW_ROOT || $FORUM_WWW_ROOT ) echo '<input type="hidden" name="FORUM_WWW_ROOT" value="'.IFSTR($WWW_ROOT, $FORUM_WWW_ROOT).'">';
	if( $section == 'cookies' || $section == 'admin' ) {
		echo '
			<input type="hidden" name="MYSQL_SERVER" value="'.$MYSQL_SERVER.'">
			<input type="hidden" name="MYSQL_PASSWORD" value="'.$MYSQL_PASSWORD.'">
			<input type="hidden" name="MYSQL_LOGIN" value="'.$MYSQL_LOGIN.'">
			<input type="hidden" name="MYSQL_DB" value="'.$MYSQL_DB.'">
		';
	}
	if( $section != 'install_path' && $section != 'stor_path' ) {
		echo '
			<input type="hidden" name="SERVER_DATA_ROOT" value="'.$SERVER_DATA_ROOT.'">
			<input type="hidden" name="SERVER_ROOT" value="'.$SERVER_ROOT.'">
		';
	}
?>
</form>
</html>