<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: compact.php,v 1.6 2002/02/12 19:25:30 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/
?>
<?php
	include_once "GLOBALS.php";
	
	$GLOBALS['ADMIN_FORM'] = 1;
	$GLOBALS['USER_REG'] = 1;
	$GLOBALS['MSG_EDIT'] = 1;
	
	fud_use('db.inc');
	fud_use('fileio.inc');
	fud_use('adm.inc');
	fud_use('private.inc');
	fud_use('glob.inc');
	
	list($ses, $usr) = initadm();
	
	include('admpanel.php');
	
	if( $GLOBALS['FORUM_ENABLED'] == 'Y' ) {
		echo '<br>Disabling the forum for the duration of maintenance run<br>';
		maintenance_status('Undergoing maintenance, please come back later.', 'N');
	}
	
	echo "<br>PLEASE WAIT WHILE FORUM IS BEING COMPACTED, THIS MAY TAKE A WHILE<br>\n";
	flush();
	
	/* Normal Messages */
	DB_LOCK('fud_msg+, fud_thread+');
	$r = Q("SELECT * FROM fud_msg ORDER BY thread_id, id ASC");
	start_bench('a');
	$prev_thread_id = 0;
	$off=$len=0;
	while ( $obj = DB_ROWOBJ($r) ) {
		if( $prev_thread_id != $obj->thread_id ) {
			open_thread_body($obj->thread_id);
			if( !empty($fp) ) {
				fclose($fp);
				rename($GLOBALS['MSG_STORE_DIR'].'th_'.$prev_thread_id.'.tmp', $GLOBALS['MSG_STORE_DIR'].'th_'.$prev_thread_id);
				chmod($GLOBALS['MSG_STORE_DIR'].'th_'.$prev_thread_id, 0644);
			}
			$off=$len=0;
			$fp = fopen($GLOBALS['MSG_STORE_DIR'].'th_'.$obj->thread_id.'.tmp', 'w');							
			$prev_thread_id = $obj->thread_id;
		}

		$b = read_ext_body($obj->offset, $obj->length);
		$len = strlen($b);
		Q("UPDATE fud_msg SET offset=".$off.", length=".$len." WHERE id=".$obj->id);
		$off += $len;
		fwrite($fp, $b);
	}
	QF($r);
	close_thread_body();
	if( $fp ) {
		fclose($fp);
		rename($GLOBALS['MSG_STORE_DIR'].'th_'.$prev_thread_id.'.tmp', $GLOBALS['MSG_STORE_DIR'].'th_'.$prev_thread_id);
		chmod($GLOBALS['MSG_STORE_DIR'].'th_'.$prev_thread_id, 0644);
	}
	DB_UNLOCK();
	
	/* Private Messages */
	DB_LOCK('fud_pmsg+');
	$off=$len=0;
	$fp = fopen($GLOBALS['MSG_STORE_DIR'].'private_tmp', 'w');
	
	$r = Q("SELECT distinct(offset),length FROM fud_pmsg");
	while ( $obj = DB_ROWOBJ($r) ) {
		$b = read_pmsg_body($obj->offset, $obj->length); 
		$len = strlen($b);
		
		Q("UPDATE fud_pmsg SET offset=".$off.", length=".$len." WHERE offset=".$obj->offset);
		
		$off += $len;
		fwrite($fp, $b);
	}
	if( !empty($fp) ) { 
		fclose($fp);
		rename($GLOBALS['MSG_STORE_DIR'].'private_tmp', $GLOBALS['MSG_STORE_DIR'].'private');
		chmod($GLOBALS['MSG_STORE_DIR'].'private', 0644);
	}	
	
	DB_UNLOCK();
	
	if( $GLOBALS['FORUM_ENABLED'] == 'Y' ) {
		echo '<br>Re-enabling the forum.<br>';
		maintenance_status($GLOBALS['DISABLED_REASON'], 'Y');
	}
 readfile('admclose.html');
?>