<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: email.php,v 1.6 2002/02/11 21:06:40 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/

/*#? Email Composition Form */
	include_once "GLOBALS.php";	
	
	$GLOBALS["USER_REG"] = 1;
	
	fud_use('db.inc');
	fud_use('widgets.inc');
	fud_use('users.inc');
	fud_use('email.inc');
	fud_use('cookies.inc');
	fud_use('style.inc');
	fud_use('error.inc');
	fud_use('rev_fmt.inc');

	list($ses, $usr) = init_user();	
	if ( !$ses->getvar('user_id') ) std_error('login');
	
	if( $GLOBALS["ALLOW_EMAIL"]=='N' ) {
		error_dialog('ERROR: Unable to email', 'The email system has been disabled by the administrator.', $WWW_ROOT, '');
		exit;
	}
	
function set_err($type, $msg)
{
	$GLOBALS['_ERROR_'][$type] = $msg;
	$GLOBALS['error'] = 1;
}

function get_err($type)
{
	if ( !isset($GLOBALS['_ERROR_'][$type]) ) return;
	return '<br><font class="ErrorText">'.$GLOBALS['_ERROR_'][$type].'</font>';
}

function mail_check()
{
	$GLOBALS['error']=0;
	
	if ( !strlen(trim($GLOBALS['tx_body'])) )
		set_err('tx_body', 'The body is requred');
	
	if ( !strlen(trim($GLOBALS['tx_subject'])) )
		set_err('tx_subject', 'Subject is required');
	
	if ( strlen(trim($GLOBALS['email_open'])) ) {
		if ( !strlen(trim($GLOBALS['tx_email'])) )
			set_err('tx_email', 'Email is required');
		else if ( validate_email($GLOBALS['tx_email']) ) {
			set_err('tx_email', 'Invalid email adress');
		}
	}
	else {
		if ( !strlen(trim($GLOBALS['tx_name'])) )
			set_err('tx_name', 'Name is required');
			
		$u_name = $GLOBALS['tx_name'];
		reverse_FMT($u_name);

		if ( !get_id_by_login(addslashes($u_name)) ) {
			set_err('tx_name', 'Invalid user');
		}
	}
	
	return $GLOBALS['error'];
}
	
	if( isset($email_open) ) {
		$tx_body = stripslashes($tx_body);
		$tx_subject = stripslashes($tx_subject);
		$tx_name = stripslashes($tx_name);
	}
	
	if( $HTTP_GET_VARS['tx_name'] ) $tx_name = stripslashes($HTTP_GET_VARS['tx_name']);
	
	if( empty($email_open) ) $email_open = '';
	if( empty($tx_subject) ) $tx_subject = '';
	if( empty($tx_body) ) $tx_body = '';
	
	if ( !empty($btn_submit) && !mail_check() ) {
		if ( $email_open ) {
			$tx_body = "\n\n".$tx_body;
			reverse_FMT($tx_name);
			$to = $tx_name.' <'.$tx_email.'>';
		}
		else {
			$usr_dst = new fud_user;
			reverse_FMT($tx_name);
			$usr_dst->get_user_by_id(get_id_by_login(addslashes($tx_name)));
			if ( !strlen($usr_dst->email) ) {
				error_dialog('ERROR: Unable to email', 'Sorry, the system was unable to email '.htmlspecialchars($usr_dst->login).' because it was unable to locate his email address', $GLOBALS['HTTP_REFERER'], 'FATAL');
				exit();
			}
			/* email here */
			reverse_FMT($usr->login);
			$tx_body .= "\n\nTo reply please use the forum mailer at:\n$WWW_ROOT/email.php?tx_login=".urlencode($usr->login)."\n";
			reverse_FMT($usr_dst->login);
			$to = $usr_dst->login.' <'.$usr_dst->email.'>';
		}
		
		send_email($usr->email, $to, $tx_subject, $tx_body, $to_str);
		check_return();
	}
	
	/* start page */
	$TITLE_EXTRA = ': Email Form';
	$layout = get_layout_id((isset($layout)?$layout:'')); include_once $GLOBALS['FORUM_SETTINGS_PATH'].'header_'.$layout.'.inc';
	
	echo '<form method="post" action="email.php">';

	lay_start_content_table();
	echo '<tr class="TableHeading"><td colspan=2 class="TableHeading">Email</td></tr>';
	set_row_color_alt(true);
	
	if ( $email_open ) {
		echo '<tr'.ROW_BGCOLOR().'><td nowrap class="GenText">Name:'.get_err('tx_name').'</td><td width="100%"><input type="text" name="tx_name" value="'.htmlspecialchars($tx_name).'"></td></tr>';
		echo '<tr'.ROW_BGCOLOR().'><td nowrap class="GenText">Email:'.get_err('tx_email').'</td><td width="100%"><input type="text" name="tx_email" value="'.$tx_email.'"></td></tr>';
	}
	else 
		echo '<tr'.ROW_BGCOLOR().'><td nowrap class="GenText">To:'.get_err('tx_name').'</td><td width="100%"><input type="text" name="tx_name" value="'.htmlspecialchars($tx_name).'"></td></tr>';
		
	echo '<tr'.ROW_BGCOLOR().'><td nowrap class="GenText">Subject:'.get_err('tx_subject').'</td><td width="100%"><input type="text" name="tx_subject" value="'.htmlspecialchars($tx_subject).'"></td></tr>';	
	echo '<tr'.ROW_BGCOLOR().'><td nowrap class="GenText" valign="top">Body:'.get_err('tx_body').'</td><td width="100%"><textarea name="tx_body" cols=40 rows=20>'.htmlspecialchars($tx_body).'</textarea></td></tr>';
	echo '<tr'.ROW_BGCOLOR().'><td align="right" colspan=2><input type="submit" name="btn_submit" value="Email"></td></tr>';
	
	lay_end_content_table();

	echo '<input type="hidden" name="email_open" value="'.$email_open.'">';
	draw_return();
	echo '</form>';
	include_once $GLOBALS['FORUM_SETTINGS_PATH'].'footer_'.$layout.'.inc';
?>