<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: ignore_list.php,v 1.10 2002/02/11 21:06:40 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/

	include_once "GLOBALS.php";
	$GLOBALS["USER_REG"] = 1;
	fud_use('db.inc');
	fud_use('style.inc');
	fud_use('users.inc');
	fud_use('error.inc');
	fud_use('widgets.inc');
	fud_use('ignore.inc');
	
	list($ses, $usr) = init_user();
	cache_buster();
	
	if ( !isset($usr) ) {
		std_error('login');
		exit();
	}
	
	$ign = new fud_ignore;
	
	if( isset($add_login) && strlen($add_login) ) {
		$ignore_id = get_id_by_login($add_login);
	
		if ( $ignore_id && !($ignore=check_ignore($usr->id, $ignore_id)) ) {
			$ign->add($usr->id, $ignore_id);
			$done=1;
			header("Location: ignore_list.php?".$_RSID."&rand=".get_random_value());
		}
		else if ( $ignore == 1 ) {
			error_dialog('Info', 'You can\'t ignore this user', 'ignore_list.php?'.$_RSID);
		}
		else if ( $ignore ) {
			error_dialog('Info', 'You already have this user on your ignore list', 'ignore_list.php?'.$_RSID);
		}
		else {
			error_dialog('User not found', 'The user you\'ve tried to add to your ignore list was not found on the forum.', 'ignore_list.php?'.$_RSID);
		}
		
		exit();
	}
	
	if ( isset($add) && is_numeric($add) && empty($done) && ($ignore_login=check_user($add)) ) {
		$test_u = new fud_user;
		$test_u->get_user_by_id($add);
		
		if( $test_u->is_mod == 'A' ) {
			error_dialog('Info', 'You can\'t ignore this user', (isset($returnto)?base64_decode($returnto):''));
		}
		else if( !check_ignore($usr->id, $add) ) {
			$ign->add($usr->id, $add);
			check_return();
		}
		exit;
	}

	if ( isset($del) && is_numeric($del) ) {
		$ign->get_ignore($usr->id, $del);
		$ign->delete();	
		if( empty($returnto) ) $returnto = base64_encode('ignore_list.php?'.$_RSID.'&rand='.get_random_value());
		check_return();	
	}

	if ( isset($ses) ) $ses->update('Browsing own ignore list');
	$layout = get_layout_id($layout); include_once $GLOBALS['FORUM_SETTINGS_PATH'].'header_'.$layout.'.inc';
	fud_use('usroptions.inc');
	
	$res = Q("SELECT 
			fud_user_ignore.id as ignoreent_id,
			fud_users.id,
			fud_users.login,
			fud_users.join_date,
			fud_users.posted_msg_count 
		FROM 
			fud_user_ignore
		LEFT JOIN 
			fud_users 
				ON fud_user_ignore.ignore_id=fud_users.id 
		WHERE 
			fud_user_ignore.user_id=".$usr->id);
	
	if( DB_COUNT($res) ) {
		lay_start_content_table();
		echo '<tr class="TableHeading"><td>Ignored Users</td><td nowrap align="center">Post Count</td><td nowrap align="center">Registered On</td><td nowrap align="center">Action</td></tr>';
	
		$returnto = base64_encode($GLOBALS["REQUEST_URI"]);
	
		set_row_color_alt(true);
		while( $obj = DB_ROWOBJ($res) ) {
			$ext = read_ext_settings($obj->id);
				
			if ( strlen($ext['home_page']) )
				$hp = '<a class="GenLink" href="'.$ext['home_page'].'" target=_new><img src="'.$GLOBALS["fud_img_suffix"].'homepage.gif" alt="Homepage" border=0></a>';
			else
				$hp=NULL;
				
			echo '<tr'.ROW_BGCOLOR().'><td width="100%" class="GenText"><a class="GenLink" href="usrinfo.php?id='.$obj->id.'&'.$_RSID.'">'.htmlspecialchars($obj->login).'</a> <font class="SmallText">(<a href="ignore_list.php?del='.$obj->ignoreent_id.'&'.$_RSID.'" class="GenLink">remove</a>)</font></td><td align="center" nowrap class="Gentext">'.$obj->posted_msg_count.'</td><td class="DateText" nowrap>'.format_date($obj->join_date).' '.format_time($obj->join_date).'</td><td nowrap class="GenText">'.(($GLOBALS["ALLOW_EMAIL"]=='Y')?'<a href="email.php?tx_name='.urlencode($obj->login).'&returnto='.$returnto.'&'.$_RSID.'" class="GenLink"><img src="'.$GLOBALS["fud_img_suffix"].'msg_email.gif" alt="Contact via Email" border=0></a> ':'').'<a href="showposts.php?id='.$obj->id.'&'.$_RSID.'" class="GenLink"><img src="'.$GLOBALS["fud_img_suffix"].'show_posts.gif" alt="Show Posts" border=0></a> '.$hp.'</td></tr>';
			
		}
		lay_end_content_table();
	}
	QF($res);
	
	echo '<br><br><div align="center">';
	
	
	lay_start_content_table('MiniTable');
	echo '<form name="buddy_add" method="post">';
	echo '<tr class="TableHeading"><td nowrap>Add Ignoramus</td></tr>';
	echo '<tr class="RowStyleA"><td nowrap class="GenText"><font class="Smalltext">Enter the login of the user you wish to add.<br>Or use the <a href="#" class="GenLink" onClick="javascript: window_open(\'finduser.php?js_redr='.base64_encode('buddy_add.add_login').'\', \'user_list\',500,500);">Find User</a> feature to find a person.</font><p>
		<input type="text" name="add_login" value="" maxlength=100 size=25> <input type="submit" name="submit" value="Add"></td></tr>';
	echo '<input type="hidden" name="S" value="'.$S.'"></form>';
	lay_end_content_table();
	
	echo '</div>';
	
	include_once $GLOBALS['FORUM_SETTINGS_PATH'].'footer_'.$layout.'.inc';
?>