<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: modque.php,v 1.14 2002/02/11 21:06:40 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/

	include_once "GLOBALS.php";
	
	$GLOBALS["ADMIN_FORM"] = 1;
	$GLOBALS["MSG_EDIT"] = 1;
	
	fud_use('db.inc');
	fud_use('que.inc');
	fud_use('users.inc');
	fud_use('cookies.inc');
	fud_use('cat.inc');
	fud_use('thread.inc');
	fud_use('msg.inc');
	fud_use('util.inc');
	fud_use('style.inc');
	fud_use('drawmsg.inc');
	
	list($ses, $usr) = init_user();
	
	if ( isset($ses) ) $ses->update();
	
	if ( !isset($usr) ) { 
		header("Location: login.php?".$_RSID."&returnto=".base64_encode('modque.php')); 
		exit(); 
	}
	
	if ( !empty($appr) ) {
		$msg = new fud_msg_edit;
		$msg->get_by_id($appr);
		$msg->approve();
		header("Location: modque.php?".$_RSID);
		exit();
	}
	else if( !empty($del) ) {
		$msg = new fud_msg_edit;
		$msg->get_by_id($del);
		$msg->delete();
		header("Location: modque.php?".$_RSID);
		exit();
	}
	
	cache_buster();
	
	$r = Q("SELECT 
		fud_msg.*,
		fud_thread.locked,
		fud_avatar.img AS avatar, 
		fud_users.id AS user_id, 
		fud_users.login, 
		fud_users.custom_status,
		fud_users.display_email, 
		fud_users.email, 
		fud_users.posted_msg_count, 
		fud_users.join_date, 
		fud_users.location,
		fud_users.sig,
		fud_users.icq,
		fud_users.aim,
		fud_users.msnm,
		fud_users.yahoo,
		fud_users.avatar_loc,
		fud_users.avatar_approved,
		fud_cat.name AS cat_name, 
		fud_level.name AS level_name,
		fud_level.pri AS level_pri,
		fud_level.img AS level_img,
		fud_forum.name AS frm_name,
		fud_ses.time_sec
	FROM
		fud_msg 
	LEFT JOIN fud_thread 
		ON fud_msg.thread_id=fud_thread.id 
	LEFT JOIN fud_forum 
		ON fud_thread.forum_id=fud_forum.id 
	LEFT JOIN fud_mod 
		ON fud_forum.id=fud_mod.forum_id AND fud_mod.user_id=".$usr->id."
	LEFT JOIN fud_cat
		ON fud_forum.cat_id=fud_cat.id	
	LEFT JOIN fud_users
		ON fud_msg.poster_id=fud_users.id
	LEFT JOIN fud_avatar
		ON fud_users.avatar=fud_avatar.id
	LEFT JOIN fud_ses
		ON fud_ses.user_id=fud_msg.poster_id
	LEFT JOIN fud_level
			ON fud_users.level_id=fud_level.id
	WHERE 
		fud_forum.moderated='Y' 
		AND fud_msg.approved='N'
	ORDER BY 
		fud_forum.id, 
		fud_msg.id DESC");
	
	set_row_color_alt(true);

	$layout = get_layout_id((isset($layout)?$layout:'')); include_once $GLOBALS['FORUM_SETTINGS_PATH'].'header_'.$layout.'.inc';

	lay_start_content_table(); 
	
	$md = new fud_modque;
	$thr = new fud_thread;
	
	if ( !DB_COUNT($r) ) {
		echo '<tr class="TableHeading"><td>There are no posted messages that you can moderate</td></tr>';
	}
	
	$MOD = 1;
	
	echo '<tr class="TableHeading"><td colspan=2>Messages awaiting approval</td></tr>';
	
	while ( $obj = DB_ROWOBJ($r) ) {
	
		echo '<tr class="RowStyleB"><td class="GenText"><b>Forum:</b> '.$obj->cat_name.'<br><b>Thread:</b> '.$obj->frm_name.'</td><td class="GenText" align="right">[<a class="GenLink" href="modque.php?appr='.$obj->id.'&'.$_RSID.'">Approve</a>]&nbsp;&nbsp;[<a class="GenLink" href="modque.php?del='.$obj->id.'&'.$_RSID.'">Delete</a>]</td></tr>';
		
		$GLOBALS["returnto"] = 'returnto='.base64_encode($GLOBALS["HTTP_SERVER_VARS"]["REQUEST_URI"]);
		if ( empty($prev_thread_id) || $prev_thread_id != $obj->thread_id ) {
			$prev_thread_id = $obj->thread_id;
			open_thread_body($obj->thread_id);
		}	
		drawmsg($obj);
	}
	QF($r);
	close_thread_body();
	
	lay_end_content_table();
	if ( isset($usr) && $usr->is_mod == 'A' ) {
		fud_use('stats.inc');
		draw_stats();
	}

	include_once $GLOBALS['FORUM_SETTINGS_PATH'].'footer_'.$layout.'.inc';
?>
