<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: msg.php,v 1.31 2002/02/12 02:42:28 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/

/*#? Message Display Generator */
	include_once "GLOBALS.php";
	
	fud_use('db.inc');
	fud_use('cookies.inc');	
	fud_use('forum.inc');	
	fud_use('fileio.inc');
	fud_use('users.inc');
	fud_use('thread.inc');
	fud_use('msg.inc');
	fud_use('style.inc');
	fud_use('cat.inc');
	fud_use('drawmsg.inc');
	fud_use('forumsel.inc');
	fud_use('help.inc');
	
	check_forum_redirect();

	list($ses, $usr) = init_user();
	cache_buster();
	
	if( empty($post_form) ) $post_form=NULL;
	else $PLAIN_FORM=1;
	
	$count = !empty($usr->posts_ppg) ? $usr->posts_ppg : $GLOBALS['POSTS_PER_PAGE'];
	
	if ( !empty($goto) ) {
		if ( empty($th) ) {
			if( !is_numeric($goto) ) invl_inp_err();
			$msg = new fud_msg;
			$msg->get_by_id($goto);
			$th = $msg->thread_id;
		} 
		else if( !is_numeric($th) ) invl_inp_err();
	
		$mid = '';
		if( $goto != 'end' ) {
			if( !is_numeric($goto) ) invl_inp_err();
			$pos = Q_SINGLEVAL("SELECT count(*) FROM fud_msg WHERE thread_id=".$th." AND id<=".$goto." AND approved='Y'");
			if( empty($post_form) ) $mid = '#msg_'.$msg->id;
		}	
		else
			$pos = Q_SINGLEVAL("SELECT replies+1 FROM fud_thread WHERE id=".$th);
	
		$start = (ceil(($pos/$count))-1)*$count;
		if ( $start < 0 ) $start = 0;
		header("Location: msg.php?th=".$th."&".$_RSID."&post_form=".$post_form."&start=".$start.$mid);
		exit();
	}
	
	$frm = new fud_forum;
	
	if ( !empty($th) ) {
		if( !is_numeric($th) ) invl_inp_err();
		$thread = new fud_thread;
		$thread->get_by_id($th);
		
		$frm->get($thread->forum_id);
		
		if( !isset($usr) && $frm->anon_viewing=='N' ) error_dialog('Only registered users may view this forum', 'In order to see this forum you need to <a href="register.php?'.$_RSID.'" class="GenLink">register</a>, if you are already registered you\'ll need to <a href="login.php?'.$_RSID.'" class="GenLink">login</a>.', '');
	}
	else error_dialog('Insufficient Information','There was a problem generating this page','');		
	
	if ( empty($start) || !is_numeric($start) ) $start = 0;
	
	if( isset($usr) ) {
		if ( ($usr->is_mod == 'A' || $frm->is_moderator($usr->id)) ) $MOD = 1;
	
		if( !empty($MOD) ) {
			fud_use('msg_edt.inc');
			fud_use('msg_mod.inc');
		}	

		if ( !empty($notify) ) {
			fud_use('thread_notify.inc');
			$th_not = new fud_thread_notify;
			if ( $opt == 'on' ) 
				$th_not->add($usr->id, $th);
			else
				$th_not->delete($usr->id, $th);

			header("Location: msg.php?th=".$th."&start=".$start.'&'.$_RSID.'&rand='.get_random_value());
			exit();
		}
	
		if ( !empty($unread) ) {
			$r=Q("SELECT msg_id FROM fud_read WHERE thread_id=".$thread->id." AND user_id=".$usr->id);
			if ( IS_RESULT($r) ) {
				list($msg_id) = DB_SINGLEARR($r);
				$rr=Q("SELECT fud_msg.id FROM fud_msg WHERE thread_id=".$thread->id." AND id>".$msg_id." ORDER BY id LIMIT 1");
				if ( IS_RESULT($rr) ) {
					list($new_msg_id) = DB_SINGLEARR($rr);
					header("Location: msg.php?goto=".$new_msg_id.'&'.$_RSID);
					exit();
				}
			}
			header("Location: msg.php?th=".$th.'&goto=end&'.$_RSID);
			exit();
		}
	}	

	$TITLE_EXTRA = ': '.$frm->name.' => '.$thread->subject;

	if ( isset($ses) && empty($post_form) && $thread->hidden!='Y' ) $ses->update('Browsing thread <a class="GenLink" href="msg.php?th='.$thread->id.'">'.$thread->subject.'</a>');

	$layout = get_layout_id((isset($layout)?$layout:'')); include_once $GLOBALS['FORUM_SETTINGS_PATH'].'header_'.$layout.'.inc';

	if ( isset($frm) ) {
		if ( !isset($cat) ) {
			$cat = new fud_cat;
			$cat->get_cat($frm->cat_id);
		}
		if( empty($post_form) ) {
			if ( $frm->allow_user_vote == 'Y' && $thread->rating ) {
				$rate_img = ' (<img src="'.$GLOBALS['fud_img_suffix'].$thread->rating.'stars.gif" border=0>)';
				$opt_s = ( ($vc=$thread->vote_count()) > 1 ) ? 's' : '';
				if ( $vc ) 
					$vote_count = $vc.' Vote'.$opt_s;
				else 
					$vc = $vote_count = '';
			}
			else {
				$rate_img=$vote_count='';
			}
				
			echo '<font class="GenText"><a class="GenLink" href="'.$WWW_ROOT.'?'.$_RSID.'">'.$cat->name.'</a> &raquo; <a href="thread.php?frm_id='.$frm->id.'&'.$_RSID.'">'.$frm->name.'</a> &raquo; <b>'.$thread->subject.'</b></font>'.$rate_img.$vote_count;
		}
	}
	
	$total = $thread->replies+1;

	$tmp = '&nbsp;';
	if( empty($post_form) ) {
		?>
		<table width="100%" border=0 cellspacing=0 cellpadding=0>
		<tr>
			<td valign="bottom" align="left" width="100%">
			<?php 
				echo '<span '.url_help('show_index').'><font class="GenText"><b>Show:</b> <a class="GenLink" href="selmsg.php?date=today&th='.$th.'&'.$_RSID.'"><acronym title="Show all posts that were made today, inside this thread">Today\'s Posts</acronym></a>'.(isset($usr)?' | <a class="GenLink" href="selmsg.php?unread=1&th='.$th.'&'.$_RSID.'"><acronym title="Show all unread posts inside this thread">Unread Posts</acronym></a>':''); 
				echo create_help_anchor('show_index', 400)."</span><br>";
			
				if ( $MOD ) {
					if ( $thread->locked == 'N' ) 
						echo '<a class="GenLink" href="msg.php?lock=1&th='.$th.'&'.$_RSID.'">Lock Thread</a> | ';
					else 
						echo '<a class="GenLink" href="msg.php?unlock=1&th='.$th.'&'.$_RSID.'">Unlock Thread</a> | ';
				}	
	
				echo '<a class="GenLink" href="remail.php?th='.$th.'&'.$_RSID.'"><acronym title="Send the url to this page to your friend(s) via email">Email to friend</acronym></a> ';
				
				if ( isset($usr) ) {
					if( $total-$start > $count ) 
						echo '| <a class="GenLink" href="msg.php?unread=1&th='.$th.'&'.$_RSID.'"><acronym title="Go to the 1st unread message inside this thread">Go to unread message(s)</acronym></a> ';
	
					$r = Q("SELECT id FROM fud_thread_notify WHERE thread_id=".$th." AND user_id=".$usr->id);
					if ( !IS_RESULT($r) )
						echo '| <a class="GenLink" href="msg.php?th='.$th.'&notify='.$usr->id.'&'.$_RSID.'&opt=on&start='.$start.'"><acronym title="Recieve notification about new posts inside this thread">Subscribe to thread</acronym></a> ';
					else 
						echo '| <a class="GenLink" href="msg.php?th='.$th.'&notify='.$usr->id.'&'.$_RSID.'&opt=off&start='.$start.'"><acronym title="Stop receiving notifications about new posts in this thread">Unsubscribe from thread</acronym></a> ';
					
					if( $usr->is_mod!='N' ) {
						fud_use('admincp.inc');
						echo $admin_cp;
					} 
				}
				echo '</font>';				
			?>
			</td>
			<td align="right" class="GenText" valign="bottom" nowrap>
		<?php
			$returnto_str = base64_encode('msg.php?th='.$th.'&start='.$start.'&prevloaded=1&'.$_RSID);
			$returnto = 'returnto='.$returnto_str;
		
			echo '<a href="tree.php?th='.$th.'&'.$_RSID.'" class="GenLink"><acronym title="Switch to threaded view of this thread"><img src="'.$GLOBALS["fud_img_suffix"].'tree_view.gif" border=0 alt="Tree/Threaded View"></acronym></a>&nbsp;<a class="GenLink" href="post.php?'.$returnto.'&frm_id='.$frm->id.'&'.$_RSID.'"><img src="'.$GLOBALS["fud_img_suffix"].'new_thread.gif" alt="Create a new thread" border=0></a>';
			if ( $thread->locked == 'N' ) echo '&nbsp;<a class="GenLink" href="post.php?th_id='.$th.'&reply_to='.$thread->root_msg_id.'&'.$_RSID.'&start='.$start.'&'.$returnto.'"><img src="'.$GLOBALS["fud_img_suffix"].'post_reply.gif" border=0 alt="Post Reply"></a>';
		?>
			</td>
		</tr>
		<tr><td colspan=2><img src="blank.gif" height=1 width=1 border=0></td></tr>
		</table>
		<?php
	}	

	lay_start_content_table();

	echo '<tr><td width=1 class="TableHeading">Author</td><td class="TableHeading">Thread</td></tr>';
	
	if ( isset($thread) && empty($prevloaded) && empty($GLOBALS["post_form"]) ) {
		if ( isset($usr) ) $usr->register_forum_view($frm->id);
		$thread->inc_view_count();
	}
	
	$msg_list = Q("SELECT fud_msg.id FROM fud_msg WHERE thread_id=".$th." AND fud_msg.approved='Y' ORDER BY id ASC LIMIT ".$start.",".$count);
	$id_list='fud_msg.id IN(';
	$m_count=0;
	while ( list($msgp_id) = DB_ROWARR($msg_list) ) { $id_list .= $msgp_id.','; $m_count++; }
	QF($msg_list);
	$id_list = substr($id_list, 0, -1).')';
	
	$result = Q("SELECT 
		fud_msg.*, 
		fud_thread.locked,
		fud_thread.root_msg_id,
		fud_thread.last_post_id,
		fud_avatar.img AS avatar, 
		fud_users.id AS user_id, 
		fud_users.login, 
		fud_users.display_email, 
		fud_users.avatar_approved,
		fud_users.avatar_loc,
		fud_users.email, 
		fud_users.posted_msg_count, 
		fud_users.join_date, 
		fud_users.location, 
		fud_users.sig,
		fud_users.custom_status,
		fud_users.icq,
		fud_users.aim,
		fud_users.msnm,
		fud_users.yahoo,
		fud_level.name AS level_name,
		fud_level.pri AS level_pri,
		fud_level.img AS level_img,
		fud_ses.time_sec
	FROM 
		fud_msg 
		LEFT JOIN fud_users 
			ON fud_msg.poster_id=fud_users.id 
		LEFT JOIN fud_avatar 
			ON fud_users.avatar=fud_avatar.id 
		LEFT JOIN fud_ses
			ON fud_ses.user_id=fud_msg.poster_id
		INNER JOIN fud_thread
			ON fud_msg.thread_id=fud_thread.id
		LEFT JOIN fud_level
			ON fud_users.level_id=fud_level.id
	WHERE 
		".$id_list."
	ORDER BY id ASC");

	open_thread_body($th);
	
	$m_count--;
	
	while ( $obj = DB_ROWOBJ($result) ) {
		drawmsg($obj, $m_count, true);
		$mid = $obj->id;
	}
	QF($result);
	
	close_thread_body();
	
	if ( isset($usr) && empty($GLOBALS["post_form"]) ) $usr->register_thread_view($thread->id, $mid);
	
	lay_end_content_table();
	
	echo '<img src="blank.gif" width=1 height=3 border=0><table border=0 cellspacing=0 cellpadding=0 width="100%"><tr><td>';
	draw_pager($start, $count, $total, "msg.php?th=".$th."&prevloaded=1&post_form=".$post_form.'&'.$_RSID.'&rev='.(isset($rev)?$rev:'').'&reveal='.(isset($reveal)?$reveal:''));					

if( empty($GLOBALS["post_form"]) ) {
	echo '&nbsp;</td><td align="right" class="GenText" valign="bottom" nowrap><a href="tree.php?th='.$th.'&'.$_RSID.'" class="GenLink"><acronym title="Switch to threaded view of this thread"><img src="'.$GLOBALS["fud_img_suffix"].'tree_view.gif" border=0 alt="Tree/Threaded View"></acronym></a>&nbsp;<a class="GenLink" href="post.php?'.$returnto.'&frm_id='.$frm->id.'&'.$_RSID.'"><img src="'.$GLOBALS["fud_img_suffix"].'new_thread.gif" alt="Create a new thread" border=0></a>';
	if ( $thread->locked == 'N' ) echo '&nbsp;<a class="GenLink" href="post.php?th_id='.$th.'&reply_to='.$thread->root_msg_id.'&'.$_RSID.'&start='.$start.'&'.$returnto.'"><img src="'.$GLOBALS["fud_img_suffix"].'post_reply.gif" border=0 alt="Post Reply"></a>';
	echo '</td></tr></table>';
	
	echo '<table border=0 cellspacing=1 cellpadding=1 align="right">';

	list($pg, $ps)= DB_SINGLEARR(Q("SELECT page, pos FROM fud_thread_view WHERE forum_id=".$thread->forum_id." AND thread_id=".$thread->id));

	$r = Q('SELECT fud_thread_view.pos,fud_thread.id,fud_msg.subject FROM fud_thread_view INNER JOIN fud_thread ON fud_thread_view.thread_id=fud_thread.id INNER JOIN fud_msg ON fud_thread.root_msg_id=fud_msg.id WHERE fud_thread_view.forum_id='.$thread->forum_id.' AND fud_thread_view.page='.$pg.' AND fud_thread_view.pos IN ('.($ps-1).', '.($ps+1).') ORDER BY pos');
	switch ( DB_COUNT($r) ) 
	{
		case 2:
			$prev_th = DB_ROWOBJ($r);
			$next_th = DB_ROWOBJ($r);
			break;
		case 1:
			$prev_th = DB_ROWOBJ($r);
			if( $prev_th->pos > $ps ) {
				$next_th = $prev_th;
				if( $pg > 1 ) 
					$prev_th = DB_SINGLEOBJ(Q('SELECT fud_thread_view.pos,fud_thread.id,fud_msg.subject FROM fud_thread_view INNER JOIN fud_thread ON fud_thread_view.thread_id=fud_thread.id INNER JOIN fud_msg ON fud_thread.root_msg_id=fud_msg.id WHERE fud_thread_view.forum_id='.$thread->forum_id.' AND fud_thread_view.page='.($pg-1).' AND fud_thread_view.pos='.$GLOBALS['THREADS_PER_PAGE']));
				else
					$prev_th = NULL;	
			}
			else {
				$next_th = DB_SINGLEOBJ(Q('SELECT fud_thread_view.pos,fud_thread.id,fud_msg.subject FROM fud_thread_view INNER JOIN fud_thread ON fud_thread_view.thread_id=fud_thread.id INNER JOIN fud_msg ON fud_thread.root_msg_id=fud_msg.id WHERE fud_thread_view.forum_id='.$thread->forum_id.' AND fud_thread_view.page='.($pg+1).' AND fud_thread_view.pos=1'));
			}
		
			break;
		default:
			$prev_th = $next_th = NULL;
	}

	if ( $prev_th )
		echo '<tr><td align=right class="GenText">Previous Thread:</td><td class="GenText" align=left><a href="msg.php?th='.$prev_th->id.'&'.$_RSID.'" class="GenLink">'.$prev_th->subject.'</a></td></tr>';
	
	if ( $next_th )
		echo '<tr><td class="GenText" align=right>Next Thread:</td><td class="GenText" align=left><a class="GenLink" href="msg.php?th='.$next_th->id.'&'.$_RSID.'">'.$next_th->subject.'</a></td></tr>';
	
	echo '</table>';
		
	if ( isset($usr) && $frm->allow_user_vote=='Y' && $thread->has_thread_vote($usr->id) == -1 ) {
		echo '<table border=0 cellspacing=0 cellpadding=0><tr><form action="ratethread.php" name="vote_frm" method="post"><td nowrap>
		<select name="sel_vote" onChange="javascript: if ( !this.value ) return false; document.vote_frm.submit();">';
		echo '<option>Rate Thread';
		for ( $i=1; $i<6; $i++ ) {
			echo '<option value="'.$i.'">'.$i."\n";
		}
		echo '</select>';
		echo '</td><td>&nbsp;<input type="submit" name="btn_vote" value="Vote">
		<input type="hidden" name="returnto" value="'.$returnto_str.'">
		<input type="hidden" name="S" value="'.$S.'">
		<input type="hidden" name="rate_thread_id" value="'.$thread->id.'">
		</td></form></tr></table>';
	}
		
	$def_frm_id = $frm->id;
	draw_forum_select();
}
else echo '&nbsp;</td><td>&nbsp;</td></tr></table>';

	fud_use('curtime.inc');
		
	if ( isset($usr) && $usr->is_mod == 'A' ) {
		fud_use('stats.inc');
		draw_stats();
	}
	
	include_once $GLOBALS['FORUM_SETTINGS_PATH'].'footer_'.$layout.'.inc';
	create_help_layers();
?>