<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: report.php,v 1.6 2002/02/11 21:06:40 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/

/*#? Post Editor Page */
	include_once "GLOBALS.php";
	fud_use('db.inc');
	fud_use('cookies.inc');	
	fud_use('style.inc');
	fud_use('ipfilter.inc');
	fud_use('error.inc');
	fud_use('users.inc');
	fud_use('widgets.inc');
	
	list($ses, $usr) = init_user();
	cache_buster();
	
	$flt = new fud_ip_filter;
	$returnto_d = base64_decode($returnto);
		
	if ( empty($msg_id) ) {
		error_dialog('ERROR', 'No Such Message', $returnto_d);
		exit();
	}
	
	
	if ( isset($GLOBALS['HTTP_SERVER_VARS']['REMOTE_ADDR']) && $flt->is_blocked($GLOBALS['HTTP_SERVER_VARS']['REMOTE_ADDR']) ) {
		error_dialog('ERROR', "You aren't allowed to report to moderator", $returnto_d);
		exit();
	}
	unset($flt);
	
	$r = Q("SELECT fud_msg.*, fud_users.login FROM fud_msg LEFT JOIN fud_users ON fud_msg.poster_id=fud_users.id LEFT JOIN fud_thread ON fud_msg.thread_id=fud_thread.id WHERE fud_msg.id=".$msg_id);
	$msg = DB_SINGLEOBJ($r);

	if ( !empty($btn_report) ) {
		fud_use('msgreport.inc');
		if ( isset($usr) ) 
			$usr_id = $usr->id;
		else 
			$usr_id = 0;
		
		submit_msg_report($usr_id, $msg->id, $reason);
		check_return();
		exit();
	}

	$layout = get_layout_id((isset($layout)?$layout:'')); include_once $GLOBALS['FORUM_SETTINGS_PATH'].'header_'.$layout.'.inc';
	echo '<form method="post">
	<div align="center">';
	lay_start_content_table('MiniTable');
	
	
	echo '<tr class="TableHeading"><td>Report Post</td></tr>';
	echo '<tr class="RowStyleB"><td><font class="GenText"><b>Reporting About:</b><br><blockquote><b>Subject:</b> '.$msg->subject.' <br><b>By:</b> '.htmlspecialchars($msg->login).' <br><b>Posted on:</b> <font class="DateText">'.format_date($msg->post_stamp).' '.format_time($msg->post_stamp).'</font></blockquote></font></td></tr>';
	echo '<tr class="RowStyleB"><td><font class="GenText">Please give a reason why you are reporting this message:</font><br><textarea name="reason" cols=80 rows=25></textarea></td></tr>';
	echo '<tr class="RowStyleB"><td align=right><input type="submit" name="btn_report" value="Submit Report"></td></tr>';
	lay_end_content_table();
	echo '
	<input type="hidden" name="msg_id" value="'.$msg_id.'">
	<input type="hidden" name="S" value="'.$S.'">
	<input type="hidden" name="returnto" value="'.$returnto.'">
	</div></form>';
	include_once $GLOBALS['FORUM_SETTINGS_PATH'].'footer_'.$layout.'.inc';	
?>