<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: reported.php,v 1.11 2002/02/11 21:06:40 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/

/*#? Message Report  Page */
	include_once "GLOBALS.php";
	fud_use('db.inc');
	fud_use('cookies.inc');	
	fud_use('style.inc');
	fud_use('error.inc');
	fud_use('users.inc');
	fud_use('drawmsg.inc');
	fud_use('msgreport.inc');
	
	
	list($ses, $usr) = init_user();
	cache_buster();
	
	if ( !empty($del) ) {
		if ( !delete_msg_report($del, $usr->id) ) { std_error('access'); exit(); }
		header("Location: reported.php?".$_RSID);
		exit();
	}
	
	$layout = get_layout_id((isset($layout)?$layout:'')); include_once $GLOBALS['FORUM_SETTINGS_PATH'].'header_'.$layout.'.inc';
	
	$r=Q("SELECT 
			fud_msg.*,
			fud_thread.locked,
			fud_avatar.img AS avatar, 
			fud_users.id AS user_id, 
			fud_users.login, 
			fud_users.custom_status,
			fud_users.display_email, 
			fud_users.email, 
			fud_users.posted_msg_count, 
			fud_users.join_date, 
			fud_users.location,
			fud_users.sig,
			fud_users.icq,
			fud_users.aim,
			fud_users.msnm,
			fud_users.yahoo,
			fud_users.avatar_loc,
			fud_users.avatar_approved,
			fud_msg_report.id AS report_id,
			fud_msg_report.stamp AS report_stamp,
			fud_msg_report.reason AS report_reason,
			fud_users_r.id AS report_user_id,
			fud_users_r.login AS report_user_login,
			fud_ses.time_sec AS time_sec,
			fud_level.name AS level_name,
			fud_level.pri AS level_pri,
			fud_level.img AS level_img,
			fud_forum.name AS frm_name,
			fud_ses_r.time_sec AS time_sec_r
		FROM 
			fud_msg_report 
			LEFT JOIN fud_msg 
				ON fud_msg_report.msg_id=fud_msg.id 
			LEFT JOIN fud_users
				ON fud_msg.poster_id=fud_users.id
			LEFT JOIN fud_avatar
				ON fud_users.avatar=fud_avatar.id
			LEFT JOIN fud_thread 
				ON fud_msg.thread_id=fud_thread.id 
			LEFT JOIN fud_forum 
				ON fud_thread.forum_id=fud_forum.id 
			INNER JOIN fud_mod 
				ON fud_forum.id=fud_mod.forum_id AND fud_mod.user_id=".$usr->id."
			LEFT JOIN fud_users AS fud_users_r
				ON fud_msg_report.user_id=fud_users_r.id
			LEFT JOIN fud_ses
				ON fud_ses.user_id=fud_msg.poster_id
			LEFT JOIN fud_ses AS fud_ses_r
				ON fud_msg_report.user_id=fud_ses_r.user_id
			LEFT JOIN fud_level
				ON fud_users.level_id=fud_level.id
		ORDER BY 
			fud_msg_report.id");
	
	lay_start_content_table();
	
	$MOD = 1;
	
	echo '<tr class="TableHeading"><td colspan=2>Reported Messages</td></tr>';
	while ( $obj = DB_ROWOBJ($r) ) {
		$reporter_login = ( strlen($obj->report_user_id) ) ? '<a href="usrinfo.php?'.$_RSID.'&id='.$obj->report_user_id.'" class="GenLink">'.htmlspecialchars($obj->report_user_login).'</a>' : $GLOBALS['ANON_NICK'];
		echo '<tr class="RowStyleB"><td colspan=2>
			<table border=0 cellspacing=0 cellpadding=3 width="100%">
			<tr>
			<td align=left nowrap valign=top>
				<font class="SmallText">
				<b>Reported By:</b> '.$reporter_login.'<br>
				<b>On:</b> '.format_date($obj->report_stamp).' '.format_time($obj->report_stamp).'
				</font>
			</td>
			<td align=center width="100%" valign=top>
				<font class="SmallText">
				<b>Reason</b><br>
				<table border=1 cellspacing=1 cellpadding=0><tr>
					<td align=left>&nbsp;'.$obj->report_reason.' &nbsp;</td>
				</tr></table>
				</font>
			</td>
			<td nowrap>
				<a class="GenLink" href="reported.php?'.$_RSID.'&del='.$obj->report_id.'">[Delete Report]</a>
			</td>
			</tr>
			</table>
		</td></tr>';
		
		$GLOBALS["returnto"] = 'returnto='.base64_encode($GLOBALS["HTTP_SERVER_VARS"]["REQUEST_URI"]);
		if ( empty($prev_thread_id) || $prev_thread_id != $obj->thread_id ) {
			$prev_thread_id = $obj->thread_id;
			open_thread_body($obj->thread_id);
		}	
		drawmsg($obj);
	}
	QF($r);
	close_thread_body();
	lay_end_content_table();
	
	include_once $GLOBALS['FORUM_SETTINGS_PATH'].'footer_'.$layout.'.inc';	

?>