<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: rpasswd.php,v 1.7 2002/02/11 21:06:40 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/

	include_once "GLOBALS.php";
	
	$GLOBALS['USER_REG'] = 1;
	
	fud_use('cookies.inc');
	fud_use('users.inc');
	fud_use('style.inc');
	fud_use('widgets.inc');
	fud_use('error.inc');

	list($ses, $usr) = init_user();
	
	if ( !isset($usr) ) {
		std_error('login');
		exit();
	}
	
	if ( !empty($btn_submit) ) {
		$cpasswd = stripslashes($cpasswd);
		$passwd1 = stripslashes($passwd1);
		$passwd2 = stripslashes($passwd2);
	
		if ( $usr->id != get_id_by_radius($usr->login, $cpasswd) ) {
			$err = '<font class="ErrorText">Invalid Password</font>';
		}
		else if ( $passwd1 != $passwd2 ) {
			$err = '<font class="ErrorText">Passwords do not match</font>';
		}
		else if ( strlen($passwd1) < 6 ) {
			$err = '<font class="ErrorText">Password must be at least 6 characters long</font>';
		}
		else {
			$usr->ch_passwd($passwd1);
			echo '<html><script>window.close();</script></html>';
			exit;
		}
	}
	
	$GLOBALS['PLAIN_FORM'] = 1;
	$TITLE_EXTRA = ': Reset';
	$layout = get_layout_id((isset($layout)?$layout:'')); include_once $GLOBALS['FORUM_SETTINGS_PATH'].'header_'.$layout.'.inc';

	echo '<div align="center"><br>';
	if ( !empty($err) ) echo $err.'<br>';

	lay_start_content_table('MiniTable');
	echo '<form method="post">';
	echo '<tr class="TableHeading"><td colspan=2>Change Password</td></tr>';
	echo '<tr class="RowStyleB"><td>Login</td><td>'.htmlspecialchars($usr->login).'</td></tr>';
	echo '<tr class="RowStyleB"><td>Current Password:</td><td><input type="password" name="cpasswd" value=""></td></tr>';
	echo '<tr class="RowStyleB"><td>New Password:</td><td><input type="password" name="passwd1" value=""></td></tr>';
	echo '<tr class="RowStyleB"><td>Confirm Password:</td><td><input type="password" name="passwd2" value=""></td></tr>';
	echo '<tr class="RowStyleB"><td align=right colspan=2><input type="submit" value="GO" name="btn_submit"></td></tr>';
	echo '<input type="hidden" name="returnto" value="'.(empty($returnto)?'':$returnto).'">';
	echo '<input type="hidden" name="S" value="'.$S.'"></form>';	
	lay_end_content_table();
	echo '</div>';
	
	include_once $GLOBALS['FORUM_SETTINGS_PATH'].'footer_'.$layout.'.inc';	
?>
