<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: search.php,v 1.12 2002/02/11 21:06:40 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/

	include_once "GLOBALS.php";
	fud_use('search.inc');
	fud_use('widgets.inc');
	fud_use('style.inc');
	fud_use('users.inc');
	fud_use('error.inc');
	fud_use('rev_fmt.inc');
	
	list($ses,$usr) = init_user();
	cache_buster();
	
	if( $GLOBALS['FORUM_SEARCH'] != 'Y' ) std_error('disabled');
	
	if ( empty($start) ) $start = 0;
	$ppg = ( !empty($usr->posts_ppg) )?$usr->posts_ppg:$GLOBALS['POSTS_PER_PAGE'];
	
	$field = ( !empty($field) ) ? trim($field) : 'all';
	if( empty($forum_limiter) ) $forum_limiter = NULL;

	if( empty($srch) ) 
		$srch = $r = '';
	else
		$r = search($srch, $field, $start, $ppg, $forum_limiter);
	
	set_row_color_alt(true);

	$TITLE_EXTRA = ': Search For: '.FMT($srch);
	if ( isset($ses) ) $ses->update('Searching posts');
	$layout = get_layout_id((isset($layout)?$layout:'')); include_once $GLOBALS['FORUM_SETTINGS_PATH'].'header_'.$layout.'.inc';

	lay_start_content_table();
	
	echo '<tr class="TableHeading"><td colspan=2 width="100%">Forum Search</td></tr>';
	echo '<form method="post" action="search.php"><input type="hidden" name="S" value="'.$S.'">';	
	echo '<tr'.ROW_BGCOLOR().'><td class="GenText">Search for:</td><td><input type="text" name="srch" value="'.FMT($srch).'"></td></tr>';
	echo '<tr'.ROW_BGCOLOR().'><td class="GenText">&nbsp;</td><td>'.create_radio_buttons('field', "Entire Message\nSubject Only", "all\nsubject", $field, false).'</td></tr>';
	echo '<tr'.ROW_BGCOLOR().'><td class="GenText">Search in Forum:</td><td>'.src_forum_sel($forum_limiter).'</td></tr>';
	echo '<tr'.ROW_BGCOLOR().'><td class="GenText" colspan=2><input type="submit" name="btn_submit" value="Search"></td></tr>';
	echo '</form>';

	if ( !empty($srch) ) {
		echo '<tr class="TableHeading"><td colspan=2 width="100%">Results</td></tr>';
		
		$i = 0;
		if ( !($total=DB_COUNT($r)) )
			echo '<tr class="RowStyleA"><td colspan=2 width="100%" class="GenText">No Results</td></tr>';
		else {
			$res_found = 1;
			echo '<tr'.ROW_BGCOLOR().'><td colspan=2>';
			lay_start_content_table();
			echo '<tr class="TableHeading"><td width="100%">Subject</td><td>Forum</td><td>Posted On</td></tr>';
		}
		
		if( $start && $start<DB_COUNT($r) ) DB_SEEK($r,$start);
		
		$z=$prev_thread_id=0;
		while ( ($obj = DB_ROWOBJ($r)) && $z<$ppg ) {
			if ( $obj->thread_id != $prev_thread_id ) open_thread_body($obj->thread_id);
			
			$body = strip_tags(read_ext_body($obj->offset, $obj->length));
			if( strlen($body) > 80 ) $body = substr($body,0,80).'...';
			
			if ( !strlen($obj->login) ) {
				$poster_info = trim_show_len($GLOBALS['ANON_NICK'],'LOGIN');
			}
			else {
				$poster_info = '<a class="GenLink" href="usrinfo.php?id='.$obj->poster_id.'&'.$_RSID.'">'.htmlspecialchars(trim_show_len($obj->login,'LOGIN')).'</a>';
			}
			echo '<tr class="RowStyle'.(($i%2)?'A':'B').'"><td class="GenText" width="100%">'.++$i.'. <a class="GenLink" href="'.$GLOBALS['D_THREAD_VIEW'].'.php?goto='.$obj->id.'&'.$_RSID.'">'.$obj->subject.'</a><br>'.$body.'</td><td class="GenText" nowrap><a class="GenLink" href="thread.php?frm_id='.$obj->forum_id.'&'.$_RSID.'">'.$obj->forum_name.'</a></td><td class="GenText" nowrap><font class="DateText">'.format_date($obj->post_stamp).' '.format_time($obj->post_stamp).'</font> by: '.$poster_info.'</td></tr>';
			$z++;
		}
		close_thread_body();
		
		if ( !empty($res_found) ) {
			lay_end_content_table();
			echo '</td></tr>';
		}
		
		QF($r);
	}
	
	lay_end_content_table();
	draw_pager($start, $ppg, $total, 'search.php?btn_submit=1&srch='.urlencode($srch).'&field='.urlencode($field).'&'.$_RSID.'&forum_limiter='.$forum_limiter);
	
	if ( isset($usr) && $usr->is_mod == 'A' ) {
		fud_use('stats.inc');
		draw_stats();
	}
	
	fud_use('curtime.inc');
	include_once $GLOBALS['FORUM_SETTINGS_PATH'].'footer_'.$layout.'.inc';
?>