<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: selmsg.php,v 1.19 2002/02/11 21:06:40 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/

/*#? Message Display Page */
	include_once "GLOBALS.php";
	fud_use('db.inc');
	fud_use('cookies.inc');	
	fud_use('forum.inc');	
	fud_use('fileio.inc');
	fud_use('users.inc');
	fud_use('thread.inc');
	fud_use('msg.inc');
	fud_use('style.inc');
	fud_use('cat.inc');
	fud_use('drawmsg.inc');

function ifstr($opt1, $opt2, $str)
{	
	return ( strlen($str) ) ? $opt1 : $opt2;
}
	
	list($ses, $usr) = init_user();
	cache_buster();	
	if ( isset($ses) ) $ses->update('Browsing <a class="GenLink" href="selmsg.php?date=today&rid='.$usr->id.'">Today\'s Posts</a>');
	
	if ( !isset($usr) && empty($count) ) 
		$count = $POSTS_PER_PAGE;
	else if ( isset($usr) ) 
		$count = ($usr->posts_ppg)?$usr->posts_ppg:$GLOBALS['POSTS_PER_PAGE'];

	if ( !isset($start) ) $start = 0;
		
	if ( ((isset($reply_count)&&!strlen($reply_count))||!isset($reply_count)) && empty($date) && empty($unread) && empty($sub_forums) && empty($sub_threads) ) {
		$date = 'today';
	}	
	
	if( isset($unread) && !strlen($unread) ) $unread='';
	if( isset($reply_count) && !strlen($reply_count) ) $reply_count='';
	if( isset($date) && !strlen($date) ) $date = '';
	if( isset($unread_join) && !strlen($unread_join) ) $unread_join = '';
	if( isset($frm_id) && !strlen($frm_id) ) $frm_id='';
	if( isset($th) && !strlen($th) ) $th='';
	
	/* figure out the query */

	$tm = time();
	$day = date('d', $tm);
	$month = date ('m', $tm);
	$year = date('Y', $tm);
	$tm_today_start = mktime(0, 0, 0, $month, $day, $year);
	$tm_today_end = mktime(24, 59, 59, $month, $day, $year);
	
	$reply_lmt=$thread_lmt=$forum_lmt='';
	
	if ( isset($frm_id) && strlen($frm_id) ) $forum_lmt = 'AND fud_forum.id='.$frm_id.' ';
	if ( isset($th) && strlen($th) ) $thread_lmt = 'AND fud_thread.id='.$th.' ';
	if ( isset($reply_count) && strlen($reply_count) ) $reply_lmt = ' AND fud_thread.replies='.$reply_count.' ';
	
	$unread_where='';
	if ( isset($unread) && strlen($unread) && isset($usr) ) {
		$unread_join = 'LEFT JOIN fud_read ON fud_read.user_id='.$usr->id.' AND fud_read.thread_id=fud_msg.thread_id';
		
		if( isset($usr) && $usr->last_read ) 
			$unread_where = ' AND fud_msg.post_stamp>'.$usr->last_read;
		$unread_where .= ' AND (fud_read.msg_id<fud_msg.id OR fud_read.msg_id IS NULL)';
	}
	
	$date_limit = '';
	if ( isset($date) && $date=='today' ) {
		$date_limit = "
			AND fud_msg.post_stamp>".$tm_today_start."
			AND fud_msg.post_stamp<".$tm_today_end;
	}
	
	
	if ( isset($usr) ) {
		if ( !empty($sub_threads) ) {
			$sub_thread_join = 'INNER JOIN fud_thread_notify
						ON fud_thread_notify.thread_id=fud_thread.id AND fud_thread_notify.user_id='.$usr->id;
		}
		
		if ( !empty($sub_forums) ) {
			$sub_forum_join = 'INNER JOIN fud_forum_notify
						ON fud_forum_notify.forum_id=fud_forum.id AND fud_forum_notify.user_id='.$usr->id;
		}
	}
	
	if ( !empty($last_id) && !empty($mark_page_read) ) {
		$id_limit = ' AND fud_msg.id<='.$last_id;
	}
	
	$anon = ( !isset($usr) ) ? " fud_forum.anon_viewing!='N' AND " : '';
	$total = Q_SINGLEVAL("SELECT
			count(*)
		FROM
			fud_msg
			INNER JOIN fud_thread
				ON fud_msg.thread_id=fud_thread.id
			INNER JOIN fud_forum
				ON fud_thread.forum_id=fud_forum.id
			INNER JOIN fud_cat
				ON fud_forum.cat_id=fud_cat.id
			".$sub_forum_join."
			".$sub_thread_join."
			".$unread_join."
		WHERE
			".$anon."
			fud_forum.hidden='N' AND 
			fud_cat.hidden='N' AND
			fud_msg.approved='Y'
			".$forum_lmt."
			".$thread_lmt."
			".$reply_lmt."
			".$unread_where."
			".$date_limit."
			".(isset($id_limit)?$id_limit:'')."
	ORDER BY 
		fud_forum.last_post_id,
		fud_thread.last_post_id, 
		fud_msg.post_stamp
	");

	$rid = Q("SELECT 
			fud_msg.id 
		FROM
			fud_msg
			INNER JOIN fud_thread
				ON fud_msg.thread_id=fud_thread.id
			INNER JOIN fud_forum
				ON fud_thread.forum_id=fud_forum.id
			INNER JOIN fud_cat
				ON fud_forum.cat_id=fud_cat.id
			".$sub_forum_join."
			".$sub_thread_join."
			".$unread_join."
		WHERE
			".$anon."
			fud_forum.hidden='N' AND 
			fud_cat.hidden='N' AND
			fud_msg.approved='Y'
			".$forum_lmt."
			".$thread_lmt."
			".$reply_lmt."
			".$unread_where."
			".$date_limit."
			".(isset($id_limit)?$id_limit:'')."
	ORDER BY 
		fud_forum.last_post_id,
		fud_thread.last_post_id, 
		fud_msg.post_stamp
	LIMIT $start,$count");
	
	
	if( DB_COUNT($rid) ) {
		$id_list='fud_msg.id IN(';
		$m_count=0;
		while ( list($msgp_id) = DB_ROWARR($rid) ) { $id_list .= $msgp_id.','; $m_count++; }
		QF($rid);
		$id_list = substr($id_list, 0, -1).')';
	
		$r = Q("SELECT 
			fud_msg.*, 
			fud_forum.id AS frm_id,
			fud_thread.last_post_id,
			fud_thread.id AS th_id,
			fud_thread.locked AS locked,
			fud_users.id AS user_id, 
			fud_users.login AS login,
			fud_users.display_email,
			fud_users.custom_status,
			fud_users.email, 
			fud_users.posted_msg_count, 
			fud_users.join_date, 
			fud_users.location,
			fud_users.avatar_approved,
			fud_users.avatar_loc,
			fud_users.sig,
			fud_users.icq,
			fud_users.aim,
			fud_users.msnm,
			fud_users.yahoo,
			fud_forum.name AS frm_name, 
			fud_msg_thread.subject AS thr_subject,
			fud_avatar.img AS avatar,
			fud_level.name AS level_name,
			fud_level.pri AS level_pri,
			fud_level.img AS level_img,
			fud_ses.time_sec
		FROM
			fud_msg 
			INNER JOIN fud_thread 
				ON fud_msg.thread_id=fud_thread.id
			INNER JOIN fud_forum 
				ON fud_forum.id=fud_thread.forum_id 
			INNER JOIN fud_cat
				ON fud_forum.cat_id=fud_cat.id	
			INNER JOIN fud_msg AS fud_msg_thread 
				ON fud_msg_thread.id=fud_thread.root_msg_id 
			LEFT JOIN fud_users 
				ON fud_msg.poster_id=fud_users.id 
			LEFT JOIN fud_ses
				ON fud_ses.user_id=fud_msg.poster_id
			LEFT JOIN fud_avatar
				ON fud_users.avatar=fud_avatar.id
			LEFT JOIN fud_level
				ON fud_users.level_id=fud_level.id
			WHERE
				".$id_list);
	}
	else $r = $rid;	

	$url_param = $_RSID.'&unread='.(isset($unread)?$unread:'').'&reply_count='.$reply_count.'&date='.(isset($date)?$date:'').'&frm_id='.(isset($frm_id)?$frm_id:'').'&th='.(isset($th)?$th:'').'&rand='.get_random_value();
	
	if ( !empty($mark_page_read) && isset($usr) ) {
		while ( $obj = DB_ROWOBJ($r) ) {
			if ( $dth_id != $obj->th_id ) { 
				if ( $dth_id && $msg_id ) $usr->register_thread_view($dth_id, $msg_id);
				if ( $p_frm_id ) $usr->register_forum_view($p_frm_id);
			}
			$dth_id = $obj->th_id;
			$msg_id = $obj->id;
			$p_frm_id = $obj->frm_id;
		}
		
		if ( $dth_id != $obj->th_id ) { 
			if ( $dth_id && $msg_id ) $usr->register_thread_view($dth_id, $msg_id);
			if ( $p_frm_id ) $usr->register_forum_view($p_frm_id);
		}
		
		header('Location: selmsg.php?'.$url_param);
		exit();
	}
	$dth_id='';
	
	$layout = get_layout_id($layout); include_once $GLOBALS['FORUM_SETTINGS_PATH'].'header_'.$layout.'.inc';
	
	$f_on = '<font style="font-size: xx-small; font-weight: bold; text-decoration: none;">(<font color="red">ON</font>)</font>';
	$f_off = '<font style="font-size: xx-small; font-weight: bold; text-decoration: none;">(OFF)</font>';
	
	if ( !empty($date) && $date == 'today' ) {
		$dt_opt = '';
		$dt_cap = '<aronym title="Disable limiter, which limits the messages viewed to those posted today only">Today\'s Posts '.$f_on.'</acronym>';
	}
	else {
		$dt_opt = 'today';
		$dt_cap = '<aronym title="Enable the limiter, which limits the messages viewed to those posted today only">Today\'s Posts '.$f_off.'</acronym>';
	}
	
	if ( !empty($unread) && strlen($unread) ) {
		$un_opt = '';
		$un_cap = '<acronym title="Disable limiter, which limits the messages shown to those you have not yet read">Unread Messages '.$f_on.'</acronym>';
	}
	else {
		$un_opt = '1';
		$un_cap = '<acronym title="Limit the messages shown to those you have not yet read">Unread Messages '.$f_off.'</acronym>';
	}
	
	if ( isset($reply_count) && strlen($reply_count) ) {
		$rp_opt = '';
		$rp_cap = '<acronym title="Disable limiter, which limits the messages to those that have no replies">Unanswered Posts '.$f_on.'</acronym>';
	}
	else {
		$rp_opt = '0';
		$rp_cap = '<acronym title="Limit the messages shown to those that have no replies">Unanswered Posts '.$f_off.'</acronym>';
	}
	
	if ( !empty($sub_forums) && isset($usr) ) {
		$frm_opt = '';
		$frm_cap = '<acronym title="Remove the subscribed to forums limiter">Subscribed Forums '.$f_on.'</acronym>';
	}
	else if ( isset($usr) ) {
		$frm_opt = '1';
		$frm_cap = '<acronym title="Only show messages from forums that you are subscribed to">Subscribed Forums '.$f_off.'</acronym>';
	}
	
	if ( $sub_threads && isset($usr) ) {
		$th_opt = '';
		$th_cap = '<acronym title="Remove the subscribed threads limiter">Subscribed Threads '.$f_on.'</acronym>';
	}
	else if ( isset($usr) ) {
		$th_opt = '1';
		$th_cap = '<acronym title="Only show messages from threads that you are subscribed to">Subscribed Threads '.$f_off.'</acronym>';
	}	
	
	$admin_cp=NULL;
	if ( isset($usr) && !empty($usr->is_mod) ) fud_use('admincp.inc');
	
	echo '<a class="GenLink" href="selmsg.php?date='.$dt_opt.'&unread='.$unread.'&reply_count='.$reply_count.'&sub_forums='.$sub_forums.'&sub_threads='.$sub_threads.'&'.$_RSID.'">'.$dt_cap.'</a>';
	if ( isset($usr) ) {
		echo ' | <a class="GenLink" href="selmsg.php?date='.$date.'&unread='.$un_opt.'&reply_count='.$reply_count.'&sub_forums='.$sub_forums.'&sub_threads='.$sub_threads.'&'.$_RSID.'">'.$un_cap.'</a>';
		echo ' | <a class="GenLink" href="selmsg.php?date='.$date.'&unread='.$unread.'&reply_count='.$reply_count.'&sub_forums='.$frm_opt.'&sub_threads='.$sub_threads.'&'.$_RSID.'">'.$frm_cap.'</a>';
		echo ' | <a class="GenLink" href="selmsg.php?date='.$date.'&unread='.$unread.'&reply_count='.$reply_count.'&sub_forums='.$sub_forums.'&sub_threads='.$th_opt.'&'.$_RSID.'">'.$th_cap.'</a>';
	}
	
	echo 	' | <a class="GenLink" href="selmsg.php?date='.$date.'&unread='.$unread.'&reply_count='.$rp_opt.'&sub_forums='.$sub_forums.'&sub_threads='.$sub_threads.'&'.$_RSID.'">'.$rp_cap.'</a>
		'.$admin_cp;
		
	echo	'<br><img src="blank.gif" height=2 border=0><br>';

	echo 'You are viewing: ';
	$str = NULL;
	if ( $date ) $str = 'Posts made <font style="color:red; font-weight: bold;">today</font>';
	if ( $unread ) $str .= ifstr(', you <font style="color:red; font-weight: bold;">have not yet read</font>', '<font style="color:red; font-weight: bold;">Unread</font> Posts', $str);
	if ( $sub_forums ) $str .= ifstr(', from the forums you <font style="color:red; font-weight: bold;">subscribe</font>', 'Posts from <font style="color:red; font-weight: bold;">subscribed forums</font> only', $str);
	if ( $sub_threads ) $str .= ifstr(',  and from <font style="color:red; font-weight: bold;"> threads which you subscribe</font>', 'Posts from <font style="color:red; font-weight: bold;">threads that you subscribe to', 'Posts from <font style="color:red; font-weight: bold;">subscribed threads</font> only', $str);
	if ( isset($reply_count) && strlen($reply_count) ) $str .= ifstr(', which <font style="color:red; font-weight: bold;">have no replies</font>', 'Posts which <font style="color:red; font-weight: bold;">have no replies</font>', $str);
	echo $str;
	
	lay_start_content_table();
	if ( $unread && $total ) {
		$LAST_ID=NULL;
		while ( $obj = DB_ROWOBJ($r) ) {
			if ( $LAST_ID < $obj->id ) $LAST_ID = $obj->id;
		}
		DB_SEEK($r, 0);
		$LAST_ID = 'last_id='.$LAST_ID;
		echo '<div align="center" class="GenText">[<a href="selmsg.php?mark_page_read=1&'.$LAST_ID.'&'.$url_param.'" class="GenLink"><acronym title="Show more unread messages and mark the currently viewable messages read">more unread messages</acronym></a>]</div><img src="blank.gif" height=3 border=0>';
	}
	
	if ( ($m_count = DB_COUNT($r)) ) {
		$m_count--;
		$dfrm_id ='';
		while ( $obj = DB_ROWOBJ($r) ) {
			if ( $dfrm_id != $obj->frm_id ) { 
				if( isset($usr) ) {
					unset($frm);
					$frm = new fud_forum;
					$frm->id = $obj->frm_id;
					unset($MOD);
					if ( $frm->is_moderator($usr->id) || $usr->is_mod == 'A' ) $MOD = 1;
				}	
				
				echo '<tr class="TableHeading"><td colspan=2><b>Forum:</b> <a class="TableHeading" href="thread.php?frm_id='.$obj->frm_id.'&'.$_RSID.'"><font style="font-size: 12px;">'.$obj->frm_name.'</font></a></td></tr>'; 
				$dfrm_id = $obj->frm_id; 
			}
			
			if ( $dth_id != $obj->th_id ) { 
				open_thread_body($obj->th_id);
				
				if( isset($usr) ) {
					unset($thread);
					$thread = new fud_thread;
					$thread->id = $obj->th_id;
					$thread->locked = $obj->locked;
					$thread->inc_view_count();
				}
				
				echo '<tr class="TableHeading"><td colspan=2>&nbsp;<b>Thread:</b> <a class="TableHeading" href="'.$GLOBALS['D_THREAD_VIEW'].'.php?goto='.$obj->id.'&'.$_RSID.'">'.$obj->thr_subject.'</a></td></tr>'; 
				$dth_id = $obj->th_id; 
			}
			
			$GLOBALS["returnto"] = 'returnto='.base64_encode($GLOBALS["HTTP_SERVER_VARS"]["REQUEST_URI"]);
			drawmsg($obj, $m_count);			
			$msg_id = $obj->id;
			$p_frm_id = $obj->frm_id;
		}
		close_thread_body();
	}
	else {
		echo '<tr class="TableHeading"><td class="TableHeading" align=middle>No Posts</td></tr>';
	}
	lay_end_content_table();	

	if( empty($unread) ) 
		draw_pager($start, $count, $total, "selmsg.php?date=".$date."&unread=".$unread."&".$_RSID."&frm_id=".$frm_id."&th=".$th."&reply_count=".$reply_count);
	else if( $unread && $total ) 
		echo '<img src="blank.gif" height=3 border=0><div align="center" class="GenText">[<a class="GenLink" href="selmsg.php?mark_page_read=1&'.$LAST_ID.'&'.$url_param.'"><acronym title="Show more unread messages and mark the currently viewable messages read">more unread messages</acronym></a>]</div>';
	else if ( isset($usr) && empty($sub_threads) && empty($sub_forums) && empty($date) && $reply_count!=='0' ) 
		$usr->mark_all_read();

	if ( isset($usr) && $usr->is_mod == 'A' ) {
		fud_use('stats.inc');
		draw_stats();
	}
	
	fud_use('curtime.inc');
	include_once $GLOBALS['FORUM_SETTINGS_PATH'].'footer_'.$layout.'.inc';
?>