<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: showposts.php,v 1.12 2002/02/11 21:06:40 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/

	include_once "GLOBALS.php";
	fud_use('db.inc');
	fud_use('cookies.inc');	
	fud_use('style.inc');
	fud_use('users.inc');
	
	list($ses, $usr) = init_user();
	if ( isset($ses) ) $ses->update('Viewing Posts by "'.htmlspecialchars($u->login).'"');
	
	$u = new fud_user();
	$u->get_user_by_id($id);
	
	$TITLE_EXTRA = ': Show Posts by: '.htmlspecialchars($u->login);

	if ( isset($ses) ) $ses->update('Viewing posts by: <a class="GenLink" href="usrinfo.php?id='.$u->id.'">'.htmlspecialchars($u->login).'</a>');

	$layout = get_layout_id($layout); include_once $GLOBALS['FORUM_SETTINGS_PATH'].'header_'.$layout.'.inc';
	
	lay_start_content_table();
	
	if ( empty($start) ) $start = 0;
	if ( empty($count) ) $count = $THREADS_PER_PAGE;
	
	echo '<tr class="TableHeading"><td colspan=3 class="TableHeading">User Information</td></tr>';
	echo '<tr class="RowStyleA"><td class="GenText" width="100%">Login: <a class="GenLink" href="usrinfo.php?id='.$u->id.'&'.$_RSID.'">'.htmlspecialchars($u->login).'</a></td><td class="GenText" nowrap>Registered On '.format_date($u->join_date).'</td><td class="GenText" nowrap>Post Count '.$u->posted_msg_count.'</td></tr>';
	
	echo '<tr class="TableHeading"><td class="TableHeading">Subject</td><td class="TableHeading">Forum</td><td class="TableHeading">Date Posted</td></tr>';
		
	$anon = ( !isset($usr) ) ? " fud_forum.anon_viewing!='N' AND " : '';

	$total = Q_SINGLEVAL("SELECT count(*) FROM fud_msg LEFT JOIN fud_thread ON fud_msg.thread_id=fud_thread.id LEFT JOIN fud_forum ON fud_thread.forum_id=fud_forum.id LEFT JOIN fud_cat ON fud_forum.cat_id=fud_cat.id WHERE ".$anon." fud_cat.hidden='N' AND fud_forum.hidden='N' AND fud_msg.approved='Y' AND fud_msg.poster_id=".$id." ORDER BY fud_msg.id");
	
	$r = Q("SELECT fud_thread.id AS th_id, fud_forum.name AS forum_name, fud_forum.id as fid, fud_msg.subject AS subject, fud_msg.id AS id, fud_msg.post_stamp AS post_stamp FROM fud_msg LEFT JOIN fud_thread ON fud_msg.thread_id=fud_thread.id LEFT JOIN fud_forum ON fud_thread.forum_id=fud_forum.id LEFT JOIN fud_cat ON fud_forum.cat_id=fud_cat.id WHERE ".$anon." fud_cat.hidden='N' AND fud_forum.hidden='N' AND fud_msg.approved='Y' AND fud_msg.poster_id=".$id." ORDER BY fud_msg.id DESC LIMIT ".$start.",".$count);
	
	set_row_color_alt(true);
	
	while ( $obj = DB_ROWOBJ($r) ) {
		echo '<tr'.ROW_BGCOLOR().'><td class="GenText"><a class="GenLink" href="'.$GLOBALS['D_THREAD_VIEW'].'.php?goto='.$obj->id.'&'.$_RSID.'">'.$obj->subject.'</a></td><td class="GenText" nowrap><a href="thread.php?frm_id='.$obj->fid.'&'.$_RSID.'" class="GenLink">'.$obj->forum_name.'</a></td><td class="DateText" nowrap>'.format_date($obj->post_stamp).' '.format_time($obj->post_stamp).'</td></tr>';
	}
	QF($r);
	
	lay_end_content_table();
	
	draw_pager($start, $count, $total, 'showposts.php?id='.$id.'&start='.$start.'&'.$_RSID);
	
	if ( isset($usr) && $usr->is_mod == 'A' ) {
		fud_use('stats.inc');
		draw_stats();
	}
	fud_use('curtime.inc');
	include_once $GLOBALS['FORUM_SETTINGS_PATH'].'footer_'.$layout.'.inc';
?>