<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: thread.php,v 1.20 2002/02/11 21:06:40 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/

	include_once "GLOBALS.php";
	fud_use('db.inc');
	fud_use('cookies.inc');	
	fud_use('forum.inc');
	fud_use('users.inc');
	fud_use('announce.inc');
	fud_use('util.inc');
	fud_use('time.inc');
	fud_use('style.inc');
	fud_use('cat.inc');
	fud_use('thread.inc');
	fud_use('forumsel.inc');
	fud_use('help.inc');
	
	check_forum_redirect();
	
	if( empty($frm_id) || !is_numeric($frm_id) ) invl_inp_err();
	
	$frm = new fud_forum;
	$frm->get($frm_id);
	
	list($ses, $usr) = init_user();
	cache_buster();
	
	if( !isset($usr) && $frm->anon_viewing=='N' ) error_dialog('Only registered users may view this forum', 'In order to see this forum you need to <a href="register.php?'.$_RSID.'" class="GenLink">register</a>, if you are already registered you\'ll need to <a href="login.php?'.$_RSID.'" class="GenLink">login</a>.', '');
	
	if ( isset($ses) && $frm->hidden!='Y' && $frm->cat_hidden!='Y' ) $ses->update('Browsing forum <a class="GenLink" href="thread.php?frm_id='.$frm->id.'">'.$frm->name.'</a>');

	if ( isset($usr) ) {
		if ( $frm->is_moderator($usr->id) || $usr->is_mod == 'A' ) $MOD = 1;
		$ppg = $usr->posts_ppg;
		
		fud_use('forum_notify.inc');
		$frm_not = new fud_forum_notify;
		
		if ( isset($sub) && $sub ) 
			$frm_not->add($usr->id, $frm->id);
		else if ( isset($unsub) && $unsub ) 
			$frm_not->delete($usr->id, $frm->id);
	}
	
	if ( $MOD ) {
		fud_use('msg.inc');
		fud_use('widgets.inc');
		fud_use('msg_edt.inc');
	}
		
	if ( strlen($frm->name) ) $TITLE_EXTRA = ': '.$frm->name;

	$layout = get_layout_id((isset($layout)?$layout:'')); include_once $GLOBALS['FORUM_SETTINGS_PATH'].'header_'.$layout.'.inc';
	
	if ( !isset($cat) ) {
		$cat = new fud_cat;
		$cat->get_cat($frm->cat_id);
	}
	
	echo '<a class="GenLink" href="'.$WWW_ROOT.'?'.$_RSID.'">'.$cat->name.'</a><font class="GenText"> &raquo; <b>'.$frm->name.'</b></font>';
	
	$returnto = 'returnto='.base64_encode("thread.php?frm_id=".$frm_id.'&'.$_RSID);

	echo '<table width="100%" border=0 cellspacing=0 cellpadding=0><tr><td valign="bottom" align="left" width="100%">';
	echo '<span '.url_help('show_index').'><font class="GenText"><b>Show:</b> </font><a class="GenLink" href="selmsg.php?date=today&frm_id='.$frm_id.'&'.$_RSID.'"><acronym title="Show all posts that were made today, inside this forum">Today\'s Posts</acronym></a> |'.(isset($usr)?' <a class="GenLink" href="selmsg.php?unread=1&frm_id='.$frm_id.'&'.$_RSID.'"><acronym title="Show all unread messages in this forum">Unread Posts</acronym></a> |':'').' <a class="GenLink" href="selmsg.php?reply_count=0&frm_id='.$frm_id.'&'.$_RSID.'"><acronym title="Show all threads in this forum, which have no replies">Unanswered Posts</acronym></a>'.create_help_anchor('show_index', 400).'</span>';
	
	if ( isset($usr) ) {
		echo '<br>';
		
		if( !isset($start) ) $start='';
		if( !isset($count) ) $count='';
		
		if ( is_forum_notified($usr->id, $frm->id) ) 
			echo '<a class="GenLink" href="thread.php?unsub=1&frm_id='.$frm_id.'&start='.$start.'&count='.$count.'&'.$_RSID.'"><acronym title="Stop receiving notifications about new threads in the forum">Unsubscribe</acronym></a>';
		else 
			echo '<a class="GenLink" href="thread.php?sub=1&frm_id='.$frm_id.'&start='.$start.'&count='.$count.'&'.$_RSID.'"><acronym title="Recieve notifications when someone creates a new thread in this forum">Subscribe</acronym></a>';

		if ( $usr->is_mod!='N' ) { 
			fud_use('admincp.inc');
			echo $admin_cp;
		}
	}

	echo '</td><td valign="bottom" align="right" class="GenText"><a class="GenLink" href="post.php?'.$returnto.'&frm_id='.$frm_id.'&'.$_RSID.'"><img src="'.$GLOBALS["fud_img_suffix"].'new_thread.gif" alt="Create a new thread" border=0></a></td></tr></table><img src="blank.gif" height=2 border=0>';

	require('announcement.php');
	
	if ( empty($start) ) $start = 0;
	if ( empty($ppg) ) $ppg = $THREADS_PER_PAGE;

	if( isset($usr) ) {
		$lread_s = ' fud_read.last_view AS last_thread_view, ';
		$lread_f = ' LEFT JOIN fud_read ON fud_read.thread_id=fud_thread.id AND fud_read.user_id='.$usr->id.' ';
	}else $lread_s=$lread_f='';

	$result = Q("SELECT 
			fud_thread.*, 
			".$lread_s."
			fud_msg.attach_cnt, 
			fud_msg.poll_id, 
			fud_msg.subject, 
			fud_users.login, 
			fud_users.id AS starter_id, 
			fud_msg.icon AS th_icon,
			fud_users_2.id AS last_poster_id,
			fud_users_2.login AS last_poster_login,
			fud_msg_2.id AS last_post_id,
			fud_msg_2.post_stamp AS last_post_stamp,
			fud_msg.post_stamp AS creation_date
		FROM 
			fud_thread_view
			INNER JOIN fud_thread
				ON fud_thread_view.thread_id=fud_thread.id
			LEFT JOIN fud_msg 
				ON fud_thread.root_msg_id=fud_msg.id
			LEFT JOIN fud_users
				ON fud_users.id = fud_msg.poster_id
			LEFT JOIN fud_msg AS fud_msg_2
				ON fud_msg_2.id=fud_thread.last_post_id
			LEFT JOIN fud_users AS fud_users_2
				ON fud_users_2.id=fud_msg_2.poster_id
			".$lread_f."
		WHERE
			fud_thread_view.forum_id=".$frm->id." AND fud_thread_view.page=".(floor($start/$ppg)+1)." 
		ORDER BY fud_thread_view.pos ASC");
	
	if ( !DB_COUNT($result) ) {
		echo '<font class="GenText">There are no messages in this forum.</font>';
	}
	else {

lay_start_content_table(); 
?>
	<tr class="TableHeading">
	<td>&nbsp;</td>
	<td>&nbsp;</td>
	<td width="100%">Thread</td>
	<td width=1>Replies</td>
	<td width=1>Views</td>
	<td align="center">Rating</td>
	<td nowrap>Last Post</td>
	<td nowrap>Started On</td>
<?php	
	if ( $MOD ) echo '<td nowrap>Moderator Options</td>';
	echo '</tr>';
	
	$POSTS_PER_PAGE = ($usr->posts_ppg)?$usr->posts_ppg:$GLOBALS['POSTS_PER_PAGE'];
	
	while ( $obj = DB_ROWOBJ($result) ) {
		$pager=$special=$n_read=$img_pic=NULL;
		
		$msg_count = $obj->replies+1;
		if ( $msg_count > $POSTS_PER_PAGE && $GLOBALS['D_THREAD_VIEW']=='msg' ) {
			$pgcount = ceil($msg_count/$POSTS_PER_PAGE);
			$i = ( $THREAD_MSG_PAGER < $pgcount ) ? $pgcount-$THREAD_MSG_PAGER : 0;
			if( $i ) $pager = "...";

			for( $i; $i<$pgcount; $i++ ) {
				$pager .= ' <a class="GenLink" href="'.$GLOBALS['D_THREAD_VIEW'].'.php?th='.$obj->id.'&start='.($i*$POSTS_PER_PAGE).'&'.$_RSID.'">'.($i+1).'</a> ';
			}
		
			if ( $pager ) $pager = '<font class="SmallText">(<img src="'.$GLOBALS["fud_img_suffix"].'pager.gif" border=0> '.$pager.')</font>';
		}
		
		if( $obj->poll_id ) 
			$special .= ' Poll: ';		
		
		if( $obj->attach_cnt ) 
			$special .= ' <img src="'.$GLOBALS["fud_img_suffix"].'attachment.gif" border=0>';

		if ( isset($usr) ) {
			if( $usr->last_read < $obj->last_post_stamp && $obj->last_post_stamp>$obj->last_thread_view ) {
				if ( $obj->locked == 'Y' ) {
					$img_pic = $GLOBALS["fud_img_suffix"].'unreadlocked.gif'; 
					$alt_tag = 'Not Read Locked';
					$u_h = 'Locked thread with unread messages';
				}
				else {
					$img_pic = $GLOBALS["fud_img_suffix"].'unread.gif'; 
					$alt_tag = 'Not Read';	
					$u_h = 'This thread contains messages you have not yet read';
				}
				$n_read = '<a href="'.$GLOBALS['D_THREAD_VIEW'].'.php?th='.$obj->id.'&unread=1&'.$_RSID.'"><acronym title="Click here to go the first unread message in this thread"><img src="'.$GLOBALS["fud_img_suffix"].'newposts.gif" alt="Go to 1st Un-Read Message" border=0></acronym></a> ';
			}
		}

		if ( !$img_pic && $obj->locked == 'Y' ) {
			$img_pic = $GLOBALS["fud_img_suffix"].'readlocked.gif'; 
			$alt_tag = 'Read Locked';
			$u_h = 'This thread has been locked';
		}
		else if ( !$img_pic ) {
			$img_pic = $GLOBALS["fud_img_suffix"].'read.gif'; 
			$alt_tag = 'Read';
			if ( !isset($usr) ) 
				$u_h = 'The read & unread messages are only tracked for registered users';
			else 
				$u_h = 'This thread has no unread messages';
		}
		
		$lv = '<td width=1 class="RowStyleB"><acronym title="'.$u_h.'"><img src="'.$img_pic.'" alt="'.$alt_tag.'" border=0></acronym></td>';
		lay_start_content_row(false);
		
		if ( $obj->moved_to ) {
			$col = ( $GLOBALS['MOD'] ) ? 8 : 9;
			list($name, $d_frm_id) = DB_SINGLEARR(Q("SELECT name, id FROM fud_forum WHERE id=".$obj->moved_to));
			echo '<td width=1 class="RowStyleB"><acronym title="This thread has been moved to another forum"><img src="'.$GLOBALS['fud_img_suffix'].'moved.gif" alt="Moved" border=0></acronym></td><td class="RowStyleB" colspan='.$col.' align=center class="GenText"><a href="'.$GLOBALS['D_THREAD_VIEW'].'.php?goto='.$obj->root_msg_id.'&'.$_RSID.'" class="GenLink">'.$obj->subject.'</a> has been moved to <a href="thread.php?frm_id='.$d_frm_id.'&'.$_RSID.'" class="GenLink">'.$name.'</a> by the moderator</td>';
			lay_end_content_row();
			continue;
		}
		if ( $obj->th_icon ) {
			$th_icon = '<img src="'.$GLOBALS['IMG_ROOT_WWW'].$GLOBALS['MESSAGE_ICON_DIR'].$obj->th_icon.'" border=0>';
		} else $th_icon = '&nbsp;';
		
		if ( $obj->rating ) {
			$rate_img = '<img src="'.$GLOBALS['fud_img_suffix'].$obj->rating.'stars.gif" border=0>';
		} else $rate_img = '&nbsp;';
		
		if ( $obj->is_sticky == 'Y' ) {
			$stick_stat = '<font class="SmallText"><b>'.(( $obj->ordertype=='STICKY' ) ? 'sticky: ' : 'announcement: ').'</b></font>';
		}
		else $stick_stat = NULL;
		
		echo $lv.'
			<td class="RowStyleB" width=1 align="center">'.$th_icon.'</td>
			<td class="RowStyleA">'.$n_read.$special.$stick_stat.'<a class="GenLink" href="'.$GLOBALS['D_THREAD_VIEW'].'.php?th='.$obj->id.'&start=0&'.$_RSID.'">'.$obj->subject.'</a> '.$pager.'</td>
			<td class="RowStyleB" align="center">'.$obj->replies.'</td>
			<td class="RowStyleB" align="center">'.$obj->views.'</td>
			<td class="RowStyleA" align="center">'.$rate_img.'</td>
			<td class="RowStyleB" nowrap><font class="DateText">'.format_date($obj->last_post_stamp).' '.format_time($obj->last_post_stamp).'<br>By: '.((strlen($obj->last_poster_login))?'<a href="usrinfo.php?id='.$obj->last_poster_id.'&'.$_RSID.'">'.htmlspecialchars(trim_show_len($obj->last_poster_login,'LOGIN')).'</a>':trim_show_len($GLOBALS["ANON_NICK"],'LOGIN')).' <a href="'.$GLOBALS['D_THREAD_VIEW'].'.php?goto='.$obj->last_post_id.'&'.$_RSID.'" class="GenLink"><acronym title="Go to the last message in this thread"><img src="'.$GLOBALS["fud_img_suffix"].'goto.gif" border=0 alt="Go to last post"></acronym></a></font></td>
			<td class="RowStyleB" nowrap><font class="DateText">'.format_date($obj->creation_date).'<br>By: '.((!strlen($obj->login))?trim_show_len($GLOBALS["ANON_NICK"],'LOGIN'):'<a href="usrinfo.php?id='.$obj->starter_id.'&'.$_RSID.'">'.htmlspecialchars(trim_show_len($obj->login,'LOGIN')).'</a>').'</font></td>';
		if( $MOD ) {
			echo '<form name="form_rate_'.$obj->id.'" method="post" action="ratethread.php"><td align=center class="RowStyleA">';
			
			if ( $frm->allow_user_vote != 'Y' ) {			
			echo '
				<input type="hidden" name="returnto" value="'.base64_encode('thread.php?frm_id='.$frm_id.'&'.$_RSID.'&start='.$start.'&count='.$count).'">
				<input type="hidden" name="rate_thread_id" value="'.$obj->id.'">
				<font size="-1">rate</font><br>
				'.create_select('th_rating_'.$obj->id, "\n0\n1\n2\n3\n4\n5", "\n0\n1\n2\n3\n4\n5", $GLOBALS['th_rating_'.$obj->id], 'onChange="javascript: document.form_rate_'.$obj->id.'.submit();"').'&nbsp;';
			}
			echo '	<a name="th_'.$obj->id.'"><a href="#th_'.$obj->id.'" onClick="javascript: window_open(\'mvthread.php?'.$_RSID.'&th='.$obj->id.'\', \'th_move\', 300, 400);">Move</a>
			</td></form>';		
		}
		lay_end_content_row();
	}
	QF($result); 	

	lay_end_content_table();
}
	if ( isset($usr) ) $usr->register_forum_view($frm->id);

	echo '<img src="blank.gif" width=1 height=2><br>';
	
	echo '<table border=0 cellspacing=0 cellpadding=0 width="100%"><tr><td valign="top">';
	draw_pager($start, $ppg, $frm->thread_count, 'thread.php?frm_id='.$frm_id.'&'.$_RSID);
	echo '&nbsp;</td><td align="right" class="GenText" valign="bottom" nowrap><a class="GenLink" href="post.php?'.$returnto.'&frm_id='.$frm_id.'&'.$_RSID.'"><img src="'.$GLOBALS["fud_img_suffix"].'new_thread.gif" alt="Create a new thread" border=0></a></td></tr></table>';
	
	$def_frm_id = $frm->id;
	draw_forum_select();
	
	echo '<br>';
	lay_start_content_table();
?>	
	<tr><td class="RowStyleB"><font class="SmallText" colspan=2><b>Legend:</b></font><br></td></tr>
	<tr><td valign=left class="RowStyleB">
		<table border=0 cellspacing=0 cellpadding=0 align=left>
			<tr>
				<td>
				<table border=0 cellspacing=0 cellpadding=2>
					<tr><td><img src="<?php echo $GLOBALS['fud_img_suffix']; ?>unread.gif" border=0></td><td class="SmallText">New Posts</td></tr>
				</table>
				</td>
				
				<td>
				<table border=0 cellspacing=0 cellpadding=2>
					<tr><td><img src="<?php echo $GLOBALS['fud_img_suffix']; ?>read.gif" border=0></td><td class="SmallText">No New posts</td></tr>
				</table>
				</td>
				
				<td>
				<table border=0 cellspacing=0 cellpadding=2>
					<tr><td><img src="<?php echo $GLOBALS['fud_img_suffix']; ?>unreadlocked.gif" border=0></td><td class="SmallText">Locked (w/ unread posts)</td></tr>
				</table>
				</td>
				
				<td>
				<table border=0 cellspacing=0 cellpadding=2>
					<tr><td><img src="<?php echo $GLOBALS['fud_img_suffix']; ?>readlocked.gif" border=0></td><td class="SmallText">Locked</td></tr>
				</table>
				</td>
				
				<td>
				<table border=0 cellspacing=0 cellpadding=2>
					<tr><td><img src="<?php echo $GLOBALS['fud_img_suffix']; ?>moved.gif" border=0></td><td class="SmallText">Moved to another forum</td></tr>
				</table>
				</td>
			</tr>
		</table>
	</td></tr>
<?php
	lay_end_content_table();
	
	if ( isset($usr) && $usr->is_mod == 'A' ) {
		echo '<br>';
		fud_use('stats.inc');
		draw_stats();
	}

	fud_use('curtime.inc');
	include_once $GLOBALS['FORUM_SETTINGS_PATH'].'footer_'.$layout.'.inc';
	create_help_layers();
?>
<div id="fhelp_newposts_ly" style="background: #fffecb; position: absolute; visibility: hidden; z-index:1">This arrow will take you to the first new post in the thread</div>