<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: tree.php,v 1.23 2002/02/12 02:42:28 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/

	include_once "GLOBALS.php";
	fud_use('db.inc');
	fud_use('cookies.inc');	
	fud_use('forum.inc');	
	fud_use('fileio.inc');
	fud_use('users.inc');
	fud_use('thread.inc');
	fud_use('msg.inc');
	fud_use('style.inc');
	fud_use('cat.inc');
	fud_use('drawmsg.inc');
	fud_use('forumsel.inc');
	fud_use('help.inc');

	list($ses, $usr) = init_user();
	cache_buster();
	
	if( !empty($goto) ) {
		if( is_numeric($goto) ) {
			$mid = $goto;
			$th = Q_SINGLEVAL("SELECT thread_id FROM fud_msg WHERE id=".$mid);
		}
		else if( $goto == 'end' && is_numeric($th) ) {
			list($mid) = DB_SINGLEARR(Q("SELECT last_post_id FROM fud_thread WHERE id=".$th));	
		}
		else
			invl_inp_err();
	}
	
	if( empty($th) || !is_numeric($th) ) {
		error_dialog('Insufficient Information','There was a problem generating this page',NULL);
		exit;
	}
	
	if ( !empty($notify) && isset($usr) ) {
		fud_use('thread_notify.inc');
		$th_not = new fud_thread_notify;
		if ( $opt == 'on' ) 
			$th_not->add($usr->id, $th);
		else
			$th_not->delete($usr->id, $th);

		header("Location: tree.php?th=".$th."&mid=".$mid.'&'.$_RSID.'&rand='.get_random_value());
		exit();
	}

	$thread = new fud_thread;
	$frm = new fud_forum;
	$thread->get_by_id($th);
	$frm->get($thread->forum_id);

	if( empty($mid) || !is_numeric($mid) ) 
		$mid = $thread->root_msg_id;	
	
	$result = Q("SELECT 
		fud_msg.*, 
		fud_thread.locked,
		fud_avatar.img AS avatar, 
		fud_users.id AS user_id, 
		fud_users.login, 
		fud_users.display_email, 
		fud_users.avatar_approved,
		fud_users.avatar_loc,
		fud_users.email, 
		fud_users.posted_msg_count, 
		fud_users.join_date, 
		fud_users.location, 
		fud_users.sig,
		fud_users.icq,
		fud_users.aim,
		fud_users.msnm,
		fud_users.yahoo,
		fud_users.custom_status,
		fud_level.name AS level_name,
		fud_level.pri AS level_pri,
		fud_level.img AS level_img,
		fud_ses.time_sec
	FROM 
		fud_msg 
		LEFT JOIN fud_users 
			ON fud_msg.poster_id=fud_users.id 
		LEFT JOIN fud_avatar 
			ON fud_users.avatar=fud_avatar.id 
		INNER JOIN fud_thread
			ON fud_msg.thread_id=fud_thread.id	
		LEFT JOIN fud_ses
			ON fud_ses.user_id=fud_msg.poster_id
		LEFT JOIN fud_level
			ON fud_users.level_id=fud_level.id
	WHERE 
		thread_id=".$th." AND fud_msg.id=".$mid." AND fud_msg.approved='Y'");

	if( !IS_RESULT($result) ) {
		error_dialog('Insufficient Information','There was a problem generating this page',$HTTP_SERVER_VARS["REQUEST_URI"]);
		exit;
	}

	$msg_obj = DB_SINGLEOBJ($result);
	$mid = $msg_obj->id;

	if( !isset($usr) && $frm->anon_viewing=='N' ) error_dialog('Only registered users may view this forum', 'In order to see this forum you need to <a href="register.php?'.$_RSID.'" class="GenLink">register</a>, if you are already registered you\'ll need to <a href="login.php?'.$_RSID.'" class="GenLink">login</a>.', '');

	if ( isset($usr) && ($frm->is_moderator($usr->id) || $usr->is_mod == 'A') ) $MOD = 1;
	
	if( isset($MOD) ) {
		fud_use('msg_edt.inc');
		fud_use('msg_mod.inc');
	}
	
	if ( isset($thread) && empty($prevloaded) ) {
		if ( isset($usr) ) $usr->register_forum_view($frm->id);
		$thread->inc_view_count();
	}

	if ( isset($frm) ) {
		$TITLE_EXTRA = ': '.$frm->name.' => '.$thread->subject;
	}

	$r = Q("SELECT 
			fud_msg.*,
			fud_users.login,
			fud_thread.root_msg_id,
			fud_ses.time_sec
		FROM 
			fud_msg 
			INNER JOIN fud_thread 
				ON fud_msg.thread_id=fud_thread.id 
			LEFT JOIN fud_users 
				ON fud_msg.poster_id=fud_users.id 
			LEFT JOIN fud_ses
				ON fud_ses.user_id=fud_msg.poster_id
		WHERE 
			thread_id=".$th." ORDER BY id");
		
	while ( $obj = DB_ROWOBJ($r) ) {
		$arr[$obj->id] = $obj;
		$arr[$obj->reply_to]->kiddies[] = &$arr[$obj->id];
		
		if ( $obj->reply_to == 0 ) {
			$tree->kiddies[] = &$arr[$obj->id];
		}
	}
	QF($r);

	if ( isset($ses) && empty($post_form) && $thread->hidden!='Y' ) $ses->update('Browsing thread (tree view) <a class="GenLink" href="tree.php?th='.$thread->id.'&'.$_RSID.'">'.$thread->subject.'</a>');

	$layout = get_layout_id((isset($layout)?$layout:'')); include_once $GLOBALS['FORUM_SETTINGS_PATH'].'header_'.$layout.'.inc';

	if ( isset($frm) ) {
		if ( !isset($cat) ) {
			$cat = new fud_cat;
			$cat->get_cat($frm->cat_id);
		}
		if( empty($post_form) ) {
			if ( $frm->allow_user_vote == 'Y' && $thread->rating ) {
				$rate_img = ' (<img src="'.$GLOBALS['fud_img_suffix'].$thread->rating.'stars.gif" border=0>)';
				$opt_s = ( ($vc=$thread->vote_count()) > 1 ) ? 's' : '';
				if ( $vc ) 
					$vote_count = $vc.' Vote'.$opt_s;
				else 
					$vc = '';
			}
			else {
				$rate_img=$vote_count='';
			}
				
			echo '<font class="GenText"><a class="GenLink" href="'.$WWW_ROOT.'?'.$_RSID.'">'.$cat->name.'</a> &raquo; <a href="thread.php?frm_id='.$frm->id.'&'.$_RSID.'">'.$frm->name.'</a> &raquo; <b>'.$thread->subject.'</b></font>'.$rate_img.$vote_count;
		}
	}
	
	$tmp = '&nbsp;';
	if( empty($post_form) ) {
		?>
		<table width="100%" border=0 cellspacing=0 cellpadding=0>
		<tr>
			<td valign="bottom" align="left" width="100%">
			<?php 
				echo '<span '.url_help('show_index').'><font class="GenText"><b>Show:</b> <a class="GenLink" href="selmsg.php?date=today&th='.$th.'&'.$_RSID.'"><acronym title="Show all posts that were made today, inside this thread">Today\'s Posts</acronym></a>'.(isset($usr)?' | <a class="GenLink" href="selmsg.php?unread=1&th='.$th.'&'.$_RSID.'"><acronym title="Show all unread posts inside this thread">Unread Posts</acronym></a>':''); 
				echo create_help_anchor('show_index', 400)."</span><br>";
			
				if ( $MOD ) {
					if ( $thread->locked == 'N' ) 
						echo '<a class="GenLink" href="tree.php?lock=1&th='.$th.'&'.$_RSID.'">Lock Thread</a> | ';
					else 
						echo '<a class="GenLink" href="tree.php?unlock=1&th='.$th.'&'.$_RSID.'">Unlock Thread</a> | ';
				}	
	
				echo ' <a class="GenLink" href="remail.php?th='.$th.'&'.$_RSID.'"><acronym title="Send the url to this page to your friend(s) via email">Email to friend</acronym></a> | ';
	
				if ( isset($usr) ) {
					$r = Q("SELECT id FROM fud_thread_notify WHERE thread_id=".$th." AND user_id=".$usr->id);
					if ( !IS_RESULT($r) )
						echo ' <a class="GenLink" href="tree.php?th='.$th.'&notify='.$usr->id.'&'.$_RSID.'&opt=on"><acronym title="Recieve notification about new posts inside this thread">Subscribe to thread</acronym></a>';
					else 
						echo ' <a class="GenLink" href="tree.php?th='.$th.'&notify='.$usr->id.'&'.$_RSID.'&opt=off"><acronym title="Stop receiving notifications about new posts in this thread">Unsubscribe from thread</acronym></a>';
				
					if ( $usr->is_mod!='N' ) {
						fud_use('admincp.inc');
						echo $admin_cp;
					} 
				}
				echo '</font>';				
			?>
			</td>
			<td align="right" class="GenText" valign="bottom">
		<?php
			$returnto_str = base64_encode('tree.php?th='.$th.'&mid='.$mid.'&prevloaded=1&'.$_RSID);
			$returnto = 'returnto='.$returnto_str;
		
			echo '<a href="msg.php?th='.$th.'&'.$_RSID.'#msg_'.$mid.'" class="GenLink"><acronym title="Return to the default flat view"><img src="'.$GLOBALS["fud_img_suffix"].'flat_view.gif" border=0 alt="Flat View"></acronym></a>&nbsp;<a class="GenLink" href="post.php?'.$returnto.'&frm_id='.$frm->id.'&'.$_RSID.'"><img src="'.$GLOBALS["fud_img_suffix"].'new_thread.gif" alt="Create a new thread" border=0></a>';
			
			if ( $thread->locked == 'N' ) echo '&nbsp;<a class="GenLink" href="post.php?th_id='.$th.'&reply_to='.$mid.'&'.$returnto.'&'.$_RSID.'"><img src="'.$GLOBALS["fud_img_suffix"].'post_reply.gif" border=0 alt="Post Reply"></a>';
		?>
			</td>
		</tr>
		<tr><td colspan=2><img src="blank.gif" height=1 width=1 border=0></td></tr>
		</table>
		<?php
	}	
	
	lay_start_content_table();
	echo '<tr><td width=1 class="TableHeading">Author</td><td class="TableHeading">Thread</td></tr>';
	open_thread_body($msg_obj->thread_id);
	drawmsg($msg_obj);
	close_thread_body();
	lay_end_content_table();
	echo '<div align=center class="GenText">[<a href="#tree_view" class="GenLink"><acronym title="View the message list">Message index</acronym></a>]</div>';
	echo '<p>';
	

	if( !is_numeric($mid) || $mid<1 ) $mid = $msg_obj->id;

	reset($tree);
	$stack[0] = &$tree;
	$j=0;
	$lev = 0;
	
	
	lay_start_content_table();
	echo '<tr class="TableHeading"><td width="100%">Subject</td><td nowrap align="center">Poster</td><td nowrap align="center">Date</td></tr>';
	
	while (1) {
		if ( count($stack) < 1 ) break;
		if ( !isset($cur) ) $cur = &$stack[count($stack)-1];
		
		if( isset($cur->subject) && strlen($cur->subject) && empty($cur->sub_shown) ) {
			$color = ($j++%2)?'A':'B';
			$a_name = '';
			if( $cur->id == $mid ) {
				$color = 'C';
				$a_name = '<a name="tree_view">&nbsp;</a>';
			}
			
			if( $cur->poster_id ) 
				$poster = '<a href="usrinfo.php?id='.$cur->poster_id.'&'.$_RSID.'" class="GenLink">'.htmlspecialchars(trim_show_len($cur->login,'LOGIN')).'</a>';
			else 
				$poster = trim_show_len($GLOBALS['ANON_NICK'], 'LOGIN');
			
			echo '<tr class="RowStyle'.$color.'">';
			echo '<td valign="top" width="100%" class="Gentext" nowrap>';
			echo '<img border=0 src="blank.gif" width="'.(25*($lev-1)).'" height=1>';
			echo '<img src="'.$GLOBALS["fud_img_suffix"].(isset($cur->kiddies) && (count($cur->kiddies))?'msg_folder.gif':'msg_arrow.gif').'"> <a href="tree.php?th='.$th.'&mid='.$cur->id.'&'.$_RSID.'&rev='.(isset($rev)?$rev:'').'&reveal='.(isset($reveal)?$reveal:'').'" class="GenLink">'.$cur->subject.'</a>'.$a_name;
			echo '</td><td class="GenText" nowrap>'.$poster.'</td><td nowrap class="DateText" colspan=99>'.format_date($cur->post_stamp).' '.format_time($cur->post_stamp).'</td></tr>';
			$cur->sub_shown = 1;
		}
		
		if ( isset($cur->kiddies) && $cur->kiddies ) {
			if ( empty($cur->kiddie_count) ) {
				$cur->kiddie_count = count($cur->kiddies);
				$cur->kiddie_pos = 0;
			}
			else {
				++$cur->kiddie_pos;
			}
		}
		
		if ( isset($cur->kiddie_pos) && isset($cur->kiddie_count) && $cur->kiddie_pos < $cur->kiddie_count ) {
			++$lev;
			$stack[count($stack)] = &$cur->kiddies[$cur->kiddie_pos];
			unset($cur);
			continue;
		}
		else { /* unwind the stack if needed */
			unset($cur);
			unset($stack[count($stack)-1]);
			--$lev;
			continue;
		}
	}

	lay_end_content_table();
	
	if ( isset($usr) ) $usr->register_thread_view($thread->id, $mid);
	
	echo '<table border=0 cellspacing=1 cellpadding=1 align="right">';
	
	list($pg, $ps)= DB_SINGLEARR(Q("SELECT page, pos FROM fud_thread_view WHERE forum_id=".$thread->forum_id." AND thread_id=".$thread->id));

	$r = Q('SELECT fud_thread_view.pos,fud_thread.id,fud_msg.subject FROM fud_thread_view INNER JOIN fud_thread ON fud_thread_view.thread_id=fud_thread.id INNER JOIN fud_msg ON fud_thread.root_msg_id=fud_msg.id WHERE fud_thread_view.forum_id='.$thread->forum_id.' AND fud_thread_view.page='.$pg.' AND fud_thread_view.pos IN ('.($ps-1).', '.($ps+1).') ORDER BY pos');
	switch ( DB_COUNT($r) ) 
	{
		case 2:
			$prev_th = DB_ROWOBJ($r);
			$next_th = DB_ROWOBJ($r);
			break;
		case 1:
			$prev_th = DB_ROWOBJ($r);
			if( $prev_th->pos > $ps ) {
				$next_th = $prev_th;
				if( $pg > 1 ) 
					$prev_th = DB_SINGLEOBJ(Q('SELECT fud_thread_view.pos,fud_thread.id,fud_msg.subject FROM fud_thread_view INNER JOIN fud_thread ON fud_thread_view.thread_id=fud_thread.id INNER JOIN fud_msg ON fud_thread.root_msg_id=fud_msg.id WHERE fud_thread_view.forum_id='.$thread->forum_id.' AND fud_thread_view.page='.($pg-1).' AND fud_thread_view.pos='.$GLOBALS['THREADS_PER_PAGE']));
				else
					$prev_th = NULL;	
			}
			else {
				$next_th = DB_SINGLEOBJ(Q('SELECT fud_thread_view.pos,fud_thread.id,fud_msg.subject FROM fud_thread_view INNER JOIN fud_thread ON fud_thread_view.thread_id=fud_thread.id INNER JOIN fud_msg ON fud_thread.root_msg_id=fud_msg.id WHERE fud_thread_view.forum_id='.$thread->forum_id.' AND fud_thread_view.page='.($pg+1).' AND fud_thread_view.pos=1'));
			}
		
			break;
		default:
			$prev_th = $next_th = NULL;
	}
	
	if ( $prev_th )
		echo '<tr><td align=right class="GenText">Previous Thread:</td><td class="GenText" align=left><a href="tree.php?th='.$prev_th->id.'&'.$_RSID.'" class="GenLink">'.$prev_th->subject.'</a></td></tr>';
	
	if ( $next_th )
		echo '<tr><td class="GenText" align=right>Next Thread:</td><td class="GenText" align=left><a class="GenLink" href="tree.php?th='.$next_th->id.'&'.$_RSID.'">'.$next_th->subject.'</a></td></tr>';
	
	echo '</table>';
	
	if ( isset($usr) && $frm->allow_user_vote=='Y' ) {
		if ( $thread->has_thread_vote($usr->id) == -1 ) {
			echo '<table border=0 cellspacing=0 cellpadding=0><tr><form action="ratethread.php" name="vote_frm" method="post"><td nowrap>
			<select name="sel_vote" onChange="javascript: if ( !this.value ) return false; document.vote_frm.submit();">';
			echo '<option>Rate Thread';
			for ( $i=1; $i<6; $i++ ) {
				echo '<option value="'.$i.'">'.$i."\n";
			}
			echo '</select>';
			echo '</td><td>&nbsp;<input type="submit" name="btn_vote" value="Vote">
			<input type="hidden" name="returnto" value="'.$returnto_str.'">
			<input type="hidden" name="S" value="'.$S.'">
			<input type="hidden" name="rate_thread_id" value="'.$thread->id.'">
			</td></form></tr></table>';
		}
	}
	
	$def_frm_id = $frm->id;
	draw_forum_select();
	fud_use('curtime.inc');
	
	if ( isset($usr) && $usr->is_mod == 'A' ) {
		fud_use('stats.inc');
		draw_stats();
	}
	
	include_once $GLOBALS['FORUM_SETTINGS_PATH'].'footer_'.$layout.'.inc';
	create_help_layers();
?>