<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: usrinfo.php,v 1.14 2002/02/11 21:06:40 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/

	include_once "GLOBALS.php";
	$GLOBALS["USER_REG"] = 1;
	fud_use('db.inc');
	fud_use('users.inc');
	fud_use('style.inc');
	fud_use('widgets.inc');
	fud_use('util.inc');
	fud_use('rev_fmt.inc');

	list($ses, $usr) = init_user();

	if( empty($id) || !is_numeric($id) ) invl_inp_err();
	
	$u = new fud_user;
	if ( !$u->get_user_by_id($id) ) {
		std_error('user');
	}

	$r = Q("SELECT name AS level_name, pri AS level_pri, img AS level_img FROM fud_level WHERE id=".$u->level_id);
	$obj = DB_SINGLEOBJ($r);

	$lev = '<font class="LevelText">';
	
	if ( $obj->level_pri ) {
		if( !empty($obj->level_name) ) $lev .= '<font class="LevelText">'.$obj->level_name.'</font><br>';
		if( !empty($obj->level_img) && strtolower($obj->level_pri)!='a' ) $lev .= '<img src="'.$obj->level_img.'" border=0><br>';
	}
	
	$r = Q("SELECT name FROM fud_custom_tags WHERE user_id=".$u->id);
	while ( list($custom_tag) = DB_ROWARR($r) ) {
		$lev .= $custom_tag.'<br>';
	}
	QF($r);

	$lev .= '</font>';

	$r = Q("SELECT fud_forum.id,fud_forum.name FROM fud_mod LEFT JOIN fud_forum ON fud_mod.forum_id=fud_forum.id LEFT JOIN fud_cat ON fud_forum.cat_id=fud_cat.id WHERE fud_cat.hidden='N' AND fud_forum.hidden='N' AND fud_mod.user_id=".$u->id);
	if( DB_COUNT($r) ) {
		$lev .= 'Moderator of: ';
		while ( $ar = DB_ROWOBJ($r) ) {
			$lev .= '<a href="thread.php?frm_id='.$ar->id.'&'.$_RSID.'" class="GenLink">'.$ar->name.'</a>, ';
		}
		$lev = substr($lev,0,-2);
	}
	QF($r);
	
	set_row_color_alt(true);
	
	$TITLE_EXTRA = ': User Info: '.$u->login;
	if ( isset($ses) ) $ses->update('Looking at <a class="GenLink" href="usrinfo.php?id='.$u->id.'">'.htmlspecialchars($u->login).'\'s</a> profile');
	$layout = get_layout_id($layout); include_once $GLOBALS['FORUM_SETTINGS_PATH'].'header_'.$layout.'.inc';

	lay_start_content_table();

	echo '<tr class="TableHeading"><td colspan=2 width="100%" class="TableHeading">Profile: '.htmlspecialchars($u->login).'</td></tr>';
	echo '<tr'.ROW_BGCOLOR().'><td nowrap class="GenText">Date Registered:</td><td width="100%" class="DateText">'.date($GLOBALS['fud_reg_date_fmt'], $u->join_date).'</td></tr>';
	echo '<tr'.ROW_BGCOLOR().'><td nowrap valign="top" class="GenText">Status:</td><td class="GenText">'.$lev.'</td></tr>';
	
	$avg = sprintf("%.2f", $u->posted_msg_count/((time()-$u->join_date)/86400));
	if( $avg > $u->posted_msg_count ) $avg = $u->posted_msg_count;
	
	echo '<tr'.ROW_BGCOLOR().'><td valign="top" nowrap class="GenText">Post Count:</td><td class="GenText">'.$u->posted_msg_count.' Post(s) ('.$avg.' average posts per day)<br><a class="GenLink" href="showposts.php?id='.$u->id.'&'.$_RSID.'">Show all posts by '.htmlspecialchars($u->login).'</a></td></tr>';
	
	$r = Q("SELECT fud_msg.subject,fud_msg.id,fud_msg.post_stamp FROM fud_msg LEFT JOIN fud_thread ON fud_msg.thread_id=fud_thread.id LEFT JOIN fud_forum ON fud_thread.forum_id=fud_forum.id LEFT JOIN fud_cat ON fud_forum.cat_id=fud_cat.id WHERE fud_cat.hidden='N' AND fud_forum.hidden='N' AND fud_msg.approved='Y' AND fud_msg.poster_id=".$u->id." ORDER BY fud_msg.id DESC LIMIT 1");
	if( IS_RESULT($r) ) {
		$m_obj = DB_SINGLEOBJ($r);
		echo '<tr'.ROW_BGCOLOR().'><td valign="top" nowrap class="GenText">Last Post:</td><td class="GenText"><font class="DateText">'.format_date($m_obj->post_stamp).' '.format_time($m_obj->post_stamp).'</font><br><a href="'.$GLOBALS['D_THREAD_VIEW'].'.php?goto='.$m_obj->id.'&'.$_RSID.'" class="GenLink">'.$m_obj->subject.'</a></td></tr>';
	}
	
	if ( $u->user_image ) echo '<tr'.ROW_BGCOLOR().'><td nowrap valign="top" class="GenText">Image:</td><td class="GenText"><img src="'.$u->user_image.'" border=0></td></tr>';
	if ( $u->avatar ) {
		$r = Q("SELECT img,descr FROM fud_avatar WHERE id=".$u->avatar);
		if( DB_COUNT($r) ) {
			$av = DB_ROWOBJ($r);
			echo '<tr'.ROW_BGCOLOR().'><td nowrap valign="top" class="GenText">Avatar:</td><td class="GenText"><img src="'.$GLOBALS["WWW_ROOT"].$GLOBALS["IMG_ROOT_WWW"].$GLOBALS["AVATAR_DIR"].$av->img.'" alt="'.$av->descr.'" border=0></td></tr>';	
		}
		QF($r);
	}
	else if( strlen($u->avatar_loc) && $u->avatar_approved=='Y' ) {
		echo '<tr'.ROW_BGCOLOR().'><td nowrap valign="top" class="GenText">Avatar:</td><td class="GenText"><img src="'.$u->avatar_loc.'" alt="Custom Avatar" border=0></td></tr>';
	}
	else if ( $u->avatar_approved=='Y' && file_exists($GLOBALS['IMG_ROOT_DISK'].$GLOBALS['CUSTOM_AVATAR_DIR'].$u->id) ) {
		echo '<tr'.ROW_BGCOLOR().'><td nowrap valign="top" class="GenText">Avatar:</td><td class="GenText"><img src="'.$GLOBALS['IMG_ROOT_WWW'].$GLOBALS['CUSTOM_AVATAR_DIR'].$u->id.'" alt="Custom Avatar" border=0></td></tr>';	
	}

	if ( $u->display_email == 'Y' ) 
		echo '<tr'.ROW_BGCOLOR().'><td nowrap class="GenText">Email:</td><td class="GenText"><a class="GenLink" href="mailto: '.$u->email.'">'.$u->email.'</a></td></tr>';
	else if( $GLOBALS["ALLOW_EMAIL"] == 'Y' ) 
		echo '<tr'.ROW_BGCOLOR().'><td nowrap class="GenText">Email:</td><td class="GenText">&lt;<a href="email.php?tx_name='.urlencode($u->login).'&returnto='.base64_encode('usrinfo.php?id='.$u->id.'&'.$_RSID).'&'.$_RSID.'">Click here to email the user</a>&gt;</td></tr>';
	
	if( $GLOBALS['PM_ENABLED'] == 'Y' && isset($usr) ) 
		echo '<tr'.ROW_BGCOLOR().'><td nowrap class="GenText">Private Message:</td><td class="GenText"><a href="ppost.php?'.$_RSID.'&msg_to_list='.$u->login.'" class="GenLink"><img src="'.$GLOBALS["fud_img_suffix"].'msg_pm.gif" border=0 alt="Send Private Message"></a></td></tr>';
		
	if ( strlen($u->home_page) ) echo '<tr'.ROW_BGCOLOR().'><td nowrap class="GenText">Homepage:</td><td class="GenText"><a href="'.$u->home_page.'" target=_new>'.$u->home_page.'</a></td></tr>';
	if ( strlen($u->gender) )  echo '<tr'.ROW_BGCOLOR().'><td nowrap class="GenText">Gender:</td><td class="GenText">'.$u->gender.'</td></tr>';
	if ( strlen($u->location) ) echo '<tr'.ROW_BGCOLOR().'><td nowrap class="GenText">Location:</td><td class="GenText">'.$u->location.'</td></tr>';
	if ( strlen($u->occupation) ) echo '<tr'.ROW_BGCOLOR().'><td nowrap class="GenText">Occupation:</td><td class="GenText">'.$u->occupation.'</td></tr>';
	if ( strlen($u->interests) ) echo '<tr'.ROW_BGCOLOR().'><td nowrap class="GenText">Interests:</td><td class="GenText">'.$u->interests.'</td></tr>';
	if ( strlen($u->bio ) ) echo '<tr'.ROW_BGCOLOR().'><td nowrap class="GenText">Biography:</td><td class="GenText">'.$u->bio.'</td></tr>';
	
	$bday = convert_bdate($u->bday, 'M');
	if ( $bday['month'] && $bday['day'] && $bday['year'] ) echo '<tr'.ROW_BGCOLOR().'><td nowrap class="GenText">Date Of Birth:</td><td class="GenText">'.$bday['month'].' '.$bday['day'].', '.$bday['year'].'</td></tr>';
	if ( $u->icq ) {            
		echo '<tr'.ROW_BGCOLOR().'><td valign="top" nowrap class="GenText"><a name="icq_msg">ICQ Message Message Form:</a></td><td class="GenText">
		'.$u->icq.' <img src="http://web.icq.com/whitepages/online?icq='.$u->icq.'&amp;img=5"><br>
			<table border="0">
			<tr><td colspan=2>
				<form action="http://wwp.icq.com/scripts/WWPMsg.dll" method="post" target=_blank>
				<font face="Arial, Helvetica" size="1"><b>ICQ Online-Message Panel</b></font>
			</td></tr>
			<tr>
				<td>
					<font face="Arial, Helvetica" size="1">Sender Name:</font><br>
					<input type="text" name="from" value="" size="15" maxlength="40" onfocus="this.select()">
				</td>
				<td>
					<font face="Arial, Helvetica" size="1">Sender Email:</font><br>
					<input type="text" name="fromemail" value="" size="15" maxlength="40" onfocus="this.select()">
				</td>
			</tr>
			
			<tr>
				<td colspan=2>
					<font face="Arial, Helvetica" size="1">Subject</font><br>
					<input type="text" name="subject" value="" size="32"><br>
					<font face="Arial, Helvetica" size="1">Message</font><br>
					<textarea name="body" rows="3" cols="32" wrap="Virtual"></textarea>
					<input type="hidden" name="to" value="'.$u->icq.'"><br>
				</td>
			</tr>
			
			<tr><td colspan=2 align=right><input type="submit" name="Send" value="Send"></td></tr>
			</form>
			</table>
			</td></tr>		
		';
	}
	
	if ( strlen($u->aim) ) {
		$aim = $u->aim;
		reverse_FMT($aim);
		echo '<tr'.ROW_BGCOLOR().'><td nowrap class="GenText">AIM Handle:</td><td class="GenText"><a href="aim:goim?screenname='.urlencode($aim).'&amp;message=Hello+Are+you+there?" class="GenLink">'.$u->aim.'</a></td></tr>';
	}		
	if ( strlen($u->yahoo) ) {
		$yahoo = $u->yahoo;
		reverse_FMT($yahoo);
		echo '<tr'.ROW_BGCOLOR().'><td nowrap class="GenText">Yahoo Messenger:</td><td class="GenText"><a href="http://edit.yahoo.com/config/send_webmesg?.target='.urlencode($yahoo).'&amp;.src=pg" class="GenLink">'.$u->yahoo.'</a></td></tr>';
	}	
	if ( strlen($u->msnm) ) echo '<tr'.ROW_BGCOLOR().'><td nowrap class="GenText">MSN Messenger:</td><td class="GenText">'.$u->msnm.'</td></tr>';
	echo '<tr'.ROW_BGCOLOR().'><td nowrap align="right" class="GenText" colspan=2><a class="GenLink" href="showposts.php?id='.$u->id.'&'.$_RSID.'">Show all posts by user</a></td></tr>';
	lay_end_content_table();
	fud_use('curtime.inc');
	include_once $GLOBALS['FORUM_SETTINGS_PATH'].'footer_'.$layout.'.inc';
?>