<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: announce_adm.inc,v 1.4 2002/02/05 00:37:54 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/

class fud_announce_adm extends fud_announce
{
	var $id;
	var $date_started;
	var $date_ended;
	
	var $subject;
	var $text;
	
	var $a_list;
	var $frm_list;
	
	function add()
	{
		Q("INSERT INTO fud_announce (date_started, date_ended, subject, text) VALUES(".$this->date_stared.",".$this->date_ended.",'".$this->subject."','".$this->text."')");
		$this->id = DB_LASTID();
	}
	
	function sync()
	{
		Q("UPDATE fud_announce SET date_started=$this->date_stared, date_ended=$this->date_ended, subject='$this->subject', text='$this->text' WHERE id=$this->id");
	}
	
	function add_forum($frm_id)
	{
		Q("INSERT INTO fud_ann_forums(ann_id, forum_id) VALUES(".$this->id.", ".$frm_id.")");
	}
	
	function rm_forum($frm_id)
	{
		Q("DELETE FROM fud_ann_forums WHERE ann_id=".$this->id." AND forum_id=".$frm_id);
	}
	
	function rm_all_forums()
	{
		Q("DELETE FROM fud_ann_forums WHERE ann_id=$this->id");
	}
	
	function get_frm_list() 
	{
		if ( isset($this->frm_list) ) unset($this->frm_list);
		$res = Q("SELECT * FROM fud_ann_forums WHERE ann_id=".$this->id);
		
		while ( $obj = DB_ROWOBJ($res) ) {
			$this->frm_list[$obj->forum_id] = $obj;
		}
		QF($res);
	}

	function reset_forums()
	{
		if ( !isset($this->frm_list) ) return;
		
		reset($this->frm_list);
	}
	
	function each_forum()
	{
		if ( !isset($this->frm_list) ) return;
		$obj = current($this->frm_list);
		if ( !isset($obj) ) return;
		next($this->frm_list);
		
		return $obj;
	}
	
	function delete()
	{
		Q("DELETE FROM fud_ann_forums WHERE ann_id=".$this->id);
		Q("DELETE FROM fud_announce WHERE id=".$this->id);
	}
	
	function getall()
	{
		$res = Q("SELECT * FROM fud_announce");
		
		unset($this->a_list);
		while ( $obj = DB_ROWOBJ($res) ) {
			$this->a_list[] = $obj;
		}
		QF($res);
	}
	
	function reseta()
	{
		if ( !isset($this->a_list) ) return;
		reset($this->a_list);
	}
	
	function fetch_vars($array, $prefix)
	{
		$this->date_started = $array[$prefix.'date_started'];
		$this->date_ended = $array[$prefix.'date_ended'];
		$this->subject = $array[$prefix.'subject'];
		$this->text = $array[$prefix.'text'];
	}	
	
	function export_vars($prefix)
	{	
		$GLOBALS[$prefix.'date_started'] = $this->date_started;
		$GLOBALS[$prefix.'date_ended'] = $this->date_ended;
		$GLOBALS[$prefix.'subject'] = $this->subject;
		$GLOBALS[$prefix.'text'] = $this->text;
	}
	
	
	function get($id)
	{
		$res = Q("SELECT * FROM fud_announce WHERE id=".$id);
		
		if ( !IS_RESULT($res) ) exit("no such annoucement\n");
		
		$obj = DB_SINGLEOBJ($res);
		
		$this->id 		= $obj->id;
		$this->date_started	= $obj->date_started;
		$this->date_ended	= $obj->date_ended;
		$this->subject		= $obj->subject;
		$this->text		= $obj->text;
	}
	
	function is_set_forum($frm_id)
	{
		if ( !isset($this->frm_list) ) $this->get_frm_list();
		
		if ( isset($this->frm_list[$frm_id]) ) return $frm_id;
		
		return;
	}
}
?>