<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: attach.inc,v 1.8 2002/02/12 16:58:17 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/
 if ( defined('_ATTACH_INC_') ) return; else define('_ATTACH_INC_', 1);

	include_once "GLOBALS.php";
	fud_use('db.inc');
	fud_use('objutil.inc');

class fud_attach
{
	var $id=NULL;
	var $proto=NULL;
	var $location=NULL;
	var $original_name=NULL;
	var $owner=NULL;
	var $private=NULL;
	var $message_id=NULL;
	var $dlcount=NULL;
	
	var $a_list;
	
	function add($owner, $message_id, $original_name, $cur_location, $private='')
	{
		$proto = proto($cur_location);
		
		Q("INSERT INTO fud_attach (proto, location, original_name, message_id, owner, private)
			VALUES('$proto', 'none://unset', '$original_name', ".INTZERO($message_id).", INTZERO($owner), '".YN($private)."')");
		$id = DB_LASTID();
		$this->message_id=$message_id;
		if ( $proto == 'LOCAL' ) {
			$loc = safe_attachment_copy($cur_location, $id);
		}
		else $loc = $cur_location;
		
		if ( $private == 'Y' ) 
			$tbl = 'fud_pmsg';
		else
			$tbl = 'fud_msg';
		
		Q("UPDATE fud_attach SET location='".$loc."' WHERE id=".$id);
		if ( $message_id ) {
			QOBJ("SELECT count(*) AS a_count FROM fud_attach WHERE message_id=".$message_id, $cObj);
			Q("UPDATE ".$tbl." SET attach_cnt=".$cObj->a_count." WHERE id=".$this->message_id);
		}
		
		return $id;
	}
		
	function get($id,$private='')
	{
		$obj = QOBJ("SELECT * FROM fud_attach WHERE id=".$id." AND private='".YN($private)."'", $this);
	}
	
	function replace($original_name, $cur_location)
	{
		$proto = proto($cur_location);
		Q("UPDATE fud_attach SET proto='".$proto."', original_name='".$original_name."', location='".$cur_location."' WHERE id=".$this->id);
		if ( $proto == 'LOCAL' ) {
			$loc = $GLOBALS['FILE_STORE'].$this->id.'.atch';
			if ( file_exists($loc) ) unlink($loc);
			safe_attachment_copy($cur_location, $id);
		}
	}
	
	function delete()
	{
		if( !DB_LOCKED() ) {
			$lock = 1;
			DB_LOCK('fud_attach+');
		}	
		$r = Q("SELECT location FROM fud_attach WHERE id=".$this->id);
		if( DB_COUNT($r) ) {
			list($loc) = DB_ROWARR($r);
			if( file_exists($loc) ) 
				unlink($loc);
		}
		QF($r);
		Q("DELETE FROM fud_attach WHERE id=".$this->id);
		if( $lock ) DB_UNLOCK();
	}
	
	function inc_dl_count()
	{
		Q("UPDATE fud_attach SET dlcount=dlcount+1 WHERE id=".$this->id);
	}
	
}

function proto($file)
{
	if ( start_match($file, 'http://') ) 	return "REMOTE";
	if ( start_match($file, 'ftp://') ) 	return "REMOTE";
	
	return "LOCAL";
}

function start_match($haystack, $needle)
{
	if ( strtolower(substr($haystack, 0, strlen($needle))) == strtolower($needle) ) return strlen($needle);
	return 0;
}

function safe_attachment_copy($source, $id)
{
	$loc = $GLOBALS['FILE_STORE'].$id.'.atch';	
	if ( file_exists($loc) ) {
		unlink($loc);
		std_out('"'.$loc.'" already exists, but shouldn\'t (old file unlinked), check security', 'ERR');
	}
	
	$fp = @fopen($loc, 'w');
	if ( !$fp ) {
		std_out('unable to create source file ('.$loc.') check permissions on ('.$GLOBALS['FILE_STORE'].'), we suggest 1777', 'ERR');
		exit('file attachment error');
	}
	chmod($loc, 0644);
	
	$fp_s = fopen($source, 'r');
	if ( !$fp_s ) {
		fclose($fp);
		std_out('unable to read temporary attachment file, ('.$source.')', 'ERR');
		exit('file attachment error');
	}
	
	while ( $str=fread($fp_s, 4096) ) {
		fwrite($fp, $str);
	}	
	fclose($fp);
	fclose($fp_s);
	
	return $loc;
}
?>