<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: core.inc,v 1.11 2002/02/11 20:20:11 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/

$GLOBALS['ADMIN_FORM']=$GLOBALS['USER_REG']=$GLOBALS['MSG_EDIT']=$GLOBALS['MOD']=$GLOBALS['PLAIN_FORM']=$GLOBALS['TITLE_EXTRA']=NULL;
$FORUM_VERSION = "1.1.9-dev";

function fud_use($file)
{
	include_once $GLOBALS["INCLUDE"].$file;
}

fud_use('error.inc');

function invl_inp_err()
{
	error_dialog('Invalid Input', 'You\'ve followed an invalid link, please notify the <a href="mailto:'.$GLOBALS["ADMIN_EMAIL"].'">webmaster</a>', NULL);
	exit;
}

function db_getmicrotime() 
{
	$tm_ar = gettimeofday();
	return ($tm_ar['sec']+$tm_ar['usec']/1000000);
}

function make_seed() 
{
	mt_srand((double)microtime()*1000000);
}

function get_random_value($bitlength=32)
{
	return str_repeat(mt_rand(), round($bitlength/32));
}

function start_bench($name, $pool='default')
{
	$GLOBALS['__BENCH_ARR__'][$pool][$name] = db_getmicrotime();
}

function end_bench($name, $pool='default')
{
	$end = db_getmicrotime();
	$GLOBALS['__BENCH_RESULT__'][$pool][$name]['runtime'] =  $end - $GLOBALS['__BENCH_ARR__'][$pool][$name];
	unset($GLOBALS['__BENCH_ARR__'][$pool][$name]);
	return $GLOBALS['__BENCH_RESULT__'][$pool][$name]['runtime'];
}

function get_bench($name, $pool='default')
{
	return $GLOBALS['__BENCH_RESULT__'][$pool][$name]['runtime'];
}

function del_pool_entry($name, $pool='default')
{
	unset($GLOBALS['__BENCH_RESULT__'][$pool][$name]);
}

function get_pool($pool='default')
{
	return $GLOBALS['__BENCH_RESULT__'][$pool];
}

function sum_pool($pool='default')
{
	$bp = &$GLOBALS['__BENCH_RESULT__'][$pool];
	reset($bp);
	
	$bt = 0;
	while ( list($k, $v) = each($bp) ) {
		$bt += $v['runtime'];
	}
	
	reset($bp);
	while ( list($k, $v) = each($bp) ) {
		$GLOBALS['__BENCH_RESULT__'][$pool][$k]['fract'] = round($v['runtime']/$bt*100).'%';
	}
	
	return $bt;
}

make_seed();

$GLOBALS['PAGE_TIME'] = db_getmicrotime();
unset($GLOBALS['BENCH_MARKS']);

/* here we do some initilization code */
if ( $FORUM_ENABLED != 'Y' && !strstr($GLOBALS["HTTP_SERVER_VARS"]["REQUEST_URI"], 'adm') ) {
	fud_use('cfg.inc');
	exit(cfg_dec($DISABLED_REASON));
}	
?>