<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: drawmsg.inc,v 1.23 2002/02/12 19:55:00 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/

fud_use('fileio.inc');
fud_use('poll.inc');

function build_ignore_list()
{
	$r = Q("SELECT id,ignore_id FROM fud_user_ignore WHERE user_id=".$GLOBALS["usr"]->id);
	while( list($id,$ignore_id) = DB_ROWARR($r) ) $GLOBALS['__IGNORE_LIST__'][$ignore_id] = $id;
	QF($r);
	
	$GLOBALS['__IGNORE_LIST__'][0] = 0;
}

if( isset($GLOBALS['rev']) ) {
	$drawmsg_inc_tmp = explode(':', $GLOBALS['rev']);
	reset($drawmsg_inc_tmp);
	while ( list($k, $v) = each($drawmsg_inc_tmp) ) {
		if ( strlen($v) ) 
			$GLOBALS['__REVEALED_POSTS__'][$v] = 1;
	}
	unset($drawmsg_inc_tmp);
}	

if( isset($GLOBALS['reveal']) ) {
	$drawmsg_inc_tmp = explode(':', $GLOBALS['reveal']);
	reset($drawmsg_inc_tmp);
	while ( list($k, $v) = each($drawmsg_inc_tmp) ) {
		if ( strlen($v) ) 
			$GLOBALS['__REVEALED_USERS__'][$v] = 1;
	}
	unset($drawmsg_inc_tmp);
}	

function register_vote($opt)
{
	$poll = new fud_poll; 
	$poll_opt = new fud_poll_opt;
	$poll_opt->get($opt);
	$poll->get($poll_opt->poll_id);
	if ( !$poll->voted($GLOBALS['usr']->id) ) {
		$poll_opt->increase();
		$poll->regvote($GLOBALS['usr']->id);
	}	
}
/* determine the source form */
$GLOBALS['__DRAW_MSG_SCRIPT_NAME'] = substr(strrchr($GLOBALS['HTTP_SERVER_VARS']['SCRIPT_NAME'], '/'), 1);

$GLOBALS['__MSG_COUNT__']=0;

function drawmsg(&$obj, $msg_count=NULL, $pager=NULL)
{
	global $_RSID;

	if( isset($GLOBALS['usr']) && !isset($GLOBALS['__IGNORE_LIST__']) ) build_ignore_list();

	if( empty($GLOBALS['returnto']) ) $GLOBALS['returnto'] = base64_encode($GLOBALS["REQUEST_URI"]);
	
	$message_pager='';
	if( $msg_count && empty($GLOBALS["post_form"]) ) { 
		if( $GLOBALS['__MSG_COUNT__'] ) 
			$message_pager .= '<a href="#msg_num_'.($GLOBALS['__MSG_COUNT__']-1).'" class="GenLink"><acronym title="Go to previous message"><img border=0 src="'.$GLOBALS["fud_img_suffix"].'up.gif" border=0></acronym></a>';
		else if ( $pager && $obj->id!=$obj->root_msg_id ) 
			$message_pager .= '<a href="msg.php?'.$_RSID.'&prevloaded=1&th='.$obj->thread_id.'&start='.($GLOBALS['start']-$GLOBALS['count']).'&rev='.$GLOBALS['rev'].'&reveal='.$GLOBALS['reveal'].'&count='.$GLOBALS['count'].'" class="GenLink"><acronym title="Go to previous message"><img border=0 src="'.$GLOBALS["fud_img_suffix"].'up.gif" border=0></acronym></a>';
			
		if( $GLOBALS['__MSG_COUNT__'] < $msg_count ) 
			$message_pager .= '<a href="#msg_num_'.($GLOBALS['__MSG_COUNT__']+1).'" class="GenLink"><acronym title="Go to next message"><img src="'.$GLOBALS["fud_img_suffix"].'down.gif" border=0></acronym></a>';
		else if ( $pager && $obj->id!=$obj->last_post_id ) 
			$message_pager .= '<a href="msg.php?'.$_RSID.'&prevloaded=1&th='.$obj->thread_id.'&start='.($GLOBALS['start']+$GLOBALS['count']).'&rev='.$GLOBALS['rev'].'&reveal='.$GLOBALS['reveal'].'&count='.$GLOBALS['count'].'" class="GenLink"><acronym title="Go to next message"><img border=0 src="'.$GLOBALS["fud_img_suffix"].'down.gif" border=0></acronym></a>';
	}	
	
	if ( !empty($GLOBALS['__IGNORE_LIST__'][$obj->poster_id]) && empty($GLOBALS['__REVEALED_POSTS__'][$obj->id]) && empty($GLOBALS['__REVEALED_USERS__'][$obj->poster_id]) ) {
		$style=lay_start_content_row(true);
		
		$null_fields = array('frm_id','reply_count','th','start','reveal','rev','count','date','unread');
		while( list(, $v) = each($null_fields) ) 
			if( !isset($GLOBALS[$v]) ) $GLOBALS[$v] = NULL;
		
		$stuff = '&'.$_RSID.'&frm_id='.$GLOBALS['frm_id'].'&th='.$GLOBALS['th'].'&start='.$GLOBALS['start'].'&count='.$GLOBALS['count'].'&unread='.$GLOBALS['unread'].'&reply_count='.$GLOBALS['reply_count'].'&date='.$GLOBALS['date'].'#msg_'.$obj->id;
		$return_to_dc = base64_encode($GLOBALS['__DRAW_MSG_SCRIPT_NAME'].'?goto='.$obj->id.'&'.$_RSID);
		echo '<tr'.$style.'><td colspan=2><table border=0 width="100%" cellspacing=0 cellpadding=0><tr><td align="left" class="GenText"><a name="msg_num_'.$GLOBALS['__MSG_COUNT__'].'"></a><a name="msg_'.$obj->id.'"></a>Post by <a href="usrinfo.php?'.$_RSID.'&id='.$obj->id.'" class="GenLink">'.htmlspecialchars($obj->login).'</a> is ignored [<a href="'.$GLOBALS['__DRAW_MSG_SCRIPT_NAME'].'?reveal='.$GLOBALS['reveal'].'&'.$_RSID.'&rev='.$GLOBALS['rev'].':'.$obj->id.$stuff.'" class="GenLink">reveal post</a>] [<a href="'.$GLOBALS['__DRAW_MSG_SCRIPT_NAME'].'?rev='.$GLOBALS['rev'].'&'.$_RSID.'&reveal='.$GLOBALS['reveal'].':'.$obj->poster_id.$stuff.'" class="GenLink">reveal all posts by '.htmlspecialchars($obj->login).'</a>] [<a href="ignore_list.php?del='.$GLOBALS['__IGNORE_LIST__'][$obj->poster_id].'&returnto='.$return_to_dc.'&'.$_RSID.'" class="GenLink">stop ignoring this user</a>]</td><td align="right">'.$message_pager.'</td></tr></table></td></tr>';
		lay_end_content_row();
		
		$GLOBALS['__MSG_COUNT__']++;
		return;
	}

	$loc=$c_tag=$show_sigs=$host_name=$avatar_img=$posted_msg_count=$registered=$ipaddr=$lev_txt=$line_status='';

	if( !empty($obj->user_id) ) {
		$disable_avatar = ( $obj->level_pri == 'l' ) ? 1 : 0;
		
		if( $GLOBALS['ONLINE_OFFLINE_STATUS'] == 'Y' ) {
			$tm = time();
		
			if( ($obj->time_sec+$GLOBALS['LOGEDIN_TIMEOUT']*60) > $tm ) 
				$line_status = '<acronym title="'.htmlspecialchars($obj->login).' is currently online"><img src="'.$GLOBALS["fud_img_suffix"].'online.gif" alt="Online" border=0></acronym>';
			else 
				$line_status = '<acronym title="'.htmlspecialchars($obj->login).' is currently offline"><img src="'.$GLOBALS["fud_img_suffix"].'offline.gif" alt="Offline" border=0></acronym>';	

			$line_status .= ' ';
		}
		
		if ( !$disable_avatar ) {
			if ( $obj->avatar_approved == 'Y' ) {
				if ( $obj->avatar_loc )
					$avatar_img = '<img src="'.$obj->avatar_loc.'" border=0>';
				else
					$avatar_img = '<img src="'.$GLOBALS['IMG_ROOT_WWW'].$GLOBALS['CUSTOM_AVATAR_DIR'].$obj->user_id.'" border=0>';
			}
			else if( $obj->avatar )
				$avatar_img = '<img src="'.$GLOBALS['IMG_ROOT_WWW'].$GLOBALS['AVATAR_DIR'].$obj->avatar.'" border=0>';
		}
		
		if ( empty($GLOBALS["post_form"]) ) {
			$login_href_pref = '<a class="GenLink" href="usrinfo.php?id='.$obj->user_id.'&'.$_RSID.'">';
			$login_href_suff = '</a>';
		}
		else $login_href_pref = $login_href_suff = NULL;
			
		$logincap = $login_href_pref.htmlspecialchars(trim_show_len($obj->login,'LOGIN')).$login_href_suff;

		if ( $GLOBALS["MOD"] || $GLOBALS["DISPLAY_IP"] == 'Y' ) 
			$ipaddr = 'IP: '.$obj->ip_addr.'<br>';
		
		if ( $GLOBALS['PUBLIC_RESOLVE_HOST'] == 'Y' && !empty($obj->host_name) ) 
			$host_name = 'From:<br><font class="SmallText">'.wordwrap($obj->host_name,30,'<br>',1)."</font><br>\n";
		
		$posted_msg_count = 'Posts: '.$obj->posted_msg_count.'<br>';
			
		$registered = 'Registered:<br><font class="DateText">'.date($GLOBALS['fud_reg_date_fmt'], $obj->join_date).'</font>';
		
		if ( $obj->location ) $loc = 'Location: '.trim_show_len($obj->location,'LOCATION').'<br>';
		$c_tag = $obj->custom_status;
		if( $GLOBALS["usr"]->show_sigs=='N' ) $show_sigs=1;
	}
	else 
		$logincap = $GLOBALS['ANON_NICK'];
	
	if ( $obj->icon ) 
		$icon = '<img src="'.$GLOBALS["IMG_ROOT_WWW"].$GLOBALS["MESSAGE_ICON_DIR"].$obj->icon.'" border=0>&nbsp;&nbsp;';
	else
		$icon=NULL;
	
	$style=lay_start_content_row(true);
	
	if ( isset($GLOBALS['usr']) && $obj->user_id > 0 && empty($GLOBALS["post_form"]) ) {
		$spacer = '<br>';
		$buddy_lnk = '[<a href="buddy_list.php?'.$GLOBALS['returnto'].'&add='.$obj->user_id.'&'.$_RSID.'" class="GenLink">add to buddy list</a>]';
		if ( $obj->poster_id != 1 ) {
			if ( !empty($GLOBALS['__IGNORE_LIST__'][$obj->poster_id]) )
				$ignore_lnk = '<br>[<a href="ignore_list.php?'.$GLOBALS['returnto'].'&'.$_RSID.'&del='.$GLOBALS['__IGNORE_LIST__'][$obj->poster_id].'" class="GenLink">stop ignoring posts by this user</a>]';
			else 
				$ignore_lnk = '<br>[<a href="ignore_list.php?'.$GLOBALS['returnto'].'&'.$_RSID.'&add='.$obj->user_id.'" class="GenLink">ignore all posts by this user</a>]';
		}
		else $ignore_lnk=NULL;
	}
	else { $spacer = $buddy_lnk = $ignore_lnk = NULL; }
	
	if ( $obj->level_pri ) {
		if( !empty($obj->level_name) ) $lev_txt .= '<font class="LevelText">'.$obj->level_name.'</font><br>';
		if( !empty($obj->level_img) && strtolower($obj->level_pri)!='a' ) $lev_txt .= '<img src="'.$obj->level_img.'" border=0><br>';
	}	
	
	if( !empty($c_tag) ) $c_tag .= '<br>';

	/* determine IM status */
	if ( $obj->icq ) 	$im_icq =   ' <a href="usrinfo.php?id='.$obj->poster_id.'#icq_msg"><img src="http://web.icq.com/whitepages/online?icq='.$obj->icq.'&amp;img=5" border=0></a> ';
	if ( $obj->aim ) 	$im_aim =   ' <a href="aim:goim?screenname='.urlencode($obj->aim).'&message=Hi.+Are+you+there?"><img src="'.$GLOBALS["fud_img_suffix"].'aim.gif" border=0></a> ';
	if ( $obj->yahoo ) 	$im_yahoo = ' <a target=_new href="http://edit.yahoo.com/config/send_webmesg?.target='.urlencode($obj->yahoo).'&.src=pg"><img src="'.$GLOBALS["fud_img_suffix"].'yahoo.gif" border=0></a> ';
	if ( $obj->msnm ) 	$im_msnm =  ' <a href="mailto:'.$obj->msnm.'"><img src="'.$GLOBALS["fud_img_suffix"].'msnm.gif" border=0></a>';
	
	echo '<td'.$style.' valign=top nowrap><table cellspacing=0 cellpadding=0 border=0><tr><td valign="middle">'.$line_status.'</td><td valign="middle" class="GenText">'.$logincap.'<br>'.$lev_txt.'</td></tr></table><font class="GenText">'.$avatar_img.'<p>'.$c_tag.$posted_msg_count.$loc.$ipaddr.$host_name.$registered.$spacer.$buddy_lnk.$ignore_lnk.'</font><div align=center>'.$im_icq.$im_aim.$im_yahoo.$im_msnm.'</div></td>';
	echo '<td'.$style.' valign="top" width="100%"><table valign="top" border=0 cellspacing=0 cellpadding=0 width="100%"><tr><td valign="top" align="left" class="MsgSubText"><a name="msg_num_'.$GLOBALS['__MSG_COUNT__'].'"></a><a name="msg_'.$obj->id.'"></a>'.$icon.$obj->subject.'</td><td valign="top" align=right><img src="'.$GLOBALS['fud_img_suffix'].'posticon.gif" border=0><font class="DateText">'.format_date($obj->post_stamp).' '.format_time($obj->post_stamp).'</font> '.$message_pager.'</td></tr><tr><td colspan=2 class="ContentTable"><img src="blank.gif" border=0></td></tr><tr'.$style.'valign="top"><td colspan=2 valign="top" height="100%"><font class="MsgBodyText">';

	if( $obj->length ) 
		echo read_ext_body($obj->offset,$obj->length);
	else
		echo 'No Message Body';	
	
	if( !empty($GLOBALS['opt']) && $obj->locked != 'Y' ) {
		register_vote($GLOBALS['opt']);
		$GLOBALS['opt']=NULL;
	}	
	
	if ( $obj->poll_id ) {
		$show_res=1;
		
		$poll_obj = DB_SINGLEOBJ(Q("SELECT * FROM fud_poll WHERE id=".$obj->poll_id));

		/* check if the thread is locked */
		if ( $obj->locked == 'N' && isset($GLOBALS["usr"]) && !BQ("SELECT id FROM fud_poll_opt_track WHERE poll_id=".$poll_obj->id." AND user_id=".$GLOBALS["usr"]->id) ) 
			$show_res=0;
		
		if ( isset($GLOBALS["pl_view"]) && $GLOBALS["pl_view"] == $poll_obj->id ) $show_res = 1;
		
		/* determine if poll is expired or reach max count */
			
		$res = Q("SELECT * FROM fud_poll_opt WHERE poll_id=".$poll_obj->id);
		$total_votes = Q_SINGLEVAL("SELECT sum(count) FROM fud_poll_opt WHERE poll_id=".$poll_obj->id." GROUP BY poll_id");
		
		$i=0;
		if ( $poll_obj->max_votes && $total_votes >= $poll_obj->max_votes ) $show_res = 1;
		if ( $poll_obj->expiry_date && ($poll_obj->creation_date + $poll_obj->expiry_date) <= time() ) $show_res = 1;
		
		echo '<p><table border=0 cellspacing=1 cellpadding=2 class="PollTable"><form method="post"><input type="hidden" name="rid" value="'.$GLOBALS["usr"]->id.'">';
		echo '<tr class="TableHeading"><td nowrap colspan=3 class="GenText">'.$poll_obj->name.'<img src="blank.gif" border=0 height=1 width=10><font class="SmallText">[ '.$total_votes.' votes ]</font></td></tr>';
		while ( $opt = DB_ROWOBJ($res) ) {
			if ( $show_res || !empty($GLOBALS["post_form"]) ) {
				if( $opt->count ) 
					$length = round($opt->count/$total_votes*100);
				else
					$length = 0;	
				echo '<tr class="RowStyle'.(($i%2)?'A':'B').'"><td>'.(++$i).'.</td><td>'.$opt->name.'</td><td><img src="'.$GLOBALS['fud_img_suffix'].'poll_pix.gif" height="10" width="'.$length.'"> '.$opt->count.' / '.$length.'%</td></tr>';
			}
			else 
				echo '<tr class="RowStyle'.(($i%2)?'A':'B').'"><td>'.(++$i).'.</td><td colspan=2><input type="radio" name="opt" value="'.$opt->id.'">&nbsp;&nbsp;'.$opt->name.'</td></tr>';
		}
			
		QF($res);
			
		if ( !$show_res ) {
			echo '<tr class="RowStyle'.((($i++)%2)?'A':'B').'"><td colspan=3 align="right">';
			echo '<input type="submit" name="pl_vote" value="Vote"> ';
			if( $total_votes ) echo '<input type="submit" name="pl_res" value="View Results">';
			echo '</td></tr>';
		}
			
		echo '<input type="hidden" name="pl_view" value="'.$poll_obj->id.'">
		      <input type="hidden" name="S" value="'.$GLOBALS["S"].'">
		      <input type="hidden" name="pl_msg" value="'.$obj->id.'">
		      </form></table><p>';
	}

	if ( $obj->attach_cnt ) {
		echo '<p>';
		$a_result = Q("SELECT id,original_name,dlcount FROM fud_attach WHERE message_id=".$obj->id." AND private='N'");
		if ( DB_COUNT($a_result) ) {
			echo '<table border=0 cellspacing=0 cellpadding=2>';
			while ( $a_obj = DB_ROWOBJ($a_result) ) {
				if( file_exists($GLOBALS["FILE_STORE"].$a_obj->id.".atch") ) {
					$sz = filesize($GLOBALS["FILE_STORE"].$a_obj->id.".atch")/1024;
					echo '<tr><td valign=middle><a class="GenLink" href="getfile.php?id='.$a_obj->id.'&'.$_RSID.'"><img src="'.$GLOBALS['fud_img_suffix'].'attach.gif" border=0 alt="Attachment"></a></td><td><font class="GenText"><b>Attachment:</b></font> <a class="GenLink" href="getfile.php?id='.$a_obj->id.'&'.$_RSID.'">'.$a_obj->original_name.'</a><br><font class="SmallText">(Size: '.(( $sz < 1000 ) ? number_format($sz,2).'Kb' : number_format($sz/1024,2).'Mb').', Downloaded '.$a_obj->dlcount.' time(s))</font></td></tr>';
				}					
			}
			echo '</table>';
		}
		QF($a_result);	
	}
		
	if ( $obj->update_stamp ) {
		if( $obj->updated_by != $obj->poster_id && strtolower($GLOBALS['EDITED_BY_MOD']) == 'y' ) 
			echo '<p>[Updated on: '.format_date($obj->update_stamp).' '.format_time($obj->update_stamp).' by Moderator]';
		else if ( $obj->updated_by == $obj->poster_id && strtolower($GLOBALS['SHOW_EDITED_BY']) == 'y' ) 
			echo '<p>[Updated on: '.format_date($obj->update_stamp).' '.format_time($obj->update_stamp).']';			
	}		
	
	if ( $GLOBALS["ALLOW_SIGS"] == 'Y' && $obj->show_sig == 'Y' && !$show_sigs && $obj->sig) echo '<p><u>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</u><br>'.$obj->sig."\n";
		
	echo '</font>';
	if( empty($GLOBALS["post_form"]) ) echo '<div align="right"><font class="SmallText">[<a class="SmallText" href="report.php?msg_id='.$obj->id.'&'.$GLOBALS['returnto'].'&'.$_RSID.'">Report message to a moderator</a>]</font></div>';
	echo '</td></tr></table></td>';
	lay_end_content_row();
		
	if( empty($GLOBALS["post_form"]) ) {
		echo '<tr class="MsgToolBar"><td colspan=2><table border=0 cellspacing=0 cellpadding=0 width="100%"><tr><td align="left" nowrap width="1%">';
		
		if( $obj->user_id ) {
			echo $login_href_pref.'<img src="'.$GLOBALS["fud_img_suffix"].'msg_about.gif" alt="Author\'s Profile" border=0>'.$login_href_suff.' ';
			if( $GLOBALS["ALLOW_EMAIL"] == 'Y' ) echo '<a class="GenLink" href="email.php?tx_name='.urlencode($obj->login).'&'.$_RSID.'&returnto='.base64_encode($GLOBALS["HTTP_SERVER_VARS"]["REQUEST_URI"].'#msg_'.$obj->id).'"><img src="'.$GLOBALS["fud_img_suffix"].'msg_email.gif" alt="Email Author" border=0></a> ';
			if( $GLOBALS['PM_ENABLED']=='Y' ) echo '<a class="GenLink" href="ppost.php?msg_to_list='.urlencode($obj->login).'&'.$_RSID.'&returnto='.base64_encode($GLOBALS["HTTP_SERVER_VARS"]["REQUEST_URI"].'#msg_'.$obj->id).'"><acronym title="Send a private message to this user"><img src="'.$GLOBALS["fud_img_suffix"].'msg_pm.gif" alt="Send Private Message" border=0></acronym></a>';
		}
		
		echo '</td><td align="center" class="GenText">';
		if( $msg_count && empty($GLOBALS["post_form"]) && $pager && $GLOBALS['__MSG_COUNT__'] == $msg_count && $obj->id!=$obj->last_post_id ) 
			echo '<a href="msg.php?'.$_RSID.'&prevloaded=1&th='.$obj->thread_id.'&start='.($GLOBALS['start']+$GLOBALS['count']).'&rev='.$GLOBALS['rev'].'&reveal='.$GLOBALS['reveal'].'&count='.$GLOBALS['count'].'" class="GenLink">Next Page <img src="'.$GLOBALS["fud_img_suffix"].'goto.gif" border=0></a>';
		else
			echo '&nbsp;';	
		echo '</td><td align="right" nowrap width="1%">';
		
		if ( isset($GLOBALS["usr"]) && ($GLOBALS["usr"]->id == $obj->poster_id || $GLOBALS["MOD"]) )
			echo '<a class="GenLink" href="post.php?'.$GLOBALS["returnto"].'&msg_id='.$obj->id.'&'.$_RSID.'"><img src="'.$GLOBALS["fud_img_suffix"].'msg_edit.gif" alt="Edit" border=0></a> ';

		if ( $GLOBALS["MOD"] ) 
			echo '<a class="GenLink" href="'.$GLOBALS["HTTP_SERVER_VARS"]["SCRIPT_NAME"].'?del='.$obj->id.'&'.$_RSID.'&th='.$obj->thread_id.'"><img src="'.$GLOBALS["fud_img_suffix"].'msg_delete.gif" alt="Delete" border=0></a> ';
		
		if( $GLOBALS["MOD"] || $obj->locked=='N' ) {
			echo '<a class="GenLink" href="post.php?'.$GLOBALS["returnto"].'&reply_to='.$obj->id.'&'.$_RSID.'"><img src="'.$GLOBALS["fud_img_suffix"].'msg_reply.gif" alt="Reply" border=0></a> ';
			echo '<a class="GenLink" href="post.php?'.$GLOBALS["returnto"].'&reply_to='.$obj->id.'&'.$_RSID.'&quote=true"><img src="'.$GLOBALS["fud_img_suffix"].'msg_quote.gif" alt="Reply w/Quote" border=0></a>';
		}	

		echo '</td></tr></table></td></tr>';
		
		$GLOBALS['__MSG_COUNT__']++;
	}	
}		
?>