<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: poll.inc,v 1.5 2002/02/05 00:37:54 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/
 if ( defined('_POLL_INC_') ) return; else define('_POLL_INC_', 1);

	include_once "GLOBALS.php";
	fud_use('db.inc');
	
	
class fud_poll
{
	var $id;
	var $name=NULL;
	var $owner=NULL;
	var $creation_date=NULL;
	var $expiry_date=NULL;
	var $max_votes=NULL;
	
	function add()
	{
		Q("INSERT INTO fud_poll (
			name, 
			owner, 
			creation_date, 
			expiry_date,
			max_votes
			) 
			VALUES(
			'".$this->name."',
			".$this->owner.",
			".time().",
			".INTZERO($this->expiry_date).",
			0
			)");
		$this->id = DB_LASTID();
		
		return $this->id;
	}
	
	function sync()
	{
		Q("UPDATE fud_poll SET 
			name='".$this->name."',
			expiry_date=".INTZERO($this->expiry_date).",
			max_votes=".INTZERO($this->max_votes)."
		WHERE id=".$this->id);
	}
	
	function get($id) 
	{
		QOBJ("SELECT * FROM fud_poll WHERE id=".$id, $this);
	}
	
	function delete()
	{
		Q("DELETE FROM fud_poll_opt WHERE poll_id=".$this->id);
		Q("DELETE FROM fud_poll_opt_track WHERE poll_id=".$this->id);
		Q("DELETE FROM fud_poll WHERE id=".$this->id);
	}
	
	function regvote($user_id)
	{
		Q("INSERT INTO fud_poll_opt_track(poll_id, user_id) VALUES(".$this->id.", ".$user_id.")");
	}
	
	function voted($user_id)
	{
		return Q_SINGLEVAL("SELECT id FROM fud_poll_opt_track WHERE poll_id=".$this->id." AND user_id=".$user_id);
	}
}

class fud_poll_opt
{
	var $id=NULL;
	var $poll_id=NULL;
	var $name=NULL;
	var $count=NULL;
	
	var $all=NULL;
	var $all_c=NULL;
	
	function add()
	{
		Q("INSERT INTO fud_poll_opt (poll_id, name, count) VALUES (".$this->poll_id.",'".$this->name."',".INTZERO($this->count).")");
		return DB_LASTID();
	}
	
	function sync()
	{
		Q("UPDATE fud_poll_opt SET name='".$this->name."' WHERE id=".$this->id);
	}
	
	function get($id)
	{
		QOBJ("SELECT * FROM fud_poll_opt WHERE id=".$id, $this);
	}
	
	function delete()
	{
		Q("DELETE FROM fud_poll_opt WHERE id=".$this->id);
	}
	
	function fetch_vars($array, $prefix)
	{
		$this->name = $array[$prefix.'name'];
	}
	
	function increase()
	{
		Q("UPDATE fud_poll_opt SET count=count+1 WHERE id=".$this->id);
	}
	
	function get_poll($pl_id) 
	{
		$res = Q("SELECT * FROM fud_poll_opt WHERE poll_id=".$pl_id." ORDER BY id");
		if ( !IS_RESULT($res) ) return;
		
		unset($this->all);
		$this->all_c = 0;
		while ( $obj=DB_ROWOBJ($res) ) {
			$this->all[] = $obj;
		}
		
		QF($res);
	}
	
	function reset_opt()
	{
		if ( isset($this->all) ) reset($this->all);
	}
	
	function count_opt()
	{
		if ( isset($this->all) ) return count($this->all);
		return;
	}
	
	function next_opt()
	{
		if ( $this->all_c > count($this->all) ) return;
		return ( isset($this->all[$this->all_c])?$this->all[$this->all_c++]:'');
	}
}
?>