<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: private.inc,v 1.15 2002/02/12 19:48:44 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/
 if ( defined('_PRIVATE_INC_') ) return; else define('_PRIVATE_INC_', 1);

	include_once "GLOBALS.php";
	fud_use('db.inc');
	fud_use('objutil.inc');
	fud_use('attach.inc');
	fud_use('rhost.inc');
	
class fud_pmsg
{
	var $id='';
	var $to_list='';
	var $ouser_id='';
	var $duser_id='';
	var $ip_addr='';
	var $host_name='';
	var $post_stamp='';
	
	var $icon='';
	var $mailed='';

	var $folder_id='';

	var $subject='';
	var $attach_cnt='';
	var $smiley_disabled='';
	var $show_sig='';
	var $track='';
	var $length='';
	var $offset='';
	var $login='';
	
	var $body;
	
	function add($track='')
	{
		$this->post_stamp = time();
		$this->ip_addr = $GLOBALS['HTTP_SERVER_VARS']['REMOTE_ADDR'];
	
		if ( $GLOBALS['PUBLIC_RESOLVE_HOST'] == 'Y' ) $this->host_name = get_host($this->ip_addr);
		
		if( empty($this->mailed) ) $this->mailed = ( $this->folder_id=='SENT' ) ? 'Y' : 'N';
		
		Q("INSERT INTO fud_pmsg (
			ouser_id,
			duser_id,
			to_list,
			ip_addr,
			host_name,
			post_stamp,
			icon,
			mailed,
			folder_id,
			subject,
			attach_cnt,
			smiley_disabled,
			show_sig,
			track,
			read_stamp
			)
			VALUES(
				".$this->ouser_id.",
				".$this->ouser_id.",
				".STRNULL($this->to_list).",
				".IFNULL($this->ip_addr, "'0.0.0.0'").",
				".STRNULL($this->host_name).",
				".$this->post_stamp.",
				".STRNULL($this->icon).",
				'".YN($this->mailed)."',
				'DRAFT',
				'".$this->subject."',
				".INTZERO($this->attach_cnt).",
				'".YN($this->smiley_disabled)."',
				'".YN($this->show_sig)."',
				'".YN($this->track)."',
				".$this->post_stamp."
			)");
			
		$this->id = DB_LASTID();
			
		list($this->offset, $this->length) = write_pmsg_body($this->body);
		
		Q("UPDATE fud_pmsg SET offset=".$this->offset.", length=".$this->length.", folder_id='".$this->folder_id."' WHERE id=".$this->id);
			
		if( $this->folder_id == 'SENT' && empty($track) ) $this->send_pmsg();
	}
	
	function send_pmsg()
	{
		while( list(, $v) = each($GLOBALS['recv_user_id']) ) {
			Q("INSERT INTO 
			fud_pmsg 
			(
				to_list,
				ouser_id,
				ip_addr,
				host_name,
				post_stamp,
				icon,
				mailed,
				folder_id,
				subject,
				attach_cnt,
				show_sig,
				smiley_disabled,
				track,
				offset,
				length,
				duser_id
			)
			VALUES
			(
				".STRNULL($this->to_list).",
				".$this->ouser_id.",
				".IFNULL($this->ip_addr, "'0.0.0.0'").",
				".STRNULL($this->host_name).",
				".$this->post_stamp.",
				".STRNULL($this->icon).",
				'Y',
				'INBOX',
				'".$this->subject."',
				".INTZERO($this->attach_cnt).",
				'".YN($this->show_sig)."',
				'".YN($this->smiley_disabled)."',
				'".YN($this->track)."',
				".$this->offset.",
				".$this->length.",
				".$v."
			)
			");
			$GLOBALS["send_to_array"][] = array($v,DB_LASTID());
		}	
	}
	
	function move_folder($folder_id)
	{
		if( empty($folder_id) ) return;
		Q("UPDATE fud_pmsg SET folder_id='".$folder_id."' WHERE duser_id=".$GLOBALS["usr"]->id." AND id=".$this->id);
		$this->mark_read();
	}
	
	function sync()
	{
		list($this->offset, $this->length) = write_pmsg_body($this->body);
		
		$this->post_stamp = time();
		$this->ip_addr = $GLOBALS['HTTP_SERVER_VARS']['REMOTE_ADDR'];
		
		if ( $GLOBALS['PUBLIC_RESOLVE_HOST'] == 'Y' ) $this->host_name = get_host($this->ip_addr);
		
		$this->mailed = ( $this->folder_id=='SENT' ) ? 'Y' : 'N';
		
		Q("UPDATE fud_pmsg 
			SET
				to_list=".STRNULL($this->to_list).",
				icon=".STRNULL($this->icon).",
				ouser_id=".$this->ouser_id.",
				duser_id=".$this->ouser_id.",
				post_stamp=".$this->post_stamp.",
				subject='".$this->subject."',
				ip_addr='".$this->ip_addr."',
				host_name='".$this->host_name."',
				mailed='".YN($this->mailed)."',
				attach_cnt=".INTZERO($this->attach_cnt).",
				show_sig='".YN($this->show_sig)."',
				smiley_disabled='".YN($this->smiley_disabled)."',
				track='".YN($this->track)."',
				folder_id='".$this->folder_id."',
				offset=".$this->offset.",
				length=".$this->length."
			WHERE
				id=".$this->id);
				
		if( $this->folder_id == 'SENT' ) $this->send_pmsg();		
	}
	
	function del_pmsg($fldr_id='')
	{
		if( empty($fldr_id) ) {
			$fldr_id = Q_SINGLEVAL("SELECT folder_id FROM fud_pmsg WHERE duser_id=".$GLOBALS["usr"]->id." AND id=".$this->id);
			$this->mark_read();
		}	
		if( empty($fldr_id) ) return;
			
		if( $fldr_id != 'TRASH' ) 
			$this->move_folder('TRASH');				
		else {
			$this->get($this->id, 1);
			
			Q("DELETE FROM fud_pmsg WHERE duser_id='".$this->duser_id."' AND id=".$this->id);
			if ( $this->attach_cnt ) {
				$res = Q("SELECT location FROM fud_attach WHERE message_id=".$this->id." AND private='Y'");
				if( DB_COUNT($res) ) {
					while ( list($loc) = DB_ROWARR($res) ) {
						if( file_exists($loc) ) unlink($loc);				
					}
				}
				QF($res);
				Q("DELETE FROM fud_attach WHERE message_id=".$this->id." AND private='Y'");
			}
		}	
	}
	
	function get($id, $re='')
	{
		QOBJ("SELECT fud_pmsg.*,fud_users.login FROM fud_pmsg LEFT JOIN fud_users ON fud_pmsg.ouser_id=fud_users.id WHERE ".(empty($GLOBALS['ADMIN_FORM'])?"fud_pmsg.duser_id=".$GLOBALS["usr"]->id." AND ":'')."fud_pmsg.id=".$id, $this);
		if( !empty($this->id) && empty($re) ) {
			$this->body = read_pmsg_body($this->offset, $this->length);
		}	
	}
	
	function send_notify_msg()
	{
		$track_msg = new fud_pmsg;
		$track_msg->ouser_id = $track_msg->duser_id = $this->ouser_id;
		$track_msg->ip_addr = $track_msg->host_name = NULL;
		$track_msg->post_stamp = time();
		$track_msg->mailed='Y';
		$track_msg->folder_id='INBOX';
		$track_msg->track='N';
		$track_msg->subject = 'Read Notification For: '.addslashes($this->subject);
		$track_msg->body = 'Hello,<br>'.$GLOBALS["usr"]->login.' has read your private message, "'.addslashes($this->subject).'", on '.format_date($track_msg->post_stamp).' '.format_time($track_msg->post_stamp).'<br>';
		$track_msg->add(1);
		$this->mark_notify();	
	}

	function mark_read()
	{
		Q("UPDATE fud_pmsg SET read_stamp=".time()." WHERE id=".$this->id);
	}
	
	function mark_notify()
	{
		Q("UPDATE fud_pmsg SET track='SENT' WHERE id=".$this->id);
	}	
}

function write_pmsg_body($text)
{
	$fp = fopen($GLOBALS['MSG_STORE_DIR'].'private', 'a');
	flock($fp, LOCK_EX);
	
	$s = ftell($fp);
	if( !$s ) $s = filesize($GLOBALS['MSG_STORE_DIR'].'private');
	
	fwrite($fp, $text);
	fflush($fp);
	flock($fp, LOCK_UN);
	$len = (ftell($fp)-$s);
	fclose($fp);
	
	return array($s,$len);
}

function read_pmsg_body($offset, $length)
{
	if( empty($length) ) return;
	
	$fp = fopen($GLOBALS['MSG_STORE_DIR'].'private', 'r');
	flock($fp, LOCK_SH);
	
	fseek($fp, $offset, SEEK_SET);
	$str = fread($fp, $length);
	
	flock($fp, LOCK_UN);
	fclose($fp);
	
	return $str;
}

function get_cur_ppage($folder_id, $msg_subject)
{
	global $_RSID;

	$data = '<font class="SmallText"><a class="GenLink" href="pmsg.php?'.$_RSID.'">Private Messaging</a> &raquo; ';
	
	if( empty($msg_subject) && strstr("ppost.php", $GLOBALS["PHP_SELF"]) ) $msg_subject = 'Writing Private Message';
	
	if( empty($folder_id) ) {
		$data .= 'Writing Private Message';
	}
	else {	
		if( !empty($msg_subject) ) 
			$data .= '<a href="pmsg.php?folder_id='.$folder_id.'&'.$_RSID.'" class="GenLink">'.$folder_id.'</a> &raquo; '.$msg_subject;
		else
			$data .= $folder_id;	
	}

	$data .= '</font><br><img src="blank.gif" height=4 width=1 border=0><br>';
	
	return $data;
}
?>