<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: style_mod.inc,v 1.4 2002/02/12 19:55:00 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/

class fud_style
{
	var $id;
	var $name;
	var $enabled;
	var $default_s;
	
	function add()
	{
		Q("INSERT INTO fud_style (name, enabled, default_s) VALUES('".$this->name."', '".YN($this->enabled)."', '".YN($this->default_s)."')");
		$this->id = DB_LASTID();
		
		if( $this->default_s == 'Y' ) 
			$this->activate_def($this->id);
			
		return $this->id;	
	}
	
	function sync($id)
	{
		Q("UPDATE fud_style SET name='".$this->name."' WHERE id=".$id);
		if( $this->default_s == 'Y' ) 
			$this->activate_def($id);
		if( $this->enabled == 'N' )
			$this->disable($id);
	}
	
	function get_default_id($id)
	{
		$res = Q("SELECT id FROM fud_style WHERE id!=".$id." AND (default_s='Y' OR enabled='Y' OR id=1) ORDER BY id LIMIT 1");
		list($this->id) = DB_ROWARR($res); 
		QF($res);
		
		return $this->id;
	}
	
	function activate_def($id=1)
	{
		Q("UPDATE fud_style SET default_s='Y',enabled='Y' WHERE id=".$id);
		Q("UPDATE fud_style SET default_s='N' WHERE id!=".$id);
	}
	
	function delete($id)
	{
		if( $id==1 ) return;
		
		$this->get_default_id($id);
		$this->activate_def($this->id);
	
		Q("UPDATE fud_users SET style=0 WHERE style=".$id);
		Q("DELETE FROM fud_style WHERE id=".$id);
		unlink($GLOBALS["FORUM_SETTINGS_PATH"].'header_'.$id.'.inc');
		unlink($GLOBALS["FORUM_SETTINGS_PATH"].'footer_'.$id.'.inc');
	}
	
	function disable($id)
	{
		$this->get_default_id($id);
		if( $this->id == $id ) return;
		$this->activate_def($this->id);
		
		Q("UPDATE fud_users SET style=0 WHERE style=".$id);
		Q("UPDATE fud_style SET enabled='N',default_s='N' WHERE id=".$id);
	}
	
	function enable($id)
	{
		Q("UPDATE fud_style SET enabled='Y' WHERE id=".$id);
	}
	
	function fetch_vars($array, $prefix)
	{
		$this->name = $array[$prefix.'name'];
		$this->enabled = $array[$prefix.'enabled'];
		$this->default_s = $array[$prefix.'default_s'];
	}
}
?>