<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: tz.inc,v 1.3 2002/02/05 00:37:54 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/

function create_timezone_select($name, $def)
{
	
	$rval = '<select name="'.$name.'" class="SmallText">';
	$rval .= "<option value=\"Asia/Kabul\"".(($def=="Asia/Kabul")?' selected':'').">Afghanistan/Kabul ";
	$rval .= "<option value=\"Europe/Tirane\"".(($def=="Europe/Tirane")?' selected':'').">Albania/Tirane ";
	$rval .= "<option value=\"Africa/Algiers\"".(($def=="Africa/Algiers")?' selected':'').">Algeria/Algiers ";
	$rval .= "<option value=\"Europe/Andorra\"".(($def=="Europe/Andorra")?' selected':'').">Andorra/Andorra ";
	$rval .= "<option value=\"Africa/Luanda\"".(($def=="Africa/Luanda")?' selected':'').">Angola/Luanda ";
	$rval .= "<option value=\"America/Anguilla\"".(($def=="America/Anguilla")?' selected':'').">Anguilla/Anguilla ";
	$rval .= "<option value=\"Antarctica/Casey\"".(($def=="Antarctica/Casey")?' selected':'').">Antarctica/Casey Casey Station, Bailey Peninsula";
	$rval .= "<option value=\"Antarctica/Davis\"".(($def=="Antarctica/Davis")?' selected':'').">Antarctica/Davis Davis Station, Vestfold Hills";
	$rval .= "<option value=\"Antarctica/DumontDUrville\"".(($def=="Antarctica/DumontDUrville")?' selected':'').">Antarctica/DumontDUrville Dumont-d'Urville Base, Terre Adelie";
	$rval .= "<option value=\"Antarctica/Mawson\"".(($def=="Antarctica/Mawson")?' selected':'').">Antarctica/Mawson Mawson Station, Holme Bay";
	$rval .= "<option value=\"Antarctica/McMurdo\"".(($def=="Antarctica/McMurdo")?' selected':'').">Antarctica/McMurdo McMurdo Station, Ross Island";
	$rval .= "<option value=\"Antarctica/Palmer\"".(($def=="Antarctica/Palmer")?' selected':'').">Antarctica/Palmer Palmer Station, Anvers Island";
	$rval .= "<option value=\"Antarctica/South_Pole\"".(($def=="Antarctica/South_Pole")?' selected':'').">Antarctica/South Pole Amundsen-Scott Station, South Pole";
	$rval .= "<option value=\"Antarctica/Syowa\"".(($def=="Antarctica/Syowa")?' selected':'').">Antarctica/Syowa Syowa Station, E Ongul I";
	$rval .= "<option value=\"America/Antigua\"".(($def=="America/Antigua")?' selected':'').">Antigua & Barbuda/Antigua ";
	$rval .= "<option value=\"America/Buenos_Aires\"".(($def=="America/Buenos_Aires")?' selected':'').">Argentina/Buenos Aires E Argentina (BA, DF, SC, TF)";
	$rval .= "<option value=\"America/Catamarca\"".(($def=="America/Catamarca")?' selected':'').">Argentina/Catamarca Catamarca (CT)";
	$rval .= "<option value=\"America/Cordoba\"".(($def=="America/Cordoba")?' selected':'').">Argentina/Cordoba W Argentina (CB, SA, TM, LR, SJ, SL, NQ, RN)";
	$rval .= "<option value=\"America/Jujuy\"".(($def=="America/Jujuy")?' selected':'').">Argentina/Jujuy Jujuy (JY)";
	$rval .= "<option value=\"America/Mendoza\"".(($def=="America/Mendoza")?' selected':'').">Argentina/Mendoza Mendoza (MZ)";
	$rval .= "<option value=\"America/Rosario\"".(($def=="America/Rosario")?' selected':'').">Argentina/Rosario NE Argentina (SF, ER, CN, MN, CC, FM, LP, CH)";
	$rval .= "<option value=\"Asia/Yerevan\"".(($def=="Asia/Yerevan")?' selected':'').">Armenia/Yerevan ";
	$rval .= "<option value=\"America/Aruba\"".(($def=="America/Aruba")?' selected':'').">Aruba/Aruba ";
	$rval .= "<option value=\"Australia/Adelaide\"".(($def=="Australia/Adelaide")?' selected':'').">Australia/Adelaide South Australia";
	$rval .= "<option value=\"Australia/Brisbane\"".(($def=="Australia/Brisbane")?' selected':'').">Australia/Brisbane Queensland - most locations";
	$rval .= "<option value=\"Australia/Broken_Hill\"".(($def=="Australia/Broken_Hill")?' selected':'').">Australia/Broken Hill New South Wales - Broken Hill";
	$rval .= "<option value=\"Australia/Darwin\"".(($def=="Australia/Darwin")?' selected':'').">Australia/Darwin Northern Territory";
	$rval .= "<option value=\"Australia/Hobart\"".(($def=="Australia/Hobart")?' selected':'').">Australia/Hobart Tasmania";
	$rval .= "<option value=\"Australia/Lindeman\"".(($def=="Australia/Lindeman")?' selected':'').">Australia/Lindeman Queensland - Holiday Islands";
	$rval .= "<option value=\"Australia/Lord_Howe\"".(($def=="Australia/Lord_Howe")?' selected':'').">Australia/Lord Howe Lord Howe Island";
	$rval .= "<option value=\"Australia/Melbourne\"".(($def=="Australia/Melbourne")?' selected':'').">Australia/Melbourne Victoria";
	$rval .= "<option value=\"Australia/Perth\"".(($def=="Australia/Perth")?' selected':'').">Australia/Perth Western Australia";
	$rval .= "<option value=\"Australia/Sydney\"".(($def=="Australia/Sydney")?' selected':'').">Australia/Sydney New South Wales - most locations";
	$rval .= "<option value=\"Europe/Vienna\"".(($def=="Europe/Vienna")?' selected':'').">Austria/Vienna ";
	$rval .= "<option value=\"Asia/Baku\"".(($def=="Asia/Baku")?' selected':'').">Azerbaijan/Baku ";
	$rval .= "<option value=\"America/Nassau\"".(($def=="America/Nassau")?' selected':'').">Bahamas/Nassau ";
	$rval .= "<option value=\"Asia/Bahrain\"".(($def=="Asia/Bahrain")?' selected':'').">Bahrain/Bahrain ";
	$rval .= "<option value=\"Asia/Dhaka\"".(($def=="Asia/Dhaka")?' selected':'').">Bangladesh/Dhaka ";
	$rval .= "<option value=\"America/Barbados\"".(($def=="America/Barbados")?' selected':'').">Barbados/Barbados ";
	$rval .= "<option value=\"Europe/Minsk\"".(($def=="Europe/Minsk")?' selected':'').">Belarus/Minsk ";
	$rval .= "<option value=\"Europe/Brussels\"".(($def=="Europe/Brussels")?' selected':'').">Belgium/Brussels ";
	$rval .= "<option value=\"America/Belize\"".(($def=="America/Belize")?' selected':'').">Belize/Belize ";
	$rval .= "<option value=\"Africa/Porto-Novo\"".(($def=="Africa/Porto-Novo")?' selected':'').">Benin/Porto-Novo ";
	$rval .= "<option value=\"Atlantic/Bermuda\"".(($def=="Atlantic/Bermuda")?' selected':'').">Bermuda/Bermuda ";
	$rval .= "<option value=\"Asia/Thimphu\"".(($def=="Asia/Thimphu")?' selected':'').">Bhutan/Thimphu ";
	$rval .= "<option value=\"America/La_Paz\"".(($def=="America/La_Paz")?' selected':'').">Bolivia/La Paz ";
	$rval .= "<option value=\"Europe/Sarajevo\"".(($def=="Europe/Sarajevo")?' selected':'').">Bosnia & Herzegovina/Sarajevo ";
	$rval .= "<option value=\"Africa/Gaborone\"".(($def=="Africa/Gaborone")?' selected':'').">Botswana/Gaborone ";
	$rval .= "<option value=\"America/Araguaina\"".(($def=="America/Araguaina")?' selected':'').">Brazil/Araguaina Tocantins";
	$rval .= "<option value=\"America/Belem\"".(($def=="America/Belem")?' selected':'').">Brazil/Belem Amapa, E Para";
	$rval .= "<option value=\"America/Boa_Vista\"".(($def=="America/Boa_Vista")?' selected':'').">Brazil/Boa Vista Roraima";
	$rval .= "<option value=\"America/Cuiaba\"".(($def=="America/Cuiaba")?' selected':'').">Brazil/Cuiaba Mato Grosso, Mato Grosso do Sul";
	$rval .= "<option value=\"America/Eirunepe\"".(($def=="America/Eirunepe")?' selected':'').">Brazil/Eirunepe W Amazonas";
	$rval .= "<option value=\"America/Fortaleza\"".(($def=="America/Fortaleza")?' selected':'').">Brazil/Fortaleza NE Brazil (MA, PI, CE, RN, PR)";
	$rval .= "<option value=\"America/Maceio\"".(($def=="America/Maceio")?' selected':'').">Brazil/Maceio Alagoas, Sergipe";
	$rval .= "<option value=\"America/Manaus\"".(($def=="America/Manaus")?' selected':'').">Brazil/Manaus E Amazonas";
	$rval .= "<option value=\"America/Noronha\"".(($def=="America/Noronha")?' selected':'').">Brazil/Noronha Atlantic islands";
	$rval .= "<option value=\"America/Porto_Acre\"".(($def=="America/Porto_Acre")?' selected':'').">Brazil/Porto Acre Acre";
	$rval .= "<option value=\"America/Porto_Velho\"".(($def=="America/Porto_Velho")?' selected':'').">Brazil/Porto Velho W Para, Rondonia";
	$rval .= "<option value=\"America/Recife\"".(($def=="America/Recife")?' selected':'').">Brazil/Recife Pernambuco";
	$rval .= "<option value=\"America/Sao_Paulo\"".(($def=="America/Sao_Paulo")?' selected':'').">Brazil/Sao Paulo S & SE Brazil (BA, GO, DF, MG, ES, RJ, SP, PR, SC, RS)";
	$rval .= "<option value=\"Europe/Belfast\"".(($def=="Europe/Belfast")?' selected':'').">Britain (UK)/Belfast Northern Ireland";
	$rval .= "<option value=\"Europe/London\"".(($def=="Europe/London")?' selected':'').">Britain (UK)/London Great Britain";
	$rval .= "<option value=\"Indian/Chagos\"".(($def=="Indian/Chagos")?' selected':'').">British Indian Ocean Territory/Chagos ";
	$rval .= "<option value=\"Asia/Brunei\"".(($def=="Asia/Brunei")?' selected':'').">Brunei/Brunei ";
	$rval .= "<option value=\"Europe/Sofia\"".(($def=="Europe/Sofia")?' selected':'').">Bulgaria/Sofia ";
	$rval .= "<option value=\"Africa/Ouagadougou\"".(($def=="Africa/Ouagadougou")?' selected':'').">Burkina Faso/Ouagadougou ";
	$rval .= "<option value=\"Africa/Bujumbura\"".(($def=="Africa/Bujumbura")?' selected':'').">Burundi/Bujumbura ";
	$rval .= "<option value=\"Asia/Phnom_Penh\"".(($def=="Asia/Phnom_Penh")?' selected':'').">Cambodia/Phnom Penh ";
	$rval .= "<option value=\"Africa/Douala\"".(($def=="Africa/Douala")?' selected':'').">Cameroon/Douala ";
	$rval .= "<option value=\"America/Cambridge_Bay\"".(($def=="America/Cambridge_Bay")?' selected':'').">Canada/Cambridge Bay Central Time - west Nunavut";
	$rval .= "<option value=\"America/Dawson\"".(($def=="America/Dawson")?' selected':'').">Canada/Dawson Pacific Time - north Yukon";
	$rval .= "<option value=\"America/Dawson_Creek\"".(($def=="America/Dawson_Creek")?' selected':'').">Canada/Dawson Creek Mountain Standard Time - Dawson Creek & Fort Saint John, British Columbia";
	$rval .= "<option value=\"America/Edmonton\"".(($def=="America/Edmonton")?' selected':'').">Canada/Edmonton Mountain Time - Alberta, east British Columbia & west Saskatchewan";
	$rval .= "<option value=\"America/Glace_Bay\"".(($def=="America/Glace_Bay")?' selected':'').">Canada/Glace Bay Atlantic Time - Nova Scotia - places that did not observe DST 1966-1971";
	$rval .= "<option value=\"America/Goose_Bay\"".(($def=="America/Goose_Bay")?' selected':'').">Canada/Goose Bay Atlantic Time - E Labrador";
	$rval .= "<option value=\"America/Halifax\"".(($def=="America/Halifax")?' selected':'').">Canada/Halifax Atlantic Time - Nova Scotia (most places), NB, W Labrador, E Quebec & PEI";
	$rval .= "<option value=\"America/Inuvik\"".(($def=="America/Inuvik")?' selected':'').">Canada/Inuvik Mountain Time - west Northwest Territories";
	$rval .= "<option value=\"America/Iqaluit\"".(($def=="America/Iqaluit")?' selected':'').">Canada/Iqaluit Eastern Standard Time - east Nunavut";
	$rval .= "<option value=\"America/Montreal\"".(($def=="America/Montreal")?' selected':'').">Canada/Montreal Eastern Time - Ontario & Quebec - most locations";
	$rval .= "<option value=\"America/Nipigon\"".(($def=="America/Nipigon")?' selected':'').">Canada/Nipigon Eastern Time - Ontario & Quebec - places that did not observe DST 1967-1973";
	$rval .= "<option value=\"America/Pangnirtung\"".(($def=="America/Pangnirtung")?' selected':'').">Canada/Pangnirtung Eastern Standard Time - Pangnirtung, Nunavut";
	$rval .= "<option value=\"America/Rainy_River\"".(($def=="America/Rainy_River")?' selected':'').">Canada/Rainy River Central Time - Rainy River & Fort Frances, Ontario";
	$rval .= "<option value=\"America/Rankin_Inlet\"".(($def=="America/Rankin_Inlet")?' selected':'').">Canada/Rankin Inlet Eastern Standard Time - central Nunavut";
	$rval .= "<option value=\"America/Regina\"".(($def=="America/Regina")?' selected':'').">Canada/Regina Central Standard Time - Saskatchewan - most locations";
	$rval .= "<option value=\"America/St_Johns\"".(($def=="America/St_Johns")?' selected':'').">Canada/St Johns Newfoundland Island";
	$rval .= "<option value=\"America/Swift_Current\"".(($def=="America/Swift_Current")?' selected':'').">Canada/Swift Current Central Standard Time - Saskatchewan - midwest";
	$rval .= "<option value=\"America/Thunder_Bay\"".(($def=="America/Thunder_Bay")?' selected':'').">Canada/Thunder Bay Eastern Time - Thunder Bay, Ontario";
	$rval .= "<option value=\"America/Vancouver\"".(($def=="America/Vancouver")?' selected':'').">Canada/Vancouver Pacific Time - west British Columbia";
	$rval .= "<option value=\"America/Whitehorse\"".(($def=="America/Whitehorse")?' selected':'').">Canada/Whitehorse Pacific Time - south Yukon";
	$rval .= "<option value=\"America/Winnipeg\"".(($def=="America/Winnipeg")?' selected':'').">Canada/Winnipeg Central Time - Manitoba & west Ontario";
	$rval .= "<option value=\"America/Yellowknife\"".(($def=="America/Yellowknife")?' selected':'').">Canada/Yellowknife Mountain Time - central Northwest Territories";
	$rval .= "<option value=\"Atlantic/Cape_Verde\"".(($def=="Atlantic/Cape_Verde")?' selected':'').">Cape Verde/Cape Verde ";
	$rval .= "<option value=\"America/Cayman\"".(($def=="America/Cayman")?' selected':'').">Cayman Islands/Cayman ";
	$rval .= "<option value=\"Africa/Bangui\"".(($def=="Africa/Bangui")?' selected':'').">Central African Rep./Bangui ";
	$rval .= "<option value=\"Africa/Ndjamena\"".(($def=="Africa/Ndjamena")?' selected':'').">Chad/Ndjamena ";
	$rval .= "<option value=\"Pacific/Easter\"".(($def=="Pacific/Easter")?' selected':'').">Chile/Easter Easter Island";
	$rval .= "<option value=\"America/Santiago\"".(($def=="America/Santiago")?' selected':'').">Chile/Santiago mainland";
	$rval .= "<option value=\"Asia/Chungking\"".(($def=="Asia/Chungking")?' selected':'').">China/Chungking China mountains";
	$rval .= "<option value=\"Asia/Harbin\"".(($def=="Asia/Harbin")?' selected':'').">China/Harbin north Manchuria";
	$rval .= "<option value=\"Asia/Kashgar\"".(($def=="Asia/Kashgar")?' selected':'').">China/Kashgar Eastern Turkestan";
	$rval .= "<option value=\"Asia/Shanghai\"".(($def=="Asia/Shanghai")?' selected':'').">China/Shanghai China coast";
	$rval .= "<option value=\"Asia/Urumqi\"".(($def=="Asia/Urumqi")?' selected':'').">China/Urumqi Tibet & Xinjiang";
	$rval .= "<option value=\"Indian/Christmas\"".(($def=="Indian/Christmas")?' selected':'').">Christmas Island/Christmas ";
	$rval .= "<option value=\"Indian/Cocos\"".(($def=="Indian/Cocos")?' selected':'').">Cocos (Keeling) Islands/Cocos ";
	$rval .= "<option value=\"America/Bogota\"".(($def=="America/Bogota")?' selected':'').">Colombia/Bogota ";
	$rval .= "<option value=\"Indian/Comoro\"".(($def=="Indian/Comoro")?' selected':'').">Comoros/Comoro ";
	$rval .= "<option value=\"Africa/Kinshasa\"".(($def=="Africa/Kinshasa")?' selected':'').">Congo (Dem. Rep.)/Kinshasa west Dem. Rep. of Congo";
	$rval .= "<option value=\"Africa/Lubumbashi\"".(($def=="Africa/Lubumbashi")?' selected':'').">Congo (Dem. Rep.)/Lubumbashi east Dem. Rep. of Congo";
	$rval .= "<option value=\"Africa/Brazzaville\"".(($def=="Africa/Brazzaville")?' selected':'').">Congo (Rep.)/Brazzaville ";
	$rval .= "<option value=\"Pacific/Rarotonga\"".(($def=="Pacific/Rarotonga")?' selected':'').">Cook Islands/Rarotonga ";
	$rval .= "<option value=\"America/Costa_Rica\"".(($def=="America/Costa_Rica")?' selected':'').">Costa Rica/Costa Rica ";
	$rval .= "<option value=\"Africa/Abidjan\"".(($def=="Africa/Abidjan")?' selected':'').">Cote d'Ivoire/Abidjan ";
	$rval .= "<option value=\"Europe/Zagreb\"".(($def=="Europe/Zagreb")?' selected':'').">Croatia/Zagreb ";
	$rval .= "<option value=\"America/Havana\"".(($def=="America/Havana")?' selected':'').">Cuba/Havana ";
	$rval .= "<option value=\"Asia/Nicosia\"".(($def=="Asia/Nicosia")?' selected':'').">Cyprus/Nicosia ";
	$rval .= "<option value=\"Europe/Prague\"".(($def=="Europe/Prague")?' selected':'').">Czech Republic/Prague ";
	$rval .= "<option value=\"Europe/Copenhagen\"".(($def=="Europe/Copenhagen")?' selected':'').">Denmark/Copenhagen ";
	$rval .= "<option value=\"Africa/Djibouti\"".(($def=="Africa/Djibouti")?' selected':'').">Djibouti/Djibouti ";
	$rval .= "<option value=\"America/Dominica\"".(($def=="America/Dominica")?' selected':'').">Dominica/Dominica ";
	$rval .= "<option value=\"America/Santo_Domingo\"".(($def=="America/Santo_Domingo")?' selected':'').">Dominican Republic/Santo Domingo ";
	$rval .= "<option value=\"Asia/Dili\"".(($def=="Asia/Dili")?' selected':'').">East Timor/Dili ";
	$rval .= "<option value=\"Pacific/Galapagos\"".(($def=="Pacific/Galapagos")?' selected':'').">Ecuador/Galapagos Galapagos Islands";
	$rval .= "<option value=\"America/Guayaquil\"".(($def=="America/Guayaquil")?' selected':'').">Ecuador/Guayaquil mainland";
	$rval .= "<option value=\"Africa/Cairo\"".(($def=="Africa/Cairo")?' selected':'').">Egypt/Cairo ";
	$rval .= "<option value=\"America/El_Salvador\"".(($def=="America/El_Salvador")?' selected':'').">El Salvador/El Salvador ";
	$rval .= "<option value=\"Africa/Malabo\"".(($def=="Africa/Malabo")?' selected':'').">Equatorial Guinea/Malabo ";
	$rval .= "<option value=\"Africa/Asmera\"".(($def=="Africa/Asmera")?' selected':'').">Eritrea/Asmera ";
	$rval .= "<option value=\"Europe/Tallinn\"".(($def=="Europe/Tallinn")?' selected':'').">Estonia/Tallinn ";
	$rval .= "<option value=\"Africa/Addis_Ababa\"".(($def=="Africa/Addis_Ababa")?' selected':'').">Ethiopia/Addis Ababa ";
	$rval .= "<option value=\"Atlantic/Faeroe\"".(($def=="Atlantic/Faeroe")?' selected':'').">Faeroe Islands/Faeroe ";
	$rval .= "<option value=\"Atlantic/Stanley\"".(($def=="Atlantic/Stanley")?' selected':'').">Falkland Islands/Stanley ";
	$rval .= "<option value=\"Pacific/Fiji\"".(($def=="Pacific/Fiji")?' selected':'').">Fiji/Fiji ";
	$rval .= "<option value=\"Europe/Helsinki\"".(($def=="Europe/Helsinki")?' selected':'').">Finland/Helsinki ";
	$rval .= "<option value=\"Europe/Paris\"".(($def=="Europe/Paris")?' selected':'').">France/Paris ";
	$rval .= "<option value=\"America/Cayenne\"".(($def=="America/Cayenne")?' selected':'').">French Guiana/Cayenne ";
	$rval .= "<option value=\"Pacific/Gambier\"".(($def=="Pacific/Gambier")?' selected':'').">French Polynesia/Gambier Gambier Islands";
	$rval .= "<option value=\"Pacific/Marquesas\"".(($def=="Pacific/Marquesas")?' selected':'').">French Polynesia/Marquesas Marquesas Islands";
	$rval .= "<option value=\"Pacific/Tahiti\"".(($def=="Pacific/Tahiti")?' selected':'').">French Polynesia/Tahiti Society Islands";
	$rval .= "<option value=\"Indian/Kerguelen\"".(($def=="Indian/Kerguelen")?' selected':'').">French Southern & Antarctic Lands/Kerguelen ";
	$rval .= "<option value=\"Africa/Libreville\"".(($def=="Africa/Libreville")?' selected':'').">Gabon/Libreville ";
	$rval .= "<option value=\"Africa/Banjul\"".(($def=="Africa/Banjul")?' selected':'').">Gambia/Banjul ";
	$rval .= "<option value=\"Asia/Tbilisi\"".(($def=="Asia/Tbilisi")?' selected':'').">Georgia/Tbilisi ";
	$rval .= "<option value=\"Europe/Berlin\"".(($def=="Europe/Berlin")?' selected':'').">Germany/Berlin ";
	$rval .= "<option value=\"Africa/Accra\"".(($def=="Africa/Accra")?' selected':'').">Ghana/Accra ";
	$rval .= "<option value=\"Europe/Gibraltar\"".(($def=="Europe/Gibraltar")?' selected':'').">Gibraltar/Gibraltar ";
	$rval .= "<option value=\"Europe/Athens\"".(($def=="Europe/Athens")?' selected':'').">Greece/Athens ";
	$rval .= "<option value=\"America/Godthab\"".(($def=="America/Godthab")?' selected':'').">Greenland/Godthab southwest Greenland";
	$rval .= "<option value=\"America/Scoresbysund\"".(($def=="America/Scoresbysund")?' selected':'').">Greenland/Scoresbysund east Greenland";
	$rval .= "<option value=\"America/Thule\"".(($def=="America/Thule")?' selected':'').">Greenland/Thule northwest Greenland";
	$rval .= "<option value=\"America/Grenada\"".(($def=="America/Grenada")?' selected':'').">Grenada/Grenada ";
	$rval .= "<option value=\"America/Guadeloupe\"".(($def=="America/Guadeloupe")?' selected':'').">Guadeloupe/Guadeloupe ";
	$rval .= "<option value=\"Pacific/Guam\"".(($def=="Pacific/Guam")?' selected':'').">Guam/Guam ";
	$rval .= "<option value=\"America/Guatemala\"".(($def=="America/Guatemala")?' selected':'').">Guatemala/Guatemala ";
	$rval .= "<option value=\"Africa/Conakry\"".(($def=="Africa/Conakry")?' selected':'').">Guinea/Conakry ";
	$rval .= "<option value=\"Africa/Bissau\"".(($def=="Africa/Bissau")?' selected':'').">Guinea-Bissau/Bissau ";
	$rval .= "<option value=\"America/Guyana\"".(($def=="America/Guyana")?' selected':'').">Guyana/Guyana ";
	$rval .= "<option value=\"America/Port-au-Prince\"".(($def=="America/Port-au-Prince")?' selected':'').">Haiti/Port-au-Prince ";
	$rval .= "<option value=\"America/Tegucigalpa\"".(($def=="America/Tegucigalpa")?' selected':'').">Honduras/Tegucigalpa ";
	$rval .= "<option value=\"Asia/Hong_Kong\"".(($def=="Asia/Hong_Kong")?' selected':'').">Hong Kong/Hong Kong ";
	$rval .= "<option value=\"Europe/Budapest\"".(($def=="Europe/Budapest")?' selected':'').">Hungary/Budapest ";
	$rval .= "<option value=\"Atlantic/Reykjavik\"".(($def=="Atlantic/Reykjavik")?' selected':'').">Iceland/Reykjavik ";
	$rval .= "<option value=\"Asia/Calcutta\"".(($def=="Asia/Calcutta")?' selected':'').">India/Calcutta ";
	$rval .= "<option value=\"Asia/Jakarta\"".(($def=="Asia/Jakarta")?' selected':'').">Indonesia/Jakarta Java & Sumatra";
	$rval .= "<option value=\"Asia/Jayapura\"".(($def=="Asia/Jayapura")?' selected':'').">Indonesia/Jayapura Irian Jaya & the Moluccas";
	$rval .= "<option value=\"Asia/Ujung_Pandang\"".(($def=="Asia/Ujung_Pandang")?' selected':'').">Indonesia/Ujung Pandang Borneo & Celebes";
	$rval .= "<option value=\"Asia/Tehran\"".(($def=="Asia/Tehran")?' selected':'').">Iran/Tehran ";
	$rval .= "<option value=\"Asia/Baghdad\"".(($def=="Asia/Baghdad")?' selected':'').">Iraq/Baghdad ";
	$rval .= "<option value=\"Europe/Dublin\"".(($def=="Europe/Dublin")?' selected':'').">Ireland/Dublin ";
	$rval .= "<option value=\"Asia/Jerusalem\"".(($def=="Asia/Jerusalem")?' selected':'').">Israel/Jerusalem ";
	$rval .= "<option value=\"Europe/Rome\"".(($def=="Europe/Rome")?' selected':'').">Italy/Rome ";
	$rval .= "<option value=\"America/Jamaica\"".(($def=="America/Jamaica")?' selected':'').">Jamaica/Jamaica ";
	$rval .= "<option value=\"Asia/Tokyo\"".(($def=="Asia/Tokyo")?' selected':'').">Japan/Tokyo ";
	$rval .= "<option value=\"Asia/Amman\"".(($def=="Asia/Amman")?' selected':'').">Jordan/Amman ";
	$rval .= "<option value=\"Asia/Almaty\"".(($def=="Asia/Almaty")?' selected':'').">Kazakhstan/Almaty east Kazakhstan";
	$rval .= "<option value=\"Asia/Aqtau\"".(($def=="Asia/Aqtau")?' selected':'').">Kazakhstan/Aqtau west Kazakhstan";
	$rval .= "<option value=\"Asia/Aqtobe\"".(($def=="Asia/Aqtobe")?' selected':'').">Kazakhstan/Aqtobe central Kazakhstan";
	$rval .= "<option value=\"Africa/Nairobi\"".(($def=="Africa/Nairobi")?' selected':'').">Kenya/Nairobi ";
	$rval .= "<option value=\"Pacific/Enderbury\"".(($def=="Pacific/Enderbury")?' selected':'').">Kiribati/Enderbury Phoenix Islands";
	$rval .= "<option value=\"Pacific/Kiritimati\"".(($def=="Pacific/Kiritimati")?' selected':'').">Kiribati/Kiritimati Line Islands";
	$rval .= "<option value=\"Pacific/Tarawa\"".(($def=="Pacific/Tarawa")?' selected':'').">Kiribati/Tarawa Gilbert Islands";
	$rval .= "<option value=\"Asia/Pyongyang\"".(($def=="Asia/Pyongyang")?' selected':'').">Korea (North)/Pyongyang ";
	$rval .= "<option value=\"Asia/Seoul\"".(($def=="Asia/Seoul")?' selected':'').">Korea (South)/Seoul ";
	$rval .= "<option value=\"Asia/Kuwait\"".(($def=="Asia/Kuwait")?' selected':'').">Kuwait/Kuwait ";
	$rval .= "<option value=\"Asia/Bishkek\"".(($def=="Asia/Bishkek")?' selected':'').">Kyrgyzstan/Bishkek ";
	$rval .= "<option value=\"Asia/Vientiane\"".(($def=="Asia/Vientiane")?' selected':'').">Laos/Vientiane ";
	$rval .= "<option value=\"Europe/Riga\"".(($def=="Europe/Riga")?' selected':'').">Latvia/Riga ";
	$rval .= "<option value=\"Asia/Beirut\"".(($def=="Asia/Beirut")?' selected':'').">Lebanon/Beirut ";
	$rval .= "<option value=\"Africa/Maseru\"".(($def=="Africa/Maseru")?' selected':'').">Lesotho/Maseru ";
	$rval .= "<option value=\"Africa/Monrovia\"".(($def=="Africa/Monrovia")?' selected':'').">Liberia/Monrovia ";
	$rval .= "<option value=\"Africa/Tripoli\"".(($def=="Africa/Tripoli")?' selected':'').">Libya/Tripoli ";
	$rval .= "<option value=\"Europe/Vaduz\"".(($def=="Europe/Vaduz")?' selected':'').">Liechtenstein/Vaduz ";
	$rval .= "<option value=\"Europe/Vilnius\"".(($def=="Europe/Vilnius")?' selected':'').">Lithuania/Vilnius ";
	$rval .= "<option value=\"Europe/Luxembourg\"".(($def=="Europe/Luxembourg")?' selected':'').">Luxembourg/Luxembourg ";
	$rval .= "<option value=\"Asia/Macao\"".(($def=="Asia/Macao")?' selected':'').">Macao/Macao ";
	$rval .= "<option value=\"Europe/Skopje\"".(($def=="Europe/Skopje")?' selected':'').">Macedonia/Skopje ";
	$rval .= "<option value=\"Indian/Antananarivo\"".(($def=="Indian/Antananarivo")?' selected':'').">Madagascar/Antananarivo ";
	$rval .= "<option value=\"Africa/Blantyre\"".(($def=="Africa/Blantyre")?' selected':'').">Malawi/Blantyre ";
	$rval .= "<option value=\"Asia/Kuala_Lumpur\"".(($def=="Asia/Kuala_Lumpur")?' selected':'').">Malaysia/Kuala Lumpur peninsular Malaysia";
	$rval .= "<option value=\"Asia/Kuching\"".(($def=="Asia/Kuching")?' selected':'').">Malaysia/Kuching Sabah & Sarawak";
	$rval .= "<option value=\"Indian/Maldives\"".(($def=="Indian/Maldives")?' selected':'').">Maldives/Maldives ";
	$rval .= "<option value=\"Africa/Bamako\"".(($def=="Africa/Bamako")?' selected':'').">Mali/Bamako southwest Mali";
	$rval .= "<option value=\"Africa/Timbuktu\"".(($def=="Africa/Timbuktu")?' selected':'').">Mali/Timbuktu northeast Mali";
	$rval .= "<option value=\"Europe/Malta\"".(($def=="Europe/Malta")?' selected':'').">Malta/Malta ";
	$rval .= "<option value=\"Pacific/Kwajalein\"".(($def=="Pacific/Kwajalein")?' selected':'').">Marshall Islands/Kwajalein Kwajalein";
	$rval .= "<option value=\"Pacific/Majuro\"".(($def=="Pacific/Majuro")?' selected':'').">Marshall Islands/Majuro most locations";
	$rval .= "<option value=\"America/Martinique\"".(($def=="America/Martinique")?' selected':'').">Martinique/Martinique ";
	$rval .= "<option value=\"Africa/Nouakchott\"".(($def=="Africa/Nouakchott")?' selected':'').">Mauritania/Nouakchott ";
	$rval .= "<option value=\"Indian/Mauritius\"".(($def=="Indian/Mauritius")?' selected':'').">Mauritius/Mauritius ";
	$rval .= "<option value=\"Indian/Mayotte\"".(($def=="Indian/Mayotte")?' selected':'').">Mayotte/Mayotte ";
	$rval .= "<option value=\"America/Cancun\"".(($def=="America/Cancun")?' selected':'').">Mexico/Cancun Central Time - Quintana Roo";
	$rval .= "<option value=\"America/Chihuahua\"".(($def=="America/Chihuahua")?' selected':'').">Mexico/Chihuahua Mountain Time - Chihuahua";
	$rval .= "<option value=\"America/Hermosillo\"".(($def=="America/Hermosillo")?' selected':'').">Mexico/Hermosillo Mountain Standard Time - Sonora";
	$rval .= "<option value=\"America/Mazatlan\"".(($def=="America/Mazatlan")?' selected':'').">Mexico/Mazatlan Mountain Time - S Baja, Nayarit, Sinaloa";
	$rval .= "<option value=\"America/Merida\"".(($def=="America/Merida")?' selected':'').">Mexico/Merida Central Time - Campeche, Yucatan";
	$rval .= "<option value=\"America/Mexico_City\"".(($def=="America/Mexico_City")?' selected':'').">Mexico/Mexico City Central Time - most locations";
	$rval .= "<option value=\"America/Monterrey\"".(($def=="America/Monterrey")?' selected':'').">Mexico/Monterrey Central Time - Coahuila, Durango, Nuevo Leon, Tamaulipas";
	$rval .= "<option value=\"America/Tijuana\"".(($def=="America/Tijuana")?' selected':'').">Mexico/Tijuana Pacific Time";
	$rval .= "<option value=\"Pacific/Kosrae\"".(($def=="Pacific/Kosrae")?' selected':'').">Micronesia/Kosrae Kosrae";
	$rval .= "<option value=\"Pacific/Ponape\"".(($def=="Pacific/Ponape")?' selected':'').">Micronesia/Ponape Ponape (Pohnpei)";
	$rval .= "<option value=\"Pacific/Truk\"".(($def=="Pacific/Truk")?' selected':'').">Micronesia/Truk Truk (Chuuk)";
	$rval .= "<option value=\"Pacific/Yap\"".(($def=="Pacific/Yap")?' selected':'').">Micronesia/Yap Yap";
	$rval .= "<option value=\"Europe/Chisinau\"".(($def=="Europe/Chisinau")?' selected':'').">Moldova/Chisinau most locations";
	$rval .= "<option value=\"Europe/Tiraspol\"".(($def=="Europe/Tiraspol")?' selected':'').">Moldova/Tiraspol Transdniestria";
	$rval .= "<option value=\"Europe/Monaco\"".(($def=="Europe/Monaco")?' selected':'').">Monaco/Monaco ";
	$rval .= "<option value=\"Asia/Hovd\"".(($def=="Asia/Hovd")?' selected':'').">Mongolia/Hovd Bayan-Olgiy, Hovd, Uvs";
	$rval .= "<option value=\"Asia/Ulaanbaatar\"".(($def=="Asia/Ulaanbaatar")?' selected':'').">Mongolia/Ulaanbaatar most locations";
	$rval .= "<option value=\"America/Montserrat\"".(($def=="America/Montserrat")?' selected':'').">Montserrat/Montserrat ";
	$rval .= "<option value=\"Africa/Casablanca\"".(($def=="Africa/Casablanca")?' selected':'').">Morocco/Casablanca ";
	$rval .= "<option value=\"Africa/Maputo\"".(($def=="Africa/Maputo")?' selected':'').">Mozambique/Maputo ";
	$rval .= "<option value=\"Asia/Rangoon\"".(($def=="Asia/Rangoon")?' selected':'').">Myanmar (Burma)/Rangoon ";
	$rval .= "<option value=\"Africa/Windhoek\"".(($def=="Africa/Windhoek")?' selected':'').">Namibia/Windhoek ";
	$rval .= "<option value=\"Pacific/Nauru\"".(($def=="Pacific/Nauru")?' selected':'').">Nauru/Nauru ";
	$rval .= "<option value=\"Asia/Katmandu\"".(($def=="Asia/Katmandu")?' selected':'').">Nepal/Katmandu ";
	$rval .= "<option value=\"Europe/Amsterdam\"".(($def=="Europe/Amsterdam")?' selected':'').">Netherlands/Amsterdam ";
	$rval .= "<option value=\"America/Curacao\"".(($def=="America/Curacao")?' selected':'').">Netherlands Antilles/Curacao ";
	$rval .= "<option value=\"Pacific/Noumea\"".(($def=="Pacific/Noumea")?' selected':'').">New Caledonia/Noumea ";
	$rval .= "<option value=\"Pacific/Auckland\"".(($def=="Pacific/Auckland")?' selected':'').">New Zealand/Auckland most locations";
	$rval .= "<option value=\"Pacific/Chatham\"".(($def=="Pacific/Chatham")?' selected':'').">New Zealand/Chatham Chatham Islands";
	$rval .= "<option value=\"America/Managua\"".(($def=="America/Managua")?' selected':'').">Nicaragua/Managua ";
	$rval .= "<option value=\"Africa/Niamey\"".(($def=="Africa/Niamey")?' selected':'').">Niger/Niamey ";
	$rval .= "<option value=\"Africa/Lagos\"".(($def=="Africa/Lagos")?' selected':'').">Nigeria/Lagos ";
	$rval .= "<option value=\"Pacific/Niue\"".(($def=="Pacific/Niue")?' selected':'').">Niue/Niue ";
	$rval .= "<option value=\"Pacific/Norfolk\"".(($def=="Pacific/Norfolk")?' selected':'').">Norfolk Island/Norfolk ";
	$rval .= "<option value=\"Pacific/Saipan\"".(($def=="Pacific/Saipan")?' selected':'').">Northern Mariana Islands/Saipan ";
	$rval .= "<option value=\"Europe/Oslo\"".(($def=="Europe/Oslo")?' selected':'').">Norway/Oslo ";
	$rval .= "<option value=\"Asia/Muscat\"".(($def=="Asia/Muscat")?' selected':'').">Oman/Muscat ";
	$rval .= "<option value=\"Asia/Karachi\"".(($def=="Asia/Karachi")?' selected':'').">Pakistan/Karachi ";
	$rval .= "<option value=\"Pacific/Palau\"".(($def=="Pacific/Palau")?' selected':'').">Palau/Palau ";
	$rval .= "<option value=\"Asia/Gaza\"".(($def=="Asia/Gaza")?' selected':'').">Palestine/Gaza ";
	$rval .= "<option value=\"America/Panama\"".(($def=="America/Panama")?' selected':'').">Panama/Panama ";
	$rval .= "<option value=\"Pacific/Port_Moresby\"".(($def=="Pacific/Port_Moresby")?' selected':'').">Papua New Guinea/Port Moresby ";
	$rval .= "<option value=\"America/Asuncion\"".(($def=="America/Asuncion")?' selected':'').">Paraguay/Asuncion ";
	$rval .= "<option value=\"America/Lima\"".(($def=="America/Lima")?' selected':'').">Peru/Lima ";
	$rval .= "<option value=\"Asia/Manila\"".(($def=="Asia/Manila")?' selected':'').">Philippines/Manila ";
	$rval .= "<option value=\"Pacific/Pitcairn\"".(($def=="Pacific/Pitcairn")?' selected':'').">Pitcairn/Pitcairn ";
	$rval .= "<option value=\"Europe/Warsaw\"".(($def=="Europe/Warsaw")?' selected':'').">Poland/Warsaw ";
	$rval .= "<option value=\"Atlantic/Azores\"".(($def=="Atlantic/Azores")?' selected':'').">Portugal/Azores Azores";
	$rval .= "<option value=\"Europe/Lisbon\"".(($def=="Europe/Lisbon")?' selected':'').">Portugal/Lisbon mainland";
	$rval .= "<option value=\"Atlantic/Madeira\"".(($def=="Atlantic/Madeira")?' selected':'').">Portugal/Madeira Madeira Islands";
	$rval .= "<option value=\"America/Puerto_Rico\"".(($def=="America/Puerto_Rico")?' selected':'').">Puerto Rico/Puerto Rico ";
	$rval .= "<option value=\"Asia/Qatar\"".(($def=="Asia/Qatar")?' selected':'').">Qatar/Qatar ";
	$rval .= "<option value=\"Indian/Reunion\"".(($def=="Indian/Reunion")?' selected':'').">Reunion/Reunion ";
	$rval .= "<option value=\"Europe/Bucharest\"".(($def=="Europe/Bucharest")?' selected':'').">Romania/Bucharest ";
	$rval .= "<option value=\"Asia/Anadyr\"".(($def=="Asia/Anadyr")?' selected':'').">Russia/Anadyr Moscow+10 - Bering Sea";
	$rval .= "<option value=\"Asia/Irkutsk\"".(($def=="Asia/Irkutsk")?' selected':'').">Russia/Irkutsk Moscow+05 - Lake Baikal";
	$rval .= "<option value=\"Europe/Kaliningrad\"".(($def=="Europe/Kaliningrad")?' selected':'').">Russia/Kaliningrad Moscow-01 - Kaliningrad";
	$rval .= "<option value=\"Asia/Kamchatka\"".(($def=="Asia/Kamchatka")?' selected':'').">Russia/Kamchatka Moscow+09 - Kamchatka";
	$rval .= "<option value=\"Asia/Krasnoyarsk\"".(($def=="Asia/Krasnoyarsk")?' selected':'').">Russia/Krasnoyarsk Moscow+04 - Yenisei River";
	$rval .= "<option value=\"Asia/Magadan\"".(($def=="Asia/Magadan")?' selected':'').">Russia/Magadan Moscow+08 - Magadan & Sakhalin";
	$rval .= "<option value=\"Europe/Moscow\"".(($def=="Europe/Moscow")?' selected':'').">Russia/Moscow Moscow+00 - west Russia";
	$rval .= "<option value=\"Asia/Novosibirsk\"".(($def=="Asia/Novosibirsk")?' selected':'').">Russia/Novosibirsk Moscow+03 - Novosibirsk";
	$rval .= "<option value=\"Asia/Omsk\"".(($def=="Asia/Omsk")?' selected':'').">Russia/Omsk Moscow+03 - west Siberia";
	$rval .= "<option value=\"Europe/Samara\"".(($def=="Europe/Samara")?' selected':'').">Russia/Samara Moscow+01 - Caspian Sea";
	$rval .= "<option value=\"Asia/Vladivostok\"".(($def=="Asia/Vladivostok")?' selected':'').">Russia/Vladivostok Moscow+07 - Amur River";
	$rval .= "<option value=\"Asia/Yakutsk\"".(($def=="Asia/Yakutsk")?' selected':'').">Russia/Yakutsk Moscow+06 - Lena River";
	$rval .= "<option value=\"Asia/Yekaterinburg\"".(($def=="Asia/Yekaterinburg")?' selected':'').">Russia/Yekaterinburg Moscow+02 - Urals";
	$rval .= "<option value=\"Africa/Kigali\"".(($def=="Africa/Kigali")?' selected':'').">Rwanda/Kigali ";
	$rval .= "<option value=\"Pacific/Pago_Pago\"".(($def=="Pacific/Pago_Pago")?' selected':'').">Samoa (American)/Pago Pago ";
	$rval .= "<option value=\"Pacific/Apia\"".(($def=="Pacific/Apia")?' selected':'').">Samoa (Western)/Apia ";
	$rval .= "<option value=\"Europe/San_Marino\"".(($def=="Europe/San_Marino")?' selected':'').">San Marino/San Marino ";
	$rval .= "<option value=\"Africa/Sao_Tome\"".(($def=="Africa/Sao_Tome")?' selected':'').">Sao Tome & Principe/Sao Tome ";
	$rval .= "<option value=\"Asia/Riyadh\"".(($def=="Asia/Riyadh")?' selected':'').">Saudi Arabia/Riyadh ";
	$rval .= "<option value=\"Africa/Dakar\"".(($def=="Africa/Dakar")?' selected':'').">Senegal/Dakar ";
	$rval .= "<option value=\"Indian/Mahe\"".(($def=="Indian/Mahe")?' selected':'').">Seychelles/Mahe ";
	$rval .= "<option value=\"Africa/Freetown\"".(($def=="Africa/Freetown")?' selected':'').">Sierra Leone/Freetown ";
	$rval .= "<option value=\"Asia/Singapore\"".(($def=="Asia/Singapore")?' selected':'').">Singapore/Singapore ";
	$rval .= "<option value=\"Europe/Bratislava\"".(($def=="Europe/Bratislava")?' selected':'').">Slovakia/Bratislava ";
	$rval .= "<option value=\"Europe/Ljubljana\"".(($def=="Europe/Ljubljana")?' selected':'').">Slovenia/Ljubljana ";
	$rval .= "<option value=\"Pacific/Guadalcanal\"".(($def=="Pacific/Guadalcanal")?' selected':'').">Solomon Islands/Guadalcanal ";
	$rval .= "<option value=\"Africa/Mogadishu\"".(($def=="Africa/Mogadishu")?' selected':'').">Somalia/Mogadishu ";
	$rval .= "<option value=\"Africa/Johannesburg\"".(($def=="Africa/Johannesburg")?' selected':'').">South Africa/Johannesburg ";
	$rval .= "<option value=\"Atlantic/South_Georgia\"".(($def=="Atlantic/South_Georgia")?' selected':'').">South Georgia & the South Sandwich Islands/South Georgia ";
	$rval .= "<option value=\"Atlantic/Canary\"".(($def=="Atlantic/Canary")?' selected':'').">Spain/Canary Canary Islands";
	$rval .= "<option value=\"Africa/Ceuta\"".(($def=="Africa/Ceuta")?' selected':'').">Spain/Ceuta Ceuta & Melilla";
	$rval .= "<option value=\"Europe/Madrid\"".(($def=="Europe/Madrid")?' selected':'').">Spain/Madrid mainland";
	$rval .= "<option value=\"Asia/Colombo\"".(($def=="Asia/Colombo")?' selected':'').">Sri Lanka/Colombo ";
	$rval .= "<option value=\"Atlantic/St_Helena\"".(($def=="Atlantic/St_Helena")?' selected':'').">St Helena/St Helena ";
	$rval .= "<option value=\"America/St_Kitts\"".(($def=="America/St_Kitts")?' selected':'').">St Kitts & Nevis/St Kitts ";
	$rval .= "<option value=\"America/St_Lucia\"".(($def=="America/St_Lucia")?' selected':'').">St Lucia/St Lucia ";
	$rval .= "<option value=\"America/Miquelon\"".(($def=="America/Miquelon")?' selected':'').">St Pierre & Miquelon/Miquelon ";
	$rval .= "<option value=\"America/St_Vincent\"".(($def=="America/St_Vincent")?' selected':'').">St Vincent/St Vincent ";
	$rval .= "<option value=\"Africa/Khartoum\"".(($def=="Africa/Khartoum")?' selected':'').">Sudan/Khartoum ";
	$rval .= "<option value=\"America/Paramaribo\"".(($def=="America/Paramaribo")?' selected':'').">Suriname/Paramaribo ";
	$rval .= "<option value=\"Atlantic/Jan_Mayen\"".(($def=="Atlantic/Jan_Mayen")?' selected':'').">Svalbard & Jan Mayen/Jan Mayen Jan Mayen";
	$rval .= "<option value=\"Arctic/Longyearbyen\"".(($def=="Arctic/Longyearbyen")?' selected':'').">Svalbard & Jan Mayen/Longyearbyen Svalbard";
	$rval .= "<option value=\"Africa/Mbabane\"".(($def=="Africa/Mbabane")?' selected':'').">Swaziland/Mbabane ";
	$rval .= "<option value=\"Europe/Stockholm\"".(($def=="Europe/Stockholm")?' selected':'').">Sweden/Stockholm ";
	$rval .= "<option value=\"Europe/Zurich\"".(($def=="Europe/Zurich")?' selected':'').">Switzerland/Zurich ";
	$rval .= "<option value=\"Asia/Damascus\"".(($def=="Asia/Damascus")?' selected':'').">Syria/Damascus ";
	$rval .= "<option value=\"Asia/Taipei\"".(($def=="Asia/Taipei")?' selected':'').">Taiwan/Taipei ";
	$rval .= "<option value=\"Asia/Dushanbe\"".(($def=="Asia/Dushanbe")?' selected':'').">Tajikistan/Dushanbe ";
	$rval .= "<option value=\"Africa/Dar_es_Salaam\"".(($def=="Africa/Dar_es_Salaam")?' selected':'').">Tanzania/Dar es Salaam ";
	$rval .= "<option value=\"Asia/Bangkok\"".(($def=="Asia/Bangkok")?' selected':'').">Thailand/Bangkok ";
	$rval .= "<option value=\"Africa/Lome\"".(($def=="Africa/Lome")?' selected':'').">Togo/Lome ";
	$rval .= "<option value=\"Pacific/Fakaofo\"".(($def=="Pacific/Fakaofo")?' selected':'').">Tokelau/Fakaofo ";
	$rval .= "<option value=\"Pacific/Tongatapu\"".(($def=="Pacific/Tongatapu")?' selected':'').">Tonga/Tongatapu ";
	$rval .= "<option value=\"America/Port_of_Spain\"".(($def=="America/Port_of_Spain")?' selected':'').">Trinidad & Tobago/Port of Spain ";
	$rval .= "<option value=\"Africa/Tunis\"".(($def=="Africa/Tunis")?' selected':'').">Tunisia/Tunis ";
	$rval .= "<option value=\"Europe/Istanbul\"".(($def=="Europe/Istanbul")?' selected':'').">Turkey/Istanbul ";
	$rval .= "<option value=\"Asia/Ashgabat\"".(($def=="Asia/Ashgabat")?' selected':'').">Turkmenistan/Ashgabat ";
	$rval .= "<option value=\"America/Grand_Turk\"".(($def=="America/Grand_Turk")?' selected':'').">Turks & Caicos Is/Grand Turk ";
	$rval .= "<option value=\"Pacific/Funafuti\"".(($def=="Pacific/Funafuti")?' selected':'').">Tuvalu/Funafuti ";
	$rval .= "<option value=\"Pacific/Johnston\"".(($def=="Pacific/Johnston")?' selected':'').">US minor outlying islands/Johnston Johnston Atoll";
	$rval .= "<option value=\"Pacific/Midway\"".(($def=="Pacific/Midway")?' selected':'').">US minor outlying islands/Midway Midway Islands";
	$rval .= "<option value=\"Pacific/Wake\"".(($def=="Pacific/Wake")?' selected':'').">US minor outlying islands/Wake Wake Island";
	$rval .= "<option value=\"Africa/Kampala\"".(($def=="Africa/Kampala")?' selected':'').">Uganda/Kampala ";
	$rval .= "<option value=\"Europe/Kiev\"".(($def=="Europe/Kiev")?' selected':'').">Ukraine/Kiev most locations";
	$rval .= "<option value=\"Europe/Simferopol\"".(($def=="Europe/Simferopol")?' selected':'').">Ukraine/Simferopol central Crimea";
	$rval .= "<option value=\"Europe/Uzhgorod\"".(($def=="Europe/Uzhgorod")?' selected':'').">Ukraine/Uzhgorod Ruthenia";
	$rval .= "<option value=\"Europe/Zaporozhye\"".(($def=="Europe/Zaporozhye")?' selected':'').">Ukraine/Zaporozhye Zaporozh'ye, E Lugansk";
	$rval .= "<option value=\"Asia/Dubai\"".(($def=="Asia/Dubai")?' selected':'').">United Arab Emirates/Dubai ";
	$rval .= "<option value=\"America/Adak\"".(($def=="America/Adak")?' selected':'').">United States/Adak Aleutian Islands";
	$rval .= "<option value=\"America/Anchorage\"".(($def=="America/Anchorage")?' selected':'').">United States/Anchorage Alaska Time";
	$rval .= "<option value=\"America/Boise\"".(($def=="America/Boise")?' selected':'').">United States/Boise Mountain Time - south Idaho & east Oregon";
	$rval .= "<option value=\"America/Chicago\"".(($def=="America/Chicago")?' selected':'').">United States/Chicago Central Time";
	$rval .= "<option value=\"America/Denver\"".(($def=="America/Denver")?' selected':'').">United States/Denver Mountain Time";
	$rval .= "<option value=\"America/Detroit\"".(($def=="America/Detroit")?' selected':'').">United States/Detroit Eastern Time - Michigan - most locations";
	$rval .= "<option value=\"Pacific/Honolulu\"".(($def=="Pacific/Honolulu")?' selected':'').">United States/Honolulu Hawaii";
	$rval .= "<option value=\"America/Indiana/Marengo\"".(($def=="America/Indiana/Marengo")?' selected':'').">United States/Indiana Eastern Standard Time - Indiana - Crawford County";
	$rval .= "<option value=\"America/Indiana/Knox\"".(($def=="America/Indiana/Knox")?' selected':'').">United States/Indiana Eastern Standard Time - Indiana - Starke County";
	$rval .= "<option value=\"America/Indiana/Vevay\"".(($def=="America/Indiana/Vevay")?' selected':'').">United States/Indiana Eastern Standard Time - Indiana - Switzerland County";
	$rval .= "<option value=\"America/Indianapolis\"".(($def=="America/Indianapolis")?' selected':'').">United States/Indianapolis Eastern Standard Time - Indiana - most locations";
	$rval .= "<option value=\"America/Juneau\"".(($def=="America/Juneau")?' selected':'').">United States/Juneau Alaska Time - Alaska panhandle";
	$rval .= "<option value=\"America/Kentucky/Monticello\"".(($def=="America/Kentucky/Monticello")?' selected':'').">United States/Kentucky Eastern Time - Kentucky - Wayne County";
	$rval .= "<option value=\"America/Los_Angeles\"".(($def=="America/Los_Angeles")?' selected':'').">United States/Los Angeles Pacific Time";
	$rval .= "<option value=\"America/Louisville\"".(($def=="America/Louisville")?' selected':'').">United States/Louisville Eastern Time - Kentucky - Louisville area";
	$rval .= "<option value=\"America/Menominee\"".(($def=="America/Menominee")?' selected':'').">United States/Menominee Central Time - Michigan - Wisconsin border";
	$rval .= "<option value=\"America/New_York\"".(($def=="America/New_York")?' selected':'').">United States/New York Eastern Time";
	$rval .= "<option value=\"America/Nome\"".(($def=="America/Nome")?' selected':'').">United States/Nome Alaska Time - west Alaska";
	$rval .= "<option value=\"America/Phoenix\"".(($def=="America/Phoenix")?' selected':'').">United States/Phoenix Mountain Standard Time - Arizona";
	$rval .= "<option value=\"America/Shiprock\"".(($def=="America/Shiprock")?' selected':'').">United States/Shiprock Mountain Time - Navajo";
	$rval .= "<option value=\"America/Yakutat\"".(($def=="America/Yakutat")?' selected':'').">United States/Yakutat Alaska Time - Alaska panhandle neck";
	$rval .= "<option value=\"America/Montevideo\"".(($def=="America/Montevideo")?' selected':'').">Uruguay/Montevideo ";
	$rval .= "<option value=\"Asia/Samarkand\"".(($def=="Asia/Samarkand")?' selected':'').">Uzbekistan/Samarkand west Uzbekistan";
	$rval .= "<option value=\"Asia/Tashkent\"".(($def=="Asia/Tashkent")?' selected':'').">Uzbekistan/Tashkent east Uzbekistan";
	$rval .= "<option value=\"Pacific/Efate\"".(($def=="Pacific/Efate")?' selected':'').">Vanuatu/Efate ";
	$rval .= "<option value=\"Europe/Vatican\"".(($def=="Europe/Vatican")?' selected':'').">Vatican City/Vatican ";
	$rval .= "<option value=\"America/Caracas\"".(($def=="America/Caracas")?' selected':'').">Venezuela/Caracas ";
	$rval .= "<option value=\"Asia/Saigon\"".(($def=="Asia/Saigon")?' selected':'').">Vietnam/Saigon ";
	$rval .= "<option value=\"America/Tortola\"".(($def=="America/Tortola")?' selected':'').">Virgin Islands (UK)/Tortola ";
	$rval .= "<option value=\"America/St_Thomas\"".(($def=="America/St_Thomas")?' selected':'').">Virgin Islands (US)/St Thomas ";
	$rval .= "<option value=\"Pacific/Wallis\"".(($def=="Pacific/Wallis")?' selected':'').">Wallis & Futuna/Wallis ";
	$rval .= "<option value=\"Africa/El_Aaiun\"".(($def=="Africa/El_Aaiun")?' selected':'').">Western Sahara/El Aaiun ";
	$rval .= "<option value=\"Asia/Aden\"".(($def=="Asia/Aden")?' selected':'').">Yemen/Aden ";
	$rval .= "<option value=\"Europe/Belgrade\"".(($def=="Europe/Belgrade")?' selected':'').">Yugoslavia/Belgrade ";
	$rval .= "<option value=\"Africa/Lusaka\"".(($def=="Africa/Lusaka")?' selected':'').">Zambia/Lusaka ";
	$rval .= "<option value=\"Africa/Harare\"".(($def=="Africa/Harare")?' selected':'').">Zimbabwe/Harare ";
	
	$rval .= '</select>';
	return $rval;
}

function draw_timezone_select($name, $def)
{
	echo create_timezone_select($name, $def);
}
?>