<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: users_adm.inc,v 1.7 2002/02/12 19:55:00 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/


fud_use('customtags.inc');
fud_use('private.inc');

class fud_user_adm extends fud_user_reg
{
	var $custom_tags;

	function delete_user()
	{
		DB_LOCK('fud_poll_opt_track+, fud_users+, fud_pmsg+, fud_attach+, fud_mod+, fud_custom_tags+, fud_thread_notify+, fud_forum_notify+, fud_read+, fud_forum_read+, fud_thread_rate_track+, fud_user_ignore+, fud_buddy+');
		$this->de_moderate();
		$tags = new fud_custom_tag;
		$tags->delete_user($this->id);
		Q("DELETE FROM fud_users WHERE id=".$this->id);
		Q("DELETE FROM fud_thread_notify WHERE user_id=".$this->id);
		Q("DELETE FROM fud_forum_notify WHERE user_id=".$this->id);
		Q("DELETE FROM fud_read WHERE user_id=".$this->id);
		Q("DELETE FROM fud_forum_read WHERE user_id=".$this->id);
		Q("DELETE FROM fud_thread_rate_track WHERE user_id=".$this->id);
		Q("DELETE FROM fud_user_ignore WHERE user_id=".$this->id);
		Q("DELETE FROM fud_user_ignore WHERE ignore_id=".$this->id);
		Q("DELETE FROM fud_buddy WHERE user_id=".$this->id);
		Q("DELETE FROM fud_buddy WHERE bud_id=".$this->id);
		Q("DELETE FROM fud_poll_opt_track WHERE user_id=".$this->id);
		
		/* Delete the private messages of this user */
		
		$r = Q("SELECT fud_pmsg.id FROM fud_pmsg LEFT JOIN fud_users ON fud_pmsg.ouser_id=fud_users.id WHERE mailed='N' AND fud_users.id IS NULL");
		while( $obj = DB_ROWOBJ($r) ) {
			$pmsg = new fud_pmsg;
			$pmsg->get($obj->id);
			$pmsg->del_pmsg('TRASH');
		}

		$r = Q("SELECT fud_pmsg.id FROM fud_pmsg LEFT JOIN fud_users ON fud_pmsg.duser_id=fud_users.id WHERE mailed='Y' AND fud_users.id IS NULL");
		while( $obj = DB_ROWOBJ($r) ) {
			$pmsg = new fud_pmsg;
			$pmsg->get($obj->id);
			$pmsg->del_pmsg('TRASH');
		}

		delete_ext_settings($this->id);
		DB_UNLOCK();
	}

	function block_user()
	{
		Q("UPDATE fud_users SET blocked='Y' WHERE id=".$this->id);
	}
	
	function unblock_user()
	{
		Q("UPDATE fud_users SET blocked='N' WHERE id=".$this->id);
	}
	
	function start_mod()
	{
		DB_LOCK('fud_forum+, fud_mod+');
	}
	
	function end_mod()
	{
		DB_UNLOCK();
	}
	
	function mk_moderator($forum_id)
	{	
		if ( !BQ("SELECT id FROM fud_forum WHERE id=".$forum_id) ) {
			exit("no such forum to moderate\n");
		}
		
		Q("INSERT INTO fud_mod(user_id, forum_id) VALUES(".$this->id.", ".$forum_id.")");
	}
	
	function rm_moderator($forum_id)
	{
		Q("DELETE FROM fud_mod WHERE user_id=".$this->id." AND forum_id=".$forum_id);
	}
	
	function de_moderate()
	{
		Q("DELETE FROM fud_mod WHERE user_id=".$this->id);
	}
	
	function mk_admin()
	{
		Q("UPDATE fud_users SET is_mod='A' WHERE id=".$this->id);
	}
	
	function de_admin()
	{
		$is_mod = ( BQ("SELECT id FROM fud_mod WHERE user_id=".$this->id." LIMIT 1") ) ? 'Y' : 'N';
		Q("UPDATE fud_users SET is_mod='".$is_mod."' WHERE id=".$this->id);
	}
	
	function getmod()
	{
		$result = Q("SELECT fud_mod.id AS id, fud_mod.user_id AS user_id, fud_forum.id AS forum_id, fud_forum.name AS name FROM fud_mod, fud_forum WHERE fud_mod.forum_id=fud_forum.id AND fud_mod.user_id=".$this->id);
		
		unset($this->mod_list);
		$this->mod_cur = 0;
		
		while ( $obj=DB_ROWOBJ($result) ) {
			$this->mod_list[$this->mod_cur++] = $obj;
		}
		QF($result);
		
		return $this->mod_cur;
	}
	
	function countmod()
	{
		if ( !isset($this->mod_list) ) return;
		return @count($this->mod_list); 
	}
	
	function resetmod()
	{
		$this->mod_cur = 0;
	}
	
	function nextmod()
	{
		if ( !isset($this->mod_list[$this->mod_cur]) ) return;
		
		return $this->mod_list[$this->mod_cur++];
	}
	
	function get_custom_tags()
	{
		$r = Q("SELECT * FROM fud_custom_tags WHERE user_id=".$this->id);
		
		unset($this->custom_tags);
		$z = 0;
		while ( $obj = DB_ROWOBJ($r) ) {
			$this->custom_tags[$z++] = $obj;
		}
		QF($r);
		
		return $this->custom_tags;
	}
	
	function approve_avatar()
	{
		Q("UPDATE fud_users SET avatar_approved='Y' WHERE id=".$this->id);
	}
	
	function unapprove_avatar()
	{
		Q("UPDATE fud_users SET avatar_approved='NO', avatar_loc=NULL WHERE id=".$this->id);
	}
}

function delete_ext_settings($id)
{
	if ( !unlink($GLOBALS['USER_SETTINGS_PATH'].$id.'.fud') ) {
		exit("unable to remove users external settings\n");
	}
}
?>