<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: admglobal.php,v 1.13 2002/02/12 17:55:06 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/

	include_once "GLOBALS.php";
	
	$GLOBALS['ADMIN_FORM'] = 1;
	
	fud_use('glob.inc');
	fud_use('widgets.inc');
	fud_use('util.inc');
	fud_use('style.inc');
	fud_use('adm.inc');
	fud_use('tz.inc');
	fud_use('cfg.inc');
	
	list($ses, $usr) = initadm();
	
	$cf = get_config($GLOBALS['__GLOBALS.INC__']);
	$arr = cf_arr($cf);
	reset($arr);
	
	if ( !empty($btn_submit) ) {
		/* remove slashes */
		while( list($k,) = each($HTTP_POST_VARS) ) {
			if( !empty($HTTP_POST_VARS[$k]) ) $HTTP_POST_VARS[$k] = $GLOBALS[$k] = stripslashes($HTTP_POST_VARS[$k]);
		}
	
		reset($HTTP_POST_VARS);	
		$HTTP_POST_VARS['CF_DISABLED_REASON'] = cfg_enc($HTTP_POST_VARS['CF_DISABLED_REASON']);
		
		while ( list($key, $val) = each($HTTP_POST_VARS) ) {
			if ( substr($key, 0, 3) != 'CF_' ) continue;
			$key = substr($key, 3, strlen($key));
			$val = addslashes($val);
			if( $GLOBALS[$key] == $val ) continue;
			
			mod_opt($cf, $key, $val);
		}
		
		$fn = $GLOBALS['TMP'].get_random_value(128);
		if( !($fp = @fopen($fn, 'w')) ) {
			exit("FATAL ERROR: Unable to write to temporary directory: ".$GLOBALS['TMP']."<br>\n");		
		}
		for ( $i=0; $i<count($cf); $i++ ) {
			fwrite($fp, $cf[$i]);
		}
		fclose($fp);
		copy($fn, $GLOBALS['__GLOBALS.INC__']);
		unlink($fn);
		
		header("Location: admglobal.php?$_RSID&rnd=".get_random_value(128));
		exit();
	}
	
	$help_ar = read_help();
	
	while ( list($key, $val) = each($arr) ) {
		$GLOBALS['CF_'.$key] = stripslashes($val);
	}
	
	$CF_DISABLED_REASON = cfg_dec($CF_DISABLED_REASON);

function draw_help($about)
{
	if( !empty($GLOBALS['help_ar'][$about]) ) 
		echo '<br><font size="-1">'.$GLOBALS['help_ar'][$about].'</font>';
}
	
include('admpanel.php'); 
?>
<h2>Global Configuration</h2>
<table border=0 cellspacing=1 cellpadding=3>
<form method="post">
<input type="hidden" name="S" value="<?php echo $S; ?>">
<tr bgcolor="#bff8ff"><td>Forum Title:<?php draw_help('FORUM_TITLE'); ?></td><td><input type="text" name="CF_FORUM_TITLE" value="<?php echo htmlspecialchars($CF_FORUM_TITLE); ?>"></td></tr>
<tr bgcolor="#bff8ff"><td>Forum Enabled:<?php draw_help('FORUM_ENABLED'); ?></td><td><?php draw_select('CF_FORUM_ENABLED', "Yes\nNo", "Y\nN", $CF_FORUM_ENABLED); ?></td></tr>
<tr bgcolor="#bff8ff"><td valign=top>Reason for disabling:<?php draw_help('DISABLED_REASON'); ?></td><td><textarea name="CF_DISABLED_REASON" cols=40 rows=5><?php echo htmlspecialchars($CF_DISABLED_REASON); ?></textarea></td></tr>
<tr bgcolor="#bff8ff"><td>Allow Registartion:<?php draw_help('ALLOW_REGISTRATION'); ?></td><td><?php draw_select('CF_ALLOW_REGISTRATION', "Yes\nNo", "Y\nN", $CF_ALLOW_REGISTRATION); ?></td></tr>
<tr bgcolor="#bff8ff"><td colspan=2><br>&nbsp;</td></tr>

<tr bgcolor="#bff8ff"><td colspan=2><br><b>GLOBAL</b></td></tr>
<tr bgcolor="#bff8ff"><td>WWW Root:<?php draw_help('WWW_ROOT'); ?></td><td><input type="text" name="CF_WWW_ROOT" value="<?php echo htmlspecialchars($CF_WWW_ROOT); ?>"></td></tr>
<tr bgcolor="#bff8ff"><td>Error File:<?php draw_help('ERROR_PATH'); ?></td><td><input type="text" name="CF_ERROR_PATH" value="<?php echo htmlspecialchars($CF_ERROR_PATH); ?>"></td></tr>
<tr bgcolor="#bff8ff"><td>Message Storage Path:<?php draw_help('MSG_STORE_DIR'); ?></td><td><input type="text" name="CF_MSG_STORE_DIR" value="<?php echo htmlspecialchars($CF_MSG_STORE_DIR); ?>"></td></tr>
<tr bgcolor="#bff8ff"><td>Temporary Path:<?php draw_help('TMP'); ?></td><td><input type="text" name="CF_TMP" value="<?php echo htmlspecialchars($CF_TMP); ?>"></td></tr>
<tr bgcolor="#bff8ff"><td>File Storage Path:<?php draw_help('FILE_STORE'); ?></td><td><input type="text" name="CF_FILE_STORE" value="<?php echo htmlspecialchars($CF_FILE_STORE); ?>"></td></tr>
<tr bgcolor="#bff8ff"><td>User Settings Dir:<?php draw_help('USER_SETTINGS_PATH'); ?></td><td><input type="text" name="CF_USER_SETTINGS_PATH" value="<?php echo htmlspecialchars($CF_USER_SETTINGS_PATH); ?>"></td></tr>
<tr bgcolor="#bff8ff"><td>Forum Settings Dir:<?php draw_help('FORUM_SETTINGS_PATH'); ?></td><td><input type="text" name="CF_FORUM_SETTINGS_PATH" value="<?php echo htmlspecialchars($CF_FORUM_SETTINGS_PATH); ?>"></td></tr>
<tr bgcolor="#bff8ff"><td>Image Root WWW Path:<?php draw_help('IMG_ROOT_WWW'); ?></td><td><input type="text" name="CF_IMG_ROOT_WWW" value="<?php echo htmlspecialchars($CF_IMG_ROOT_WWW); ?>"></td></tr>
<tr bgcolor="#bff8ff"><td>Image Root DISK Path:<?php draw_help('IMG_ROOT_DISK'); ?></td><td><input type="text" name="CF_IMG_ROOT_DISK" value="<?php echo htmlspecialchars($CF_IMG_ROOT_DISK); ?>"></td></tr>
<tr bgcolor="#bff8ff"><td>Forum Icon Dir:<?php draw_help('FORUM_ICON_DIR'); ?></td><td><input type="text" name="CF_FORUM_ICON_DIR" value="<?php echo htmlspecialchars($CF_FORUM_ICON_DIR); ?>"></td></tr>
<tr bgcolor="#bff8ff"><td>Message Icon Dir:<?php draw_help('MESSAGE_ICON_DIR'); ?></td><td><input type="text" name="CF_MESSAGE_ICON_DIR" value="<?php echo htmlspecialchars($CF_MESSAGE_ICON_DIR); ?>"></td></tr>
<tr bgcolor="#bff8ff"><td>Smiley Dir:<?php draw_help('SMILEY_DIR'); ?></td><td><input type="text" name="CF_SMILEY_DIR" value="<?php echo htmlspecialchars($CF_SMILEY_DIR); ?>"></td></tr>
<tr bgcolor="#bff8ff"><td>Avatar Dir:<?php draw_help('AVATAR_DIR'); ?></td><td><input type="text" name="CF_AVATAR_DIR" value="<?php echo htmlspecialchars($CF_AVATAR_DIR); ?>"></td></tr>
<tr bgcolor="#bff8ff"><td>Morgify Path:<?php draw_help('MOGRIFY_BIN'); ?><br><font size="-1">ImageMagick utility for manipulating images, used to allow the admin to scale/convert custom avatars</font></td><td><input type="text" name="CF_MOGRIFY_BIN" value="<?php echo htmlspecialchars($CF_MOGRIFY_BIN); ?>"></td></tr>
<tr bgcolor="#bff8ff"><td colspan=2><br>&nbsp;</td></tr>

<tr bgcolor="#bff8ff"><td colspan=2><br><b>MYSQL</b> </td></tr>
<tr bgcolor="#bff8ff"><td>Mysql Server:<?php draw_help('MYSQL_SERVER'); ?></td><td><input type="text" name="CF_MYSQL_SERVER" value="<?php echo htmlspecialchars($CF_MYSQL_SERVER); ?>"></td></tr>
<tr bgcolor="#bff8ff"><td>Mysql Login:<?php draw_help('MYSQL_LOGIN'); ?></td><td><input type="text" name="CF_MYSQL_LOGIN" value="<?php echo htmlspecialchars($CF_MYSQL_LOGIN); ?>"></td></tr>
<tr bgcolor="#bff8ff"><td>Mysql PASSWORD:<?php draw_help('MYSQL_PASSWORD'); ?></td><td><input type="text" name="CF_MYSQL_PASSWORD" value="<?php echo htmlspecialchars($CF_MYSQL_PASSWORD); ?>"></td></tr>
<tr bgcolor="#bff8ff"><td>Mysql DB:<?php draw_help('MYSQL_DB'); ?></td><td><input type="text" name="CF_MYSQL_DB" value="<?php echo htmlspecialchars($CF_MYSQL_DB); ?>"></td></tr>
<tr bgcolor="#bff8ff"><td>User Persistent Connections:<?php draw_help('MYSQL_PERSIST'); ?></td><td><?php draw_select('CF_MYSQL_PERSIST', "Yes\nNo", "Y\nN", $MYSQL_PERSIST); ?></td></tr>
<tr bgcolor="#bff8ff"><td colspan=2><br>&nbsp;</td></tr>

<tr bgcolor="#bff8ff"><td colspan=2><br><b>Private Messaging</b> </td></tr>
<tr bgcolor="#bff8ff"><td>Allow Private Messanging:<?php draw_help('PM_ENABLED'); ?></td><td><?php draw_select('CF_PM_ENABLED', "Yes\nNo", "Y\nN", $PM_ENABLED); ?></td></tr>
<tr bgcolor="#bff8ff"><td>File Attachments in Private Messages:<?php draw_help('PRIVATE_ATTACHMENTS'); ?></td><td><input type="text" name="CF_PRIVATE_ATTACHMENTS" value="<?php echo $CF_PRIVATE_ATTACHMENTS; ?>"></td></tr>
<tr bgcolor="#bff8ff"><td>Maximum Attachment Size (bytes):<?php draw_help('PRIVATE_ATTACH_SIZE'); ?></td><td><input type="text" name="CF_PRIVATE_ATTACH_SIZE" value="<?php echo $CF_PRIVATE_ATTACH_SIZE; ?>"></td></tr>
<tr bgcolor="#bff8ff"><td>Allow Smileys:<?php draw_help('PRIVATE_MSG_SMILEY'); ?></td><td><?php draw_select('CF_PRIVATE_MSG_SMILEY', "Yes\nNo", "Y\nN", $CF_PRIVATE_MSG_SMILEY); ?></td></tr>
<tr bgcolor="#bff8ff"><td>Allow Images (fudcode only):<?php draw_help('PRIVATE_IMAGES'); ?></td><td><?php draw_select('CF_PRIVATE_IMAGES', "Yes\nNo", "Y\nN", $CF_PRIVATE_IMAGES); ?></td></tr>
<tr bgcolor="#bff8ff"><td>Tag Style:<?php draw_help('PRIVATE_TAGS'); ?></td><td><?php draw_select('CF_PRIVATE_TAGS', "FUD ML\nHTML\nNone", "ML\nHTML\nNONE", $CF_PRIVATE_TAGS); ?></td></tr>
<tr bgcolor="#bff8ff"><td colspan=2><br>&nbsp;</td></tr>

<tr bgcolor="#bff8ff"><td colspan=2><br><b>Cookie & Session Settings</b> </td></tr>
<tr bgcolor="#bff8ff"><td>Cookie Path:<?php draw_help('COOKIE_PATH'); ?></td><td><input type="text" name="CF_COOKIE_PATH" value="<?php echo htmlspecialchars($CF_COOKIE_PATH); ?>"></td></tr>
<tr bgcolor="#bff8ff"><td>Cookie Domain:<?php draw_help('COOKIE_DOMAIN'); ?></td><td><input type="text" name="CF_COOKIE_DOMAIN" value="<?php echo htmlspecialchars($CF_COOKIE_DOMAIN); ?>"></td></tr>
<tr bgcolor="#bff8ff"><td>Cookie Name:<?php draw_help('COOKIE_NAME'); ?></td><td><input type="text" name="CF_COOKIE_NAME" value="<?php echo htmlspecialchars($CF_COOKIE_NAME); ?>"></td></tr>
<tr bgcolor="#bff8ff"><td>Cookie Timeout:<?php draw_help('COOKIE_TIMEOUT'); ?></td><td><input type="text" name="CF_COOKIE_TIMEOUT" value="<?php echo $CF_COOKIE_TIMEOUT; ?>"></td></tr>
<tr bgcolor="#bff8ff"><td>Session Timeout:<?php draw_help('SESSION_TIMEOUT'); ?></td><td><input type="text" name="CF_SESSION_TIMEOUT" value="<?php echo $CF_SESSION_TIMEOUT; ?>"></td></tr>
<tr bgcolor="#bff8ff"><td colspan=2><br>&nbsp;</td></tr>

<tr bgcolor="#bff8ff"><td colspan=2><br><b>Custom Avatar Settings</b> </td></tr>
<tr bgcolor="#bff8ff"><td>Custom Avatars:<?php draw_help('CUSTOM_AVATARS'); ?></td><td><?php draw_select('CF_CUSTOM_AVATARS', "OFF\nURL Only\nUploaded Only\nBoth", "OFF\nURL\nUPLOAD\nBOTH", $CF_CUSTOM_AVATARS); ?></td></tr>
<tr bgcolor="#bff8ff"><td>Custom Avatar Path:<?php draw_help('CUSTOM_AVATAR_DIR'); ?></td><td><input type="text" name="CF_CUSTOM_AVATAR_DIR" value="<?php echo htmlspecialchars($CUSTOM_AVATAR_DIR); ?>"></td></tr>
<tr bgcolor="#bff8ff"><td>Custom Avatar Max Size (bytes):<?php draw_help('CUSTOM_AVATAR_MAX_SIZE'); ?></td><td><input type="text" name="CF_CUSTOM_AVATAR_MAX_SIZE" value="<?php echo $CUSTOM_AVATAR_MAX_SIZE; ?>"></td></tr>
<tr bgcolor="#bff8ff"><td>Custom Avatar Max Dimentions:<?php draw_help('CUSTOM_AVATAR_MAX_DIM'); ?></td><td><input type="text" name="CF_CUSTOM_AVATAR_MAX_DIM" value="<?php echo htmlspecialchars($CUSTOM_AVATAR_MAX_DIM); ?>"></td></tr>
<tr bgcolor="#bff8ff"><td colspan=2><br>&nbsp;</td></tr>

<tr bgcolor="#bff8ff"><td colspan=2><br><b>Signature Settings</b> </td></tr>
<tr bgcolor="#bff8ff"><td>Allow Signatures:<?php draw_help('ALLOW_SIGS'); ?></td><td><?php draw_select('CF_ALLOW_SIGS', "Yes\nNo", "Y\nN", $CF_ALLOW_SIGS); ?></td></tr>
<tr bgcolor="#bff8ff"><td>Tag Style:<?php draw_help('FORUM_CODE_SIG'); ?></td><td><?php draw_select('CF_FORUM_CODE_SIG', "FUD ML\nHTML\nNone", "ML\nHTML\nNONE", $CF_FORUM_CODE_SIG); ?></td></tr>
<tr bgcolor="#bff8ff"><td>Allow Smilies:<?php draw_help('FORUM_SML_SIG'); ?></td><td><?php draw_select('CF_FORUM_SML_SIG', "Yes\nNo", "Y\nN", $CF_FORUM_SML_SIG); ?></td></tr>
<tr bgcolor="#bff8ff"><td>Allow Images (fudcode only):<?php draw_help('FORUM_IMG_SIG'); ?></td><td><?php draw_select('CF_FORUM_IMG_SIG', "Yes\nNo", "Y\nN", $CF_FORUM_IMG_SIG); ?></td></tr>
<tr bgcolor="#bff8ff"><td colspan=2><br>&nbsp;</td></tr>

<?php
if ( function_exists('pspell_new_config') )
	$pspell_support = '<font color="red">is enabled</font>';
else
	$pspell_support = '<font color="red">is disabled<br>please ask your administrator to enable pspell support</font>';
?>
<tr bgcolor="#bff8ff"><td colspan=2><br><b>Spell Checker</b> </td></tr>
<tr bgcolor="#bff8ff"><td>Enable Spell Checker:<?php draw_help('SPELL_CHECK_ENABLED'); ?><br><font size=-1>requres pspell support in php which is currently <?php echo $pspell_support; ?></font></td><td><?php draw_select('CF_SPELL_CHECK_ENABLED', "Yes\nNo", "Y\nN", $CF_SPELL_CHECK_ENABLED); ?></td></tr>
<tr bgcolor="#bff8ff"><td colspan=2><br>&nbsp;</td></tr>

<tr bgcolor="#bff8ff"><td colspan=2><br><b>General Settings</b> </td></tr>
<tr bgcolor="#bff8ff"><td>Public Host Resolving:<?php draw_help('PUBLIC_RESOLVE_HOST'); ?></td><td><?php draw_select('CF_PUBLIC_RESOLVE_HOST', "Yes\nNo", "Y\nN", $CF_PUBLIC_RESOLVE_HOST); ?></td></tr>
<tr bgcolor="#bff8ff"><td>Maximum Shown Login Length:<?php draw_help('MAX_LOGIN_SHOW'); ?></td><td><input type="text" name="CF_MAX_LOGIN_SHOW" value="<?php echo $CF_MAX_LOGIN_SHOW; ?>"></td></tr>
<tr bgcolor="#bff8ff"><td>Maximum Shown Location Length:<?php draw_help('MAX_LOCATION_SHOW'); ?></td><td><input type="text" name="CF_MAX_LOCATION_SHOW" value="<?php echo $CF_MAX_LOCATION_SHOW; ?>"></td></tr>
<tr bgcolor="#bff8ff"><td>Loged in users list enabled:<?php draw_help('LOGEDIN_LIST'); ?></td><td><?php draw_select('CF_LOGEDIN_LIST', "Yes\nNo", "Y\nN", $CF_LOGEDIN_LIST); ?></td></tr>
<tr bgcolor="#bff8ff"><td>Loged in users list timeout (minutes):<?php draw_help('LOGEDIN_TIMEOUT'); ?></td><td><input type="text" name="CF_LOGEDIN_TIMEOUT" value="<?php echo $CF_LOGEDIN_TIMEOUT; ?>"></td></tr>
<tr bgcolor="#bff8ff"><td>Allow Action List:<?php draw_help('ACTION_LIST_ENABLED'); ?></td><td><?php draw_select('CF_ACTION_LIST_ENABLED', "Yes\nNo", "Y\nN", $CF_ACTION_LIST_ENABLED); ?></td></tr>
<tr bgcolor="#bff8ff"><td>Online/Offline Status Inidicator:<?php draw_help('ONLINE_OFFLINE_STATUS'); ?></td><td><?php draw_select('CF_ONLINE_OFFLINE_STATUS', "Yes\nNo", "Y\nN", $CF_ONLINE_OFFLINE_STATUS); ?></td></tr>
<tr bgcolor="#bff8ff"><td>Administrator EMail:<?php draw_help('ADMIN_EMAIL'); ?></td><td><input type="text" name="CF_ADMIN_EMAIL" value="<?php echo htmlspecialchars($CF_ADMIN_EMAIL); ?>"></td></tr>
<tr bgcolor="#bff8ff"><td>Coppa:<?php draw_help('COPPA'); ?></td><td><?php draw_select('CF_COPPA', "Off\nOn", "N\nY", $CF_COPPA); ?></td></tr>
<tr bgcolor="#bff8ff"><td>Posts Per Page:<?php draw_help('POSTS_PER_PAGE'); ?></td><td><input type="text" name="CF_POSTS_PER_PAGE" value="<?php echo $CF_POSTS_PER_PAGE; ?>"></td></tr>
<tr bgcolor="#bff8ff"><td>Threads Per Page:<?php draw_help('THREADS_PER_PAGE'); ?></td><td><input type="text" name="CF_THREADS_PER_PAGE" value="<?php echo $CF_THREADS_PER_PAGE; ?>"></td></tr>
<tr bgcolor="#bff8ff"><td>Default Thread View:<?php draw_help('DEFAULT_THREAD_VIEW'); ?></td><td><?php draw_select('CF_DEFAULT_THREAD_VIEW', "Flat View\nTree View", "msg\ntree", $CF_DEFAULT_THREAD_VIEW); ?></td></tr>
<tr bgcolor="#bff8ff"><td>Word Wrap:<?php draw_help('WORD_WRAP'); ?></td><td><input type="text" name="CF_WORD_WRAP" value="<?php echo $CF_WORD_WRAP; ?>"></td></tr>
<tr bgcolor="#bff8ff"><td>Flood Check Time:<?php draw_help('FLOOD_CHECK_TIME'); ?></td><td><input type="text" name="CF_FLOOD_CHECK_TIME" value="<?php echo $CF_FLOOD_CHECK_TIME; ?>"></td></tr>
<tr bgcolor="#bff8ff"><td>Allow Email:<?php draw_help('ALLOW_EMAIL'); ?></td><td><?php draw_select('CF_ALLOW_EMAIL', "Yes\nNo", "Y\nN", $CF_ALLOW_EMAIL); ?></td></tr>
<tr bgcolor="#bff8ff"><td>Allow Tool Tips (registered users):<?php draw_help('ENABLE_TOOL_TIPS'); ?></td><td><?php draw_select('CF_ENABLE_TOOL_TIPS', "Yes\nNo", "Y\nN", $CF_ENABLE_TOOL_TIPS); ?></td></tr>
<tr bgcolor="#bff8ff"><td>Allow Tool Tips (anonymous users):<?php draw_help('ENABLE_TOOL_TIPS_AN'); ?></td><td><?php draw_select('CF_ENABLE_TOOL_TIPS_AN', "Yes\nNo", "Y\nN", $CF_ENABLE_TOOL_TIPS_AN); ?></td></tr>
<tr bgcolor="#bff8ff"><td>Server Time Zone:<?php draw_help('SERVER_TZ'); ?></td><td><?php draw_timezone_select('CF_SERVER_TZ', $CF_SERVER_TZ); ?></td></tr>
<tr bgcolor="#bff8ff"><td>Date Format:<?php draw_help('DATE_FORMAT'); ?></td><td><input type="text" name="CF_DATE_FORMAT" value="<?php echo htmlspecialchars($CF_DATE_FORMAT); ?>"></td></tr>
<tr bgcolor="#bff8ff"><td>Time Format:<?php draw_help('TIME_FORMAT'); ?></td><td><input type="text" name="CF_TIME_FORMAT" value="<?php echo htmlspecialchars($CF_TIME_FORMAT); ?>"></td></tr>
<tr bgcolor="#bff8ff"><td>Forum Search Engine:<?php draw_help('FORUM_SEARCH'); ?></td><td><?php draw_select('CF_FORUM_SEARCH', "Yes\nNo", "Y\nN", $CF_FORUM_SEARCH); ?></td></tr>
<tr bgcolor="#bff8ff"><td>Member Search:<?php draw_help('MEMBER_SEARCH_ENABLED'); ?></td><td><?php draw_select('CF_MEMBER_SEARCH_ENABLED', "Yes\nNo", "Y\nN", $CF_MEMBER_SEARCH_ENABLED); ?></td></tr>
<tr bgcolor="#bff8ff"><td>Members Per Page:<?php draw_help('MEMBERS_PER_PAGE'); ?></td><td><input type="text" name="CF_MEMBERS_PER_PAGE" value="<?php echo $CF_MEMBERS_PER_PAGE; ?>"></td></tr>
<tr bgcolor="#bff8ff"><td>Quick Pager Link Count:<?php draw_help('THREAD_MSG_PAGER'); ?></td><td><input type="text" name="CF_THREAD_MSG_PAGER" value="<?php echo $CF_THREAD_MSG_PAGER; ?>"></td></tr>
<tr bgcolor="#bff8ff"><td>General Pager Link Count:<?php draw_help('GENERAL_PAGER_COUNT'); ?></td><td><input type="text" name="CF_GENERAL_PAGER_COUNT" value="<?php echo $CF_GENERAL_PAGER_COUNT; ?>"></td></tr>
<tr bgcolor="#bff8ff"><td>Show Edited By:<?php draw_help('SHOW_EDITED_BY'); ?></td><td><?php draw_select('CF_SHOW_EDITED_BY', "Yes\nNo", "Y\nN", $CF_SHOW_EDITED_BY); ?></td></tr>
<tr bgcolor="#bff8ff"><td>Show Edited By Moderator:<?php draw_help('EDITED_BY_MOD'); ?></td><td><?php draw_select('CF_EDITED_BY_MOD', "Yes\nNo", "Y\nN", $CF_EDITED_BY_MOD); ?></td></tr>
<tr bgcolor="#bff8ff"><td>Edit Time Limit (minutes):<?php draw_help('EDIT_TIME_LIMIT'); ?></td><td><input type="text" name="CF_EDIT_TIME_LIMIT" value="<?php echo $CF_EDIT_TIME_LIMIT; ?>"></td></tr>
<tr bgcolor="#bff8ff"><td>Display IP publicaly:<?php draw_help('DISPLAY_IP'); ?></td><td><?php draw_select('CF_DISPLAY_IP', "Yes\nNo", "Y\nN", $CF_DISPLAY_IP); ?></td></tr>
<tr bgcolor="#bff8ff"><td>Max image count:<?php draw_help('MAX_IMAGE_COUNT'); ?></td><td><input type="text" name="CF_MAX_IMAGE_COUNT" value="<?php echo $CF_MAX_IMAGE_COUNT; ?>"></td></tr>
<tr bgcolor="#bff8ff"><td>Email Confirmation:<?php draw_help('EMAIL_CONFIRMATION'); ?></td><td><?php draw_select('CF_EMAIL_CONFIRMATION', "Yes\nNo", "Y\nN", $CF_EMAIL_CONFIRMATION); ?></td></tr>
<tr bgcolor="#bff8ff"><td>Admin Stats:<?php draw_help('ADMIN_STATS'); ?></td><td><?php draw_select('CF_ADMIN_STATS', "Yes\nNo", "Y\nN", $CF_ADMIN_STATS); ?></td></tr>
<tr bgcolor="#bff8ff"><td>Forum Info:<?php draw_help('FORUM_INFO'); ?></td><td><?php draw_select('CF_FORUM_INFO', "Yes\nNo", "Y\nN", $CF_FORUM_INFO); ?></td></tr>
<tr bgcolor="#bff8ff"><td colspan=2 align=right><input type="submit" name="btn_submit" value="Set"></td></tr>
</table>
</form>
<?php require('admclose.html'); ?>