<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: admreplace.php,v 1.5 2002/02/12 17:55:06 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/

	include_once "GLOBALS.php";
	
	$GLOBALS['ADMIN_FORM'] = 1;
	
	fud_use('cat.inc');
	fud_use('widgets.inc');
	fud_use('replace.inc');
	fud_use('util.inc');
	fud_use('adm.inc');
	
	list($ses, $usr) = initadm();
	
	if ( !empty($edit) && empty($resub) ) {
		$rpl_r = new fud_replace;
		$rpl_r->get($edit);
		$rpl_r->replace_str = addslashes($rpl_r->replace_str);
		$rpl_r->with_str = addslashes($rpl_r->with_str);
		$rpl_r->from_post = addslashes($rpl_r->from_post);
		$rpl_r->to_msg = addslashes($rpl_r->to_msg);
		$rpl_r->export_vars('rpl_');
	}
	
	if ( !empty($btn_update) ) {
		if ( empty($edit) ) exit("error");
		$rpl_u = new  fud_replace;
		$rpl_u->get($edit);
		$rpl_u->fetch_vars($HTTP_POST_VARS, 'rpl_');
		$rpl_u->sync();
		header("Location: admreplace.php?$_RSID");
		exit();
	}
	
	if ( !empty($btn_cancel) ) {
		header("Location: admreplace.php?$_RSID");
		exit();
	}
	
	if ( !empty($btn_submit) ) {
		$rpl = new fud_replace;
		$rpl->fetch_vars($HTTP_POST_VARS, 'rpl_');
		$rpl->add();
		header("Location: admreplace.php?$_RSID");
		exit();
	}
	
	if ( !empty($del) ) {
		$rpl = new fud_replace;
		$rpl->get($del);
		$rpl->delete();
		header("Location: admreplace.php?$_RSID");
		exit();
	}
	
	cache_buster();
	require('admpanel.php'); 
?>
<h2>Replacement Management System</h2>
<form name="frm_rpl" method="post">
<input type="hidden" name="S" value="<?php echo $S; ?>">
<table border=0 cellspacing=1 cellpadding=3>
	<tr bgcolor="#bff8ff">
		<td>Replacement Type:</td>
		<td><?php draw_select_ex('rpl_type', "String Replace (str_replace)\nPerl Regexp (preg_replace)\nPHP Regexp (ereg_replace)", "REPLACE\nPERL\nPHP", empty($rpl_type)?'':$rpl_type, "onChange=\"document.frm_rpl.submit();\""); ?></td>
	</tr>
	
	<tr bgcolor="#bff8ff">
		<td>Replace</td>
		<td><input type="text" name="rpl_replace_str" value="<?php echo (empty($rpl_replace_str)?'':htmlspecialchars($rpl_replace_str)); ?>"></td>
	</tr>
	
	<tr bgcolor="#bff8ff">
		<td>With</td>
		<td><input type="text" name="rpl_with_str" value="<?php echo (empty($rpl_with_str)?'':htmlspecialchars($rpl_with_str)); ?>"></td>
	</tr>
	
	<?php if ( !empty($rpl_type) && ($rpl_type == 'PERL' || $rpl_type == 'PHP') ) { ?>
	<tr>
		<td colspan=2><br></td>
	</tr>
	
	<tr bgcolor="#bff8ff">	
		<td colspan=2><b><font size=-2>Only needed with the Perl Regexp or PHP Regexp options</font></b></td>
	</tr>
	
	<tr bgcolor="#bff8ff">
		<td>From post:</td>
		<td><input type="text" name="rpl_from_post" value="<?php echo (empty($rpl_from_post)?'':htmlspecialchars($rpl_from_post)); ?>"></td>
	</tr>
	
	<tr bgcolor="#bff8ff">
		<td>To:<br></td>
		<td><input type="text" name="rpl_to_msg" value="<?php echo (empty($rpl_to_msg)?'':htmlspecialchars($rpl_to_msg)); ?>"></td>
	</tr>
	
	<?php } ?>
	
	<tr bgcolor="#bff8ff" align=right>
		<td colspan=2><?php
			if ( !empty($edit) ) {
				echo '<input type="submit" value="Cancel" name="btn_cancel"> ';
				echo '<input type="submit" value="Update" name="btn_update">';
			}
			else {		
				echo '<input type="submit" value="Add" name="btn_submit">';
			}
		?></td>
	</tr>
</table>
<input type="hidden" name="edit" value="<?php echo (empty($edit)?'':$edit); ?>">
<input type="hidden" name="resub" value="1">
</form>
<table border=0 cellspacing=3 cellpadding=2>
<tr bgcolor="#e5ffe7">
	<td>Replace Type</td>
	<td>Replace</td>
	<td>With</td>
	<td valign=center><font size=-3>(only if regexp:</font> From</td>
	<td valign=center>To<font size=-3>)</font></td>
	<td>Action</td>
</tr>
<?php
	$rpl_draw = new fud_replace;
	
	$rpl_draw->getall();
	$rpl_draw->resetrpl();	
	$i=1;
	while ( $obj = $rpl_draw->eachrpl() ) {
		$bgcolor = ($i++%2)?' bgcolor="#fffee5"':'';
		if ( !empty($edit) && $edit==$obj->id ) $bgcolor =' bgcolor="#ffb5b5"';
		
		$ctl = '<td>&lt;<a href="admreplace.php?edit='.$obj->id.'&'.$_RSID.'">Edit</a>&gt; &lt;<a href="admreplace.php?del='.$obj->id.'&'.$_RSID.'">Delete</a>&gt;</td>';
		if ( $obj->type == 'REPLACE' ) 
			echo "<tr$bgcolor><td>String Replace</td><td>".htmlspecialchars(addslashes($obj->replace_str))."&nbsp;</td><td>".htmlspecialchars(addslashes($obj->with_str))."&nbsp;</td><td>N/A</td><td>N/A</td>$ctl</tr>\n";
		else {
			switch ( $obj->type ) {
				case "PERL":
					$rpl = "Perl Regexp";
					break;
				case "PHP":
					$rpl = "PHP Regexp";
					break;
			}
			echo "<tr$bgcolor><td>".htmlspecialchars($rpl)."</td><td>".htmlspecialchars(addslashes($obj->replace_str))."&nbsp;</td><td>".htmlspecialchars(addslashes($obj->with_str))."&nbsp;</td><td>".htmlspecialchars(addslashes($obj->from_post))."&nbsp;</td><td>".htmlspecialchars(addslashes($obj->to_msg))."&nbsp;</td>$ctl</tr>\n";
		}
	}  

?>
</table>
<?php require('admclose.html'); ?>