<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: buddy_list.php,v 1.10 2002/02/11 21:06:40 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/

	include_once "GLOBALS.php";
	$GLOBALS["USER_REG"] = 1;
	fud_use('db.inc');
	fud_use('style.inc');
	fud_use('users.inc');
	fud_use('error.inc');
	fud_use('widgets.inc');
	fud_use('buddy.inc');
	
	list($ses, $usr) = init_user();
	cache_buster();
	
	if ( !isset($usr) ) {
		std_error('login');
		exit();
	}
	
	if( !isset($returnto) ) $returnto='';
	
	$bud = new fud_buddy;
	
	if( isset($add_login) && strlen($add_login) ) {
		$buddy_id = get_id_by_login($add_login);
		
		if ( $buddy_id == $usr->id ) {
			error_dialog('Info', 'Can\'t add your self to the buddy list', 'buddy_list.php?'.$_RSID);
			exit();
		}
		
		if ( $buddy_id && !($buddy=check_buddy($usr->id, $buddy_id)) ) {
			$bud->add($usr->id, $buddy_id);
			$done=1;
			header("Location: buddy_list.php?".$_RSID."&rand=".get_random_value());
		}
		else if ( $buddy ) {
			error_dialog('Info', 'You already have this user on your buddy list', 'buddy_list.php?'.$_RSID);
		}
		else {
			error_dialog('User not found', 'The user you\'ve tried to add to your buddy list was not found on the forum.', 'buddy_list.php?'.$_RSID);
		}
		
		exit();
	}
	
	if ( isset($add) && is_numeric($add) && empty($done) && ($buddy_login=check_user($add)) ) {
		if( !check_buddy($usr->id, $add) ) $bud->add($usr->id, $add);
		check_return();
		exit();
	}

	if ( isset($del) && is_numeric($del) ) {
		$bud->get_buddy($usr->id, $del);
		$bud->delete();	
		if( !$returnto ) $returnto = base64_encode('buddy_list.php?'.$_RSID);
		check_return();	
	}

	if ( isset($ses) ) $ses->update('Browsing own buddy list');
	$layout = get_layout_id($layout); include_once $GLOBALS['FORUM_SETTINGS_PATH'].'header_'.$layout.'.inc';
	fud_use('usroptions.inc');
	
	$res = Q("SELECT 
			fud_buddy.id as bud_id,
			fud_users.id,
			fud_users.login,
			fud_users.join_date,
			fud_users.bday,
			fud_users.posted_msg_count,
			fud_ses.time_sec
		FROM fud_buddy 
		LEFT JOIN fud_users 
			ON fud_buddy.bud_id=fud_users.id 
		LEFT JOIN fud_ses
			ON fud_buddy.bud_id=fud_ses.user_id		
		WHERE 
			fud_buddy.user_id=".$usr->id);
	
	if( DB_COUNT($res) ) {
		lay_start_content_table();
		echo '<tr class="TableHeading"><td>Status</td><td>My Buddies</td><td nowrap align="center">Post Count</td><td nowrap align="center">Registered On</td><td nowrap align="center">Action</td></tr>';
	
		set_row_color_alt(true);
		while( $obj = DB_ROWOBJ($res) ) {
			$ext = read_ext_settings($obj->id);
				
			$hp = ( strlen($ext['home_page']) ) ? '<a class="GenLink" href="'.$ext['home_page'].'" target=_new><img src="'.$GLOBALS["fud_img_suffix"].'homepage.gif" alt="Homepage" border=0></a>' : '';	
			$log_text = ( $obj->time_sec+$GLOBALS['LOGEDIN_TIMEOUT']*60 > time() ) ? 'on' : 'off';				
			$bday = ( substr($obj->bday,4) != date("md") ) ? '' : '<img src="blank.gif" width=10 height=1 alt="" border=0><img src="'.$GLOBALS["fud_img_suffix"].'bday.gif" alt="Birthday" border=0> Today '.htmlspecialchars($obj->login).' turns '.(date("Y")-substr($obj->bday,0,4));
			echo '<tr'.ROW_BGCOLOR().'><td align="center"><acronym title="This user is currently '.$log_text.'line"><img src="'.$GLOBALS["fud_img_suffix"].$log_text.'line.gif" alt="This user is currently '.$log_text.'line" border=0></acronym></td><td width="100%" class="GenText"><a class="GenLink" href="'.(($GLOBALS['PM_ENABLED']=='Y')?'ppost.php?id='.$obj->id.'&'.$_RSID.'&msg_to_list='.urlencode($obj->login):'usrinfo.php?id='.$obj->id.'&'.$_RSID.'').'">'.htmlspecialchars($obj->login).'</a> <font class="SmallText">(<a href="buddy_list.php?'.$_RSID.'&del='.$obj->bud_id.'" class="GenLink">remove</a>)</font>'.$bday.'</td><td align="center" nowrap class="Gentext">'.$obj->posted_msg_count.'</td><td class="DateText" nowrap>'.format_date($obj->join_date).' '.format_time($obj->join_date).'</td><td nowrap class="GenText"><a href="usrinfo.php?id='.$obj->id.'&'.$_RSID.'" class="GenLink"><img src="'.$GLOBALS["fud_img_suffix"].'msg_about.gif" alt="View user\'s profile" border=0></a> <a href="showposts.php?'.$_RSID.'&id='.$obj->id.'" class="GenLink"><img src="'.$GLOBALS["fud_img_suffix"].'show_posts.gif" alt="Show Posts" border=0></a> '.$hp.'</td></tr>';
		}
		lay_end_content_table();
	}
	QF($res);
	
	echo '<br><br><div align="center">';
	
	lay_start_content_table('MiniTable');
	echo '<form name="buddy_add" action="buddy_list.php" method="post"><input type="hidden" name="S" value="'.$S.'">';
	echo '<tr class="TableHeading"><td nowrap>Add Buddy</td></tr>';
	echo '<tr class="RowStyleA"><td nowrap class="GenText"><font class="Smalltext">Enter the login of the user you wish to add.<br>Or use the <a href="#" class="GenLink" onClick="javascript: window_open(\'finduser.php?'.$_RSID.'&js_redr='.base64_encode('buddy_add.add_login').'\', \'user_list\',500,500);">Find User</a> feature to find a person.</font><p>
		<input type="text" name="add_login" value="" maxlength=100 size=25> <input type="submit" name="submit" value="Add"></td></tr>';
	echo '</form>';
	lay_end_content_table();
	
	echo '</div>';
	
	include_once $GLOBALS['FORUM_SETTINGS_PATH'].'footer_'.$layout.'.inc';
?>