<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: index.php,v 1.19 2002/02/11 21:06:40 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/

/*#? The Forum Display Page*/

	include_once "GLOBALS.php";
	
	fud_use('db.inc');
	fud_use('cookies.inc');
	fud_use('users.inc');
	fud_use('style.inc');
	fud_use('util.inc');
	fud_use('help.inc');

function set_collapse($id, $val)
{
	if ( isset($GLOBALS['collapse'][$id]) ) return;
	$GLOBALS['collapse'][$id] = $val;
}

function reload_collapse($str)
{
	$arr = explode('_', $str);	
	$arr_n = count($arr);
	
	for ( $i=0; $i<$arr_n; $i++ ) {
		list($key, $val) = explode(':', $arr[$i]);
		if ( !strlen($key) ) continue;
		$GLOBALS['collapse'][$key] = $val;
	}
}

function url_tog_collapse($id)
{
	if ( !isset($GLOBALS['collapse'][$id]) ) {
		return "ERR";
	}
	
	reset($GLOBALS['collapse']);
	$str = '';
	while ( list($key, $val) = each($GLOBALS['collapse']) ) {
		if ( !$key ) break;	
		if ( $key == $id ) {
			$val = ( $val=='0' ) ? '1' : '0';
		}
		$str .= '_'.$key.':'.$val;
	}
	
	$str = substr($str, 1, strlen($str)-1);
	return $str;	
}

function iscollapsed($id)
{
	if ( !isset($GLOBALS['collapse'][$id]) ) return;
	return $GLOBALS['collapse'][$id];
}

	/*----------------- END FORM FUNCTIONS --------------------*/

	if ( isset($c) && $c ) reload_collapse($c);
	list($ses, $usr) = init_user();
	
	cache_buster();
	if( empty($rid) && $usr ) {
		header("Location: index.php?".$_RSID);
		exit();
	}
	
	if ( isset($ses) ) $ses->update('Browsing the <a href="index.php" class="GenLink">forum list</a>');
	
	$TITLE_EXTRA = '';
	$layout = get_layout_id((isset($layout)?$layout:'')); include_once $GLOBALS['FORUM_SETTINGS_PATH'].'header_'.$layout.'.inc';

	$admin_cp='';
	if ( isset($usr) ) {
		if( $usr->is_mod!='N' ) fud_use('admincp.inc');
		echo '<font class="GenText">Welcome <b>'.htmlspecialchars($usr->login).'</b>, you last visit was on '.format_date(($usr->last_visit)?$usr->last_visit:$usr->join_date).'.</font><br>';
	}	
	echo '<span '.url_help('show_index').'><font class="GenText"><b>Show:</b> </font><a class="GenLink" href="selmsg.php?date=today'.$_RSID.'"><acronym title="Show all messages that were posted today">Today\'s Posts</acronym></a> |'.(isset($usr)?' <a class="GenLink" href="selmsg.php?unread=1&'.$_RSID.'"><acronym title="Show all unread messages">Unread Posts</acronym></a> |':'').' <a class="GenLink" href="selmsg.php?reply_count=0&'.$_RSID.'"><acronym title="Show all messages, which have no replies">Unanswered Posts</acronym></a>'.$admin_cp.create_help_anchor('show_index', 400).'</span>';
	echo '<br><img src="blank.gif" height=2 border=0>';
	
lay_start_content_table(); 
?>
	<tr>
		<td colspan=3 width="100%" class="TableHeading">Forum</td>
		<td class="TableHeading">Posts</td>
		<td class="TableHeading">Threads</td>
		<td nowrap class="TableHeading">Last Post</td>
		<td nowrap class="TableHeading">Moderator(s)</td>
	</tr>
<?php
	if ( isset($usr) ) {
		$frm_sel = 'fud_forum_read.last_view,';
		$frm_join = 'LEFT JOIN fud_forum_read ON fud_forum.id=fud_forum_read.forum_id AND fud_forum_read.user_id='.$usr->id;
	}
	else $frm_sel=$frm_join='';
	
	$frmres = Q("SELECT fud_cat.description, fud_cat.name AS cat_name, fud_cat.default_view, fud_cat.allow_collapse, fud_forum.*, ".$frm_sel." fud_msg.id AS msg_id, fud_msg.post_stamp AS msg_post_stamp, fud_users.id AS user_id, fud_users.login AS user_login
		FROM 
			fud_cat
			INNER JOIN fud_forum 
				ON fud_cat.id=fud_forum.cat_id AND fud_cat.hidden='N'
			LEFT JOIN fud_msg 
				ON fud_forum.last_post_id=fud_msg.id 
			LEFT JOIN fud_users 
				ON fud_msg.poster_id=fud_users.id
			".$frm_join."
			WHERE 
				fud_forum.hidden='N'
			ORDER BY 
				fud_cat.view_order,
				fud_forum.view_order
		");
		
	$cat=0;	
	while ( $data = DB_ROWOBJ($frmres) ) {
		if( $cat != $data->cat_id ) {
			$desc = ( strlen($data->description) ) ? ' - '.$data->description : '';
	
			echo '<tr class="CatDesc"><td colspan="7">';
			if ( $data->allow_collapse == 'Y' ) {
				set_collapse($data->cat_id, (($data->default_view=='COLLAPSED')?'1':'0'));
				$acronym = iscollapsed($data->cat_id) ? 'Maximize Category' : 'Minimize Category';
			
				echo '&nbsp;<a href="index.php?c='.url_tog_collapse($data->cat_id).'&'.$_RSID.'" class="CatLink"><acronym title="'.$acronym.'">'.((iscollapsed($data->cat_id))?'+':'-').'</acronym></a> <a href="index.php?c='.url_tog_collapse($data->cat_id).'&'.$_RSID.'" class="CatLink"><acronym title="'.$acronym.'">'.$data->cat_name.'</acronym></a>';
				echo $desc;
			}
			else {
				echo ' * <font style="CatLockedName">'.$data->cat_name.'</font>'.$desc;
			}
			echo '</td></tr>';
		
			$cat = $data->cat_id;
			set_row_color_alt(true);
		}
		
		if( iscollapsed($data->cat_id) ) continue;
		
		lay_start_content_row(false);

		echo '<td class="RowStyleA" width=1>'.(($data->forum_icon)?'<img src="'.$data->forum_icon.'" border=0 alt="Forum Icon">':'&nbsp;').'</td>';

		echo '<td class="RowStyleB" width=1>';
		if ( isset($usr) && $data->last_view < $data->msg_post_stamp && $usr->last_read < $data->msg_post_stamp )
			echo '<acronym title="New messages"><img src="'.$GLOBALS["fud_img_suffix"].'new_content.gif" alt="New messages" border=0></acronym>';
		else 
			echo '<acronym title="'.(isset($usr)?'No new messages':'Only registered forum members can track read & unread messages').'"><img src="'.$GLOBALS["fud_img_suffix"].'existing_content.gif" alt="No new messages" border=0></acronym>';
		echo '</td>';	
				
		echo '<td class="RowStyleA" width="100%"><a href="thread.php?frm_id='.$data->id.'&'.$_RSID.'" class="GenLink">'.$data->name.'</a><br>'.$data->descr.'</td>';
				
		echo '<td class="RowStyleB" align="center">'.$data->post_count.'</td>';
				
		echo '<td class="RowStyleB" align="center">'.$data->thread_count.'</td>';
				
		echo '<td class="RowStyleA" nowrap align="center"><font class="DateText">'.(($data->last_post_id)?format_date($data->msg_post_stamp.' '.format_time($data->msg_post_stamp)).'<br>By: '.(($data->user_id)?'<a href="usrinfo.php?id='.$data->user_id.'&'.$_RSID.'" class="GenLink">'.htmlspecialchars(trim_show_len($data->user_login,'LOGIN')).'</a>':trim_show_len($GLOBALS["ANON_NICK"],'LOGIN')).' <a href="'.$GLOBALS['D_THREAD_VIEW'].'.php?goto='.$data->last_post_id.'&'.$_RSID.'" class="GenLink"><acronym title="View the lastest message in this forum"><img src="'.$GLOBALS["fud_img_suffix"].'goto.gif" border=0 alt="Go to last post"></acronym></a>':'n/a').'</font></td>';
				
		echo '<td class="RowStyleB" align="center"><font class="SmallText">';
		if( $data->moderators ) eval($data->moderators); else echo '&nbsp;';
		echo '</font></td>';
		lay_end_content_row();
	}
	
	QF($frmres);
	lay_end_content_table();

	if( isset($usr) ) 
		echo '<div align=right><font class="SmallText">[<a href="markread.php?'.$_RSID.'&returnto='.base64_encode('index.php?'.$_RSID.'&c='.((isset($c))?$c:'')).'" class="GenLink"><acronym title="All your unread messages will be marked as read">mark all messages read</acronym></a>]</font></div>';
	
	fud_use('logedin.inc');	
	
	echo '<br>';
	lay_start_content_table();
?>	
	<tr><td class="RowStyleB"><font class="SmallText"><b>Legend:</b></font><br></td></tr>
	<tr><td valign=left class="RowStyleB">
		<table border=0 cellspacing=0 cellpadding=0 align=left>
			<tr>
				<td>
				<table border=0 cellspacing=0 cellpadding=2>
					<tr><td><img src="<?php echo $GLOBALS['fud_img_suffix']; ?>new_content.gif" border=0></td><td class="SmallText">New posts since last read</td></tr>
				</table>
				</td>
				
				<td>
				<table border=0 cellspacing=0 cellpadding=2>
					<tr><td><img src="<?php echo $GLOBALS['fud_img_suffix']; ?>existing_content.gif" border=0></td><td class="SmallText">No new posts since last read</td></tr>
				</table>
				</td>
			
			</tr>
		</table>
	</td></tr>
<?php
	lay_end_content_table();
	
	if ( isset($usr) && $usr->is_mod == 'A' ) {
		fud_use('stats.inc');
		draw_stats();
	}
	
	fud_use('curtime.inc');
	include_once $GLOBALS['FORUM_SETTINGS_PATH'].'footer_'.$layout.'.inc';
	create_help_layers();
	
	$lw = ( !isset($usr) ) ? ' width: 300;' : NULL;
?>