<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: login.php,v 1.10 2002/02/12 20:14:02 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/

/*#? Login Page */
	include_once "GLOBALS.php";
	
	$GLOBALS['USER_REG'] = 1;
	
	fud_use('cookies.inc');
	fud_use('users.inc');
	fud_use('style.inc');
	fud_use('widgets.inc');

	clear_old_sessions();

	list($ses, $usr) = init_user();
	
	if ( !empty($logout) && isset($ses) ) {
		$ses->delete_session();
		check_return();
	}
	
	if ( is_object($usr) ) {
		header("Location: register.php?".$_RSID);
		exit();
	}

function set_err($type, $val)
{
	$GLOBALS['_ERROR_'] = 1;
	$GLOBALS['_ERROR_MSG_'][$type] = $val;
}

function get_err($type)
{
	if ( empty($GLOBALS['_ERROR_MSG_'][$type]) || !strlen($GLOBALS['_ERROR_MSG_'][$type]) ) return;
	return '<font class="ErrorText">'.$GLOBALS['_ERROR_MSG_'][$type].'</font><br>';
}
	
function error_check()
{
	$GLOBALS['_ERROR_'] = NULL;

	if ( !strlen(trim($GLOBALS['login'])) ) {
		set_err('login', 'Login name is required');
	}
	
	if ( !strlen(trim($GLOBALS['password'])) ) {
		set_err('password', 'Password is required');
	}
	
	return $GLOBALS['_ERROR_'];
}
	
	if ( @count($HTTP_POST_VARS) && !error_check() ) {
		if ( !($id = get_id_by_radius($login, $password)) ) {
			set_err('login', 'Invalid login/password combination');
		}
		else {
			$usr = new fud_user_reg;
			$usr->get_user_by_id($id);
			
			if ( !isset($ses) ) $ses = new fud_session;
			
			$ses->putvar('user_id', $id);
			
			$uck = empty($GLOBALS["HTTP_POST_VARS"]["use_cookie"]) ? 1 : NULL;
			
			$ses->save_session($id,$uck);
			
			if ( $usr->email_conf != 'Y' ) {
				std_error('emailconf');
				exit();
			}
			
			if( !empty($GLOBALS["HTTP_POST_VARS"]["adm"]) && $usr->is_mod == 'A' ) {
				header("Location: adm/admglobal.php?".$_RSID);
				exit;
			}
			check_return();
		}
	}
	
	if ( isset($ses) ) $ses->update('Login Form');
	$TITLE_EXTRA = ': Login';
	$layout = get_layout_id((isset($layout)?$layout:'')); include_once $GLOBALS['FORUM_SETTINGS_PATH'].'header_'.$layout.'.inc';

	echo '<div align=center>';
	lay_start_content_table('DialogTable');

	echo '<tr><td colspan=3 class="TableHeading">Login Form</td></tr>';
	echo '<form method="post">';

	if( isset($msg) ) {
		$msg = base64_decode($msg);
		if ( strlen($msg) ) 
			$msg = '<p align="center" class="ErrorText">'.$msg.'</div></p>';
	} else $msg = NULL;
	
	echo '<tr class="RowStyleA"><td class="RowStyleA" colspan=3><font class="GenText">'.$msg.' You are not logged in. This could be due to one of several reasons:
		<ol>
		<li>Your cookie has expired, and you need to login to renew your cookie.
		<li>You do not have permission to access the requested resource as anonymous user, and must login to gain permission to said resource.
		</ol></font></td></tr>';
	echo '<tr class="RowStyleB"><td class="GenText">Login:</td><td>'.get_err('login').'<input type="text" name="login"></td><td nowrap><a class="GenLink" href="register.php?'.$_RSID.'">Want to register?</a></td></tr>';
	echo '<tr class="RowStyleA"><td class="GenText">Password:</td><td>'.get_err('password').'<input type="password" name="password"></td><td nowrap><a class="GenLink" href="reset.php?'.$_RSID.'">Forgot password</a></td></tr>';
	echo '<tr class="RowStyleB"><td colspan=3 align="left"><input type="checkbox" name="use_cookie" value="Y" checked> Use cookies<br><font class="SmallText">If you\'re using a public terminal, such as a computers from libraries, schools, or Internet cafes, it is recommended that you uncheck this option for greater security.</font></td></tr>';
	echo '<tr class="RowStyleA"><td colspan=3 align="right"><input type="submit" value="Login"></td></tr>';
	
	if( !empty($adm) ) echo '<input type="hidden" name="adm" value="1">';
	echo '<input type="hidden" name="S" value="'.$S.'"></form>';

	lay_end_content_table();
	echo '</div>';
	include_once $GLOBALS['FORUM_SETTINGS_PATH'].'footer_'.$layout.'.inc';
?>