<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: poll.php,v 1.11 2002/02/11 21:06:40 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/

	include_once "GLOBALS.php";
	fud_use('db.inc');
	fud_use('widgets.inc');
	fud_use('cookies.inc');
	fud_use('users.inc');
	fud_use('poll.inc');
	fud_use('style.inc');
	fud_use('post.inc');
	fud_use('forum.inc');
	fud_use('util.inc');
	fud_use('objutil.inc');
	fud_use('smiley.inc');
	
	list($ses, $usr) = init_user();
	
	cache_buster();
	
	if( !isset($ses) ) 
		std_error('login');
		
	$frm = new fud_forum;
	
	if ( !empty($pl_id) ) {
		if( !strlen($frm_id) ) 
			$frm_id = Q_SINGLEVAL("SELECT forum_id FROM fud_poll LEFT JOIN fud_msg ON fud_poll.id=fud_msg.poll_id LEFT JOIN fud_thread ON fud_thread.id=fud_msg.thread_id WHERE fud_poll.id=".$pl_id);

		if ( $frm_id ) {
			$frm->get($frm_id);
			$MOD=NULL;
			if ( isset($usr) && ($frm->is_moderator($usr->id) || $usr->is_mod == 'A') ) $MOD = 1;
		}
		
		/* check if owner */
		
		$poll = new fud_poll;
		$poll->get($pl_id);
		if ( $poll->owner != $usr->id && !$MOD ) {
			std_error('access');
			exit();
		}

		if ( !isset($pl_submit) ) {
			$pl_name = $poll->name;
			$pl_max_votes = $poll->max_votes;
			$pl_expiry_date = $poll->expiry_date;
		}
	}
	else if ( !empty($frm_id) ) {
		$frm->get($frm_id);
	}
	else {
		exit('<html><div align="center">Fatal Error<br><a href="#" onClick="javascript:window.close();">Close Window</a></div></html>');
	}	
	
	if ( isset($poll) && !empty($pl_optedit) && empty($pl_upd) ) {
		$a_poll = new fud_poll_opt;
		$a_poll->get($pl_optedit);
		$pl_option = $a_poll->name;
		$ses->putvar('pl_optedit', $a_poll->id);
	}
	else if ( empty($pl_upd) ) $ses->rmvar('pl_optedit');
	
	if ( isset($usr) ) $usr_id = $usr->id;
	
	$ses->save_session($usr_id);
	
	if ( isset($poll) && !empty($pl_id) && !empty($pl_submit) ) {
		$poll->name = htmlspecialchars($pl_name);
		$poll->max_votes = $pl_max_votes;
		$poll->expiry_date = $pl_expiry_date;
		$poll->sync();
		header("Location: poll.php?frm_id=".$frm_id."&".$_RSID."&pl_id=".$poll->id);
		exit();
	}
	
	/* Adding or Updating poll options */	
	
	if( isset($poll) && (!empty($pl_upd) || !empty($pl_add)) ) {
	
		$pl_option = apply_custom_replace($pl_option);
		
		switch ( $frm->tag_style )
		{
			case 'ML':
				$pl_option = tags_to_html($pl_option, $frm->enable_images);
				break;
			case 'HTML':
				break;
			default:
				$pl_option = nl2br(htmlspecialchars($pl_option));	
		}
	
		if ( $frm->enable_smileys == 'Y' && empty($HTTP_POST_VARS["pl_smiley_disabled"]) ) smiley_to_post($pl_option);
	
		$a_opt = new fud_poll_opt;
	
		if ( !empty($pl_upd) ) {
			$a_opt->get($ses->getvar('pl_optedit'));
			if( strlen(trim($pl_option)) ) { 
				$a_opt->name = $pl_option;
				$a_opt->sync();
			}
			else {
				$a_opt->delete();
			}	
		}
		else if ( !empty($pl_add) ) {
			if( strlen(trim($pl_option)) ) { 
				$a_opt->name = $pl_option;
				$a_opt->poll_id = $poll->id;
				$a_opt->add();
			}	
		}
		
		header("Location: poll.php?frm_id=".$frm_id."&".$_RSID."&pl_id=".$poll->id);
		exit;
	}	
	
	if ( isset($poll) && !empty($del_id) ) {
		$a_opt = new fud_poll_opt;
		$a_opt->get($del_id);
		$a_opt->delete();
		header("Location: poll.php?frm_id=".$frm_id."&".$_RSID."&pl_id=".$pl_id);
		exit();
	}
	
	if ( !empty($pl_submit) ) {
		$in_pl = new fud_poll;
		fetch_vars('pl_', $in_pl, $HTTP_POST_VARS);
		$in_pl->owner = $usr->id;
		$id = $in_pl->add();
		header("Location: poll.php?frm_id=".$frm_id."&".$_RSID."&pl_id=".$id);
	 	exit();
	}
	
	$GLOBALS['PLAIN_FORM'] = 1;
	$TITLE_EXTRA = ': Poll Editor';
	$layout = get_layout_id((isset($layout)?$layout:'')); include_once $GLOBALS['FORUM_SETTINGS_PATH'].'header_'.$layout.'.inc';
?>
<script language="JavaScript" type="javascript/text">
function check_submission()
{
	var a;
	
	a = document.poll_submit.pl_option.value.replace('/[ \n\r]/g', '');

	if( !a.length ) {
		if( document.poll_submit.pl_add && document.poll_submit.pl_add.value.length ) {
			alert("You cannot add a blank option.");
			return false;
		}
		else if( document.poll_submit.pl_upd && document.poll_submit.pl_upd.value.length ) {
			return confirm("If you want to delete this option, press OK");
		}
	}
	return true;	
}
</script>
<form method="post" name="poll_submit" >
<input type="hidden" name="frm_id" value="<?php echo $frm_id; ?>"><input type="hidden" name="S" value="<?php echo $S; ?>">
<table border=0 cellspacing=2 width="99%" cellpadding=0 class="dashed">
	<tr>
		<td class="GenText">Poll Name:</td>
		<td><input type="text" name="pl_name" value="<?php echo (empty($pl_name)?'':$pl_name); ?>"></td>	
	</tr>
	<tr><td class="GenText">Time Limit</td><td><?php draw_select("pl_expiry_date", "Unlimited\n1 hour\n6 hours\n12 hours\n1 day\n3 days\n1 week\n1 month\n1 year", "0\n3600\n21600\n43200\n86400\n259200\n604800\n2635200\n31536000", $pl_expiry_date); ?></td></tr>
	<tr><td class="GenText">Maxium Votes</td><td><?php draw_select("pl_max_votes", "Unlimited\n10\n50\n100\n200\n500\n1000\n10000\n100000", "0\n10\n50\n100\n200\n500\n1000\n10000\n100000", $pl_max_votes); ?></td></tr>
<?php
	if( $frm->enable_smileys=='Y' ) {
		echo '<tr><td colspan=2 class="GenText">'.create_checkbox('pl_smiley_disabled', 'Y', (isset($pl_smiley_disabled)?$pl_smiley_disabled:'')).'Disable smilies</td></tr>';
	}
?>
	<tr><td colspan=2 align="right">
	<?php
		echo '<input type="submit" name="pl_submit" value="'.(!empty($pl_id)?'Update':'Create').' Poll">';
	?>
	</td></tr>
	</table>
	<p>
	<table width="99%" border=0 cellspacing=2 cellpadding=0 class="dashed">
<?php 
	/* 
	 * this is only available on a created poll
	 */
	if ( !empty($pl_id) ) { 
		if( empty($pl_option) ) $pl_option = '';
		
		switch( $frm->tag_style )
	 	{
	 		case 'ML':
	 			$pl_option = html_to_tags($pl_option);
	 			break;
	 		case 'HTML':
	 			break;
	 		default:
	 			reverse_nl2br($pl_option);
	 	}
	 	
	 	$pl_option = post_to_smiley($pl_option);
		$pl_option = apply_reverse_replace($pl_option);
	
		?><tr><td class="GenText">Add Option:</td><td align="right"><input type="text" name="pl_option" value="<?php echo htmlspecialchars($pl_option); ?>">&nbsp;<?php
		echo '<input type="submit" name="pl_'.(!empty($pl_optedit)?'upd':'add').'" onClick="javascript: return check_submission();" value="'.(!empty($pl_optedit)?'Update':'Add').' Option"><br>';
		
		$closed = 1;
		echo '</td></tr><tr><td colspan=2>&nbsp;</td></tr>';
		$opt = new fud_poll_opt;
		$opt->get_poll($pl_id);
		$opt->reset_opt();
		
		echo '<tr><td colspan=2><table>';
		while ( $obj=$opt->next_opt() ) {
			echo '<tr><td class="GenText">'.$obj->name.'</td><td nowrap>[<a class="GenLink" href="poll.php?frm_id='.$frm_id.'&'.$_RSID.'&pl_id='.$pl_id.'&pl_optedit='.$obj->id.'">Edit</a>] [<a href="poll.php?frm_id='.$frm_id.'&pl_id='.$pl_id.'&del_id='.$obj->id.'&'.$_RSID.'">Delete</a>]</td></tr>';
		}
		echo '</table></td></tr></table><br>';	
	} 
	/* end of poll option code */

	if ( empty($closed) ) echo "</table>";

?>
<div align=right>
<input type="button" onClick="javascript: window.opener.document.post_form.pl_id.value=<?php echo (!empty($pl_id)?$pl_id:'0'); ?>; window.opener.document.post_form.submit(); window.close();" value="<?php echo (isset($poll))?'Edit':'Create'; ?>">
</div>
</form>
<?php include_once $GLOBALS['FORUM_SETTINGS_PATH'].'footer_'.$layout.'.inc'; ?>