<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: post.php,v 1.24 2002/02/12 17:55:54 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/

/*#? Post Editor Page */
	include_once "GLOBALS.php";
	
	$GLOBALS['MSG_EDIT'] = 1;
	
	fud_use('db.inc');
	fud_use('cookies.inc');	
	fud_use('widgets.inc');
	fud_use('msg.inc');
	fud_use('thread.inc');
	fud_use('forum.inc');
	fud_use('users.inc');
	fud_use('poll.inc');
	fud_use('style.inc');
	fud_use('smiley.inc');
	fud_use('ipfilter.inc');
	fud_use('email.inc');
	fud_use('postcheck.inc');
	fud_use('post.inc');
	fud_use('help.inc');
	fud_use('thread_notify.inc');
	fud_use('spell.inc');
	fud_use('wordwrap.inc');
	fud_use('post_opt.inc');
	fud_use('rev_fmt.inc');
	
	/* Information Retrieval */
	list($ses, $usr) = init_user();
	
	cache_buster();
	$smiley_www = $GLOBALS['IMG_ROOT_WWW'].$GLOBALS['SMILEY_DIR'];
	$icon_path = $IMG_ROOT_DISK.$MESSAGE_ICON_DIR;
	$icon_path_www = $IMG_ROOT_WWW.$MESSAGE_ICON_DIR;
	$returnto_d = base64_decode((!empty($returnto)?$returnto:NULL));
	$attach_control_error=NULL;

	/* INITIAL SECURITY CHECKS */
	$flt = new fud_ip_filter;
	if ( isset($GLOBALS['HTTP_SERVER_VARS']['REMOTE_ADDR']) && $flt->is_blocked($GLOBALS['HTTP_SERVER_VARS']['REMOTE_ADDR']) ) {
		error_dialog('ERROR', "You aren't allowed to post", $returnto_d);
		exit();
	}
	$flt=NULL;

	if( empty($reply_to) ) $reply_to = NULL;
	if( empty($msg_id) ) $msg_id = NULL;
	
	if( $reply_to || $msg_id ) {
		$mid = ($reply_to)?$reply_to:$msg_id;
		if( !is_numeric($mid) ) invl_inp_err();
		$msg = new fud_msg_edit;
		$msg->get_by_id($mid);
	 	$th_id = $msg->thread_id;
	}

	$frm = new fud_forum;
	if( !empty($th_id) ) {
		if( !is_numeric($th_id) ) invl_inp_err();
		$thr = new fud_thread;
		$thr->get_by_id($th_id);	
		$frm->get($thr->forum_id);
	}
	else if( !empty($frm_id) ) {
		$frm->get($frm_id);
		$th_id = NULL;
	}	
	else 
		error_dialog('ERROR: System Error', 'System error has occured, please report it to the <a href="mailto:'.$GLOBALS["ADMIN_EMAIL"].'">webmaster</a>.', $returnto_d);
	
	$MAX_F_SIZE = $frm->max_attach_size;
	
	/* More Security */
	if( isset($thr) && $thr->locked=='Y' ) {
		error_dialog('ERROR: Locked Thread', 'This thread is locked, no more posting allowed', $returnto_d);
		exit();
	}
	
	if( isset($usr) ) {
		/* check if moderator */
		if ( $frm->is_moderator($usr->id) || $usr->is_mod == 'A' ) { $MOD = 1; } else { $MOD=NULL; }

		if ( strtoupper($GLOBALS['COPPA']) == 'Y' && strtoupper($usr->coppa) == 'Y' ) { error_dialog('ERROR: Your account is not yet confirmed', "We have not received a confirmation from your parent and/or legal guardian, which would allow you to post messages. If you lost your coppa form <a href=\"".$WWW_ROOT."coppa_fax.php?".$_RSID."\">click here</a> to get it", $returnto_d); exit(); }
		if ( $EMAIL_CONFIRMATION == 'Y' && $usr->email_conf == 'N' ) { std_error('emailconf'); exit(); }	
		if ( $usr->blocked == 'Y' ) { error_dialog('ERROR: you aren\'t allowed to post', 'Your account has been blocked from posting', $returnto_d); exit(); }
		if ( is_email_blocked($usr->email) ) { error_dialog('ERROR: you aren\'t allowed to post', 'Your account has been blocked from posting', $returnto_d); exit(); }
		if ( $msg_id && empty($MOD) ) {
			if ( $msg->poster_id != $usr->id ) { error_dialog('ERROR', "You are not the owner of this message", $returnto_d); exit(); } 
			if ( $EDIT_TIME_LIMIT && ($msg->post_stamp+$EDIT_TIME_LIMIT*60<time()) ) { error_dialog('ERROR', "You can no longer edit this message", $returnto_d); exit(); } 
		}	
	}
	else {
		if( empty($th_id) && $frm->anon_topic_creation!='Y' ) {
			error_dialog('ERROR: Insufficient Priviledges', 'Annonymous users aren\'t allowed to create topics<br><br>If you would like to register go to the <a href="register.php?'.$_RSID.'">registration form</a><br>If you would like to login please go to the <a href="login.php?'.$_RSID.'">login form</a>', $returnto_d); 
			exit(); 
		}
		else if ( $frm->anon_replying!='Y' ) {
			error_dialog('ERROR: Insufficient Priviledges', 'Annonymous users aren\'t allowed to reply<br><br>If you would like to register go to the <a href="register.php?'.$_RSID.'">registration form</a><br>If you would like to login please go to the <a href="login.php?'.$_RSID.'">login form</a>', $returnto_d); 
			exit(); 
		}
	}

	/* check replying is allowed for annonce or sticky */
	if( isset($thr) && $thr->replyallowed!='Y' && empty($MOD) ) {
		error_dialog('ERROR: Replying Not Allowed', 'You cannot post replies to this thread, because it is either an annoucment or sticky message, to which the moderator disallowed replying.', $returnto_d);
		exit();
	}

	/* Retrieve Message */
	if( empty($HTTP_POST_VARS['prev_loaded']) ) { 
		if( isset($usr) ) {
			$msg_show_sig = $usr->append_sig;
			$msg_poster_notif = $usr->notify;
		}
		
		if( $msg_id ) {
			$msg->export_vars('msg_');
			
			$msg_body = post_to_smiley($msg_body);
	 		
	 		switch( $frm->tag_style )
	 		{
	 			case 'ML':
	 				$msg_body = html_to_tags($msg_body);
	 				break;
	 			case 'HTML':
	 				break;
	 			default:
	 				reverse_FMT($msg_body);
	 				reverse_nl2br($msg_body);
	 		}
	 		
	 		$msg_body = apply_reverse_replace($msg_body);
	 		
	 		reverse_FMT($msg_subject);
			$msg_subject = apply_reverse_replace($msg_subject);
	 		
	 		$msg_smiley_disabled = $msg->smiley_disabled;
	 	
	 		$msg_poster_notif = ( is_notified($usr->id, $msg->thread_id) ) ? 'Y' : 'N';
	 			
	 		if ( $msg->attach_cnt ) {
	 			$r = Q("SELECT * FROM fud_attach WHERE message_id=".$msg->id." AND private='N'");
	 			while ( $obj = DB_ROWOBJ($r) ) {
	 				$afile['name'] = $obj->original_name;
	 				$afile['db_id'] = $obj->id;
	 				$afile['size'] = filesize($obj->location);
	 				$afile['tmp'] = $afile['delque'] = NULL;
	 				$attach_list[$obj->id] = $afile;
	 			}
	 			QF($r);
		 	}
		 	$pl_id = $msg->poll_id;	
		}
		else if( $reply_to || $th_id ) {
			$subj = ( $th_id ) ? $thr->subject : $msg->subject;
			reverse_FMT($subj);
			$subj = apply_reverse_replace($subj);
		
			$msg_subject = ( !preg_match('/^re: /i', $subj) ) ? "Re: ".$subj : $subj;
			$old_subject = $msg_subject;

			if( isset($quote) ) {
				$msg_body = apply_reverse_replace($msg->body);
				$msg_body = post_to_smiley(str_replace("\r", '', $msg_body));
				
				switch ( $frm->tag_style )
				{
					case 'ML':
						$msg_body = html_to_tags($msg_body);
						reverse_FMT($msg_body);
				 		$msg_body = '[quote title='.$msg->login.' wrote on '.format_date($msg->post_stamp).' '.format_time($msg->post_stamp).']'.$msg_body.'[/quote]';
				 		break;
					case 'HTML':
						$msg_body = '<table border="0" align="center" width="90%" cellpadding="3" cellspacing="1"><tr><td class="SmallText"><b>'.$msg->login.' wrote on '.format_date($msg->post_stamp).' '.format_time($msg->post_stamp).'</b></td></tr><tr><td class="quote"><br>'.$msg_body.'<br></td></tr></table>';
						break;
					default:
						reverse_FMT($msg_body);
						reverse_nl2br($msg_body);
						$msg_body = 'Quote: '.$msg->login.' wrote on '.format_date($msg->post_stamp).' '.format_time($msg->post_stamp)."\n----------------------------------------------------\n".$msg_body."\n----------------------------------------------------\n";
				}
		 		
	 			if( empty($msg->login) ) $msg->login = $GLOBALS['ANON_NICK'];
			}
		}
	}	
	else { /* $HTTP_POST_VARS['prev_loaded'] */
		/* remove slashes */
		while( list($k,) = each($HTTP_POST_VARS) ) {
			if( !empty($HTTP_POST_VARS[$k]) ) $HTTP_POST_VARS[$k] = $GLOBALS[$k] = stripslashes($HTTP_POST_VARS[$k]);
		}

		if ( $FLOOD_CHECK_TIME && !$MOD && !$msg_id ) {
			if ( ($tm=flood_check()) ) {
				error_dialog('ERROR: Post flood triggered.', "Please try again in ".$tm." seconds", $returnto_d);
				exit();
			}
		}
		
		if( $frm->enable_attachments=='Y' ) {
			/* restore the attachment array */
			
			$attach_count=0;
			if ( !empty($file_array) ) {
				$file_array = base64_decode($HTTP_POST_VARS['file_array']);
				
				if ( strlen($file_array) ) {
					$arr = explode("\n", $file_array);
					reset($arr);
					while ( list($k, $v) = each($arr) ) {
						if ( $v ) {
							list($afile['tmp'], $afile['name'], $afile['size'], $afile['delque'], $afile['db_id']) = explode("\r", $v);
							if ( strlen($afile['db_id']) ) 
								$k = $afile['db_id'];
							else
								$k = $afile['tmp'];
							
							$attach_list[$k] = $afile;
							
							if( empty($afile['delque']) ) $attach_count++;
						}
					}
				}
				
				if ( $file_del_opt && isset($attach_list[$file_del_opt]) ) {
					$attach_list[$file_del_opt]['delque'] = 1;
					$attach_count--;
				}
			}
			
			if ( !empty($attach_control_size) ) {
				if( $attach_control_size>($MAX_F_SIZE*1024) ) {
					$attach_control_error = '<font class="ErrorText">File Attachment is too big (over allowed limit of '.$MAX_F_SIZE.' bytes)</font><br>';
				}
				else {
					if( filter_ext($attach_control_name) ) {
						$attach_control_error = '<font class="ErrorText">The file you are trying to upload doesn\'t match the allowed file types.</font><br>';
					}
					else {
						if( ($attach_count+1) <= $frm->max_file_attachments ) { 
							unset($afile);
							$afile['tmp'] = safe_tmp_copy($attach_control);
							$afile['name'] = htmlspecialchars($attach_control_name);
							$afile['size'] = $attach_control_size;
							$afile['db_id'] = $afile['delque'] = NULL;
							$attach_list[$afile['tmp']] = $afile;
							$attach_count++;
						}
						else {
							$attach_control_error = '<font class="ErrorText">You are trying to upload more files then it is allowed.</font><br>';
						}	
					}	
				}	
			}
			$attach_cnt = $attach_count;
		}
		
		if( !empty($HTTP_POST_VARS["pl_del"]) ) {
			$poll = new fud_poll;
			$poll->get($pl_id);
			$poll->delete($pl_id);
			$pl_id = 0;
			unset($poll);
		}
		
		if ( $reply_to && $old_subject == $msg_subject )
				$no_spell_subject = 1;
		
		if( !empty($HTTP_POST_VARS["btn_spell"]) ) {
			$text = apply_custom_replace($HTTP_POST_VARS["msg_body"]);
			$text_s = apply_custom_replace($HTTP_POST_VARS["msg_subject"]);
		
			switch( $frm->tag_style )
			{
				case 'ML':
					$text = tags_to_html($text, $frm->enable_images);
					break;
				case 'HTML':
					break;
				default:
					$text = htmlspecialchars($text);
			}
		
			if ( $frm->enable_smileys == 'Y' && empty($HTTP_POST_VARS["msg_smiley_disabled"]) ) smiley_to_post($text);

	 		if( strlen($text) ) {	
				$wa = tokenize_string($text);
				$text = spell_replace($wa,'body');
				
				if ( $frm->enable_smileys == 'Y' && empty($HTTP_POST_VARS["msg_smiley_disabled"]) ) $msg_body = post_to_smiley($msg_body);
				if($frm->tag_style == 'ML' ) $msg_body = html_to_tags($msg_body);
				else if ( $frm->tag_style !='HTML' )  reverse_FMT($msg_body);
				
				$msg_body = apply_reverse_replace($msg_body);
			}	
			$wa='';
			
			if( strlen($HTTP_POST_VARS["msg_subject"]) && empty($no_spell_subject) ) {
				$text_s = htmlspecialchars($text_s);
				$wa = tokenize_string($text_s);
				$text_s = spell_replace($wa,'subject');
				reverse_FMT($text_s);
				$msg_subject = apply_reverse_replace($text_s);
			}
		}
		
		if( empty($frm_passwd) ) $frm_passwd = '';	
		 	
		if ( !empty($HTTP_POST_VARS["btn_submit"]) && $frm->passwd_posting == 'Y' && $frm->post_passwd != $frm_passwd ) {
			set_err('password', 'Incorrect password.');
		}
		
		if( !empty($HTTP_POST_VARS["btn_submit"]) && !check_post_form() ) {
			$msg_post = new fud_msg_edit;
			
			/* Process Message Data */
			$msg_post->poster_id = (isset($usr))?$usr->id:0;
			
			$msg_post->poll_id = $pl_id;
			$msg_post->fetch_vars($HTTP_POST_VARS, 'msg_');
		 	$msg_post->smiley_disabled = YN($msg_smiley_disabled);
		 	$msg_post->attach_cnt = empty($attach_cnt)?0:$attach_cnt;
			
			$msg_post->body = apply_custom_replace($msg_post->body);
			switch ( $frm->tag_style )
			{
				case 'ML':
					$msg_post->body = tags_to_html($msg_post->body, $frm->enable_images);
					break;
				case 'HTML':
					break;
				default:
					$msg_post->body = nl2br(htmlspecialchars($msg_post->body));
			}
	 		if( $frm->enable_smileys=='Y' && $msg_post->smiley_disabled!='Y' ) smiley_to_post($msg_post->body);
			fud_wordwrap($msg_post->body);
			
			$msg_post->subject = apply_custom_replace($msg_post->subject);
			$msg_post->subject = htmlspecialchars($msg_post->subject);
			$msg_post->subject = addslashes($msg_post->subject);
		
			$th_not = new fud_thread_notify;
		 	
		 	if( !$th_id ) {
		 		$create_thread=1;
		 		$msg_post->add_thread($frm->id);
		 		$thr = new fud_thread;
		 		$thr->get_by_id($msg_post->thread_id);
		 	}
			else if( $th_id && !$msg_id ) {
				$msg_post->thread_id = $th_id;
		 		$msg_post->add_reply($reply_to, $th_id);
			}
			else if ( $msg_id ) {
				$msg_post->id = $msg_id;
				$msg_post->thread_id = $th_id;
				$msg_post->sync($usr->id);
			}
			else {
				error_dialog('ERROR: Fatal Error', 'System error, notify the administrator', $returnto);	
				exit();
			}

			if( $frm->enable_attachments == 'Y' && isset($attach_list) ) {
				reset($attach_list);
				while ( list($k, $v) = each($attach_list) ) {
					if( !$v ) continue;
					if ( strlen($v['delque']) ) {
						if ( $v['tmp'] ) {
							if( file_exists($GLOBALS['TMP'].$v['tmp']) ) 
								unlink($GLOBALS['TMP'].$v['tmp']);
						}		
						else {
							unset($at_obj);
							$at_obj = new fud_attach();
							if( $v['db_id'] ) {
								$at_obj->get($v['db_id']);
								$at_obj->delete();
							}	
						}
					}
					else if( !$v['db_id'] ) {
						unset($at_obj);
						$at_obj = new fud_attach();
						if ( isset($usr) ) $o_id = $usr->id;
						$at_obj->add($o_id, $msg_post->id, addslashes($v['name']), $GLOBALS['TMP'].$v['tmp'], 'N');
						if( file_exists($GLOBALS['TMP'].$v['tmp']) )
							unlink($GLOBALS['TMP'].$v['tmp']);
					}
				}
			}

			if ( isset($usr) ) {
	 			if ( isset($HTTP_POST_VARS["msg_poster_notif"]) && $HTTP_POST_VARS["msg_poster_notif"]=='Y' ) 
	 				$th_not->add($usr->id, $msg_post->thread_id);
	 			else if ( !empty($GLOBALS["HTTP_POST_VARS"]["msg_id"]) )
	 				$th_not->delete($usr->id, $msg_post->thread_id);
			}

			if ( isset($frm) && isset($usr) ) $usr->register_forum_view($frm->id);
			
			$msg_url = ( strstr($returnto_d, 'tree.php') ) ? 'tree' : 'msg';
			
			if( $frm->moderated != 'Y' )
				if( !strstr($returnto_d, 'selmsg.php') )
					$returnto = base64_encode($msg_url.'.php?goto='.$msg_post->id.'&'.$_RSID);
				else {
					if( ($pos = strpos($returnto_d, '#')) ) $returnto_d = substr($returnto_d, 0, $pos);
					$returnto = base64_encode($returnto_d.'#msg_'.$msg_post->id);	
				}	
			else {
				if( !strstr($returnto_d, 'selmsg.php') )
					$returnto = ( $th_id ) ? base64_encode($msg_url.'.php?'.$_RSID.'&th='.$th_id) : base64_encode('thread.php?'.$_RSID.'&frm_id='.$frm_id);
				else 
					$returnto = base64_encode($returnto_d);					
		 	}
		 	
		 	check_return();
		} /* Form submitted and user redirected to own message */
	} /* $prevloaded is SET, this form has been submitted */
	
	/* form start */	 
	if ( isset($ses) ) {
		if ( $reply_to || $th_id && !$msg_id ) {
			if( $thr->hidden!='Y') $ses->update('Replying to <a class="GenLink" href="msg.php?goto='.$thr->root_msg_id.'">'.htmlspecialchars($thr->subject).'</a> in '.$frm->name);
		}
		else if ( $msg_id ) {
			if( $thr->hidden!='Y') $ses->update('Editing <a class="GenLink" href="msg.php?goto='.$thr->root_msg_id.'">'.htmlspecialchars($msg->subject).'</a> in '.$frm->name);
		}
		else {
			if($frm->hidden!='Y' && $frm->cat_hidden!='Y' ) $ses->update('Writing new topic in <a class="GenLink" href="thread.php?frm_id='.$frm->id.'">'.$frm->name.'</a>');
		}
	}
	$layout = get_layout_id((isset($layout)?$layout:'')); include_once $GLOBALS['FORUM_SETTINGS_PATH'].'header_'.$layout.'.inc';
	set_row_color_alt(true);
	echo '<form action="post.php" method="post" name="post_form" enctype="multipart/form-data">';

if ( !empty($preview) || !empty($spell) ) {
	$text = apply_custom_replace($HTTP_POST_VARS['msg_body']);
	$text_s = apply_custom_replace($HTTP_POST_VARS['msg_subject']);

	switch ( $frm->tag_style )
	{
		case 'ML':
			$text = tags_to_html($text, $frm->enable_images);
			break;
		case 'HTML':
			break;
		default:
			$text = nl2br(htmlspecialchars($text));
	}
			
	if ( $frm->enable_smileys == 'Y' && empty($HTTP_POST_VARS["msg_smiley_disabled"]) ) smiley_to_post($text);
	
	$text_s = htmlspecialchars($text_s);
		
	if( !function_exists('pspell_config_create') ) $spell=0;
	
	if ( !empty($spell) && !empty($text) ) $text = check_data_spell($text,'body');
	fud_wordwrap($text);

	$sig=$subj='';
	if ( $text_s ) {
		$subj = '<tr><td class="RowStyleA"><font class="MsgSubText">';
		
		if ( !empty($spell) && empty($no_spell_subject) && strlen($text_s) )
			$subj .= check_data_spell($text_s,'subject');
		else
			$subj .= $text_s;

		$subj .= '</font></td></tr>';
	}
	if ( !empty($msg_show_sig) && $msg_show_sig == 'Y' && $usr->sig ) $sig = '<p><u>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</u><br>'.$usr->sig;
	
	echo '<div align="center">';
	lay_start_content_table('PreviewTable');
	
	echo '<tr><td class="TableHeading" colspan=2>Post Preview</td></tr>';
	echo $subj.'<tr><td class="RowStyleA"><font class="MsgBodyText">';
	echo $text.'<br>'.$sig.'</font>';
	if ( !empty($spell) ) echo '<p><input type="submit" name="btn_spell" value="Apply Spelling Changes"></td></tr>';
	
	lay_end_content_table();
	echo '</div><br>';
}

if ( is_post_error() ) echo '<h4 align="center"><font class="ErrorText">You have an error</font></h4>';

lay_start_content_table();

	set_row_color_alt(true);
	echo '<tr><td colspan=2 class="TableHeading"><a name="ptop"> </a>Post Form</td></tr>';
	if ( isset($usr) ) {
		echo '<tr'.ROW_BGCOLOR().'><td nowrap class="GenText">Logged in user:</td><td class="GenText" width="100%">'.htmlspecialchars($usr->login).' [<a href="login.php?'.$_RSID.'&logout=1" class="GenLink">logout</a>]</td></tr>';
	}

	/*
	 * form begins here
	 */
		
	if ( $frm->passwd_posting == 'Y' ) {
		echo '<tr'.ROW_BGCOLOR().'><td class="GenText">Posting Password:</td><td><input type="password" name="frm_passwd" value="">'.get_err('password').'</td></tr>';
	}
	
	if ( isset($frm) ) echo '<tr'.ROW_BGCOLOR().'><td class="GenText">Forum:</td><td class="GenText">'.$frm->name.'</td></tr>';

	echo '<tr'.ROW_BGCOLOR().'><td class="GenText">Title:</td><td class="GenText"><input type="text" name="msg_subject" value="'.(isset($msg_subject)?htmlspecialchars($msg_subject):'').'" size=50> '.get_err('msg_subject').'</td></tr>';
	
	if ( isset($usr) && $frm->allow_polls == 'Y' ) {
		if ( empty($pl_id) ) {
			echo '<tr'.ROW_BGCOLOR().'><td class="GenText">Poll:</td><td '.url_help('create_poll').' class="GenText"><a class="GenLink" href="#" onClick="javascript: window_open(\'poll.php?'.$_RSID.'&frm_id='.$frm->id.'\', \'poll_creator\', 400, 300);">[CREATE POLL]</a>'.create_help_anchor('create_poll').'</td></tr>';
		}
		else if ( is_numeric($pl_id) ) {
			$poll = new fud_poll;
			$poll->get($pl_id);
			echo '<tr'.ROW_BGCOLOR().'><td class="GenText">Poll:</td><td class="GenText">'.$poll->name.' [<a class="GenLink" href="#" onClick="javascript: window_open(\'poll.php?'.$_RSID.'&pl_id='.$pl_id.'\', \'poll\', 400, 300);">EDIT</a>] <input type="hidden" name="pl_del" value="">[<a class="GenLink" href="#" onClick="javascript: document.post_form.pl_del.value=\'1\'; document.post_form.submit();">DELETE</a>]</td></tr>';
		}
	}
	
	/* determine if admin and are allowed to make sticky messages */
	if ( isset($MOD) && ( empty($thr) || ($thr->root_msg_id==$msg->id && empty($reply_to)) ) ) {
		if ( !$prev_loaded ) {
			$thr_ordertype = $thr->ordertype;
			$thr_orderexpiry = $thr->orderexpiry;
			$thr_replyallowed = $thr->replyallowed;
		}

		echo '<tr'.ROW_BGCOLOR().'><td class="GenText">Moderator Options:</td>
			<td>
			Thread Type: '.create_select('thr_ordertype', "Normal\nSticky\nAnnoncement", "NONE\nSTICKY\nANNOUNCE", $thr_ordertype).'
			Thread Expiry: '.create_select('thr_orderexpiry', "Never\n1 Hour\n2 Hours\n4 Hours\n8 Hours\n16 Hours\n1 Day\n2 Days\n4 Days\n1 Week\n2 Weeks\n1 Month\n2 Month\n4 Month\n1 Year", 
									"0\n3600\n7200\n14400\n28800\n57600\n86400\n172800\n345600\n604800\n1209600\n2635200\n5270400\n10540800\n938131200", $thr_orderexpiry).'
			'.create_checkbox('thr_replyallowed', 'Y', ((!isset($thr_replyallowed))?'Y':$thr_replyallowed)).' Replying allowed
			</td>
		</tr>';
	}
	
	/* 
	 * draw the icon select here
	 */
	 
	 $icons_per_row = 9;
	 $icon = '';
	 if( !isset($msg_icon) ) $msg_icon='';
	 if ( $dp = opendir($icon_path) ) {
	 	$icon .= '<table border=0 cellspacing=0 cellpadding=2 '.url_help('post_icon').'><tr>';
	 	$icon .= '<tr><td class="GenText" colspan='.$icons_per_row.'><input type="radio" name="msg_icon" value=""'.((!strlen($msg_icon))?' checked':'').'>No Icon</td></tr>';
	 	$col = 1;
	 	while ( $de = readdir($dp) ) {
	 		if ( $de == '.' || $de == '..' ) continue;
			if ( strlen($de) < 4 ) continue;
			$ext = strtolower(substr($de, -4));
			if ( $ext != '.gif' && $ext != '.jpg' && $ext != '.png' ) continue;
			
			if ( !($col++%$icons_per_row) ) {
				$icon .= "\n</tr>\n<tr>\n";
			}
						
	 		$icon .= '<td nowrap valign=middle><input type="radio" name="msg_icon" value="'.$de.'"'.(($de==$msg_icon)?' checked':'').'><img src="'.$icon_path_www.$de.'"></td>';
	 	}
	 	closedir($dp);
	 	$icon .= '<td>'.create_help_anchor('post_icon')."</td></tr></table>";
	 }
	 
	echo '<tr'.ROW_BGCOLOR().'><td valign=top class="GenText">Post Icon:</td><td>'.$icon.'</td></tr>';
	
	if( $frm->enable_smileys == 'Y' ) {
		$smileys = new fud_smiley;
		$smileys->getall();
		$smileys->resets();
	
		$col_count = 25;
		$col_pos = 0;
		$sml = '<tr valign=bottom>';
		while ( $obj = $smileys->eachs() ) {
			if ( ++$col_pos > $col_count ) { $sml .= '</tr><tr>'; $col_pos = 0; }
			$obj->code = ($a=strpos($obj->code, '~')) ? substr($obj->code,0,$a) : $obj->code;
			$sml .= '<td><a href="javascript: insertTag(document.post_form.msg_body, \'\', \' '.$obj->code.' \');"><acronym title="'.$obj->descr.'"><img alt="'.$obj->descr.'" src="'.$smiley_www.$obj->img.'" border=0></acronym></a></td>';
		}
		
		if ( $col_pos ) $sml .= '<td>'.create_help_anchor('smilies').'</td></tr>';
	
		echo '<tr'.ROW_BGCOLOR().'><td nowrap valign=top class="GenText">Smiley Shortcuts:</td><td valign=top><table border=0 cellspacing=5 cellpadding=0 '.url_help('smilies').'>'.$sml.'</table></td></tr>';
	}
	
	if( $frm->tag_style == 'ML' ) {
		echo '<tr'.ROW_BGCOLOR().'><td nowrap class="GenText">Formatting Tools:</td><td>
		<table border=0 cellspacing=0 cellpadding=0>
		<tr><td>
			<table border=0 cellspacing=1 cellpadding=2 class="FormattingToolsBG">
				<tr>
					<td class="FormattingToolsCLR" '.url_help('bold').'><a href="javascript: insertTag(document.post_form.msg_body, \'[B]\', \'[/B]\');"><img id="bold_anc" name="bold_anc" alt="Bold"  src="images/b_bold.gif" border=0 alt="Bold"></a></td>
					<td class="FormattingToolsCLR" '.url_help('italic').'><a href="javascript: insertTag(document.post_form.msg_body, \'[I]\', \'[/I]\');""><img id="italic_anc" name="italic_anc" alt="Italic" src="images/b_italic.gif" border=0 alt="Italics"></a></td>
					<td class="FormattingToolsCLR" '.url_help('underline').'><a href="javascript: insertTag(document.post_form.msg_body, \'[U]\', \'[/U]\');"><img id="underline_anc" name="underline_anc" alt="Underline" src="images/b_underline.gif" border=0 alt="Underline"></a></td>
					<td class="FormattingToolsCLR" '.url_help('url').'><a href="javascript: url_insert();"><img id="url_anc" name="url_anc" src="images/b_url.gif" border=0 alt="URL"></a></td>
					<td class="FormattingToolsCLR" '.url_help('email').'><a href="javascript: email_insert();"><img id="email_anc" name="email_anc" src="images/b_email.gif" border=0 alt="Email"></a></td>
					<td class="FormattingToolsCLR" '.url_help('image').'><a href="javascript: image_insert();"><img id="image_anc" name="image_anc" src="images/b_image.gif" border=0 alt="Insert Image"></a></td>
					<td class="FormattingToolsCLR" '.url_help('nlist').'><a href="javascript: window_open(\'mklist.php?'.$_RSID.'&tp=OL:1\', \'listmaker\', 350, 350);"><img id="nlist_anc" name="nlist_anc" src="images/b_numlist.gif" border=0 alt="Numerical List"></a></td>
					<td class="FormattingToolsCLR" '.url_help('blist').'><a href="javascript: window_open(\'mklist.php?'.$_RSID.'&tp=UL:square\', \'listmaker\', 350, 350);"><img id="blist_anc" name="blist_anc" src="images/b_bulletlist.gif" border=0 alt="Bullet List"></a></td>
					<td class="FormattingToolsCLR" '.url_help('quote').'><a href="javascript: insertTag(document.post_form.msg_body, \'[QUOTE]\', \'[/QUOTE]\');"><img id="quote_anc" name="quote_anc" src="images/b_quote.gif" border=0 alt="Quote"></a></td>
					<td class="FormattingToolsCLR" '.url_help('code').'><a href="javascript: insertTag(document.post_form.msg_body, \'[CODE]\', \'[/CODE]\');"><img id="code_anc" name="code_anc" src="images/b_code.gif" border=0 alt="Code"></a></td>
				</tr>
			</table>
		</td>
		<td '.url_help('fsize').'>
			&nbsp;'.create_select('fnt_size', "Size\n1\n5\n10\n20", "\n1\n5\n10\n20", '', "onChange=\"javascript:insertTag(document.post_form.msg_body, '[SIZE='+document.post_form.fnt_size.options[this.selectedIndex].value+']', '[/SIZE]'); document.post_form.fnt_size.options[0].selected=true\"").'<img src="blank.gif" width=0 height=0 border=0 id="fsize_anc" name="fsize_anc">
		</td>
		<td '.url_help('fcolor').'>
			&nbsp;'.create_select('fnt_color', "Color\nSky Blue\nRoyal Blue\nBlue\nDark Blue\nOrange\nOrange Red\nCrimson\nRed\nFirebrick\nDark Red\nGreen\nLime Green\nSea Green\nDeep Pink\nTomato\nCoral\nPurple\nIndigo\nBurlywood\nSandy Brown\nSienna\nChocolate\nTeal\nSilver", "\nskyblue\nroyalblue\nblue\ndarkblue\norange\norangered\ncrimson\nred\nfirebrick\ndarkred\ngreen\nlimegreen\nseagreen\ndeeppink\ntomato\ncoral\npurple\nindigo\nburlywood\nsandybrown\nsienna\nchocolate\nteal\nsilver", '', "onChange=\"javascript:insertTag(document.post_form.msg_body, '[COLOR='+document.post_form.fnt_color.options[this.selectedIndex].value+']', '[/COLOR]'); document.post_form.fnt_color.options[0].selected=true\"", "\nstyle=\"color:skyblue\"\nstyle=\"color:royalblue\"\nstyle=\"color:blue\"\nstyle=\"color:darkblue\"\nstyle=\"color:orange\"\nstyle=\"color:orangered\"\nstyle=\"color:crimson\"\nstyle=\"color:red\"\nstyle=\"color:firebrick\"\nstyle=\"color:darkred\"\nstyle=\"color:green\"\nstyle=\"color:limegreen\"\nstyle=\"color:seagreen\"\nstyle=\"color:deeppink\"\nstyle=\"color:tomato\"\nstyle=\"color:coral\"\nstyle=\"color:purple\"\nstyle=\"color:indigo\"\nstyle=\"color:burlywood\"\nstyle=\"color:sandybrown\"\nstyle=\"color:sienna\"\nstyle=\"color:chocolate\"\nstyle=\"color:teal\"\nstyle=\"color:silver\"").'<img src="blank.gif" width=0 height=0 border=0 id="fcolor_anc" name="fcolor_anc">
		</td>
		<td '.url_help('fface').'>
			&nbsp;'.create_select('fnt_face', "Font\nArial\nTimes\nCourier\nCentury", "\nArial\nTimes\nCourier\nCentury", '', "onChange=\"javascript:insertTag(document.post_form.msg_body, '[FONT='+document.post_form.fnt_face.options[this.selectedIndex].value+']', '[/FONT]'); document.post_form.fnt_face.options[0].selected=true\"").'<img src="blank.gif" width=0 height=0 border=0 id="fface_anc" name="fface_anc">
		</td>
		</tr></table></td></tr>';
	}
	
	echo '<tr'.ROW_BGCOLOR().'><td nowrap valign=top class="GenText">Body:<br><br>'.post_options($frm).'</td><td>'.get_err('msg_body',1).'<textarea rows="20" cols="65" wrap="virtual" tabindex="2" name="msg_body" onKeyUp="storeCaret(this);" onClick="storeCaret(this);" onSelect="storeCaret(this);">'.(isset($msg_body)?htmlspecialchars(str_replace("\r", "", $msg_body)):'').'</textarea></td></tr>';
	
	if ( $frm->enable_attachments == 'Y' ) {	
		echo '<tr'.ROW_BGCOLOR().'><td nowrap valign=top class="GenText">File Attachments:</td><td>';
		/* check if there are any attached files, if so draw a table */
		if ( isset($attach_list) ) {
			reset($attach_list);
			lay_start_content_table();
			echo '<tr>
				<td class="TableHeading">Name</td>
				<td class="TableHeading">Size</td>
				<td class="TableHeading">Action</td>
			</tr>';
			$file_array=NULL;
			while ( list($k, $v) = each($attach_list) ) {
				$file_array .= $v['tmp']."\r".$v['name']."\r".$v['size']."\r".$v['delque']."\r".$v['db_id']."\n";
				if ( empty($v['delque']) ) {
					if( $v['size'] < 100000 )
						$sz = number_format($v['size']/1024,2).'Kb';
					else 
						$sz = number_format($v['size']/1048576,2).'Mb';

					echo '<tr>
						<td class="RowStyleB">'.$v['name'].'</td>
						<td class="RowStyleB">'.$sz.'</td>
						<td class="RowStyleB"><a class="GenLink" href="javascript: document.post_form.file_del_opt.value=\''.$k.'\'; document.post_form.submit();">Delete</a></td>
					</tr>';
				}
			}
			lay_end_content_table();
			echo '<input type="hidden" name="file_del_opt" value="">';
			echo '<input type="hidden" name="file_array" value="'.base64_encode($file_array).'">';
		}
		if( empty($attach_count) ) $attach_count=0;
		echo ((!empty($attach_control_error))?$attach_control_error:'').'<font class="SmallText"><b>Allowed File Types:</b> '.list_ext().'<br><b>Maximum File Size</b> '.$MAX_F_SIZE.'Kb<br><b>Maximum Files per Message:</b> '.$frm->max_file_attachments.(($attach_count)?'<font class="SmallText"> currently attached '.$attach_count.' file(s) ':'').'<p></font>';
		if( ($attach_count+1) <= $frm->max_file_attachments ) echo '<input type="file" name="attach_control"> <input type="submit" name="attach_control_add" value="Upload File">';
		echo '</td></tr>';
	}

	echo '<tr'.ROW_BGCOLOR().' valign="top"><td class="GenText">Options:</td><td><table border=0 cellspacing=0 cellpadding=1>';
	if( isset($usr) ) {
		echo '<tr><td '.url_help('post_not').'>'.create_checkbox('msg_poster_notif', 'Y', (isset($msg_poster_notif)?$msg_poster_notif:'')).'</td><td class="GenText" '.url_help('post_not').'><b>Post Notification</b>'.create_help_anchor('post_not').'</td></tr>
		<tr><td>'.create_checkbox('msg_show_sig', 'Y', $msg_show_sig).'</td><td class="GenText"><b>Include Signature</b></td></tr>
		<tr><td></td><td><font class="SmallText">Include your profile signature.</font></td></tr>';
	}
	
	if( $frm->enable_smileys=='Y' ) {
		echo '<tr><td '.url_help('dis_sml').'>'.create_checkbox('msg_smiley_disabled', 'Y', (isset($msg_smiley_disabled)?$msg_smiley_disabled:'')).'</td><td class="GenText"'.url_help('dis_sml').'><b>Disable smilies in this post</b>'.create_help_anchor('dis_sml').'</td></tr>';
	}	
	echo '</table></td></tr>';
	
	if ( isset($usr) ) {
		
	}
	
	if ( empty($th_id) ) 
		$label = 'Create Thread';
	else
		$label = 'Submit Reply';
	
	if ( $msg_id ) $label = 'Edit Message';
	
	echo '<tr'.ROW_BGCOLOR().'><td class="GenText" align="right" colspan=2><input type="submit" value="Preview Message" name="preview">'.(($GLOBALS["SPELL_CHECK_ENABLED"]=='Y' && function_exists('pspell_config_create') )?' <input type="submit" value="Spell-check Message" name="spell">':'').' <input type="submit" name="btn_submit" value="'.$label.'" onClick="javascript: if( document.post_form.java_script_pcount.value>0 ) { alert(\'Your post is being processed, please wait.\'); return false;  } else { document.post_form.java_script_pcount.value++;  }"></td></tr>';

	lay_end_content_table(); 
?>
<input type="hidden" name="java_script_pcount" value="0">
<input type="hidden" name="S" value="<?php echo $S; ?>">
<input type="hidden" name="reply_to" value="<?php echo $reply_to; ?>">
<input type="hidden" name="th_id" value="<?php echo $th_id; ?>">
<input type="hidden" name="frm_id" value="<?php echo $frm_id; ?>">
<input type="hidden" name="msg_id" value="<?php echo $msg_id; ?>">
<input type="hidden" name="pl_id" value="<?php echo (isset($pl_id)?$pl_id:''); ?>">
<input type="hidden" name="old_subject" value="<?php echo (isset($old_subject)?$old_subject:''); ?>">
<input type="hidden" name="prev_loaded" value="1">
<?php 	if ( !empty($attach_enabled) ) { ?><input type="hidden" name="attach_enabled" value="<?php echo $attach_enabled; ?>"><?php } 
	draw_return(); 
?>
</form>
<?php if ( isset($thr) ) {?>
<div align=center>
<iframe name="msg_ref" src="<?php echo $WWW_ROOT.'/msg.php'.'?'.$_RSID.'&th='.$thr->id.'&post_form=1&goto='.(($reply_to)?$reply_to:$msg_id).'&start='.(isset($start)?$start:''); ?>" height=400 width=640>
</iframe>
</div>

<?php }
	include_once $GLOBALS['FORUM_SETTINGS_PATH'].'footer_'.$layout.'.inc';
?>
<div id="fhelp_bold_ly" style="background: #fffecb; position: absolute; visibility: hidden; z-index:1">Bold</div>
<div id="fhelp_italic_ly" style="background: #fffecb; position: absolute; visibility: hidden; z-index:1">Italic</div>
<div id="fhelp_underline_ly" style="background: #fffecb; position: absolute; visibility: hidden; z-index:1">Underline</div>
<div id="fhelp_url_ly" style="background: #fffecb; position: absolute; visibility: hidden; z-index:1">Insert URL (Link)</div>
<div id="fhelp_email_ly" style="background: #fffecb; position: absolute; visibility: hidden; z-index:1">Insert Email</div>
<div id="fhelp_nlist_ly" style="background: #fffecb; position: absolute; visibility: hidden; z-index:1">Number List</div>
<div id="fhelp_blist_ly" style="background: #fffecb; position: absolute; visibility: hidden; z-index:1">Bullet List</div>
<div id="fhelp_quote_ly" style="background: #fffecb; position: absolute; visibility: hidden; z-index:1">Quote Text</div>
<div id="fhelp_image_ly" style="background: #fffecb; position: absolute; visibility: hidden; z-index:1">Insert Image</div>
<div id="fhelp_code_ly" style="background: #fffecb; position: absolute; visibility: hidden; z-index:1">Code</div>
<div id="fhelp_fsize_ly" style="background: #fffecb; position: absolute; visibility: hidden; z-index:1">Font Size</div>
<div id="fhelp_fcolor_ly" style="background: #fffecb; position: absolute; visibility: hidden; z-index:1">Font Color</div>
<div id="fhelp_fface_ly" style="background: #fffecb; position: absolute; visibility: hidden; z-index:1">Font Face</div>
<?php create_help_layers() ;?>