<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: ppost.php,v 1.20 2002/02/12 17:55:54 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/

/*#? Post Editor Page */
	include_once "GLOBALS.php";	
	$GLOBALS['MSG_EDIT'] = 1;
	$GLOBALS['USER_REG'] = 1;
	fud_use('db.inc');
	fud_use('cookies.inc');	
	fud_use('widgets.inc');
	fud_use('users.inc');
	fud_use('style.inc');
	fud_use('smiley.inc');
	fud_use('ipfilter.inc');
	fud_use('email.inc');
	fud_use('postcheck.inc');
	fud_use('post.inc');
	fud_use('help.inc');
	fud_use('spell.inc');
	fud_use('wordwrap.inc');
	fud_use('private.inc');
	fud_use('attach.inc');
	fud_use('post_opt.inc');
	fud_use('rev_fmt.inc');
	
	/* Information Retrieval */
	list($ses, $usr) = init_user();
	
	if( $GLOBALS['PM_ENABLED']=='N' ) {
		error_dialog('ERROR: Private Messaging Disabled', 'You cannot use the pivate messaging system, it has been disabled by the administrator.', $WWW_ROOT, '');
		exit;		
	}

	cache_buster();
	$smiley_www = $GLOBALS['IMG_ROOT_WWW'].$GLOBALS['SMILEY_DIR'];
	$icon_path = $IMG_ROOT_DISK.$MESSAGE_ICON_DIR;
	$icon_path_www = $IMG_ROOT_WWW.$MESSAGE_ICON_DIR;
	$returnto = base64_encode("ppost.php?".$_RSID);
	$returnto_d = base64_decode($returnto);
	$attach_control_error=NULL;

	/* INITIAL SECURITY CHECKS */
	
	$flt = new fud_ip_filter;
	if ( isset($GLOBALS['HTTP_SERVER_VARS']['REMOTE_ADDR']) && $flt->is_blocked($GLOBALS['HTTP_SERVER_VARS']['REMOTE_ADDR']) ) {
		error_dialog('ERROR', "You aren't allowed to post", $returnto_d);
		exit();
	}
	unset($flt);

	if ( !isset($usr) ) std_error('login');

	/* remove any slashes from msg_to_list passed by get */
	if( isset($HTTP_GET_VARS['msg_to_list']) ) $HTTP_GET_VARS['msg_to_list'] = $GLOBALS['msg_to_list'] = stripslashes($HTTP_GET_VARS['msg_to_list']);

	if( empty($prev_loaded) ) {
		$msg_r = new fud_pmsg;
		if( !empty($msg_id) && is_numeric($msg_id) ) {
			$msg_r->get($msg_id);
			export_vars('msg_', $msg_r);

			reverse_FMT($msg_subject);
			$msg_subject = apply_reverse_replace($msg_subject);
			
			$msg_body = post_to_smiley($msg_body);
			switch ( $GLOBALS['PRIVATE_TAGS'] )
			{
				case 'ML':
					$msg_body = html_to_tags($msg_body);
				 	break;
				case 'HTML':
					break;
				default:
					reverse_FMT($msg_body);
					reverse_nl2br($msg_body);
			}
			$msg_body = apply_reverse_replace($msg_body);
		}
		else if( !empty($quote) || !empty($forward) ) {
			$msg_r->get((empty($quote)?$forward:$quote));
			export_vars('msg_', $msg_r);
			$msg_id=$msg_to_list=$msg_duser_id='';
			
			$msg_body = post_to_smiley($msg_body);
			switch ( $GLOBALS['PRIVATE_TAGS'] )
			{
				case 'ML':
					$msg_body = html_to_tags($msg_body);
				 	$msg_body = '[quote title='.$msg_r->login.' wrote on '.format_date($msg_r->post_stamp).' '.format_time($msg_r->post_stamp).']'.$msg_body.'[/quote]';
				 	break;
				case 'HTML':
					$msg_body = '<table border="0" align="center" width="90%" cellpadding="3" cellspacing="1"><tr><td class="SmallText"><b>'.$msg_r->login.' wrote on '.format_date($msg_r->post_stamp).' '.format_time($msg_r->post_stamp).'</b></td></tr><tr><td class="quote"><br>'.$msg_body.'<br></td></tr></table>';
					break;
				default:
					reverse_FMT($msg_body);
					reverse_nl2br($msg_body);
					$msg_body = 'Quote: '.$msg_r->login.' wrote on '.format_date($msg_r->post_stamp).' '.format_time($msg_r->post_stamp)."\n----------------------------------------------------\n".$msg_body."\n----------------------------------------------------\n";
			}
		 	$msg_body = apply_reverse_replace($msg_body);	
		 	
		 	reverse_FMT($msg_subject);
			$msg_subject = apply_reverse_replace($msg_subject);
			
			if( !empty($quote) && !preg_match("!^Re: !", $msg_subject) ) 
				$msg_subject = 'Re: '.$msg_subject;
			
			if( !empty($forward) && !preg_match("!^Fwd: !", $msg_subject) )
				$msg_subject = 'Fwd: '.$msg_subject;	
			
			if( !empty($quote) ) $msg_to_list = Q_SINGLEVAL("SELECT login FROM fud_users WHERE id=".$msg_r->ouser_id);
		}
		else if( !empty($reply) && is_numeric($reply) ) {
			$msg_r->get($reply,1);
			$msg_subject = $msg_r->subject;
			
			$msg_to_list = Q_SINGLEVAL("SELECT login FROM fud_users WHERE id=".$msg_r->ouser_id);
			
			unset($msg_r);
			
			reverse_FMT($msg_subject);
			$msg_subject = apply_reverse_replace($msg_subject);
			
			if( !empty($reply) && !preg_match("!^Re:!", $msg_subject) ) 
				$msg_subject = 'Re: '.$msg_subject;
		}
		
		if ( !empty($msg_r->attach_cnt) && ( !empty($msg_id) || !empty($forward) ) ) {
	 		$r = Q("SELECT * FROM fud_attach WHERE message_id=".$msg_r->id." AND private='Y'");
	 		while ( $obj = DB_ROWOBJ($r) ) {
	 			$afile['name'] = $obj->original_name;
	 			$afile['db_id'] = $obj->id;
	 			$afile['size'] = filesize($obj->location);
	 			$afile['tmp'] = $afile['delque'] = NULL;
	 			$attach_list[$obj->id] = $afile;
	 		}
	 		QF($r);
		 }
	}
	else {
		/* remove slashes */
		while( list($k,) = each($HTTP_POST_VARS) ) {
			if( !empty($HTTP_POST_VARS[$k]) ) $HTTP_POST_VARS[$k] = $GLOBALS[$k] = stripslashes($HTTP_POST_VARS[$k]);
		}
	}

	$MAX_F_SIZE = round($PRIVATE_ATTACH_SIZE/1024);
	
	if( $PRIVATE_ATTACHMENTS > 0 ) {
		/* restore the attachment array */
		$attach_count=0;
		if ( !empty($file_array) ) {
			$file_array = base64_decode($HTTP_POST_VARS['file_array']);
			if ( strlen($file_array) ) {
				$arr = explode("\n", $file_array);
				reset($arr);
				while ( list($k, $v) = each($arr) ) {
					if ( $v ) {
						list($afile['tmp'], $afile['name'], $afile['size'], $afile['delque'], $afile['db_id']) = explode("\r", $v);
						if ( strlen($afile['db_id']) ) 
							$k = $afile['db_id'];
						else
							$k = $afile['tmp'];
							
						$attach_list[$k] = $afile;
						if( $afile['delque']<1 ) $attach_count++;
					}
				}
			}
				
			if ( $file_del_opt && isset($attach_list[$file_del_opt]) ) {
				$attach_list[$file_del_opt]['delque'] = 1;
				$attach_count--;
			}
		}

		if ( !empty($attach_control_size) ) {
			if( $attach_control_size>$PRIVATE_ATTACH_SIZE ) {
				$attach_control_error = '<font class="ErrorText">File Attachment is too big (over allowed limit of '.$MAX_F_SIZE.' bytes)</font><br>';
			}
			else {
				if( filter_ext($attach_control_name) ) {
					$attach_control_error = '<font class="ErrorText">The file you are trying to upload doesn\'t match the allowed file types.</font><br>';}
				else {
					if( ($attach_count+1) <= $PRIVATE_ATTACHMENTS ) { 
						unset($afile);
						$afile['tmp'] = safe_tmp_copy($attach_control);
						$afile['name'] = htmlspecialchars($attach_control_name);
						$afile['size'] = $attach_control_size;
						$afile['db_id'] = $afile['delque'] = NULL;
						$attach_list[$afile['tmp']] = $afile;
						$attach_count++;
					}
					else {
						$attach_control_error = '<font class="ErrorText">You are trying to upload more files then it is allowed.</font><br>';
					}	
				}	
			}	
		}
		$attach_cnt = $attach_count;
	}

	if( !empty($HTTP_POST_VARS["btn_submit"]) || !empty($HTTP_POST_VARS['btn_draft']) ) {
		$msg_p = new fud_pmsg;
		fetch_vars('msg_', $msg_p, $HTTP_POST_VARS);
		$msg_p->smiley_disabled = YN($msg_smiley_disabled);
		$msg_p->attach_cnt = isset($attach_cnt)?$attach_cnt:0;
		$msg_p->body = $HTTP_POST_VARS['msg_body'];
		$msg_p->folder_id = isset($HTTP_POST_VARS["btn_submit"])?'SENT':'DRAFT';
		$msg_p->to_list = addslashes($msg_p->to_list);
		
		$msg_p->body = apply_custom_replace($msg_p->body);
		switch ( $GLOBALS['PRIVATE_TAGS'] )
		{
			case 'ML':
				$msg_p->body = tags_to_html($msg_p->body, strtoupper($GLOBALS['PRIVATE_IMAGES']));
				break;
			case 'HTML':
				break;
			default:
				$msg_p->body = nl2br(htmlspecialchars($msg_p->body));	
		}
		
		if( $msg_p->smiley_disabled!='Y' ) smiley_to_post($msg_p->body);
		fud_wordwrap($msg_p->body);
		
		$msg_p->attach_cnt = empty($attach_cnt)?0:$attach_cnt;
		$msg_p->ouser_id = $usr->id;
		
		$msg_p->subject = apply_custom_replace($msg_p->subject);
		$msg_p->subject = htmlspecialchars($msg_p->subject);
		$msg_p->subject = addslashes($msg_p->subject);
	
		if( !empty($HTTP_POST_VARS['btn_draft']) || !check_ppost_form() ) {
			if( empty($msg_id) ) 
				$msg_p->add();
			else 
				$msg_p->sync();	
		}
		
		if( $PRIVATE_ATTACHMENTS>0 && isset($attach_list) ) {
			reset($attach_list);
			while ( list($k, $v) = each($attach_list) ) {
				if( empty($v) ) continue;
				if ( strlen($v['delque']) ) {
					if ( $v['tmp'] ) {
						if( file_exists($GLOBALS['TMP'].$v['tmp']) ) 
							unlink($GLOBALS['TMP'].$v['tmp']);
					}		
					else {
						unset($at_obj);
						$at_obj = new fud_attach();
						if( $v['db_id'] ) {
							$at_obj->get($v['db_id'], 'Y');
							$at_obj->delete();
						}	
					}
				}
				else if( empty($v['db_id']) ) {
					unset($at_obj);
					$at_obj = new fud_attach();
					$at_obj->add($usr->id, $msg_p->id, $v['name'], $GLOBALS['TMP'].$v['tmp'], 'Y');
					
					if( count($GLOBALS["send_to_array"]) ) {
						reset($GLOBALS["send_to_array"]);
						while( list(,$va) = each($GLOBALS["send_to_array"]) ) {
							unset($at_obj);
							$at_obj = new fud_attach();
							$at_obj->add($va[0], $va[1], $v['name'], $GLOBALS['TMP'].$v['tmp'], 'Y');
						}
					}
					
					if( file_exists($GLOBALS['TMP'].$v['tmp']) )
						unlink($GLOBALS['TMP'].$v['tmp']);	
				}
				else if( !empty($v['db_id']) && count($GLOBALS["send_to_array"]) ) {
					if( $forward && !BQ("SELECT id FROM fud_attach WHERE message_id=".$msg_p->id." AND id=".$v['db_id']) ) {
						unset($at_obj);
						$at_obj = new fud_attach();
						$at_obj->add($usr->id, $msg_p->id, $v['name'], $GLOBALS['FILE_STORE'].$v['db_id'].'.atch', 'Y');
					}
				
					reset($GLOBALS["send_to_array"]);
					while( list(,$va) = each($GLOBALS["send_to_array"]) ) {
						unset($at_obj);
						$at_obj = new fud_attach();
						$at_obj->add($va[0], $va[1], $v['name'], $GLOBALS['FILE_STORE'].$v['db_id'].'.atch', 'Y');
					}
				}
			}
		}
		
		if( empty($GLOBALS['__error__']) ) {
			header("Location: pmsg.php?".$_RSID."&folder_id=".$msg_p->folder_id);
			exit;
		}	
	}
		
	if ( !empty($reply_to) && $old_subject == $msg_subject ) $no_spell_subject = 1;
	
	if( !empty($HTTP_POST_VARS["btn_spell"]) ) {
		$text = apply_custom_replace($HTTP_POST_VARS["msg_body"]);
		$text_s = apply_custom_replace($HTTP_POST_VARS["msg_subject"]);
		
		switch ( $GLOBALS['PRIVATE_TAGS'] )
		{
			case 'ML':
				$text = tags_to_html($text, strtoupper($GLOBALS['PRIVATE_IMAGES']));
				break;
			case 'HTML':
				break;
			default:
				$text = htmlspecialchars($text);	
		}
		
		if( empty($msg_smiley_disabled) ) smiley_to_post($text);

	 	if( strlen($text) ) {	
			$wa = tokenize_string($text);
			$text = spell_replace($wa,'body');
			
			if( empty($msg_smiley_disabled) ) $msg_body = post_to_smiley($text);
			
			switch ( $GLOBALS['PRIVATE_TAGS'] ) 
			{
				case 'ML':
					$msg_body = html_to_tags($msg_body);
					break;
				case 'HTML':
					break;
				default:
					reverse_FMT($msg_body);		
			}
			
			$msg_body = apply_reverse_replace($msg_body);
		}	
		$wa='';
			
		if( strlen($HTTP_POST_VARS["msg_subject"]) && empty($no_spell_subject) ) {
			$text_s = htmlspecialchars($text_s);
			$wa = tokenize_string($text_s);
			$text_s = spell_replace($wa,'subject');
			reverse_FMT($text_s);
			$msg_subject = apply_reverse_replace($text_s);
		}
	}

	/* form start */	 
	$ses->update('Private messaging');
	
	$layout = get_layout_id($layout); include_once $GLOBALS['FORUM_SETTINGS_PATH'].'header_'.$layout.'.inc';
	echo get_cur_ppage('', '');
	fud_use('usroptions.inc');
	
	set_row_color_alt(true);
	echo '<form action="ppost.php" method="post" name="post_form" enctype="multipart/form-data">';

if ( !empty($preview) || !empty($spell) ) {
	$text = apply_custom_replace($HTTP_POST_VARS['msg_body']);
	$text_s = apply_custom_replace($HTTP_POST_VARS['msg_subject']);

	switch ( $GLOBALS['PRIVATE_TAGS'] ) 
	{
		case 'ML':
			$text = tags_to_html($text, strtoupper($GLOBALS['PRIVATE_IMAGES']));
			break;
		case 'HTML':
			break;
		default:
			$text = nl2br(htmlspecialchars($text));
	}
	
	if ( $PRIVATE_MSG_SMILEY == 'Y' && empty($HTTP_POST_VARS["msg_smiley_disabled"]) ) smiley_to_post($text);
	
	$text_s = htmlspecialchars($text_s);
	
	if( !function_exists('pspell_config_create') ) $spell=0;
	
	if ( !empty($spell) && strlen($text) ) $text = check_data_spell($text,'body');
	
	fud_wordwrap($text);

	$sig=$subj='';
	if ( $text_s ) {
		$subj = '<tr><td class="RowStyleA"><font class="MsgSubText">';
		
		if ( !empty($spell) && empty($no_spell_subject) && strlen($text_s) )
			$subj .= check_data_spell($text_s,'subject');
		else
			$subj .= $text_s;

		$subj .= '</font></td></tr>';
	}
	if ( !empty($msg_show_sig) && $msg_show_sig == 'Y' && $usr->sig ) $sig = '<p><u>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</u><br>'.$usr->sig;
	
	echo '<div align="center">';
	lay_start_content_table('PreviewTable');
	
	echo '<tr><td class="TableHeading" colspan=2>Post Preview</td></tr>';
	echo $subj.'<tr><td class="RowStyleA"><font class="MsgBodyText">';
	echo $text.'<br>'.$sig.'</font>';
	if ( !empty($spell) ) echo '<p><input type="submit" name="btn_spell" value="Apply Spelling Changes"></td></tr>';
	
	lay_end_content_table();
	echo '</div><br>';
}

if ( is_post_error() ) echo '<h4 align="center"><font class="ErrorText">You have an error</font></h4>';

lay_start_content_table();

	set_row_color_alt(true);
	echo '<tr><td colspan=2 class="TableHeading"><a name="ptop"> </a>Post Form</td></tr>';
	echo '<tr'.ROW_BGCOLOR().'><td nowrap class="GenText">Logged in user:</td><td class="GenText" width="100%">'.htmlspecialchars($usr->login).' [<a href="login.php?'.$_RSID.'&logout=1" class="GenLink">logout</a>]</td></tr>';

	/*
	 * form begins here
	 */
	 
	echo '<tr'.ROW_BGCOLOR().'><td class="GenText">To:</td><td class="GenText"><input type="text" name="msg_to_list" value="'.(empty($msg_to_list)?NULL:htmlspecialchars($msg_to_list)).'"> [<a href="#" class="GenLink" onClick="javascript: window_open(\'finduser.php?'.$_RSID.'&append=1&js_redr='.base64_encode('post_form.msg_to_list').'\',\'user_list\',500,500);">Find User</a>] [<a href="#" onClick="javascript: window_open(\'qbud.php?'.$_RSID.'\', \'buddy_list\',200,300);" class="GenLink">Select from Buddy List</a>]</font>'.get_err('msg_to_list').'</td></tr>';
	echo '<tr'.ROW_BGCOLOR().'><td class="GenText">Title:</td><td class="GenText"><input type="text" name="msg_subject" value="'.(empty($msg_subject)?NULL:htmlspecialchars($msg_subject)).'" size=50> '.get_err('msg_subject').'</td></tr>';
	
	/* 
	 * draw the icon select here
	 */
	 
	 $icons_per_row = 9;
	 $icon = '';
	 if( !isset($msg_icon) ) $msg_icon='';
	 if ( $dp = opendir($icon_path) ) {
	 	$icon .= '<table border=0 cellspacing=0 cellpadding=2><tr>';
	 	$icon .= '<tr><td class="GenText" colspan='.$icons_per_row.'><input type="radio" name="msg_icon" value=""'.((!strlen($msg_icon))?' checked':'').'>No Icon</td></tr>';
	 	$col = 1;
	 	while ( $de = readdir($dp) ) {
	 		if ( $de == '.' || $de == '..' ) continue;
			if ( strlen($de) < 4 ) continue;
			$ext = strtolower(substr($de, -4));
			if ( $ext != '.gif' && $ext != '.jpg' && $ext != '.png' ) continue;
			
			if ( !($col++%$icons_per_row) ) {
				$icon .= "\n</tr>\n<tr>\n";
			}
						
	 		$icon .= '<td nowrap valign=middle><input type="radio" name="msg_icon" value="'.$de.'"'.(($de==$msg_icon)?' checked':'').'><img src="'.$icon_path_www.$de.'"></td>';
	 	}
	 	closedir($dp);
	 	$icon .= "</tr></table>";
	 }
	 
	echo '<tr'.ROW_BGCOLOR().'><td valign=top class="GenText">Post Icon:</td><td>'.$icon.'</td></tr>';
	
	if( strtolower($GLOBALS['PRIVATE_MSG_SMILEY']) == 'y' ) {
		$smileys = new fud_smiley;
		$smileys->getall();
		$smileys->resets();
	
		$col_count = 25;
		$col_pos = 0;
		$sml = '<tr valign=bottom>';
		while ( $obj = $smileys->eachs() ) {
			if ( ++$col_pos > $col_count ) { $sml .= '</tr><tr>'; $col_pos = 0; }
			$obj->code = ($a=strpos($obj->code, '~')) ? substr($obj->code,0,$a) : $obj->code;
			$sml .= '<td><a href="javascript: insertTag(document.post_form.msg_body, \'\', \' '.$obj->code.' \');"><acronym title="'.$obj->descr.'"><img alt="'.$obj->descr.'" src="'.$smiley_www.$obj->img.'" border=0></acronym></a></td>';
		}
		if ( $col_pos ) $sml .= '</tr>';
	
		echo '<tr'.ROW_BGCOLOR().'><td nowrap valign=top class="GenText">Smiley Shortcuts:'.create_help('smileys').'</td><td valign=top><table border=0 cellspacing=5 cellpadding=0>'.$sml.'</table></td></tr>';
	}	

	if( strtolower($GLOBLALS['PRIVATE_TAGS']) == 'ml' ) {
		echo '<tr'.ROW_BGCOLOR().'><td nowrap class="GenText">Formatting Tools:</td><td>
		<table border=0 cellspacing=0 cellpadding=0>
		<tr><td>
			<table border=0 cellspacing=1 cellpadding=2 class="FormattingToolsBG">
				<tr>
					<td class="FormattingToolsCLR"><a href="javascript: insertTag(document.post_form.msg_body, \'[B]\', \'[/B]\');"><img alt="Bold" src="images/b_bold.gif" border=0 alt="Bold"></a></td>
					<td class="FormattingToolsCLR"><a href="javascript: insertTag(document.post_form.msg_body, \'[I]\', \'[/I]\');""><img alt="Italic" src="images/b_italic.gif" border=0 alt="Italics"></a></td>
					<td class="FormattingToolsCLR"><a href="javascript: insertTag(document.post_form.msg_body, \'[U]\', \'[/U]\');"><img alt="Underline" src="images/b_underline.gif" border=0 alt="Underline"></a></td>
					<td class="FormattingToolsCLR"><a href="javascript: url_insert();"><img src="images/b_url.gif" border=0 alt="URL"></a></td>
					<td class="FormattingToolsCLR"><a href="javascript: email_insert();"><img src="images/b_email.gif" border=0 alt="Email"></a></td>
					<td class="FormattingToolsCLR"><a href="javascript: image_insert();"><img src="images/b_image.gif" border=0 alt="Insert Image"></a></td>
					<td class="FormattingToolsCLR"><a href="javascript: window_open(\'mklist.php?'.$_RSID.'&tp=OL:1\', \'listmaker\', 350, 350);"><img src="images/b_numlist.gif" border=0 alt="Numerical List"></a></td>
					<td class="FormattingToolsCLR"><a href="javascript: window_open(\'mklist.php?'.$_RSID.'&tp=UL:square\', \'listmaker\', 350, 350);"><img src="images/b_bulletlist.gif" border=0 alt="Bullet List"></a></td>
					<td class="FormattingToolsCLR"><a href="javascript: insertTag(document.post_form.msg_body, \'[QUOTE]\', \'[/QUOTE]\');"><img src="images/b_quote.gif" border=0 alt="Quote"></a></td>
					<td class="FormattingToolsCLR"><a href="javascript: insertTag(document.post_form.msg_body, \'[CODE]\', \'[/CODE]\');"><img src="images/b_code.gif" border=0 alt="Code"></a></td>
				</tr>
			</table>
		</td>
		<td>
			&nbsp;'.create_select('fnt_size', "Size\n1\n5\n10\n20", "\n1\n5\n10\n20", '', "onChange=\"javascript:insertTag(document.post_form.msg_body, '[SIZE='+document.post_form.fnt_size.options[this.selectedIndex].value+']', '[/SIZE]'); document.post_form.fnt_size.options[0].selected=true\"").'
		</td>
		<td>
			&nbsp;'.create_select('fnt_color', "Color\nSky Blue\nRoyal Blue\nBlue\nDark Blue\nOrange\nOrange Red\nCrimson\nRed\nFirebrick\nDark Red\nGreen\nLime Green\nSea Green\nDeep Pink\nTomato\nCoral\nPurple\nIndigo\nBurlywood\nSandy Brown\nSienna\nChocolate\nTeal\nSilver", "\nskyblue\nroyalblue\nblue\ndarkblue\norange\norangered\ncrimson\nred\nfirebrick\ndarkred\ngreen\nlimegreen\nseagreen\ndeeppink\ntomato\ncoral\npurple\nindigo\nburlywood\nsandybrown\nsienna\nchocolate\nteal\nsilver", '', "onChange=\"javascript:insertTag(document.post_form.msg_body, '[COLOR='+document.post_form.fnt_color.options[this.selectedIndex].value+']', '[/COLOR]'); document.post_form.fnt_color.options[0].selected=true\"", "\nstyle=\"color:skyblue\"\nstyle=\"color:royalblue\"\nstyle=\"color:blue\"\nstyle=\"color:darkblue\"\nstyle=\"color:orange\"\nstyle=\"color:orangered\"\nstyle=\"color:crimson\"\nstyle=\"color:red\"\nstyle=\"color:firebrick\"\nstyle=\"color:darkred\"\nstyle=\"color:green\"\nstyle=\"color:limegreen\"\nstyle=\"color:seagreen\"\nstyle=\"color:deeppink\"\nstyle=\"color:tomato\"\nstyle=\"color:coral\"\nstyle=\"color:purple\"\nstyle=\"color:indigo\"\nstyle=\"color:burlywood\"\nstyle=\"color:sandybrown\"\nstyle=\"color:sienna\"\nstyle=\"color:chocolate\"\nstyle=\"color:teal\"\nstyle=\"color:silver\"").'
		</td>
		<td>
			&nbsp;'.create_select('fnt_face', "Font\nArial\nTimes\nCourier\nCentury", "\nArial\nTimes\nCourier\nCentury", '', "onChange=\"javascript:insertTag(document.post_form.msg_body, '[FONT='+document.post_form.fnt_face.options[this.selectedIndex].value+']', '[/FONT]'); document.post_form.fnt_face.options[0].selected=true\"").'
		</td>
		</tr></table></td></tr>';
	}
	
	echo '<tr'.ROW_BGCOLOR().'><td nowrap valign=top class="GenText">Body:<br><br>
		'.post_options('private').'
	</td><td>'.get_err('msg_body',1).'<textarea rows="20" cols="65" wrap="virtual" tabindex="2" name="msg_body" onKeyUp="storeCaret(this);" onClick="storeCaret(this);" onSelect="storeCaret(this);">'.(isset($msg_body)?htmlspecialchars(str_replace("\r", "", $msg_body)):'').'</textarea></td></tr>';
	
	if ( $PRIVATE_ATTACHMENTS > 0 ) {	
		echo '<tr'.ROW_BGCOLOR().'><td nowrap valign=top class="GenText">File Attachments:</td><td>';
		/* check if there are any attached files, if so draw a table */
		if ( isset($attach_list) && is_array($attach_list) ) {
			reset($attach_list);
			lay_start_content_table();
			echo '<tr><td class="TableHeading">Name</td><td class="TableHeading">Size</td><td class="TableHeading">Action</td></tr>';
			$file_array=NULL;
			while ( list($k, $v) = each($attach_list) ) {
				$file_array .= $v['tmp']."\r".$v['name']."\r".$v['size']."\r".$v['delque']."\r".$v['db_id']."\n";
				if ( empty($v['delque']) ) {
					$sz = ( $v['size'] < 100000 ) ? number_format($v['size']/1024,2).'Kb' : number_format($v['size']/1048576,2).'Mb';
					echo '<tr><td class="RowStyleB">'.$v['name'].'</td><td class="RowStyleB">'.$sz.'</td><td class="RowStyleB"><a class="GenLink" href="javascript: document.post_form.file_del_opt.value=\''.$k.'\'; document.post_form.submit();">Delete</a></td></tr>';
				}
			}
			lay_end_content_table();
			echo '<input type="hidden" name="file_del_opt" value="">';
			echo '<input type="hidden" name="file_array" value="'.base64_encode($file_array).'">';
		}
		echo (($attach_control_error)?$attach_control_error:'').'<font class="SmallText"><b>Allowed File Types:</b> '.list_ext().'<br><b>Maximum File Size</b> '.$MAX_F_SIZE.'Kb<br><b>Maximum Files per Message:</b> '.$PRIVATE_ATTACHMENTS.(($attach_count)?'<font class="SmallText"> currently attached '.$attach_count.' file(s) ':'').'<p></font>';
		if( ($attach_count+1) <= $PRIVATE_ATTACHMENTS ) echo '<input type="file" name="attach_control"> <input type="submit" name="attach_control_add" value="Upload File">';
		echo '</td></tr>';
	}

	echo '<tr'.ROW_BGCOLOR().' valign="top"><td class="GenText">Options:</td><td><table border=0 cellspacing=0 cellpadding=1>
	<tr><td>'.create_checkbox('msg_track', 'Y', (empty($msg_track)?'':$msg_track)).'</td><td class="GenText"><b>Track This Message</b></td></tr>
	<tr><td> </td><td><font class="SmallText">Notify me when message gets read.</font></td></tr>	
	<tr><td>'.create_checkbox('msg_show_sig', 'Y', (empty($msg_show_sig)?'':$msg_show_sig)).'</td><td class="GenText"><b>Include Signature</b></td></tr>
	<tr><td> </td><td><font class="SmallText">Include your profile signature.</font></td></tr>';
	
	if( strtolower($GLOBALS['PRIVATE_MSG_SMILEY']) == 'y' ) {
		echo '<tr><td>'.create_checkbox('msg_smiley_disabled', 'Y', (empty($msg_smiley_disabled)?NULL:$msg_smiley_disabled)).'</td><td class="GenText"><b>Disable smilies in this post</b></td></tr>';
	}
	
	echo '</table></td></tr>';
	
	echo '<tr'.ROW_BGCOLOR().'><td class="GenText" align="right" colspan=2><input type="submit" value="Preview Message" name="preview">'.(($GLOBALS["SPELL_CHECK_ENABLED"]=='Y' && function_exists('pspell_config_create') )?' <input type="submit" value="Spell-check Message" name="spell">':'').' <input type="submit" name="btn_draft" value="Save Draft" onClick="javascript: if( document.post_form.java_script_pcount.value>0 ) { alert(\'Your post is being processed, please wait.\'); return false;  } else { document.post_form.java_script_pcount.value++;  }"> <input type="submit" name="btn_submit" value="Send" onClick="javascript: if( document.post_form.java_script_pcount.value>0 ) { alert(\'Your post is being processed, please wait.\'); return false;  } else { document.post_form.java_script_pcount.value++;  }"></td></tr>';

	lay_end_content_table(); 
?>
<input type="hidden" name="java_script_pcount" value="0">
<input type="hidden" name="S" value="<?php echo (empty($S)?'':$S); ?>">
<input type="hidden" name="msg_id" value="<?php echo (empty($msg_id)?'':$msg_id); ?>">
<input type="hidden" name="forward" value="<?php echo (empty($forward)?'':$forward); ?>">
<input type="hidden" name="old_subject" value="<?php echo (empty($old_subject)?'':$old_subject); ?>">
<input type="hidden" name="prev_loaded" value="1">
<?php 	if ( !empty($attach_enabled) ) { ?><input type="hidden" name="attach_enabled" value="<?php echo $attach_enabled; ?>"><?php } 
	draw_return(); 
?>
</form>
<?php
	include_once $GLOBALS['FORUM_SETTINGS_PATH'].'footer_'.$layout.'.inc';	
?>