<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: referals.php,v 1.8 2002/02/11 21:06:40 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/

	include_once "GLOBALS.php";
	fud_use('db.inc');
	fud_use('cookies.inc');	
	fud_use('forum.inc');
	fud_use('users.inc');
	fud_use('style.inc');
	fud_use('util.inc');

	list($ses, $usr) = init_user();
	
	if ( isset($ses) ) $ses->update('Browsing referals');
	$layout = get_layout_id($layout); include_once $GLOBALS['FORUM_SETTINGS_PATH'].'header_'.$layout.'.inc';
	
	if( empty($id) || !is_numeric($id) ) $id = NULL;
	
	if( $id == $usr->id ) fud_use('usroptions.inc');

	$returnto = base64_encode($GLOBALS["REQUEST_URI"]);

	set_row_color_alt(true);
	lay_start_content_table();
		
	if( $id ) {
		$r = Q("SELECT id,login FROM fud_users WHERE id=".$id);
		if( ($ttl=DB_COUNT($r)) ) {
			list($r_id,$r_login) = DB_SINGLEARR($r);
		
			$res = Q("SELECT login,id,join_date,posted_msg_count FROM fud_users WHERE referer_id=".$id);
			
			echo '<tr class="TableHeading"><td>Forum members referred by: <b><a class="TableHeading" href="usrinfo.php?id='.$r_id.'&'.$_RSID.'">'.htmlspecialchars($r_login).'</a></b></td><td align="center" nowrap>Post Count</td><td align="center">Registered On</td><td nowrap align="center">Action</td></tr>';
			$i=0;
			while ( $obj = DB_ROWOBJ($res) ) {
				$ext = read_ext_settings($obj->id);
				
				$hp='';
				if( $GLOBALS['PM_ENABLED'] == 'Y' && isset($usr) ) 
					$hp .= ' <a href="ppost.php?'.$_RSID.'&msg_to_list='.urlencode($obj->login).'" class="GenLink"><img src="'.$GLOBALS["fud_img_suffix"].'msg_pm.gif" border=0 alt="Send Private Message"></a>';
				
				if ( strlen($ext['home_page']) )
					$hp .= ' <a class="GenLink" href="'.$ext['home_page'].'" target=_new><img src="'.$GLOBALS["fud_img_suffix"].'homepage.gif" alt="Homepage" border=0></a>';
				
				echo '<tr class="RowStyle'.(($i%2)?'A':'B').'"><td width="100%" nowrap class="GenText"><a class="GenLink" href="usrinfo.php?id='.$obj->id.'&'.$_RSID.'">'.htmlspecialchars($obj->login).'</a></td><td nowrap align="center" nowrap class="Gentext">'.$obj->posted_msg_count.'</td><td nowrap class="DateText" nowrap>'.format_date($obj->join_date).' '.format_time($obj->join_date).'</td><td nowrap class="GenText">'.(($GLOBALS["ALLOW_EMAIL"]=='Y')?'<a href="email.php?tx_name='.urlencode($obj->login).'&returnto='.$returnto.'&'.$_RSID.'" class="GenLink"><img src="'.$GLOBALS["fud_img_suffix"].'msg_email.gif" alt="Contact via Email" border=0></a> ':'').'<a href="showposts.php?id='.$obj->id.'&'.$_RSID.'" class="GenLink"><img src="'.$GLOBALS["fud_img_suffix"].'show_posts.gif" alt="Show Posts" border=0></a>'.$hp.'</td></tr>';
				
				$i++;		
			}
			lay_end_content_table();
			QF($res);
		}
	}	
	else {
		if( empty($start) || $start>$ttl ) $start=0;
			
		$res = Q("SELECT fud_users_ref.login,fud_users_ref.id,SUM(1) AS cnt FROM fud_users LEFT JOIN fud_users AS fud_users_ref ON fud_users_ref.id=fud_users.referer_id WHERE fud_users.referer_id>0 AND fud_users_ref.id IS NOT NULL GROUP BY fud_users_ref.id ORDER BY cnt DESC");
		$ttl = DB_COUNT($res);
		if( $ttl ) { 
			if( $start ) DB_SEEK($res, $start);
			
			echo '<tr class="TableHeading"><td align="center">Member</td><td align="center">Referrals</td><td>Members Referred</td></tr>';
			
			$i=0;
			while ( ($obj = DB_ROWOBJ($res)) && $i<$GLOBALS['MEMBERS_PER_PAGE'] ) {	
				$r_list='';		
				$r = Q("SELECT login,id FROM fud_users WHERE referer_id=".$obj->id);
				while ( list($rf_login,$rf_id) = DB_ROWARR($r) ) {
					$r_list .= '<a class="GenLink" href="usrinfo.php?id='.$rf_id.'&'.$_RSID.'">'.htmlspecialchars($rf_login).'</a>, ';
				}
				QF($r);
				$r_list = substr($r_list,0,-2);
				
				echo '<tr class="RowStyle'.(($i%2)?'A':'B').'"><td nowrap class="GenText" valign="top"><a class="GenLink" href="usrinfo.php?id='.$obj->id.'&'.$_RSID.'">'.htmlspecialchars($obj->login).'</a></td><td align="center" class="GenText">'.$obj->cnt.'</td><td class="GenText">'.$r_list.'</td></tr>';
							
				$i++;
			}
			
			lay_end_content_table();
			draw_pager($start,$GLOBALS['MEMBERS_PER_PAGE'],$ttl,'referals.php?id='.$id.'&'.$_RSID);
		}
		QF($res);
	}
	
	if( empty($ttl) ) {
		lay_start_content_table();
		echo '<tr class="TableHeading"><td>No referals yet.</td></tr>';
		lay_end_content_table();	
	}	

	fud_use('curtime.inc');
	include_once $GLOBALS['FORUM_SETTINGS_PATH'].'footer_'.$layout.'.inc';
?>