<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: reset.php,v 1.8 2002/02/11 21:06:40 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/

	include_once "GLOBALS.php";
	
	$GLOBALS['USER_REG'] = 1;
	
	fud_use('widgets.inc');
	fud_use('cookies.inc');
	fud_use('users.inc');
	fud_use('style.inc');
	fud_use('email.inc');
	fud_use('fileio_reg.inc');
	
	list($ses, $usr) = init_user();
	cache_buster();
	
	if ( $reset_key ) {
		if ( $parr = reset_user_passwd_by_key($reset_key) ) {
			$conf_body = read_email_message('newpass.msg', array("login"=>$parr['usr']->login, 'password'=>$parr['passwd'], "url"=>$GLOBALS['WWW_ROOT'].'register.php'));
			send_email($GLOBALS['NOTIFY_FROM'], $parr['usr']->email, "Password Reset", "Password Reset", $conf_body, "");
			header('Location: login.php?S='.$S.'&msg='.base64_encode('Your password has been emailed to you. You should receive it within few minutes. Please check your email for your password and login'));
		}
		else {
			error_dialog('Error', 'Invalid password reset key', NULL);
		}
		exit();
		
	}
	
	$error_msg = NULL;
	if ( isset($GLOBALS['email']) ) {
		$email= $GLOBALS['email'];
		$usr = new fud_user_reg;
		
		if ( $id=get_id_by_email($email) ) {
			$usr->get_user_by_id($id);
			if ( $EMAIL_CONFIRMATION == 'Y' && $usr->email_conf == 'N' ) {
				$conf_key = $usr->email_unconfirm();
				$conf_body = read_email_message('confirmation.msg', array("url"=>$GLOBALS['WWW_ROOT']."emailconf.php?conf_key=".$conf_key));
				send_email($GLOBALS['NOTIFY_FROM'], $usr->email, "Registation Confirmation", $conf_body, "");
			}
			else {
				$key = $usr->reset_key();
				$conf_body = read_email_message('reset.msg', array("URL"=>$GLOBALS['WWW_ROOT'].'reset.php?reset_key='.$key));
				send_email($GLOBALS['NOTIFY_FROM'], $usr->email, "Password Reset", $conf_body, "");
			}
			
			if ( isset($ses) ) {
				$ses->delete_session();
			}
			error_dialog('Information', 'You should receive instructions in your email in the next few minutes', NULL);
			exit();
		}
		else {
			$error_msg = '<font class="ErrorText">Email not found in database</font><br>';
		}
	}
	else $email = NULL;
	if ( empty($usr->id) ) unset($usr);
	
	set_row_color_alt(true);

	$TITLE_EXTRA = ': Reset Password';
	$layout = get_layout_id((isset($layout)?$layout:'')); include_once $GLOBALS['FORUM_SETTINGS_PATH'].'header_'.$layout.'.inc';

	echo '<div align=center>';
	lay_start_content_table('DialogTable');

	echo '<tr><td colspan=2 class="TableHeading">Password Reminder</td></tr>';
	echo '<form method="post">';

	echo '<tr class="RowStyleA"><td colspan=2 class="RowStyleA"><font class="GenText">Your password will be reset and sent to you, or in case you have not confirmed your email the email confirmation request will be resent to you.</font></td></tr>';
	echo '<tr class="RowStyleB"><td class="GenText">Email:</td><td>'.$error_msg.'<input type="text" name="email" value="'.stripslashes($email).'"></td></tr>';
	echo '<tr class="RowStyleA"><td colspan=2 nowrap align="right"><input type="submit" name="Reset Password" value="Go"></td></tr>';
	echo '<input type="hidden" name="S" value="'.$S.'"></form>';

	lay_end_content_table();
	echo '</div>';
	include_once $GLOBALS['FORUM_SETTINGS_PATH'].'footer_'.$layout.'.inc';
?>