<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: drawpmsg.inc,v 1.14 2002/02/12 19:55:00 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/

function drawpmsg(&$obj)
{
	global $_RSID;

	if( empty($GLOBALS['returnto']) ) $GLOBALS['returnto'] = base64_encode($GLOBALS["REQUEST_URI"]);

	$info_id = $obj->ouser_id;
	$loc=$c_tag=$show_sigs=$avatar_img=$lev_txt=$line_status='';

	$posted_msg_count = $obj->posted_msg_count;
	$info_login = htmlspecialchars(trim_show_len($obj->login,'LOGIN'));
	$join_date = $obj->join_date;
				
	$disable_avatar = ( $obj->level_pri == 'l' ) ? 1 : 0;
	
	if ( !$disable_avatar ) {
		if ( $obj->avatar_approved == 'Y' ) {
			if ( $obj->avatar_loc )
				$avatar_img = '<img src="'.$obj->avatar_loc.'" border=0>';
			else
				$avatar_img = '<img src="'.$GLOBALS['IMG_ROOT_WWW'].$GLOBALS['CUSTOM_AVATAR_DIR'].$info_id.'" border=0>';
		}
		else if( $obj->avatar )
			$avatar_img = '<img src="'.$GLOBALS['IMG_ROOT_WWW'].$GLOBALS['AVATAR_DIR'].$obj->avatar.'" border=0>';
	}
	
	if( $GLOBALS['ONLINE_OFFLINE_STATUS'] == 'Y' ) {
		$tm = time();
		
		if( ($obj->time_sec+$GLOBALS['LOGEDIN_TIMEOUT']*60) > $tm ) 
			$line_status = '<acronym title="'.htmlspecialchars($obj->login).' is currently online"><img src="'.$GLOBALS["fud_img_suffix"].'online.gif" alt="Online" border=0></acronym>';
		else 
			$line_status = '<acronym title="'.htmlspecialchars($obj->login).' is currently offline"><img src="'.$GLOBALS["fud_img_suffix"].'offline.gif" alt="Offline" border=0></acronym>';	

		$line_status .= ' ';
	}
		
	$login_href_pref = '<a class="GenLink" href="usrinfo.php?id='.$info_id.'&'.$_RSID.'">';
	$login_href_suff = '</a>';
			
	$logincap = $login_href_pref.$info_login.$login_href_suff;

	if ( $GLOBALS['PUBLIC_RESOLVE_HOST'] == 'Y' && strlen($obj->host_name) ) 
		$host_name = 'From:<br><font class="SmallText">'.wordwrap($obj->host_name,30,'<br>',1)."</font><br>\n";
	else
		$host_name = '';
		
	$posted_msg_count = 'Posts: '.$posted_msg_count.'<br>';
			
	$registered = 'Registered:<br><font class="DateText">'.date($GLOBALS['fud_reg_date_fmt'], $join_date).'</font>';
		
	if ( $obj->location ) $loc = 'Location: '.trim_show_len($obj->location,'LOCATION').'<br>';
	$c_tag = $obj->custom_status;
	if( $GLOBALS["usr"]->show_sigs=='N' ) $show_sigs=1;
	
	if ( $obj->icon ) 
		$icon = '<img src="'.$GLOBALS["IMG_ROOT_WWW"].$GLOBALS["MESSAGE_ICON_DIR"].$obj->icon.'" border=0>&nbsp;&nbsp;';
	else
		$icon='';
	
	$style=lay_start_content_row(true);
	
	$spacer = '<br>';
	$buddy_lnk = '[<a href="buddy_list.php?'.$GLOBALS['returnto'].'&add='.$info_id.'&'.$_RSID.'" class="GenLink">add to buddy list</a>]';
	$ignore_lnk='';
	if ( $obj->ouser_id != 1 && empty($obj->ignore_post) ) {
		$ignore_lnk = '<br>[<a href="ignore_list.php?'.$GLOBALS['returnto'].'&add='.$info_id.'&'.$_RSID.'" class="GenLink">ignore all future posts by this user</a>]';
	}
	
	if ( $obj->level_pri ) {
		if( !empty($obj->level_name) ) $lev_txt .= '<font class="LevelText">'.$obj->level_name.'</font><br>';
		if( !empty($obj->level_img) && strtolower($obj->level_pri)!='a' ) $lev_txt .= '<img src="'.$obj->level_img.'" border=0><br>';
	}
	
	if( !empty($c_tag) ) $c_tag .= '<br>';
	
	/* determine IM status */
	if ( $obj->icq ) 	$im_icq =   ' <a href="usrinfo.php?id='.$obj->poster_id.'#icq_msg"><img src="http://web.icq.com/whitepages/online?icq='.$obj->icq.'&amp;img=5" border=0></a> ';
	if ( $obj->aim ) 	$im_aim =   ' <a href="aim:goim?screenname='.urlencode($obj->aim).'&message=Hi.+Are+you+there?"><img src="'.$GLOBALS["fud_img_suffix"].'aim.gif" border=0></a> ';
	if ( $obj->yahoo ) 	$im_yahoo = ' <a target=_new href="http://edit.yahoo.com/config/send_webmesg?.target='.urlencode($obj->yahoo).'&.src=pg"><img src="'.$GLOBALS["fud_img_suffix"].'yahoo.gif" border=0></a> ';
	if ( $obj->msnm ) 	$im_msnm =  ' <a href="mailto:'.$obj->msnm.'"><img src="'.$GLOBALS["fud_img_suffix"].'msnm.gif" border=0></a>';
	
	echo '<td'.$style.' valign=top nowrap><table cellspacing=0 cellpadding=0 border=0><tr><td valign="middle">'.$line_status.'</td><td valign="middle" class="GenText">'.$logincap.'<br>'.$lev_txt.'</td></tr></table><font class="GenText">'.$avatar_img.'<p>'.$c_tag.$posted_msg_count.$loc.$host_name.$registered.$spacer.$buddy_lnk.$ignore_lnk.'</font><div align=center>'.$im_icq.$im_aim.$im_yahoo.$im_msnm.'</div></td>';
	echo '<td'.$style.' valign="top" width="100%"><table valign="top" border=0 cellspacing=0 cellpadding=0 width="100%"><tr><td valign="top" align="left" class="MsgSubText"><a name="msg_'.$obj->id.'"></a>'.$icon.$obj->subject.'</td><td valign="top" align=right><img src="'.$GLOBALS['fud_img_suffix'].'posticon.gif" border=0><font class="DateText">'.format_date($obj->post_stamp).' '.format_time($obj->post_stamp).'</font></td></tr><tr><td colspan=2 class="ContentTable"><img src="blank.gif" border=0></td></tr><tr'.$style.'valign="top"><td colspan=2 valign="top" height="100%"><font class="MsgBodyText">';

	if( $obj->length ) 
		echo read_pmsg_body($obj->offset, $obj->length);
	else
		echo 'No Message Body';	
	
	if ( $obj->attach_cnt ) {
		echo '<p>';
		$a_result = Q("SELECT id,original_name,dlcount FROM fud_attach WHERE message_id=".$obj->id." AND private='Y'");
		if ( DB_COUNT($a_result) ) {
			echo '<table border=0 cellspacing=0 cellpadding=2>';
			while ( $a_obj = DB_ROWOBJ($a_result) ) {
				if( file_exists($GLOBALS["FILE_STORE"].$a_obj->id.".atch") ) {
					$sz = filesize($GLOBALS["FILE_STORE"].$a_obj->id.".atch")/1024;
					echo '<tr><td valign=middle><a class="GenLink" href="getfile.php?'.$_RSID.'&id='.$a_obj->id.'&private=1"><img src="'.$GLOBALS['fud_img_suffix'].'attach.gif" border=0 alt="Attachment"></a></td><td><font class="GenText"><b>Attachment:</b></font> <a class="GenLink" href="getfile.php?'.$_RSID.'&id='.$a_obj->id.'&private=1">'.$a_obj->original_name.'</a><br><font class="SmallText">(Size: '.(( $sz < 1000 ) ? number_format($sz,2).'Kb' : number_format($sz/1024,2).'Mb').', Downloaded '.$a_obj->dlcount.' time(s))</font></td></tr>';
				}					
			}
			echo '</table>';
		}
		QF($a_result);	
	}
		
	if ( $GLOBALS["ALLOW_SIGS"] == 'Y' && $obj->show_sig == 'Y' && !$show_sigs && $obj->sig) echo '<p><u>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</u><br>'.$obj->sig."\n";
		
	echo '</font></td></tr></table></td>';
	lay_end_content_row();
		
	echo  '<tr class="MsgToolBar"><td colspan=3><table border=0 cellspacing=0 cellpadding=0 width="100%"><tr><td align="left" nowrap>';
		
	if( $obj->ouser_id != $GLOBALS["usr"]->id ) {
		echo $login_href_pref.'<img src="'.$GLOBALS["fud_img_suffix"].'msg_about.gif" alt="Author\'s Profile" border=0>'.$login_href_suff.' ';
		if( $GLOBALS["ALLOW_EMAIL"] == 'Y' ) echo '<a class="GenLink" href="email.php?'.$_RSID.'&tx_name='.urlencode($obj->login).'&returnto='.base64_encode($GLOBALS["HTTP_SERVER_VARS"]["REQUEST_URI"].'#msg_'.$obj->id).'"><img src="'.$GLOBALS["fud_img_suffix"].'msg_email.gif" alt="Email Author" border=0></a> ';
		if( $GLOBALS['PM_ENABLED'] == 'Y' ) echo '<a class="GenLink" href="ppost.php?'.$_RSID.'&msg_to_list='.urlencode($obj->login).'&returnto='.base64_encode($GLOBALS["HTTP_SERVER_VARS"]["REQUEST_URI"].'#msg_'.$obj->id).'"><img src="'.$GLOBALS["fud_img_suffix"].'msg_pm.gif" alt="Send Private Message" border=0></a> ';
	}			
	
	echo '</td><td colspan=2 align="right">';
		
	if( $obj->folder_id=='DRAFT' ) echo '<a class="GenLink" href="ppost.php?'.$_RSID.'&msg_id='.$obj->id.'"><img src="'.$GLOBALS["fud_img_suffix"].'msg_edit.gif" alt="Edit" border=0></a> ';
			
	if( $obj->folder_id=='INBOX' ) {
		echo '<a class="GenLink" href="ppost.php?'.$_RSID.'&reply='.$obj->id.'"><img src="'.$GLOBALS["fud_img_suffix"].'msg_reply.gif" alt="Reply" border=0></a> ';
		echo '<a class="GenLink" href="ppost.php?'.$_RSID.'&quote='.$obj->id.'"><img src="'.$GLOBALS["fud_img_suffix"].'msg_quote.gif" alt="Reply w/Quote" border=0></a> ';
	}			
	
	echo '<a class="GenLink" href="ppost.php?'.$_RSID.'&forward='.$obj->id.'"><img src="'.$GLOBALS["fud_img_suffix"].'msg_forward.gif" alt="Forward" border=0></a> ';
	echo '<a class="GenLink" href="pmsg.php?'.$_RSID.'&btn_delete=1&sel='.$obj->id.'"><img src="'.$GLOBALS["fud_img_suffix"].'msg_delete.gif" alt="Delete" border=0></a>';
	echo '</td></tr></table></td></tr>';
}		
?>