<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: email.inc,v 1.7 2002/02/11 19:36:23 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/
 if ( defined('_EMAIL_INC_') ) return; else define('_EMAIL_INC_', 1);

	include_once "GLOBALS.php";
	fud_use('db.inc');

function validate_email($email)
{ 
        if (eregi("(@.*@)|(\.\.)|(@\.)|(\.@)|(^\.)", $email) || !eregi ("^.+\@(\[?)[-_a-zA-Z0-9\.]+\.([a-zA-Z]{2,3}|[0-9]{1,3})(\]?)$", $email)) { 
                return 1; 
        } 
        else { 
                list($user, $domain) = explode('@', $email); 
                if ((!eregi("^[_a-zA-Z0-9\.\-]+$", $user)) || (!eregi("^[_a-zA-Z0-9\.\-]+$", $domain))) { 
                        return 1; 
                } 
                else { 
                        return 0; 
                } 
        }
}

class fud_email_block
{
	var $id;
	var $type;
	var $string;
	
	var $e_list;
	
	function add($type, $string)
	{
		Q("INSERT INTO fud_email_block(type, string) VALUES('".$type."', '".$string."')");
	} 
	
	function sync($type, $string)
	{
		Q("UPDATE fud_email_block SET type='".$type."', string='".$string."' WHERE id=".$this->id);
	}
	
	function get($id)
	{
		$res = Q("SELECT * FROM fud_email_block WHERE id=".$id);
		if ( !IS_RESULT($res) ) exit("no such email block");
		
		$obj = DB_SINGLEOBJ($res);
		
		$this->id 	= $obj->id;
		$this->type	= $obj->type;
		$this->string	= $obj->string;
	}
	
	function delete()
	{
		Q("DELETE FROM fud_email_block WHERE id=".$this->id);
	}
	
	function getall()
	{
		$res = Q("SELECT * FROM fud_email_block ORDER BY id");
		
		unset($this->e_list);
		while ( $obj = DB_ROWOBJ($res) ) {
			$this->e_list[] = $obj;
		}
		if ( isset($this->e_list) ) reset($this->e_list);
		QF($res); 
	}
	
	function counte()
	{
		if ( !isset($this->e_list) ) return;
		return count($this->e_list);
	}
	
	function resete()
	{
		if ( !isset($this->e_list) ) return;
		reset($this->e_list);
	}
	
	function eache()
	{
		if ( !isset($this->e_list) ) return;
		$obj = current($this->e_list);
		if ( !isset($obj) ) return;
		next($this->e_list);
		
		return $obj;
	}
}

function is_email_blocked($addr)
{

	if ( BQ("SELECT * FROM fud_email_block WHERE string='".$addr."'") ) return 1;

	$r = Q("SELECT * FROM fud_email_block ORDER BY id");
	while ( $obj = DB_ROWOBJ($r) ) {
		if ( $obj->type == 'SIMPLE' ) {
			$reg = $obj->string;
			$reg = str_replace('.', '\.', $reg);
			$reg = str_replace('*', '.*?', $reg);			
			if ( preg_match("!".$reg."!i", $addr, $res) ) {
				return 1;
			}
		}
		else if ( $obj->type == 'REGEX' ) {
			$reg = $obj->string;
			if ( preg_match("!".$reg."!i", $addr, $res) ) {
				return 1;
			}	
		}
	}
	QF($r);
	
	return 0;
}

function send_email($from, $to, $subj, $body, $header='')
{
	if( empty($to) || !count($to) ) return;	
	$bcc='';
	
	if( is_array($to) ) {
		if( ($a = count($to)) > 1 ) {
			$bcc = "Bcc: ";
			for( $i=1; $i<$a; $i++ ) 
				$bcc .= $to[$i].', ';
				
			$bcc = substr($bcc,0,-2);	
		}		

		$to = $to[0];
	}
	
	
	mail($to, $subj, $body, "From: $from\r\nReturn-Path: $from\r\nX-Mailer: FUDforum\r\n".$header.$bcc);
}

function send_notifications($to, $msg_id, $thr_subject, $poster_login, $id_type, $id, $frm_name='')
{
	$icq = str_replace("http://", "http'+'://'+'", $GLOBALS['WWW_ROOT']);
	$icq = str_replace("www.", "www'+'.", $icq);

	$goto_url['icq'] = "javascript:window.location='".$icq."rview.php?goto=".$msg_id."';";
	$goto_url['email'] = $GLOBALS['WWW_ROOT'].'rview.php?goto='.$msg_id;
	
	reverse_FMT($thr_subject);
	reverse_FMT($poster_login);
	
	if( $id_type == 'thr' ) {
		$subj = 'New reply to "'.$thr_subject.'" by '.$poster_login;
		
		$unsub_url['icq'] = "javascript:window.location='".$icq."rview.php?th=".$id."&notify=1&opt=off';";
		$unsub_url['email'] = $GLOBALS['WWW_ROOT'].'rview.php?th='.$id.'&notify=1&opt=off';
		
		$body_email = "To view unread replies goto ".$goto_url['email']."\n\nIf you do not wish to recieve further notifications about replies in this thread, please go here: ".$unsub_url['email'];
		$body_icq = "To view unread replies goto\n".$goto_url['icq']."\n\nIf you do not wish to recieve further notifications about replies in this thread, please go here:\n".$unsub_url['icq'];
	}
	else if ( $id_type == 'frm' ) {
		reverse_FMT($frm_name);
		
		$subj = "New thread in forum '".$frm_name."' called '".$thr_subject."' by ".$poster_login;
		
		$unsub_url['icq'] = "javascript:window.location='".$icq."thread.php?unsub=1&frm_id=".$id."';";
		$unsub_url['email'] = $GLOBALS['WWW_ROOT'].'rview.php?thread.php?unsub=1&frm_id='.$id;
		
		$body_email = "To view the thread goto:\n".$goto_url['email']."\n\nTo stop recieving notifications about new threads in this forum, please go here: ".$unsub_url['email'];
		$body_icq = "To view the thread goto:\n".$goto_url['icq']."\n\nTo stop recieving notifications about new threads in this forum, please go here:\n".$unsub_url['icq'];
	}	
	
	send_email($GLOBALS["FORUM_TITLE"].' <'.$GLOBALS['NOTIFY_FROM'].'>', $to['EMAIL'], $subj, $body_email);
	send_email($GLOBALS["FORUM_TITLE"].' <'.$GLOBALS['NOTIFY_FROM'].'>', $to['ICQ'], $subj, $body_icq);
}
?>