<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: error.inc,v 1.7 2002/02/12 19:55:00 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/
if ( defined('_ERROR_INC_') ) return; else define('_ERROR_INC_', 1);

	include_once "GLOBALS.php";

/*
 * if severity is >0 the error handler will merely output the error the file 
 * however if the error severity is 0, the the function will terminate the script.
*/ 

function error_handler($function_name, $error_message, $severity)
{	
	if( !$fp = fopen($GLOBALS['ERROR_PATH'].'errors.inc', 'a') ) {
		echo '<br><font color="#ff0000">Unable to open error file</font><br>';
		exit;
		$fp = fopen("php://stdout", "w");
		$TO_SCREEN = 1;
	}

	unset($error_msg);

	$err = gmdate("Y-m-d-H-i-s", time());
	$err .= ' [s:'.$GLOBALS["HTTP_SERVER_VARS"]["SCRIPT_FILENAME"].'@'.$function_name.'] '.str_replace("\r", ' ', str_replace("\n", ' ', $GLOBALS["HTTP_SERVER_VARS"]["REMOTE_ADDR"].' "'.$GLOBALS["HTTP_SERVER_VARS"]["PATH_TRANSLATED"].'" "'.$GLOBALS["HTTP_SERVER_VARS"]["HTTP_USER_AGENT"].'" '.$error_message))."\n";
	
	if( $TO_SCREEN ) {
		$error_msg = "\n--------------------------------------\n";
		$error_msg .= "Error in function/script: <b>".$function_name."</b>\n";
		$error_msg .= "has caused the following error: <b>".$error_message."</b>\n";
		$error_msg .= "while processing script name: <b>".$GLOBALS["HTTP_SERVER_VARS"]["SCRIPT_FILENAME"]."</b>\n";
		$error_msg .= "the error occured at: <b>".gmdate("d/m/Y H:i:s T")."</b>\n";
		$error_msg .= "Browser: <b>".$GLOBALS["HTTP_SERVER_VARS"]["HTTP_USER_AGENT"]."</b>\nUser Ip: <b>".$GLOBALS["HTTP_SERVER_VARS"]["REMOTE_ADDR"]."</b>\nScript Accessed: <b>".$GLOBALS["HTTP_SERVER_VARS"]["PATH_TRANSLATED"]."</b>\n\n";
		$error_msg = nl2br($error_msg);
	}
	
	fwrite($fp, $err);
	fclose($fp);	

	if( !$severity ) exit;
}

function error_dialog($title, $msg, $returnto, $level='', $ses=NULL)
{
	if ( empty($ses) ) $ses = $GLOBALS['ses'];
	
	$level = ( empty($level) ) ? 'WARN' : strtoupper($level);
	$ref = !empty($GLOBALS["HTTP_SERVER_VARS"]["HTTP_REFERER"]) ? $GLOBALS["HTTP_SERVER_VARS"]["HTTP_REFERER"] : '';
	
	$err_str = gmdate("Y-m-d-H-i-s", time());
	$err_str .= " [d:$level]";
	$err_str .= ' '.strip_tags(str_replace("\n", ' ', str_replace("\r", ' ', $title.':'.$msg.':'.$returnto.':'.$ref)))."\n";

	$fp = fopen($GLOBALS['ERROR_PATH'].'error_dialog.log', 'a');
		fwrite($fp, $err_str);
		fflush($fp);
	fclose($fp);

	$err_id = md5(get_random_value(128).time());
	$ses->putvar('err_id', $err_id);
	$ses->putvar('er_msg', $msg);
	$ses->putvar('err_t', $title);
	$ses->putvar('ret_to', base64_encode($returnto));
	$ses->save_session();
	header("Location: ".$GLOBALS['WWW_ROOT'].'error.php?'.$GLOBALS["_RSID"].'&err_id='.$err_id);
	exit;
}

function std_error($type)
{
	include_once $GLOBALS['FORUM_SETTINGS_PATH'].'error_types.inc';
	$err = $GLOBALS["ERR_".$type];
	if ( is_array($err) ) {
		error_dialog($err[0], $err[1], $err[2], $err[3]);
	}
	else {
		error_dialog('CRITIAL ERROR', 'You have encountered an error, but unfortunatly there is a problem with the error reporting system', $GLOBALS['WWW_ROOT'], 'FATAL');
		exit();
	}
}

function std_out($text, $level='INFO')
{
	$fp = fopen($GLOBALS['ERROR_PATH'].'std_out.log', 'a');
	$log_str = gmdate("Y-m-d-H-i-s", time());
	$log_str .= " [".$level."] ";
	$log_str .= str_replace("\n", ' ', str_replace("\r", ' ', $text))."\n";
	fwrite($fp, $log_str);
	fclose($fp);
}
?>