<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: forum.inc,v 1.9 2002/02/05 00:37:54 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/
 if ( defined('_FORUM_INC_') ) return; else define('_FORUM_INC_', 1);

	include_once "GLOBALS.php";
	fud_use('db.inc');
	
	
class fud_forum
{
	var $id=NULL;
	var $cat_id=NULL;
	var $name=NULL;
	var $descr=NULL;
	var $passwd_posting=NULL;
	var $post_passwd=NULL;
	var $only_registered=NULL;
	var $hidden=NULL;
	var $cat_hidden=NULL;
	var $anon_topic_creation=NULL;
	var $anon_viewing=NULL;
	var $anon_replying=NULL;
	var $anon_forum=NULL;
	var $forum_icon=NULL;
	var $tag_style=NULL;
	var $last_post_id=NULL;
	
	var $allow_polls=NULL;
	var $date_created=NULL;
	var $thread_count=NULL;
	var $view_order=NULL;
	
	var $moderated=NULL;
	var $enable_attachments=NULL;
	var $enable_smileys=NULL;
	var $enable_images=NULL;
	var $max_attach_size=NULL;
	var $max_file_attachments=NULL;
	var $allow_user_vote=NULL;
	
	var $forums=NULL;
	var $cur_frm=NULL;
	
	var $locked=NULL;
	
	
	function get($id)
	{
		QOBJ("SELECT fud_forum.*,fud_cat.hidden AS cat_hidden FROM fud_forum LEFT JOIN fud_cat ON fud_forum.cat_id=fud_cat.id WHERE fud_forum.id=".$id, $this);
		if( empty($this->id) ) invl_inp_err();
			
		return $id;		
	}
	
	function is_moderator($user_id)
	{
		return Q_SINGLEVAL("SELECT id FROM fud_mod WHERE user_id=".$user_id." AND forum_id=".$this->id);
	}
	
	function inc_reply_count($val)
	{
		Q("UPDATE fud_forum SET post_count=post_count+".$val." WHERE id=".$this->id);
	}
	
	function dec_reply_count($val)
	{
		Q("UPDATE fud_forum SET post_count=post_count-".$val." WHERE id=".$this->id);
	}
	
	function inc_thread_count($val)
	{
		Q("UPDATE fud_forum SET thread_count=thread_count+".$val." WHERE id=".$this->id);
	}
	
	function dec_thread_count($val)
	{
		Q("UPDATE fud_forum SET thread_count=thread_count-".$val." WHERE id=".$this->id);
	}
	
	function get_notify_list($user_id)
	{
		$r = Q("SELECT 
				fud_users.email, 
				fud_users.icq, 
				fud_users.notify_method 
			FROM 
				fud_forum_notify 
				INNER JOIN fud_users 
					ON fud_forum_notify.user_id=fud_users.id 
			WHERE 
				fud_forum_notify.forum_id=".$this->id." 
				AND fud_forum_notify.user_id!=".$user_id);

		$to=NULL;
		while ( $obj = DB_ROWOBJ($r) ) {
			$to[$obj->notify_method][] = ( $obj->notify_method == 'EMAIL' ) ? $obj->email : $obj->icq.'@pager.icq.com';
		}

		QF($r);
				
		return $to;
	}
	
}

if ( $GLOBALS['ADMIN_FORM'] ) fud_use('forum_adm.inc');
?>