<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: forum_adm.inc,v 1.10 2002/02/11 19:36:23 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/


	fud_use('widgets.inc');
	fud_use('msg.inc');

class fud_forum_adm extends fud_forum
{
	function get_max_view($cat_id)
	{
		$ret = Q_SINGLEVAL("SELECT MAX(view_order) FROM fud_forum WHERE cat_id=".$cat_id);
		return ( empty($ret) ? 0 : $ret );
	}
	
	function add($pos)
	{
		DB_LOCK('fud_forum+');
		$max = $this->get_max_view($this->cat_id);
		if ( $max > 0 ) {
			$this->view_order = $max+1;
		}
		else $this->view_order = 1;
		
		if ( $pos == 'FIRST' ) {
			$this->move_up(1, $max, $this->cat_id);
			$this->view_order = 1;
		}
		
		Q("INSERT INTO fud_forum (
			cat_id, 
			name, 
			descr, 
			passwd_posting, 
			post_passwd, 
			only_registered, 
			hidden, 
			anon_topic_creation, 
			anon_forum, 
			allow_polls, 
			date_created, 
			view_order, 
			forum_icon, 
			tag_style, 
			moderated, 
			enable_attachments, 
			enable_smileys, 
			enable_images, 
			max_attach_size,
			allow_user_vote,
			max_file_attachments,
			anon_viewing
		) 
		VALUES(
			".$this->cat_id.",
			'".$this->name."',
			".STRNULL($this->descr).",
			'".$this->passwd_posting."',
			".STRNULL($this->post_passwd).",
			'".$this->only_registered."',
			'".$this->hidden."',
			'".$this->anon_topic_creation."',
			'".$this->anon_replying."',
			'".$this->anon_forum."',
			'".$this->allow_polls."',
			".$this->view_order.",
			".STRNULL($this->forum_icon).",
			'".$this->tag_style."',
			'".$this->moderated."',
			'".$this->enable_attachments."',
			'".$this->enable_smileys."',
			'".$this->enable_images."',
			".INTZERO($this->max_attach_size).",
			'".YN($this->allow_user_vote)."',
			".INTZERO($this->max_file_attachments).",
			'".$this->anon_viewing."'
		)");
		DB_UNLOCK();
	}
	
	function sync()
	{
		Q("UPDATE fud_forum SET 
			cat_id=".$this->cat_id.",
			name='".$this->name."',
			descr=".STRNULL($this->descr).",
			passwd_posting='".$this->passwd_posting."',
			post_passwd=".STRNULL($this->post_passwd).",
			only_registered='".$this->only_registered."',
			hidden='".$this->hidden."',
			anon_topic_creation='".$this->anon_topic_creation."',
			anon_replying='".$this->anon_replying."',
			anon_forum='".$this->anon_forum."',
			allow_polls='".$this->allow_polls."',
			view_order=".$this->view_order.",
			forum_icon=".STRNULL($this->forum_icon).",
			tag_style='".$this->tag_style."',
			moderated='".$this->moderated."',
			enable_attachments='".$this->enable_attachments."',
			enable_smileys='".$this->enable_smileys."',
			enable_images='".$this->enable_images."',
			max_attach_size=".$this->max_attach_size.", 
			max_file_attachments=".INTZERO($this->max_file_attachments).",
			allow_user_vote='".YN($this->allow_user_vote)."',
			anon_viewing='".YN($this->anon_viewing)."'
		WHERE id=".$this->id);

		if ( $this->allow_user_vote == 'Y' ) {
			$r = Q("SELECT fud_thread.id, ROUND(AVG(fud_thread_rate_track.rating)) as avg_rating FROM fud_thread LEFT JOIN fud_forum ON fud_thread.forum_id=fud_forum.id AND fud_forum.allow_user_vote='Y' LEFT JOIN fud_thread_rate_track ON fud_thread_rate_track.thread_id=fud_thread.id AND fud_forum.id=".$this->id." GROUP BY fud_thread_rate_track.thread_id");
			while ( $obj = DB_ROWOBJ($r) ) {
				if ( !strlen($obj->avg_rating) ) $obj->avg_rating = 0;
				Q("UPDATE fud_thread SET rating=".$obj->avg_rating." WHERE id=".$obj->id);
			}
			QF($r);
		}
	}
	
	function change_pos($old, $new, $cat_id)
	{
		DB_LOCK('fud_forum+');
		Q("UPDATE fud_forum SET view_order=42000000 WHERE cat_id=".$cat_id." AND view_order=".$old);
		
		if ( $old > $new ) 
			$this->move_up($new, $old, $cat_id);			
		else 
			$this->move_down($old, $new, $cat_id);
		
		Q("UPDATE fud_forum SET view_order=".$new." WHERE cat_id=".$cat_id." AND view_order=42000000");
		DB_UNLOCK();
	}
	
	function move_up($start, $max, $cat_id)
	{
		Q("UPDATE fud_forum SET view_order=view_order+1 WHERE cat_id=".$cat_id." AND view_order>=".$start." AND view_order<=".$max);
	}
	
	function move_down($start, $max, $cat_id)
	{
		Q("UPDATE fud_forum SET view_order=view_order-1 WHERE cat_id=".$cat_id." AND view_order>=".$start." AND view_order<=".$max);
	}

	function get_cat_forums($cat_id)
	{
		$result = Q("SELECT * FROM fud_forum WHERE cat_id=".$cat_id." ORDER BY view_order");

		unset($this->forums);
		$this->cur_frm=0;
		if ( !IS_RESULT($result) ) return;
		
		while ( $obj=DB_ROWOBJ($result) ) {
			$this->forums[$this->cur_frm++] = $obj;
		}
		
		QF($result);
		
		$this->cur_frm = 0;
		return 1;
	}
	
	function get_all_forums()
	{
		$result = Q("SELECT fud_forum.* FROM fud_forum INNER JOIN fud_cat ON fud_forum.cat_id=fud_cat.id ORDER BY fud_cat.view_order, fud_forum.view_order");
		
		unset($this->forums);
		$this->cur_frm=0;
		if ( !IS_RESULT($result) ) return;
		
		while ( $obj=DB_ROWOBJ($result) ) {
			$this->forums[$this->cur_frm++] = $obj;
		}
		
		QF($result);
		
		$this->cur_frm = 0;
		return 1;
	}
	
	function get_all_mod_forums($user_id,$admin)
	{
		if( $admin!='A' )
			$add = ' AND fud_mod.user_id='.$user_id;
		else
			$add = '';	
	
		$result = Q("SELECT fud_forum.* FROM fud_forum LEFT JOIN fud_mod ON fud_forum.id=fud_mod.forum_id WHERE fud_forum.cat_id!=0".$add." GROUP BY fud_forum.id ORDER BY fud_forum.cat_id, fud_forum.view_order");
		unset($this->forums);
		$this->cur_frm=0;
		if ( !IS_RESULT($result) ) return;
		
		while ( $obj=DB_ROWOBJ($result) ) {
			$this->forums[$this->cur_frm++] = $obj;
		}
		
		QF($result);
		
		$this->cur_frm = 0;
		return 1;
	}
	
	function resetfrm()
	{
		$this->cur_frm = 0;
	}
	
	function countfrm()
	{
		if ( !isset($this->forums) ) return;
		return count($this->forums);
	}
	
	function nextfrm()
	{
		if ( !isset($this->forums[$this->cur_frm]) ) return;

		$this->id = $this->forums[$this->cur_frm]->id;
		$this->cat_id = $this->forums[$this->cur_frm]->cat_id;
		$this->name = $this->forums[$this->cur_frm]->name;
		$this->descr = $this->forums[$this->cur_frm]->descr;
		$this->passwd_posting = $this->forums[$this->cur_frm]->passwd_posting;
		$this->post_passwd = $this->forums[$this->cur_frm]->post_passwd;
		$this->only_registered = $this->forums[$this->cur_frm]->only_registered;
		$this->hidden = $this->forums[$this->cur_frm]->hidden;
		$this->anon_topic_creation = $this->forums[$this->cur_frm]->anon_topic_creation;
		$this->anon_replying = $this->forums[$this->cur_frm]->anon_replying;
		$this->anon_forum = $this->forums[$this->cur_frm]->anon_forum;
		$this->anon_viewing = $this->forums[$this->cur_frm]->anon_viewing;
		$this->allow_polls = $this->forums[$this->cur_frm]->allow_polls;
		$this->date_created = $this->forums[$this->cur_frm]->date_created;
		$this->thread_count = $this->forums[$this->cur_frm]->thread_count;
		$this->post_count = $this->forums[$this->cur_frm]->post_count;
		$this->view_order = $this->forums[$this->cur_frm]->view_order;
		$this->forum_icon = $this->forums[$this->cur_frm]->forum_icon;
		$this->tag_style = $this->forums[$this->cur_frm]->tag_style;
		$this->moderated = $this->forums[$this->cur_frm]->moderated;
		$this->enable_attachments = $this->forums[$this->cur_frm]->enable_attachments;
		$this->enable_smileys = $this->forums[$this->cur_frm]->enable_smileys;
		$this->enable_images = $this->forums[$this->cur_frm]->enable_images;
		$this->max_attach_size = $this->forums[$this->cur_frm]->max_attach_size;
		$this->max_file_attachments = $this->forums[$this->cur_frm]->max_file_attachments;
		$this->allow_user_vote = $this->forums[$this->cur_frm]->allow_user_vote;
		$this->cur_frm++;
		
		return 1;
	}
	
	function delete($id) {
		DB_LOCK('fud_forum+, 
			fud_mod+, 
			fud_thread+, 
			fud_msg+, 
			fud_ann_forums+, 
			fud_forum_notify+, 
			fud_thread_notify+, 
			fud_read+, 
			fud_cat+, 
			fud_attach+, 
			fud_poll+, 
			fud_poll_opt+, 
			fud_poll_opt_track+, 
			fud_users+, 
			fud_msg_report+, 
			fud_thread_rate_track+');
		$result = Q("SELECT cat_id, view_order FROM fud_forum WHERE id=".$id);
		
		if ( !IS_RESULT($result) ) exit("no such forum\n");
		
		list($cat_id, $view_order) = DB_SINGLEARR($result);
		
		$max = $this->get_max_view($cat_id);
		
		$thr = Q("SELECT root_msg_id FROM fud_thread WHERE forum_id=".$id);
		while ( $obj = DB_ROWOBJ($thr) ) {
			$msg = new fud_msg_edit;
			$msg->get_by_id($obj->root_msg_id);
			$msg->delete();
			unset($msg);
		}
		QF($thr);
		
		Q("DELETE FROM fud_ann_forums WHERE forum_id=".$id);
		Q("DELETE FROM fud_thread WHERE forum_id=".$id);
		Q("DELETE FROM fud_mod WHERE forum_id=".$id);
		Q("DELETE FROM fud_forum WHERE id=".$id);
		Q("DELETE FROM fud_forum_notify WHERE forum_id=".$id);
		$this->move_down($view_order, $max, $cat_id); 
		DB_UNLOCK();
	}
		
	function chcat($id, $new_cat)
	{
		DB_LOCK('fud_forum+');
		$result = Q("SELECT cat_id, view_order FROM fud_forum WHERE id=".$id);
		
		if ( !IS_RESULT($result) ) exit("no such forum");		
		
		list($old_cat_id, $view_order) = DB_SINGLEARR($result);
		$old_max = $this->get_max_view($old_cat_id);
		
		$new_n = $this->get_max_view($new_cat);
		if ( !$new_n ) {
			$new_n = 1;
		}
		else $new_n += 1;
		
		Q("UPDATE fud_forum SET cat_id=".$new_cat.", view_order=".$new_n." WHERE id=".$id);
		$this->move_down($view_order, $old_max, $old_cat_id); 
		DB_UNLOCK();
	}
}
?>