<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: glob.inc,v 1.7 2002/02/11 19:36:23 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/
 if ( defined('_GLOB_INC_') ) return; else define('_GLOB_INC_', 1);

	include_once "GLOBALS.php";

$GLOBALS['__GLOB_INC__']['EOF_IND'] = '/*$EOF$*/';

function get_config($file)
{
	$fl = file($file,1);
	for ( $i=0; $i<count($fl); $i++ ) {
		$arr[$i] = $fl[$i];
	}
	
	return $arr;
}

function write_config($arr, $file)
{
	if ( !($fp = fopen($file, 'w')) ) {
		exit("can't open file\n");
	}
	
	for ( $i=0; $i<count($arr); $i++ ) {
		fwrite($fp, $arr[$i]);
	}
	fclose($fp);
	return;
}

function mod_opt(&$f, $opt, $val)
{
	$found = 0;
	for ( $i=0; $i<count($f); $i++ ) {
		$str = '/\$'.$opt.'.*=.*".*";/';
		$ln = str_replace("\r", '', $f[$i]);
		$ln = str_replace("\n", '', $ln);

		if ( substr($ln, 0, strlen($GLOBALS['__GLOB_INC__']['EOF_IND'])) == $GLOBALS['__GLOB_INC__']['EOF_IND'] ) break;
	
		if ( preg_match($str, $ln, $regs) ) {
			if ( preg_match('/(.*)\$'.$opt.'(.*)=(.*)"(.*)"(.*);(.*)/', $ln, $regs) ) {
				$nln = $regs[1].'$'.$opt.$regs[2].'='.$regs[3].'"'.$val.'"'.$regs[5].';'.$regs[6]."\n";
				$f[$i] = $nln;
			}
			$found = 1;
			break;
		}
	}
	
	if ( !$found ) {
		arr_insert($f, $i, $nln);
	}
}

function arr_insert(&$arr, $pos, $val)
{
	array_splice($arr, $pos, 1, array($val, $arr[$pos]));
}

function cf_arr($cf)
{
	for ( $i=0; $i<count($cf); $i++ ) {
		$str = '/\$([A-Za-z0-9_]+)[^=]*=[^"]*"(.*)";/';
		$ln = str_replace("\r", '', $cf[$i]);
		$ln = str_replace("\n", '', $ln);

		if ( substr($ln, 0, strlen($GLOBALS['__GLOB_INC__']['EOF_IND'])) == $GLOBALS['__GLOB_INC__']['EOF_IND'] ) break;

		if ( preg_match($str, $ln, $regs) ) {
			$arr[$regs[1]] = $regs[2];
		}
	}
	
	return $arr;
}

function read_help()
{
	$fp = fopen($GLOBALS['INCLUDE'].'GLOBALS_HELP', 'r');
		$data = fread($fp, filesize($GLOBALS['INCLUDE'].'GLOBALS_HELP'));
	fclose($fp);
	
	$pos = 0;
	$len = filesize($GLOBALS['INCLUDE'].'GLOBALS_HELP');
	
	$help_ar = array();
	
	while( $pos<$len ) {
		if( ord($data[$pos]) >= ord('A') && ord($data[$pos]) <= ord('Z') ) {
			$end = strpos($data, "\n", $pos);
			$dt = substr($data, $pos, ($end-$pos));
			if( strtoupper($dt) == $dt ) {
				$end2 = strpos($data, ".\n\n", $end);
				$help_ar[$dt] = str_replace("\n\n", '<br>', htmlspecialchars(substr($data, $end+1, ($end2-$end))));
			}
			
			$pos = $end+1;
			continue;
		}
		else {
			$pos = strpos($data, "\n", $pos);
			$pos++;
		}	
			
		if( !$pos ) break;	
	}
	
	return $help_ar;
}

function maintenance_status($reason, $status)
{
	$data = get_config($GLOBALS['INCLUDE'].'GLOBALS.php');
	
	mod_opt($data, 'FORUM_ENABLED', $status);
	mod_opt($data, 'DISABLED_REASON', $reason);
	
	write_config($data, $GLOBALS['INCLUDE'].'GLOBALS.php');
}
?>