<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: msg_edt.inc,v 1.22 2002/02/11 19:36:23 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/

fud_use('poll.inc');
fud_use('search.inc');
fud_use('attach.inc');
fud_use('email.inc');
fud_use('rhost.inc');
fud_use('rev_fmt.inc');

class fud_msg_edit extends fud_msg
{
	function add_thread($forum_id)
	{
		return $this->add($forum_id);
	}
	
	function add_reply($reply_to, $th_id=NULL)
	{
		if( !empty($reply_to) ) {
			$this->reply_to=$reply_to;
			$forum_id = Q_SINGLEVAL("SELECT fud_thread.forum_id FROM fud_msg LEFT JOIN fud_thread ON fud_msg.thread_id=fud_thread.id WHERE fud_msg.id=".$reply_to);
		}
		else
			$forum_id = Q_SINGLEVAL("SELECT fud_thread.forum_id FROM fud_thread WHERE fud_thread.id=".$th_id);	
		
		return $this->add($forum_id);
	}
	
	function add($forum_id)
	{
		if ( empty($this->attachment_id) ) $this->attachment_id = 0;
		if ( isset($GLOBALS['HTTP_SERVER_VARS']['REMOTE_ADDR']) ) $this->ip_addr = $GLOBALS['HTTP_SERVER_VARS']['REMOTE_ADDR'];
		
		if ( !DB_LOCKED() ) {
			DB_LOCK('fud_thread_view+, fud_level+, fud_forum_read+, fud_forum_notify+, fud_cat+, fud_users+, fud_forum+, fud_thread+, fud_msg+, fud_index+, fud_title_index+, fud_search+, fud_thread_notify+, fud_read+');
			$local_lock = 1;
		}
		
		$this->post_stamp = time();
		
		if ( $GLOBALS['PUBLIC_RESOLVE_HOST'] == 'Y' ) $this->host_name = get_host($this->ip_addr);
		
		$this->thread_id = isset($this->thread_id) ? $this->thread_id : 0;
		$this->reply_to = isset($this->reply_to) ? $this->reply_to : 0;
		
		Q("INSERT INTO fud_msg (
			thread_id, 
			poster_id, 
			reply_to, 
			ip_addr,
			host_name,
			post_stamp, 
			subject, 
			attach_cnt, 
			poll_id, 
			icon, 
			show_sig,
			smiley_disabled
		) 
		VALUES(
			".$this->thread_id.",
			".$this->poster_id.",
			".INTZERO($this->reply_to).",
			".IFNULL($this->ip_addr, "'0.0.0.0'").",
			".STRNULL($this->host_name).",
			".$this->post_stamp.",
			".STRNULL($this->subject).",
			".INTZERO($this->attach_cnt).",
			".INTZERO($this->poll_id).",
			".STRNULL($this->icon).",
			'".YN($this->show_sig)."',
			'".YN($this->smiley_disabled)."'
		)");
		
		$this->id = DB_LASTID();
		
		$frm = new fud_forum;
		$frm->get($forum_id);
			
		if ( !$this->thread_id ) { /* new thread */
			$thr = new fud_thread;
			$thr->last_post = $this->post_stamp;
			
			/* if moderator is creating a thread consider a number of other properties */
			if ( isset($GLOBALS['MOD']) ) {
				if ( $GLOBALS['HTTP_POST_VARS']['thr_ordertype'] != 'NONE' ) 
					$is_sticky = 'Y';
				else
					$is_sticky = 'N';
				$this->thread_id = $thr->add($this->id, $forum_id, $this->poster_id, NULL, $is_sticky, $GLOBALS['HTTP_POST_VARS']['thr_ordertype'], $GLOBALS['HTTP_POST_VARS']['thr_orderexpiry'], $GLOBALS['HTTP_POST_VARS']['thr_replyallowed']);
			}
			else
				$this->thread_id = $thr->add($this->id, $forum_id, $this->poster_id);
				
			Q("UPDATE fud_msg SET thread_id=".$this->thread_id." WHERE id=".$this->id);
		}
		
		if ( empty($frm->moderated) || $frm->moderated != 'Y' ) $this->approve();

		list($offset,$length) = write_msg_body($this->thread_id, $this->body);
		Q("UPDATE fud_msg SET offset=".INTZERO($offset).", length=".INTZERO($length)." WHERE id=".$this->id);
		
		if ( $local_lock ) DB_UNLOCK();
		
		return $this->id;
	}
	
	function sync($id)
	{
		list($offset,$length) = write_msg_body($this->thread_id, $this->body);
		Q("UPDATE fud_msg SET offset=".INTZERO($offset).", length=".INTZERO($length).", smiley_disabled='".YN($this->smiley_disabled)."', updated_by=".$id.", show_sig='".YN($this->show_sig)."', subject='".$this->subject."', attach_cnt=".INTZERO($this->attach_cnt).", poll_id=".INTZERO($this->poll_id).", update_stamp=".time().", icon=".STRNULL($this->icon)." WHERE id=".$this->id);
		
		delete_msg_index($this->id);
		
		$root_msg_id = Q_SINGLEVAL("SELECT root_msg_id FROM fud_thread WHERE id=".$this->thread_id);
		
		if ( isset($GLOBALS['MOD']) && $root_msg_id==$this->id ) {
			$thr = new fud_thread;
			if ( $GLOBALS['HTTP_POST_VARS']['thr_ordertype'] != 'NONE' ) 
				$thr->is_sticky = 'Y';
			else
				$thr->is_sticky = 'N';
				
			$thr->ordertype = $GLOBALS['HTTP_POST_VARS']['thr_ordertype'];
			$thr->orderexpiry = $GLOBALS['HTTP_POST_VARS']['thr_orderexpiry'];
			$thr->replyallowed = $GLOBALS['HTTP_POST_VARS']['thr_replyallowed'];
			$thr->id = $this->thread_id;
			$thr->sync();
		}
		$s_text = preg_match("!^Re: !i", $this->subject) ? '': $this->subject;
		if( $GLOBALS['FORUM_SEARCH'] == 'Y' ) index_text($s_text, $this->body, $this->id);
	}
	
	function fetch_vars($array, $prefix)
	{
		$this->subject = $array[$prefix.'subject'];
		$this->body = $array[$prefix.'body'];
		$this->icon = isset($array[$prefix.'icon'])?$array[$prefix.'icon']:'';
		$this->show_sig = isset($array[$prefix.'show_sig'])?$array[$prefix.'show_sig']:'';
	}
	
	function export_vars($prefix)
	{	
		$GLOBALS[$prefix.'subject'] = $this->subject;
		$GLOBALS[$prefix.'body'] = $this->body;
		$GLOBALS[$prefix.'icon'] = $this->icon;
		$GLOBALS[$prefix.'show_sig'] = $this->show_sig;
	}
	
	function delete()
	{
		if ( !DB_LOCKED() ) {
			DB_LOCK('fud_thread_view+, fud_level+, fud_forum+, fud_forum_read+, fud_thread+, fud_msg+, fud_attach+, fud_poll+, fud_poll_opt+, fud_poll_opt_track+, fud_users+, fud_thread_notify+, fud_msg_report+, fud_thread_rate_track+');
			$local_lock = 1;
		}
		
		$res = Q("SELECT 
				fud_msg.*,
				fud_thread.root_msg_id AS root_msg_id, 
				fud_thread.last_post_id AS thread_lip,
				fud_forum.last_post_id AS forum_lip,
				forum_id 
			FROM fud_msg 
			LEFT JOIN fud_thread 
				ON fud_msg.thread_id=fud_thread.id 
			LEFT JOIN fud_forum 
				ON fud_thread.forum_id=fud_forum.id 
			WHERE 
				fud_msg.id=".$this->id);
		if ( !IS_RESULT($res) ) exit("no such message");
		$del = DB_SINGLEOBJ($res);
		
		if ( $del->attach_cnt ) {
			$res = Q("SELECT location FROM fud_attach WHERE message_id=".$this->id." AND private='N'");
			if( DB_COUNT($res) ) {
				while ( list($loc) = DB_ROWARR($res) ) {
					if( file_exists($loc) ) unlink($loc);				
				}
			}
			QF($res);
			Q("DELETE FROM fud_attach WHERE message_id=".$this->id." AND private='N'");
		}
		
		Q("DELETE FROM fud_msg_report WHERE msg_id=".$this->id);
		
		if ( $del->poll_id ) {
			$poll = new fud_poll;
			$poll->get($del->poll_id);
			$poll->delete();
		}

		if( $del->root_msg_id==$del->id ) {
			$rmsg = Q("SELECT * FROM fud_msg WHERE thread_id=".$del->thread_id." AND id!=".$del->id);
			$d_msg = new fud_msg_edit;
			while ( $obj = DB_ROWOBJ($rmsg) ) {
				$d_msg->get_by_id($obj->id);
				$d_msg->delete();
			}
			QF($rmsg);
			Q("DELETE FROM fud_thread_notify WHERE thread_id=".$del->thread_id);
			$rthd=Q("SELECT forum_id, root_msg_id FROM fud_thread WHERE root_msg_id=".$del->root_msg_id);
			$i = 0;
			while ( list($th_forum_id, $th_root_msg_id) = DB_ROWARR($rthd) ) {
				Q("UPDATE fud_forum SET thread_count=thread_count-1 WHERE id=".$th_forum_id);
				$lip_update[$i]['forum_id'] = $th_forum_id;
				$lip_update[$i]['msg_id'] = $th_root_msg_id;
				++$i;
			}
			QF($rthd);
			
			Q("DELETE FROM fud_thread WHERE root_msg_id=".$del->root_msg_id);
			Q("DELETE FROM fud_thread_rate_track WHERE thread_id=".$del->thread_id);
			if( $del->approved!='N' ) Q("UPDATE fud_forum SET post_count=post_count-1 WHERE id=".$del->forum_id);
		}
		else {
			if( $del->approved!='N' ) {
				Q("UPDATE fud_thread SET replies=replies-1 WHERE id=".$del->thread_id);
				Q("UPDATE fud_forum SET post_count=post_count-1 WHERE id=".$del->forum_id);
				$lip_update[0]['forum_id'] = $del->forum_id;
				$lip_update[0]['msg_id'] = $del->id;
			}	
		}
		
		if ( $this->poster_id && $del->approved!='N' ) {
			$u = new fud_user;
			$u->id = $this->poster_id;
			$u->set_post_count(-1);
		}	
		
		Q("DELETE FROM fud_msg WHERE id=".$this->id);
		
		if( $del->root_msg_id!=$this->id && $del->thread_lip == $this->id ) {
			$mid = Q_SINGLEVAL("SELECT id FROM fud_msg WHERE thread_id=".$del->thread_id." AND approved='Y' ORDER BY post_stamp DESC LIMIT 1");
			Q("UPDATE fud_thread SET last_post_id=".$mid." WHERE id=".$del->thread_id);
		}
		
		reset($lip_update);
		while ( list($k, $v) = each($lip_update) ) {
			if( $v['msg_id'] == $this->id ) {
				$mid = Q_SINGLEVAL("SELECT last_post_id FROM fud_thread INNER JOIN fud_msg ON fud_thread.last_post_id=fud_msg.id WHERE forum_id=".$v['forum_id']." AND fud_msg.approved='Y' ORDER BY last_post_id DESC LIMIT 1");
				if( !$mid ) $mid = 0;
			
				Q("UPDATE fud_forum SET last_post_id=".$mid." WHERE id=".$v['forum_id']);
				rebuild_forum_view($v['forum_id']);
			}
		}
		if ( $local_lock ) DB_UNLOCK();
	}	
	
	function approve($id=NULL)
	{
		if( !DB_LOCKED() ) {
			DB_LOCK('fud_thread_view+, fud_level+, fud_forum_read+, fud_forum_notify+, fud_cat+, fud_users+, fud_forum+, fud_thread+, fud_msg+, fud_index+, fud_title_index+, fud_search+, fud_thread_notify+, fud_read+');
			$local_lock = 1;
		}
		
		if( $id ) $this->get_by_id($id);
		
		if ( $this->approved != 'Y' ) {
			$thr = new fud_thread;
			$frm = new fud_forum;
			
			$thr->get_by_id($this->thread_id);
			$frm->get($thr->forum_id);
			
			Q("UPDATE fud_msg SET approved='Y' WHERE id=".$this->id);
			
			if ( $this->poster_id ) {
				$u = new fud_user;
				$u->id = $this->poster_id;
				$u->set_post_count(1);
			}
		
			if ( $thr->last_post_id <= $this->id ) { 
				Q("UPDATE fud_thread SET last_post_id=".$this->id.", last_post_date=".$this->post_stamp." WHERE id=".$this->thread_id);
				
				if( Q_SINGLEVAL("SELECT last_post_id FROM fud_forum WHERE id=".$thr->forum_id) < $this->id ) 
					Q("UPDATE fud_forum SET last_post_id=".$this->id." WHERE id=".$thr->forum_id);
			}	

			if( $thr->root_msg_id == $this->id ) {/* new thread */
				Q("UPDATE fud_forum SET thread_count=thread_count+1 WHERE id=".$frm->id);
				rebuild_forum_view($thr->forum_id);
			}	
			else {/* reply to thread */
				$thr->inc_post_count(1);
				rebuild_forum_view($thr->forum_id, Q_SINGLEVAL("SELECT page FROM fud_thread_view WHERE forum_id=".$thr->forum_id." AND thread_id=".$this->thread_id));
			}	
				
			$frm->inc_reply_count(1);
			
			if( $GLOBALS['FORUM_SEARCH'] == 'Y' ) {
				$s_text = preg_match("!Re: !i", $this->subject) ? '': $this->subject;
				index_text($s_text, $this->body, $this->id);
			}
			
			if ( $thr->root_msg_id == $this->id ) 
				send_notifications($frm->get_notify_list(INTZERO($this->poster_id)), $this->id, $thr->subject, ($GLOBALS['usr']->login?$GLOBALS['usr']->login:$GLOBALS['ANON_NICK']), 'frm', $frm->id, $frm->name);
			else
				send_notifications($thr->get_notify_list(INTZERO($this->poster_id)), $this->id, $thr->subject, ($GLOBALS['usr']->login?$GLOBALS['usr']->login:$GLOBALS['ANON_NICK']), 'thr', $thr->id);
		}
		
		if( !empty($local_lock) ) DB_UNLOCK();
	}
	
	function unapprove()
	{
		Q("UPDATE fud_msg SET approved='N' WHERE id=".$this->id);
	}
	
}

function flood_check()
{
	$check_time = time()-$GLOBALS['FLOOD_CHECK_TIME'];
	
	if( ($v = Q_SINGLEVAL("SELECT post_stamp FROM fud_msg WHERE ip_addr='".$GLOBALS['HTTP_SERVER_VARS']['REMOTE_ADDR']."' AND poster_id=".(($GLOBALS["usr"]->id)?$GLOBALS["usr"]->id:0)." AND post_stamp>".$check_time." ORDER BY post_stamp DESC LIMIT 1")) ) {
		$v += $GLOBALS['FLOOD_CHECK_TIME']-time();
		if( $v<1 ) $v=1;
		return $v;
	}
	
	return;		
}
?>