<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: search.inc,v 1.6 2002/02/12 01:48:19 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/
 if ( defined('_SEARCH_INC_') ) return; else define('_SEARCH_INC_', 1);

	include_once "GLOBALS.php";
	fud_use('db.inc');
	fud_use('fileio.inc');
	fud_use('rev_fmt.inc');

function src_forum_sel($def)
{
	$r = Q("SELECT fud_forum.id,fud_forum.name,fud_cat.id AS cat_id,fud_cat.name AS cat_name FROM fud_cat INNER JOIN fud_forum ON fud_cat.id=fud_forum.cat_id WHERE fud_cat.hidden='N' AND fud_forum.hidden='N' ORDER BY fud_cat.view_order,fud_forum.view_order");
	$sel = $old_cat = NULL;	
	if( DB_COUNT($r) ) {
		$sel .= '<select name="forum_limiter"><option value="">Search all Forums</option>';
		while( $obj = DB_ROWOBJ($r) ) {
			if( $old_cat != $obj->cat_id ) {
				$sel .= '<option value="c'.$obj->cat_id.'"'.(('c'.$obj->cat_id==$def)?' selected':'').'>'.$obj->cat_name.'</option>';
				$old_cat = $obj->cat_id;
			}
			$sel .= '<option value="'.$obj->id.'"'.(($obj->id==$def)?' selected':'').'>&nbsp;&nbsp;&nbsp;'.$obj->name.'</option>';	
		}
		$sel .= '</select>';
	}
	QF($r);	
	return $sel;
}

function delete_msg_index($msg_id)
{
	Q("DELETE FROM fud_index WHERE msg_id=".$msg_id);
	Q("DELETE FROM fud_title_index WHERE msg_id=".$msg_id);
}	
	
function index_text($subj, $body, $msg_id)
{
	/* Remove Stuff In Quotes */
	while ( preg_match('!<table border="0" align="center" width="90%" cellpadding="3" cellspacing="1"><tr><td class="SmallText"><b>(.*?)</b></td></tr><tr><td class="quote"><br>(.*?)<br></td></tr></table>!is', $body) ) 
		$body = preg_replace('!<table border="0" align="center" width="90%" cellpadding="3" cellspacing="1"><tr><td class="SmallText"><b>(.*?)</b></td></tr><tr><td class="quote"><br>(.*?)<br></td></tr></table>!is', '', $body);
		
	/* Remove HTML */
	reverse_FMT($body);
	$body = addslashes(strip_tags($body));

	reverse_FMT($subj);
	$subj = strtolower($subj);
	$subj = preg_replace('/[^A-Za-z0-9 ]+/si', ' ',  $subj);
	$subj = trim(preg_replace("! +!", " ", $subj));
	
	$body = strtolower($body);
	$body = preg_replace('/[^A-Za-z0-9 ]+/si', ' ',  $body);
	$body = trim(preg_replace("! +!", " ", $body));

	/* build full text index */
	$w = explode(' ', trim($subj.' '.$body));
	$a = count($w);
	for ( $i=0; $i<$a; $i++ ) {
		if ( strlen($w[$i]) > 50 || strlen($w[$i])<3 ) continue;
		
		$r=Q("SELECT id FROM fud_search WHERE word='".$w[$i]."'");
		if ( !DB_COUNT($r) ) {
			Q("INSERT INTO fud_search(word) VALUES('".$w[$i]."')");
			$id = DB_LASTID();
		}
		else list($id) = DB_ROWARR($r);
		QF($r);
		
		if ( !BQ("SELECT id FROM fud_index WHERE word_id=".$id." AND msg_id=".$msg_id) ) {
			Q("INSERT INTO fud_index(word_id, msg_id) VALUES(".$id.", ".$msg_id.")");
		}
	}
	
	/* build subject only index */
	$w = explode(' ', $subj);
	for ( $i=0; $i<count($w); $i++ ) {
		if ( strlen($w[$i]) > 50 || strlen($w[$i])<3 ) continue;
		$r=Q("SELECT id FROM fud_search WHERE word='".$w[$i]."'");
		if ( !DB_COUNT($r) ) {
			Q("INSERT INTO fud_search(word) VALUES('".$w[$i]."')");
			$id = DB_LASTID();
		}
		else list($id) = DB_ROWARR($r);
		QF($r);
		
		if ( !BQ("SELECT id FROM fud_title_index WHERE word_id=$id AND msg_id=".$msg_id) ) {
			Q("INSERT INTO fud_title_index(word_id, msg_id) VALUES(".$id.", ".$msg_id.")");
		}
	}
}

function re_build_index()
{
	DB_LOCK('fud_search+, fud_index+, fud_title_index+, fud_msg+');
	Q("DELETE FROM fud_search");
	Q("DELETE FROM fud_index");
	Q("DELETE FROM fud_title_index");
	$r = Q("SELECT id,subject,thread_id,length,offset FROM fud_msg ORDER BY thread_id,id ASC");
	if( !($cnt=DB_COUNT($r)) ) {
		QF($r);
		DB_UNLOCK();
		return;
	}

	$th_id=$i=0;
	$old_suject=$subj=NULL;
	while( $obj = DB_ROWOBJ($r) ) {
		if( $th_id != $obj->thread_id ) {
			open_thread_body($obj->thread_id);
			$th_id = $obj->thread_id;
		}
		$body = read_ext_body($obj->offset, $obj->length);
		
		/* Remove Stuff In Quotes */
		while ( preg_match('!<table border="0" align="center" width="90%" cellpadding="3" cellspacing="1"><tr><td class="SmallText"><b>(.*?)</b></td></tr><tr><td class="quote"><br>(.*?)<br></td></tr></table>!is', $body) ) 
			$body = preg_replace('!<table border="0" align="center" width="90%" cellpadding="3" cellspacing="1"><tr><td class="SmallText"><b>(.*?)</b></td></tr><tr><td class="quote"><br>(.*?)<br></td></tr></table>!is', '', $body);
		
		/* Remove HTML */
		$body = addslashes(strip_tags($body));
		
		/* Do not store the same subjects twice */
		if( $old_suject!=$obj->subject ) {
			$subj = addslashes($obj->subject);
			$old_suject = $obj->subject;
		}
		else
			$subj = NULL;
			
		index_text($subj, $body, $obj->id);
	}
	close_thread_body();
	DB_UNLOCK();
}

function search($str, $fld, $start, $count, $forum_limiter='')
{
	$w = explode(" ", $str);
	$qr = '';
	for ( $i=0; $i<count($w); $i++ ) {
		$qr .= " '".$w[$i]."',"; 
	}
	
	if ( substr($qr, strlen($qr)-1, 1) == ',' ) {
		$qr = substr($qr, 0, strlen($qr)-1);
	}
	
	switch ( $fld ) 
	{
		case "subject":
			$field = "fud_title_index";
			break;
		case "all":
			$field = "fud_index";
			break;
		default:
			$field = "fud_index";
			break;
	}

	if( is_numeric($forum_limiter) ) {
		$forum_limiter_sql = " fud_forum.id=".$forum_limiter." AND ";
	}
	else if( $forum_limiter[0]=='c' && is_numeric(substr($forum_limiter,1)) ) {
		$forum_limiter_sql = " fud_cat.id=".substr($forum_limiter,1)." AND ";
	}
	else {
		$forum_limiter_sql = NULL;
	}

	$anon = ( !isset($GLOBALS["usr"]) ) ? " AND fud_forum.anon_viewing!='N' " : '';

	$r = Q("SELECT 
		fud_users.login,
		fud_forum.name AS forum_name, 
		fud_forum.id AS forum_id,
		fud_msg.poster_id,
		fud_msg.id, 
		fud_msg.thread_id,
		fud_msg.subject,
		fud_msg.poster_id,
		fud_msg.offset,
		fud_msg.length,
		fud_msg.post_stamp,
		SUM(1) as rev_match
	FROM 
		fud_search
		LEFT JOIN ".$field." ON fud_search.id=".$field.".word_id
		LEFT JOIN fud_msg ON ".$field.".msg_id=fud_msg.id
		LEFT JOIN fud_users ON fud_msg.poster_id=fud_users.id
		LEFT JOIN fud_thread ON fud_msg.thread_id=fud_thread.id
		LEFT JOIN fud_forum ON fud_thread.forum_id=fud_forum.id
		LEFT JOIN fud_cat ON fud_forum.cat_id=fud_cat.id
	WHERE 
		".$forum_limiter_sql."
		word IN ( ".$qr." ) 
		AND fud_msg.approved='Y'
		AND fud_forum.hidden='N'
		AND fud_cat.hidden='N'
		".$anon."
	GROUP BY 
		fud_msg.id 
	ORDER BY rev_match DESC, fud_msg.post_stamp DESC");

	return $r;
}
?>