<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: smiley.inc,v 1.8 2002/02/11 19:36:23 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/
 if ( defined('_SMILEY_INC_') ) return; else define('_SMILEY_INC_', 1);

	include_once "GLOBALS.php";
	fud_use('db.inc');
	
class fud_smiley
{
	var $id;
	var $img;
	var $descr;
	var $code;
	
	var $s_list;
	
	function add()
	{
		Q("INSERT INTO fud_smiley(img, descr, code) VALUES ('".$this->img."','".$this->descr."','".$this->code."')");
	}
	
	function get($id)
	{
		QOBJ("SELECT * FROM fud_smiley WHERE id=".$id, $this);
		if( empty($this->id) ) exit("no such smiley\n");
	}
	
	function sync()
	{
		Q("UPDATE fud_smiley SET img='".$this->img."', descr='".$this->descr."', code='".$this->code."' WHERE id=".$this->id);
	}
	
	function delete()
	{
		Q("DELETE FROM fud_smiley WHERE id=".$this->id);
		if( @is_writable($GLOBALS['IMG_ROOT_DISK'].$GLOBALS['SMILEY_DIR'].$this->img) ) 
			unlink($GLOBALS['IMG_ROOT_DISK'].$GLOBALS['SMILEY_DIR'].$this->img);
	}
	
	function fetch_vars($array, $prefix)
	{
		reset($array);
		while ( list($key, $val) = each($array) ) {
			if ( substr($key, 0, strlen($prefix)) == $prefix ) {
				$key = substr($key, strlen($prefix), strlen($key)-strlen($prefix));

				if ( $key == 'img' )		$this->img = $val;
				if ( $key == 'descr' )		$this->descr = $val;
				if ( $key == 'code' )		$this->code = $val;
			}
		}
	}	
	
	function export_vars($prefix)
	{	
		$GLOBALS[$prefix.'img'] = $this->img;
		$GLOBALS[$prefix.'descr'] = $this->descr;
		$GLOBALS[$prefix.'code'] = $this->code;
	}
	
	function getall()
	{
		$res = Q("SELECT * FROM fud_smiley");
		if ( !IS_RESULT($res) ) return;
		
		unset($this->s_list);
		while ( $obj = DB_ROWOBJ($res) ) {
			$this->s_list[] = $obj;
		}
	}
	
	function resets()
	{
		if ( !isset($this->s_list) ) return;
		reset($this->s_list);
	}
	
	function counts()
	{
		if ( !isset($this->s_list) ) return;
		return count($this->s_list);
	}
	
	function eachs()
	{
		if ( !isset($this->s_list) ) return;
		@$obj = current($this->s_list);
		if ( !isset($obj) ) return;
		
		
		next($this->s_list);
		
		return $obj;
	}
}

function smiley_to_post(&$text)
{
	$res = Q("SELECT *,LENGTH(code) as code_l FROM fud_smiley ORDER BY code_l ASC");
	
	$smiley_www = $GLOBALS['IMG_ROOT_WWW'].$GLOBALS['SMILEY_DIR'];
	$i=0;
	$haystack=$needle=array();
	
	while ( $obj = DB_ROWOBJ($res) ) {
		if ( empty($obj->code) ) continue;
		
		$code = str_replace("~", "|", preg_quote($obj->code));
		$haystack[] = '!(\s|^|\W|\B)'.$code.'!is';
		$needle[] = '\1<img src="'.$smiley_www.$obj->img.'" border=0 alt="'.$obj->descr.'">';

		$i++;
	}
	QF($res);
	
	if ( $i ) $text = preg_replace($haystack, $needle, $text);
}

function post_to_smiley($text)
{
	$res = Q("SELECT * FROM fud_smiley");
	
	$smiley_www = $GLOBALS['IMG_ROOT_WWW'].$GLOBALS['SMILEY_DIR'];
	while ( $obj = DB_ROWOBJ($res) ) {
		if ( empty($obj->code) ) continue;
		
		$needle = ($a=strpos($obj->code, '~')) ? substr($obj->code,0,$a) : $obj->code;

		$text = str_replace('<img src="'.$smiley_www.$obj->img.'" border=0 alt="'.$obj->descr.'">', $needle, $text);
	}
	QF($res);
	
	return $text;
}
?>