<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: users_reg.inc,v 1.11 2002/02/12 16:44:05 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/


fud_use("fileio.inc");
fud_use("objutil.inc");

class fud_user_reg extends fud_user
{
	function add_user()
	{	
		DB_LOCK('fud_users+');
		
		do {
			$this->conf_key = md5(get_random_value(128));
		} while ( BQ("SELECT id FROM fud_users WHERE conf_key='".$this->conf_key."'") );

		$ref_id = !empty($GLOBALS["HTTP_COOKIE_VARS"]["frm_referer_id"]) ? $GLOBALS["HTTP_COOKIE_VARS"]["frm_referer_id"] : 0;
		if( empty($this->avatar_loc) ) $this->avatar_loc = NULL;
		
		$md5pass = md5($this->plaintext_passwd);
		
		$tm = time();
		
		Q("INSERT INTO 
			fud_users (
				login, 
				passwd, 
				name, 
				email, 
				display_email, 
				notify, 
				notify_method, 
				ignore_admin, 
				private_messages, 
				gender, 
				icq, 
				aim,
				yahoo,
				msnm,
				append_sig, 
				posts_ppg, 
				time_zone, 
				bday, 
				invisible_mode, 
				last_visit, 
				conf_key, 
				user_image, 
				join_date, 
				location, 
				avatar, 
				style, 
				coppa, 
				occupation, 
				interests,
				referer_id,
				show_sigs,
				last_read,
				avatar_loc,
				avatar_approved,
				sig,
				show_tool_tips,
				default_view
			)
			VALUES (
				'".$this->login."',
				'".$md5pass."',
				'".$this->name."',
				'".$this->email."',
				'".YN($this->display_email)."',
				'".YN($this->notify)."',
				'".$this->notify_method."',
				'".YN($this->ignore_admin)."',
				'".YN($this->private_messages)."',
				'".$this->gender."',
				".INTNULL($this->icq).",
				".STRNULL($this->aim).",
				".STRNULL($this->yahoo).",
				".STRNULL($this->msnm).",
				'".YN($this->append_sig)."',
				'".$this->posts_ppg."',
				'".$this->time_zone."',
				".INTZERO($this->bday).",
				'".YN($this->invisible_mode)."',
				".$tm.",
				'".$this->conf_key."',
				".STRNULL($this->user_image).",
				".$tm.",
				'".$this->location."',
				".INTZERO($this->avatar).",
				".$this->style.",
				'".YN($this->coppa)."',
				".STRNULL($this->occupation).",
				".STRNULL($this->interests).",
				".INTZERO($ref_id).",
				'".YN($this->show_sigs)."',
				".$tm.",
				".STRNULL($this->avatar_loc).",
				'NO',
				".STRNULL($this->sig).",
				'".YN($this->show_tool_tips)."',
				'".$this->default_view."'
			)
		");
		$this->id = DB_LASTID();
		if( $GLOBALS['EMAIL_CONFIRMATION'] == 'N' ) $this->email_confirm();
		DB_UNLOCK();
		write_ext_settings($this->id, $this->home_page, $this->bio);
		return $this->id;
	}
	
	function get_user_by_login($login)
	{
		QOBJ("SELECT * WHERE login='".$login."'", $this);
		if( empty($this->id) ) return;

		$ext = read_ext_settings($this->id);
		$this->home_page 	= $ext['home_page'];
		$this->bio		= $ext['bio'];
		
		return $this;
	}
	
	function sync_user()
	{
		if ( $plaintext_passwd ) $passwd = "'".md5($plaintext_passwd)."',";
		Q("UPDATE 
				fud_users 
			SET 
				$passwd name='".$this->name."',
				email='".$this->email."',
				display_email='".YN($this->display_email)."',
				notify='".YN($this->notify)."',
				notify_method='".$this->notify_method."',
				ignore_admin='".YN($this->ignore_admin)."',
				private_messages='".YN($this->private_messages)."',
				gender='".$this->gender."',
				icq=".INTNULL($this->icq).",
				aim=".STRNULL($this->aim).",
				yahoo=".STRNULL($this->yahoo).",
				msnm=".STRNULL($this->msnm).",
				append_sig='".YN($this->append_sig)."',
				show_sigs='".YN($this->show_sigs)."',
				show_tool_tips='".YN($this->show_tool_tips)."',
				posts_ppg='".$this->posts_ppg."',
				time_zone='".$this->time_zone."',
				invisible_mode='".YN($this->invisible_mode)."',
				bday=".INTZERO($this->bday).",
				user_image=".STRNULL($this->user_image).",
				location='".$this->location."',
				occupation='".$this->occupation."',
				interests='".$this->interests."',
				avatar=".INTZERO($this->avatar).",
				style=".$this->style.",
				avatar_loc=".STRNULL($this->avatar_loc).",
				avatar_approved='".$this->avatar_approved."',
				sig=".STRNULL($this->sig).",
				default_view='".$this->default_view."'
			WHERE id=".$this->id
		);
		write_ext_settings($this->id, $this->home_page, $this->bio);
	}
	
	function ch_passwd($pass)
	{
		Q("UPDATE fud_users SET passwd='".md5($pass)."' WHERE id=".$this->id);
	}

	function reset_passwd()
	{
		$randval = get_random_value(32);
		Q("UPDATE fud_users SET passwd='".md5($randval)."', reset_key='0' WHERE id=".$this->id);
		return $randval;
	}
	
	function reset_key()
	{
		
		DB_LOCK('fud_users+');
		do {
			$reset_key = md5(get_random_value(128));
		} while ( BQ("SELECT id FROM fud_users WHERE reset_key='".$reset_key."'") );
		Q("UPDATE fud_users SET reset_key='".$reset_key."' WHERE id=".$this->id);
		DB_UNLOCK();
		return $reset_key;
	}

	function disable_tool_tips()
	{
		Q("UPDATE fud_users SET show_tool_tips='N' WHERE id=".$this->id);
	}
	
	function email_confirm()
	{
		Q("UPDATE fud_users SET email_conf='Y', conf_key='0' WHERE id=".$this->id);
	}
	
	function email_unconfirm()
	{
		DB_LOCK('fud_users+');
		do {
			$this->conf_key = md5(get_random_value(128));
		} while ( BQ("SELECT id FROM fud_users WHERE conf_key='".$this->conf_key."'") );
	
		Q("UPDATE fud_users SET email_conf='N', conf_key='".$this->conf_key."' WHERE id=".$this->id);
		DB_UNLOCK();
		
		return $this->conf_key;
	}
}

function get_id_by_email($email)
{
	return Q_SINGLEVAL("SELECT id FROM fud_users WHERE email='".$email."'");
}

function get_id_by_login($login)
{
	return Q_SINGLEVAL("SELECT id FROM fud_users WHERE login='".$login."'");
}

function get_id_by_radius($login, $passwd)
{
	return Q_SINGLEVAL("SELECT id FROM fud_users WHERE login='".$login."' AND passwd='".md5($passwd)."'");
}

function check_user($id)
{
	return Q_SINGLEVAL("SELECT login FROM fud_users WHERE id=".$id);
}

function check_passwd($id, $passwd)
{
	return Q_SINGLEVAL("SELECT login FROM fud_users WHERE id=".$id." AND passwd='".md5($passwd)."'");
}

function reset_user_passwd_by_key($key)
{
	if ( empty($key) ) return;
	DB_LOCK('fud_users+');
	$pass=NULL;
	$id = Q_SINGLEVAL("SELECT id FROM fud_users WHERE reset_key='".$key."'");
	if ( $id ) {
		$u = new fud_user_reg;
		$u->get_user_by_id($id);
		$pass['passwd'] = $u->reset_passwd();
		$pass['usr'] = $u;
		
	}
	DB_UNLOCK();
	
	return $pass;
}

function create_style_list($name, $def)
{ /* here because only used on register form */
	$ret='';
	if( !empty($def) || !is_numeric($def) ) $def=NULL;
	
	$ret .= '<select name="'.$name.'">';
	$r = Q("SELECT * FROM fud_style WHERE enabled='Y' ORDER BY id");
	while ( $obj = DB_ROWOBJ($r) ) {
		if ( $obj->id == $def || ($obj->default_s=='Y' && !$def) ) 
			$sel = ' selected';

		$ret .= '<option value="'.$obj->id.'"'.$sel.'>'.$obj->name.'</option>';
	}
	QF($r);
	$ret .= '</select>';

	return $ret;
}
?>