<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: util.inc,v 1.5 2002/02/05 00:37:54 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/
 if ( defined('_UTIL_INC_') ) return; else define('_UTIL_INC_', 1);

	include_once "GLOBALS.php";
	
function prepad($val, $to, $chr)
{
	$ln_pad = $to - strlen($val);
        
	for ( $i=0; $i<$ln_pad; $i++ ) {
		$val = $chr.$val;
	}
	
	return $val;
}

function fmt_year($val)
{
	return  date("Y", mktime(1,1,1,1,1,$val));
}

function cache_buster()
{
	header ("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
        header ("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
	header ("Cache-Control: no-cache, must-revalidate");
	header ("Pragma: no-cache");
}

function create_pager($start, $count, $total, $arg, $suf='')
{
	if ( $total <= $count ) return;
	if ( !$count ) $count = $GLOBALS["POSTS_PER_PAGE"];	
	
	$cur_pg = ceil($start/$count);
	$ttl_pg = ceil($total/$count);
	
	$pager = '<font class="SmallText"><b>Pages ('.$ttl_pg.'): [ ';
	if ( $start-$count > -1 ) 
		$pager .= ' <a href="'.$arg.'&start=0&count='.$count.$suf.'" class="PagerLink">&laquo</a>&nbsp;&nbsp;<a href="'.$arg.'&start='.($start-$count).'&count='.$count.$suf.'" class="PagerLink">&lt;</a>&nbsp;&nbsp;';

	$mid = ceil($GLOBALS["GENERAL_PAGER_COUNT"]/2);
	
	if( $ttl_pg > $GLOBALS["GENERAL_PAGER_COUNT"] ) {
		if( ($mid+$cur_pg)>=$ttl_pg ) {
			$end = $ttl_pg;
			$mid += ($mid+$cur_pg)-$ttl_pg;
			$st = $cur_pg-$mid;
		}
		else if( ($cur_pg-$mid)<=0 ) {
			$st = 0;				
			$mid += $mid-$cur_pg;
			$end = $mid+$cur_pg;
		}
		else {
			$st = $cur_pg-$mid;
			$end = $mid+$cur_pg;
		}
		
		if( $st < 0 ) $start = 0;
		if( $end > $ttl_pg ) $end = $ttl_pg;
	}
	else {
		$end = $ttl_pg;
		$st = 0;
	}
	
	while ( $st<$end ) {
		if( $st != $cur_pg ) 
			$pager .= '<a href="'.$arg.'&start='.($st*$count).'&count='.$count.$suf.'" class="PagerLink">'.(++$st).'</a>&nbsp;&nbsp;';
		else
			$pager .= (++$st).'&nbsp;&nbsp;';
	}
	$pager = substr($pager,0,-12);
	
	if ( ($start+$count)<$total ) { 
		$pager .= '&nbsp;&nbsp;<a href="'.$arg.'&start='.($start+$count).'&count='.$count.$suf.'" class="PagerLink">&gt;</a>&nbsp&nbsp;<a href="'.$arg.'&start='.(($st-1)*$count).'&count='.$count.$suf.'" class="PagerLink">&raquo;</a>';
	}
	
	$pager .= ' ]</b></font>';
	
	return $pager;
}

function draw_pager($start, $count, $total, $arg, $suf='')
{
	echo create_pager($start, $count, $total, $arg, $suf);
}

function format_time($tm)
{
	return date($GLOBALS['TIME_FORMAT'], $tm);
}

function format_date($tm)
{
	return date($GLOBALS['DATE_FORMAT'], $tm);
}

function trim_show_len($text,$type)
{
	if( strlen($text)>$GLOBALS["MAX_".$type."_SHOW"] ) $text = substr($text,0,$GLOBALS["MAX_".$type."_SHOW"]).'...';
	
	return $text;
}
?>